/**
* Copyright (C) 2008, BOSCH Security Systems (Zhuhai)
* 
* Project: FPA-1000
*
* @file  myformutil.js
*
* @brief Javascript for forms
* @author Tony
*
* @date Created: 1008/08/12
*
* $Source: /Repo-Fire/Projects/21_FirePanelPrototype/21_FirePanelPrototype_PWD/SW/CFP-webpage-offline/essential_htmls/myformutil.js,v $
*
* @version $Revision $
*
* History: 
*  $Log: myformutil.js,v $
*  Revision 1.3.6.1  2010/05/12 03:12:37  lii2zhu
*  Merged tagged version "REL11-02Build021" to branch "Branch_FPA-1000_Rel_20".
*
*  Revision 1.3.2.1  2009/07/16 01:27:19  wau2zhu
*  fix the special character '&' input bug 622. commit by Wang Yujing
*
*  Revision 1.3  2009/05/25 09:33:22  wau2zhu
*  commit by Wang Yujing, comment some redundant source code.
*
*  Revision 1.2  2009/03/31 03:43:10  zhx2zhu
*  no message
*
*  Revision 1.4  2008/09/01 01:49:01  zhx2zhu
*  make the doxygen header well-formed
*
*  Revision 1.3  2008/08/15 05:27:29  zhx2zhu
*  no message
*
*  Revision 1.2  2008/08/15 05:26:31  zhx2zhu
*  adding doxygen header
*
*/
/**
* @fn 	 myform2xml(formdata, myDOMtree)
* @brief   convert formdate to domtree
* @param formdata[io] form object whose content to be added to myDOMtree as new node,myDOMtree has to be inner node of document
* @param myDOMtree[io] node of document ,in which to add new nodes 
* @return   	
*/  
function myform2xml(formdata, myDOMtree) 
{
	//xmldoc must be created outside (global config data document)
	if(!xmldoc)
		return;

	var conf_tag;
	var conf_value;
	var counter = 0;
	while (formdata[counter])
	{		//collect all form fields
		if ((formdata[counter].type=="radio")&&(!formdata[counter].checked))
		{
			//do nothing for not checked, if checked like normal input fields.
			conf_tag="";
		}
		else if ((formdata[counter].type=="checkbox")&&(!formdata[counter].checked))
		{
			conf_tag=formdata[counter].name;
			if(formdata[counter].id.match(/CT[12]_DIS/))
				conf_value="1";
			else
				conf_value="FALSE"; 
		}
		else if ((formdata[counter].type=="checkbox")&&(formdata[counter].checked))
		{
			conf_tag=formdata[counter].name;
			if(formdata[counter].id.match(/CT[12]_DIS/))
				conf_value="2";
			else
				conf_value="TRUE";
		}
		else if (formdata[counter].name)
		{
			//name and value are assigned like this
			conf_tag=formdata[counter].name;
			conf_value=formdata[counter].value; 			
		}
		else 
		{
			// do nothing if fieldname empty
			conf_tag="";
		}
		//add node to myDOMtree
		if (conf_tag) 
		{
			var path = conf_tag.split("_");
			switch (path.length)
			{
				case 1:
					var x = myDOMtree.getElementsByTagName(conf_tag);
					if (x.length==0)
					{
						var newel=xmldoc.createElement(conf_tag);
						var newtxt=xmldoc.createTextNode(conf_value);
						newel.appendChild(newtxt);
						myDOMtree.appendChild(newel);				
					}
					else if (x[0].childNodes[0])
					{
						x[0].childNodes[0].nodeValue = conf_value;
					}
					else 
					{
						var newtxt=xmldoc.createTextNode(conf_value);
						x[0].appendChild(newtxt);
					}			
					break;
				case 2:
					var x = myDOMtree.getElementsByTagName(path[0]);
					if (x.length==0)
					{
						var newel=xmldoc.createElement(path[0]);
						myDOMtree.appendChild(newel);
						x = myDOMtree.getElementsByTagName(path[0]);
					}
					var y = x[0].getElementsByTagName(path[1]);
					if (y.length==0)
					{
						var newel=xmldoc.createElement(path[1]);
						var newtxt=xmldoc.createTextNode(conf_value);
						newel.appendChild(newtxt);
						x[0].appendChild(newel);
					}
					else if (y[0].childNodes[0])
					{
						y[0].childNodes[0].nodeValue = conf_value;
					}
					else 
					{
						var newtxt=xmldoc.createTextNode(conf_value);
						y[0].appendChild(newtxt);
					}
					break;
				case 3:
//					alert('tag name split into 3');		
					var x = myDOMtree.getElementsByTagName(path[0]);
					if (x.length==0)
					{
						var newel=xmldoc.createElement(path[0]);
						myDOMtree.appendChild(newel);
						x = myDOMtree.getElementsByTagName(path[0]);
					}
					var y = x[0].getElementsByTagName(path[1]);
					if (y.length==0)
					{
						var newel=xmldoc.createElement(path[1]);
						x[0].appendChild(newel);
						y = x[0].getElementsByTagName(path[1]);
					}
					var z = y[0].getElementsByTagName(path[2]);
					if (z.length==0)
					{
						var newel=xmldoc.createElement(path[2]);
						var newtxt=xmldoc.createTextNode(conf_value);
						newel.appendChild(newtxt);
						y[0].appendChild(newel);
					}
					else if (z[0].childNodes[0])
					{
						z[0].childNodes[0].nodeValue = conf_value;
					}
					else 
					{
						var newtxt=xmldoc.createTextNode(conf_value);
						z[0].appendChild(newtxt);
					}
					break;
					default:
					alert('wrong tag name');
					break;
			} //switch
		} // if conf_tag
		counter ++;
	}//while
//all should be in the xml document now
}

 /**
* @fn 	  myxml2form(myDOMtree, formdata)
* @brief   this function fills input fields of a from with xml date by tag name
* @param formdata[io] pointer  to actual form
* @param myDOMtree[io] tree with data for form
* @return 	
*/  
function myxml2form(myDOMtree, formdata) {

try{
	if(myDOMtree.firstchild);
}
catch(err){
	alert ("Debug:no xml data in function myxml2form()!");
	return;
}

// assign to form fields:
if (formdata && formdata.name) {
	var looptag=formdata.name;
}// end "if formdata...."
else {
	alert("no form name assigned!");
	return;
}
var tempvalue ="";
var conf_tag;
var counter = 0;
var x0=new Array();
var x1=new Array();
var x2=new Array();
x2[0] = myDOMtree;
if (x2.length>0) {  //if loop tag exists in xml file
while (formdata[counter]){
	if (formdata[counter].name){ //only handle fields with name
		conf_tag=formdata[counter].name;
		var path = conf_tag.split("_"); //find correct place in xml tree first
		switch (path.length){
			case 1:
				conf_tag=path[0];	
				x1 = x2[0].getElementsByTagName(conf_tag);
			break;
			case 2:
				x1 = x2[0].getElementsByTagName(path[0]);
				if (x1.length>0)
					x1 = x1[0].getElementsByTagName(path[1]);
				else x1=new Array();
			break;
			case 3:
//				alert('tag name split into 3');		
				x1 = x2[0].getElementsByTagName(path[0]);
				if (x1.length>0){
					x1 = x1[0].getElementsByTagName(path[1]);
					if (x1.length>0)
						x1 = x1[0].getElementsByTagName(path[2]);
					//else x1=new Array();	
				}
				else x1=new Array();
			break;
			default:
				alert('wrong tag name');
			break;
		} //switch

		if (x1.length>0){ //if the conf_tag exists in XML file
			// read the value of the tag
			if (x1[0].childNodes.length>0) //tag not empty!
				var tempvalue = x1[0].childNodes[0].nodeValue;
			else tempvalue ="";
			if ((formdata[counter].type=="radio")){
					if(formdata[counter].value==tempvalue){
						formdata[counter].checked="checked";
					}
					else {
						formdata[counter].checked="";
					}
			}
			else if ((formdata[counter].type=="checkbox")){
				if((tempvalue=="TRUE")||(tempvalue=="2")){
						formdata[counter].checked="checked";
					}
					else {
						formdata[counter].checked="";
					}
			}
			else {//for input and select field just assign the value
				//TODO: (Fiona) find the input type control parsed from server configuration.
				//tempvalue = confTXTCheck(tempvalue);
				formdata[counter].value=tempvalue;
			}
		} //if the tag exists in XML File
	}//if field exists exists in form
	counter ++;
}//while
}//if looptag exists in xml tree
} //end of function myxml2form

//----------------------------------------------------------------------
//Parse the word '&', replaced by '&amp;'.
//----------------------------------------------------------------------
/*
function confTXTCheck(confTXT){
	
	var tempTXT = confTXT;
	
	alert("get value from input : "+inStr);
	var index = inStr.indexOf("&");
	if(index > 0){
		//find the character
		var inStrs = inStr.split('&');
		tempTXT = inStrs[0] + '&amp;' + inStrs[1];
		alert("result str is : "+tempTXT);
	}
	return tempTXT;
}
*/

//---------------------------------------------------------------------
//function to check if value of input field is in correct range
//---------------------------------------------------------------------
function formFieldRangeChk(field, valmin, valmax, valdef) {
	if (field.value < valmin ||field.value > valmax || field.value.match(/\D+/)) {
		alert("The value has to be in the range of "+valmin+" to "+valmax+"!\n");
		// field.focus(); //does not work for Firefox
		//field.value=valdef;
		field.value=preInputValue;
		return false;
	}
	return;
} //End formFieldRangeChk

var preInputValue=null;
function formFieldValueRead(field){		 
	    preInputValue=field.value;
}
//---------------------------------------------------------------------
//function to check if value of PIN input field is correct
//---------------------------------------------------------------------
//Not used in offline mode
//function formFieldPINChk(field, valdef) {
//	//var test1=field.value.match(/\D+/);
//	if (field.value.length != 4 || (field.value) > 9999 || (field.value) < 0 || field.value.match(/\D+/) ) {
//		alert("A PIN must be a four digit number!");
//		field.focus(); //does not work for Firefox
//		field.value=valdef;
//		return false;
//	}
//	return;
//} //End formFieldPINChk


//---------------------------------------------------------------------
//function to check if value of IP address input field is in correct range
// parameter valdef is the default value
//---------------------------------------------------------------------
function formFieldIPChk(field, valdef) {
	var unvalidflag=0;
	//empty field is okay, if default value is empty
	if (field.value ==""&& valdef =="")
		return;
	var oct = field.value.split(".");
	if (oct.length!=4){
		unvalidflag+=1;
	} //end if
	else {
		for (var i=0; i<4; i++){
			if (oct[i]<0||oct[i]>254||oct[i].match(/\D+/)||oct[i]==""||oct[i].length >3)
				unvalidflag+=1;
		} //end for
	}//end else
	if (unvalidflag>0) {
		alert("Invalid IP address:"+field.value+"\nHas to be four numbers between 0 and 254, separated with a '.' !");
		//field.focus(); //does not work for Firefox
		//field.value=valdef;
		field.value=preInputValue;
		return false;
	}
	return;
} //End formFieldIPChk


//---------------------------------------------------------------------
//function to check if value is as valid netmask.
// parameter valdef is the default value
//---------------------------------------------------------------------
function formFieldNetMaskChk(field, valdef) {
	var unvalidflag=0;
	var wasSmallerFF=0;
	var oct = field.value.split(".");
	if (oct.length!=4){
		unvalidflag+=1;
	} //end if
	else {
		for (var i=0; i<4; i++){
			if (oct[i]==0)
				wasSmallerFF+=1;
			else if (oct[i]==128||oct[i]==192||oct[i]==224||oct[i]==240||oct[i]==248||oct[i]==252||oct[i]==254){
				if (wasSmallerFF>0)
					unvalidflag+=1;
				else
					wasSmallerFF+=1;
			}//if 128 ... 254
			else if (oct[i]==255){
				if (wasSmallerFF>0)
					unvalidflag+=1;
			}// if 255
			else 
				unvalidflag+=1;
			if (oct[i]<0||oct[i]>255||oct[i].match(/\D+/)||oct[i]==""||oct[i].length >3)
				unvalidflag+=1;
		} //end for
	}//end else
	if (unvalidflag>0) {
		alert("Invalid Netmask: "+field.value);
		//field.focus(); //does not work for Firefox
		//field.value=valdef;
		field.value=preInputValue;
		return false;
	}
	return;
} //End formFieldNetMaskChk

//---------------------------------------------------------------------
//function to test text valid or not.
//---------------------------------------------------------------------
/* function FormfieldTextCheck(field)
{
   if(-1!=field.value.search(/[&<>"']/))
     field.value=preInputValue;
}*/
/*function FormfieldTextCheck(field)
{
	var flag = field.value.search(/[&]/);
	if(flag != -1){
		//find the invalid character
			//find such invalid character
			var resultStr = field.value;
			alert("invalid & has been found, the total input string is '"+field.value+"', the length is "+field.value.length);
	}else{
		alert("not found it!");
		field.value = preInputValue;	
	}
}*/

//invalid words list:
//< &#60; &lt;
//> &#62; &gt;
//" &#34; &quot;
//' &#39; null
var invalidWords = new Array("&#60;","&lt;","&#62;","&gt;","&#34;","&quot;", "&#39;","<",">","'");


//add filter for & symbol and its encoded words.
function checkSpecial(field){
	
	//alert("inside for adjusting!");
	var preWords = field.value;	
	//alert("word list length: "+invalidWords.length);
	for(var i=0; i < invalidWords.length; i++){
		
		var preStr = preWords.toString();
		
		if(-1 != preStr.search(invalidWords[i].toString())){
			//field.value=preInputValue;
			return false;
		
		}
	}//end of for loop
	
	return true;
}

//"&#60;","&lt;","&#62;","&gt;","&#34;","&quot;", "&#39;","<",">","'"
function FormfieldTextCheck(field)
{
	//alert("inside old entry!");
   if(-1!=field.value.search(/["]/))
     field.value=preInputValue;
	 
   if(false == checkSpecial(field)){
	 field.value=preInputValue; 
	}
	//alert("check has been done!");
}