/**
* Copyright (C) 2008, BOSCH Security Systems (Zhuhai)
* 
* Project: FPA-1000
*
* @file  xml_tools.js
*
* @brief load or creat xml file
* 
* @author Tony
*
* @date Created: 2008/08/12
*
* $Source: /Repo-Fire/Projects/21_FirePanelPrototype/21_FirePanelPrototype_PWD/SW/CFP-webpage-offline/essential_htmls/xml_tools.js,v $
*
* @version $Revision $
*
* History: 
*  $Log: xml_tools.js,v $
*  Revision 1.9  2009/05/27 05:46:26  wau2zhu
*  commit the first offline release ver1.1 by Fiona Wang. change the language displayed.
*
*  Revision 1.8  2009/05/25 09:33:51  wau2zhu
*  commit by Wang Yujing, removed unused function
*
*  Revision 1.7  2009/04/15 00:56:20  zhx2zhu
*  no message
*
*  Revision 1.6  2009/04/10 03:53:10  zhx2zhu
*  no message
*
*  Revision 1.5  2009/03/31 03:43:10  zhx2zhu
*  no message
*
*  Revision 1.4  2008/09/01 03:21:30  zhx2zhu
*  make the doxygen header well-formed
*
*  Revision 1.3  2008/08/15 07:00:08  zhx2zhu
*  no message
*
*  Revision 1.2  2008/08/15 06:12:14  zhx2zhu
*  addming doxygen header
*
*/
//---------------------------------------------------------------------
// Self-made importNode function
//---------------------------------------------------------------------
function CloneNodebetween2XMLs(XMLdoc,node, allChildren) {
	if (document.ELEMENT_NODE == null) {
  	//alert("Yes,ELEMENT_NODE is null!");
	document.ELEMENT_NODE = 1;
  	document.ATTRIBUTE_NODE = 2;
  	document.TEXT_NODE = 3;
  	document.CDATA_SECTION_NODE = 4;
  	document.ENTITY_REFERENCE_NODE = 5;
  	document.ENTITY_NODE = 6;
  	document.PROCESSING_INSTRUCTION_NODE = 7;
  	document.COMMENT_NODE = 8;
  	document.DOCUMENT_NODE = 9;
  	document.DOCUMENT_TYPE_NODE = 10;
  	document.DOCUMENT_FRAGMENT_NODE = 11;
  	document.NOTATION_NODE = 12;
	}
    switch (node.nodeType) {
      case document.ELEMENT_NODE:
           var newnode = XMLdoc.createElement(node.nodeName);
        /* are we going after children too, and does ?
the node have any? */
        if (allChildren&& node.childNodes && node
.childNodes.length > 0)
          for (var i = 0;  i < node.childNodes.length; 
i++)
            newnode.appendChild(CloneNodebetween2XMLs 
(XMLdoc,node.childNodes[i], true));
        return newnode;
        break;
      case document.TEXT_NODE:
        // globalnode.appendChild(XMLDoc.createTextNode(node.nodeValue));
		var newnode=XMLdoc.createTextNode(node.nodeValue);
		return newnode;
        break;
    }
  }


/**
* @fn 	myloadXMLDoc(dname)
* @brief function to load a xmlDOM tree from a xml file
* @param dname[in] file name of xml file
* @return 
*/  
function myloadXMLDoc(dname)
{
	var xmlDoc;
	// code for IE
	if (window.ActiveXObject)
	{
		xmlDoc=new ActiveXObject("Microsoft.XMLDOM");
	}
	// code for Mozilla, Firefox, Opera, etc.
	else if (document.implementation && document.implementation.createDocument)
	{
		xmlDoc=document.implementation.createDocument("","",null);
	}
	else
	{
		alert('Your browser cannot handle this script');
	}
	xmlDoc.async=false;
	xmlDoc.load(dname);
return(xmlDoc);
}
/**
* @fn 	mycreateXMLdoc()
* @brief function to create a xmlDOM tree
* @return 
*/
function mycreateXMLdoc()
{
// code for IE
if (window.ActiveXObject)
  {
  var xmlDoc=new ActiveXObject("Microsoft.XMLDOM");
  }
// code for Mozilla, Firefox, Opera, etc.
else if (document.implementation &&
document.implementation.createDocument)
  {
  var xmlDoc=document.implementation.createDocument("","",null);
  }
else
  {
  alert('Your browser cannot handle this script');
  }
return(xmlDoc);
}
var ProgramChangeFlag;
var xmldoc;

function Readformdata(formdata)
{
  	if (formdata && formdata.name) 
	{	
		var looptag=formdata.name;
	}// end "if fromdata...."
	else
	{
		alert("no form name assigned!");
		return;
	}
	var loopxmldoc = xmldoc.getElementsByTagName(looptag);
	if (loopxmldoc.length>0) {  //if loop tag exists in xml file
		myxml2form(loopxmldoc[0], formdata); 
	}
	else
	{
	 	alert("Debug information:\n The xml doc doesn't contain a tree node with same name as the assigined form has!");
		return ;
	}
}
var open_success=false;

function LoadConfiguration(LoadFromDefault){
	
	if(LoadFromDefault)
	{// true flow
		xmldoc=myloadXMLDoc("./essential_htmls/FPA1000Default.xml");
		if((!xmldoc)||(!xmldoc.getElementsByTagName("GENERAL").length))
			document.getElementById("Layer39").innerHTML="Debug information:Fail to create a new file or restore the file to default!";       else
		{
			open_success=true;
			document.getElementById("Layer39").innerHTML="Create new file or restore file to default successfully!";
		}
	}
	else
	{// false flow
		if(!document.form_File_Select.ConFileSelect.value)
	  	{
           alert("Please specify the local file to load!");
			return;  
	 	 }
		else
		   xmldoc=myloadXMLDoc(document.form_File_Select.ConFileSelect.value);	
		if((!xmldoc)||(!xmldoc.getElementsByTagName("GENERAL").length))
		{
				
			document.getElementById("Layer39").innerHTML="Fail to load configuration file,please check the file!";
		}
		else
		{	
			open_success=true;
			document.getElementById("Layer39").innerHTML="Load configuration file successfully!";
		}
	}
	//	}
		//catch(err){
		//	document.getElementById(DebugWindow)[0].innerHTML="Fail to open or restore configuration file!";
			
		//}	
}

function initSiteData(){
		try{
			xmldoc=this.opener.xmldoc;
			}
		catch(err){
			alert("No configuration file found!");
		}
		Readformdata(document.getElementById("GENERAL"));
}

function initMainBoard(){
	    try{
			xmldoc=this.opener.xmldoc;
			}
		catch(err){
			alert("No configuration file found!");
		}
		Readformdata(document.getElementById("MAINBOARD"));
		 
}

function initOptionBus(){
	    try{
			xmldoc=this.opener.xmldoc;
			}
		catch(err){
			alert("No configuration file found!");
		}
		Readformdata(document.getElementById("OPTIONBUS"));
		 
}

function initReporting(){
	    try{
			xmldoc=this.opener.xmldoc;
			}
		catch(err){
			alert("No configuration file found!");
		}
		Readformdata(document.getElementById("REPORT"));
		 
}

function initZones(){
	    try{
			xmldoc=this.opener.xmldoc;
			}
		catch(err){
			alert("No configuration file found!");
		}
		Readformdata(document.getElementById("ZONES"));
		 
}

//---------------------------------------------------------------------
//Scripts to implement the SW zone configuration of FPA-1000-UL
//---------------------------------------------------------------------

//--------------------------------------------------------------------
//this function restores SW zones from server and refreshes zone display
//uses global: 
//--------------------------------------------------------------------
function SWZrestoreFromxml () {
	var MyDOMtree=this.opener.xmldoc.getElementsByTagName("ZONES")[0];
	xmldoc=mycreateXMLdoc();
	xmldoc.appendChild(CloneNodebetween2XMLs(xmldoc,MyDOMtree,true));
SWZdisplaySWZones (); //refesh		
} //end of SWZrestoreFromxml()

function SWZsaveToHTA(){
	var HTAMyDOMTree=this.opener.xmldoc.getElementsByTagName("ZONES")[0];
	allzones = HTAMyDOMTree.getElementsByTagName("Zone");
	for(var i=0;i<allzones.length;i++)
	   HTAMyDOMTree.removeChild(allzones[i]);
	
	var MyDOMtree=xmldoc.getElementsByTagName("ZONES")[0];
	var Localallzones=MyDOMtree.getElementsByTagName("Zone");
	for(var i=0; i<Localallzones.length;i++)
	{
		var node=CloneNodebetween2XMLs(this.opener.xmldoc,Localallzones[i],true);
		HTAMyDOMTree.appendChild(node);
	}
}

var allzones;
//--------------------------------------------------------------------
//this function displays all SW Zones in a table
//uses global: xmldoc
//
//--------------------------------------------------------------------
function SWZdisplaySWZones (){
//create document root if it does not exist
if(!xmldoc) {
	xmldoc=mycreateXMLdoc();
	var newel=xmldoc.createElement("FPA1000");
	xmldoc.appendChild(newel);
}
//for IE
if(!xmldoc.firstChild) {
	var newel=xmldoc.createElement("FPA1000");
	xmldoc.appendChild(newel);
}
//creat zone tag if not exists
var zonexmldoc = xmldoc.getElementsByTagName("ZONES");
if (zonexmldoc.length==0){
	var newel=xmldoc.createElement("ZONES");
	xmldoc.firstChild.appendChild(newel);
	zonexmldoc = xmldoc.getElementsByTagName("ZONES");
}

var targetwindow="SWZones_";
var SWZPattern=new Array("Default","Steady","Pulsing","Temporal Code 3");
SWZxmlTags=new Array("ZoneNum","Label","Pattern","Counting","Bypassed","Networked");
SWZxmlTagDefaults=new Array("","","0","1","FALSE","FALSE");
var SWZTagsNames=new Array("Zone No","Label","Pattern","Counting","Bypassed","Networked");
var str="";

allzones = zonexmldoc[0].getElementsByTagName("Zone");
//todo add handling to fill not existing zones 
//todo sort the zones by zone number
str="<TABLE border='1'>";
//header
str+="<TR><TH>Zone No</TH><TH>Label</TH><TH>Pattern</TH><TH>Counting</TH><TH>Bypassed</TH><TH>Networked</TH><TH>Configure</TH><TH>Set default</TH></TR>";
for (var i=0; i<allzones.length; i++) {
	if (allzones[i].getElementsByTagName('ZoneNum')[0].firstChild)
		var znum=allzones[i].getElementsByTagName('ZoneNum')[0].firstChild.nodeValue;
	else var znum="";
	if (allzones[i].getElementsByTagName('Label')[0].firstChild)
		var lab=allzones[i].getElementsByTagName('Label')[0].firstChild.nodeValue;
	else var lab="";
	if (allzones[i].getElementsByTagName('Pattern')[0].firstChild) {
		var pat=allzones[i].getElementsByTagName('Pattern')[0].firstChild.nodeValue;
		var patname=SWZPattern[eval(pat)];
	} //end if (allzones ...
	else var patname="";
	if (allzones[i].getElementsByTagName('Counting')[0].firstChild)
		var count=allzones[i].getElementsByTagName('Counting')[0].firstChild.nodeValue;
	else var count="";
	if (allzones[i].getElementsByTagName('Bypassed')[0].firstChild)
		var bp=allzones[i].getElementsByTagName('Bypassed')[0].firstChild.nodeValue;
	else var bp="";
	if (allzones[i].getElementsByTagName('Networked')[0].firstChild)
		var nw=allzones[i].getElementsByTagName('Networked')[0].firstChild.nodeValue;
	else var nw="";
	var conf='<input type="button" value="Configure" onclick="javascript:ProgramChangeFlag=1; SWZButtonConfigure('+i+')"/>';
	var rem="";
	rem='<input type="button" value="Set default" onclick="javascript:ProgramChangeFlag=1; SWZButtonSetDefaults('+i+' )"/>';
	str+="<TR><TD>"+znum+"</TD><TD>"+lab+"</TD><TD>"+patname+"</TD><TD>"+count+"</TD><TD>"+bp+"</TD><TD>"+nw+"</TD><TD>"+conf+"</TD><TD>"+rem+"</TD></TR>";
} //end for
str+="</TABLE>";
document.getElementById(targetwindow).innerHTML=str;
return;
}//end function SWZdisplaySWZones


//--------------------------------------------------------------------
//this function all config data in one SW zone to default values
//uses global: xmldoc
//
//--------------------------------------------------------------------
function SWZButtonSetDefaults (zoneno){

for (var i=1; i<SWZxmlTags.length; i++) {
	if (allzones[zoneno].getElementsByTagName(SWZxmlTags[i])[0].firstChild)
		allzones[zoneno].getElementsByTagName(SWZxmlTags[i])[0].firstChild.nodeValue=SWZxmlTagDefaults[i];
} //end for all tags
SWZdisplaySWZones();
return;
}//end function SWZButtonSetDefaults


//--------------------------------------------------------------------
//this function sets all config values in all SW Zones to default values
//uses global: xmldoc
//
//--------------------------------------------------------------------
function SWZButtonSetAllDefaults (){

for (var j=0; j<allzones.length; j++) {
	for (var i=1; i<SWZxmlTags.length; i++) {
		if (allzones[j].getElementsByTagName(SWZxmlTags[i])[0].firstChild)
			allzones[j].getElementsByTagName(SWZxmlTags[i])[0].firstChild.nodeValue=SWZxmlTagDefaults[i];
	} //end i for all tags
} //end j for all zones 
SWZdisplaySWZones();
return;
}//end function SWZButtonSetAllDefaults


//--------------------------------------------------------------------
//this function opens dialogue to configure zone parameters
//uses global: xmldoc, allzones
//
//--------------------------------------------------------------------
function SWZButtonConfigure (pzonenum){
//SWZdisplaySWZones();
currentDeviceDOMtree=allzones[pzonenum];
//
MyWindow = window.open("DCP_SWZone.html", "ZweitfensterDCP", "width=848,height=300,left=100,top=20");
MyWindow.focus();
return;
}//end function SWZButtonConfigure


