//this javascript file added for converting configuration file from REL1.x to REL2.0
var DebugField = null;

function start_convert()
{
	var pathID = "convert_file";
	var conf_tags = new Array("HEADER","GENERAL","LOOP1","LOOP2","MAINBOARD","OPTIONBUS","REPORT","ZONES");
	var FilePath = document.getElementById(pathID).value;
	
	var src_xmldoc = null;
	var tar_xmldoc = null;
	var srcElem = null;
	var tarElem = null;
	DebugField = document.getElementById("Layer39");
	if ("" == FilePath)
	{
		alert(warnMsg_Offline(11));//alert("First select the configuration file you want to convert.");
	}
	else
	{
		src_xmldoc = myloadXMLDoc(FilePath);	
		if (!src_xmldoc)
		{	//loading failed
			alert(warnMsg_Offline(1));
		}
		else
		{
			var Verobj = src_xmldoc.getElementsByTagName("DataVersion");
			if (0 == Verobj.length)
			{
				alert(warnMsg_Offline(12));//alert("The configuration file may be corrupted. Conversion failed. Provide a valid file.");
				return;
			}
			else
			{
				var VerValue = Verobj[0].firstChild.nodeValue;
				if (1. != VerValue.substring(0,2))
				{
					if (2.0 == VerValue)
					{
						alert(warnMsg_Offline(15));//alert("Input file version is already 2.0!");
					}
					else
					{
						alert(warnMsg_Offline(12));//alert("The configuration file may be corrupted. Conversion failed. Provide a valid file.");
					}
					return;
				}
			}
			tar_xmldoc = src_xmldoc.cloneNode(true);
			show_info(13);//show_info("Conversion running");
			for (var i = 0; i < conf_tags.length; i++)
			{
				srcElem = src_xmldoc.getElementsByTagName(conf_tags[i])[0];
				tarElem = tar_xmldoc.getElementsByTagName(conf_tags[i])[0];
				if (null == srcElem)
				{
					alert(warnMsg_Offline(12));//alert("The configuration file may be corrupted. Conversion failed. Provide a valid file.");
					return;
				}
				else
				{
					dispatch_convert(srcElem, tarElem, conf_tags[i]);
				}
			}
			convert_network(tar_xmldoc);
			tar_xmldoc.save(FilePath);
			show_info(14);//show_info("The conversion of the configuration file was successful.");
		}
	}
}

function dispatch_convert(srcElem, tarElem, tagname)
{
	if (null == srcElem || null == tarElem)
	{
		return;
	}
	
	switch(tagname)
	{
		case "HEADER":
			convert_header(tarElem);
			break;
		case "GENERAL":
			convert_general(tarElem);
			break;
		case "LOOP1":
		case "LOOP2":
			convert_loop(tarElem);
			break;
		case "MAINBOARD":
			convert_MB(tarElem);
			break;
		case "OPTIONBUS":
			convert_OB(tarElem);
			break;
		case "REPORT":
			convert_RP(tarElem);
			break;
		case "ZONES":
			convert_zones(tarElem);
			break;
		/*case "NETWORK":
			convert_network(tarElem);
			break;*/
		default:
			break;
	}	
}

function convert_header(tarElem)
{
	//update_tag_value("DataVersion", "2.0");
	var taglist = new Array("DataVersion,2.0");
	update_tags(tarElem, taglist, null);
}

function convert_general(tarElem)
{
	var newtags = new Array("PrintWide,1", 
							"TimeSyncEnable,FALSE", 
							"NTPIP,192.168.0.1",
							"NTPPort,123",
							"PanelID,1",
							"NetworkID,1");
	
	//adjust level value in v2.0
	var lvobjs = new Array("HistoryLv",
						   "WalktestLv",
						   "TestLv",
						   "DateLv",
						   "BypassLv");
	var lvValues = new Array("1","2","2","1","2");
	var updatedLvTags = new Array(5);
	
	for (var i = 0; i < lvobjs.length; i++)
	{
		var LvObj = tarElem.getElementsByTagName(lvobjs[i]);
		if (0 < LvObj.length)
		{
			if (2 >=  LvObj[0].firstChild.nodeValue)
			{
				lvValues[i] = parseInt(LvObj[0].firstChild.nodeValue) + 1;
			//alert("level before = " + LvObj[0].firstChild.nodeValue + " new =" + lvValues[i]);}
			}
		}
		updatedLvTags[i] = lvobjs[i] + "," + lvValues[i];
		//alert(updatedLvTags[i]);
	}
	
	update_tags(tarElem, newtags, null);
	update_tags(tarElem, updatedLvTags, null);
}

function convert_loop(tarElem)
{
	var DevType = null;
	var alldevices = tarElem.getElementsByTagName('Device');
	
	for (var i = 0; i < alldevices.length; i++)
	{
		DevType = parseInt(alldevices[i].getElementsByTagName('DeviceType')[0].firstChild.nodeValue); 
		
		if ((0 <= DevType) && (2 >= DevType)) 
		{	//no need to process
			//alert("no need to process");
			continue;
		}
		else if (is_input_device(DevType))
		{	//input devices
			//alert("input device, divice number =" + DevType);
			if ((20 == DevType)||(21 == DevType))//removed device: FLM-325-IW-A, FLM-325-IW-AI
			{
				tarElem.removeChild(alldevices[i]);
			}			
			
			if ((8 == DevType)||(18 == DevType)||(19 == DevType)) //FLM-325-I4, FLM-325-I4-A, FLM-325-I4-AI, 
			{
				if(1 == alldevices[i].getElementsByTagName('DelayMode')[0].firstChild.nodeValue)
				{
					alldevices[i].getElementsByTagName('DelayMode')[0].firstChild.nodeValue = 0;	
				}
				if(3 == alldevices[i].getElementsByTagName('DelayMode')[0].firstChild.nodeValue)
				{
					alldevices[i].getElementsByTagName('DelayMode')[0].firstChild.nodeValue = 1;	
				}
			}
			
			if (11 == DevType) //FLM-325-2I4
			{

				var objinput1 = alldevices[i].getElementsByTagName('Input1')[0];
				if(1 == objinput1.getElementsByTagName('DelayMode')[0].firstChild.nodeValue)
				{
					objinput1.getElementsByTagName('DelayMode')[0].firstChild.nodeValue = 0;	
				}
				if(3 == objinput1.getElementsByTagName('DelayMode')[0].firstChild.nodeValue)
				{
					objinput1.getElementsByTagName('DelayMode')[0].firstChild.nodeValue = 1;	
				}
				
				var objinput2 = alldevices[i].getElementsByTagName('Input2')[0]; 
				if(1 == objinput2.getElementsByTagName('DelayMode')[0].firstChild.nodeValue)
				{
					objinput2.getElementsByTagName('DelayMode')[0].firstChild.nodeValue = 0;	
				}
				if(3 == objinput2.getElementsByTagName('DelayMode')[0].firstChild.nodeValue)
				{
					objinput2.getElementsByTagName('DelayMode')[0].firstChild.nodeValue = 1;	
				}
				append_pids(objinput1);
				append_pids(objinput2);
			}
			else
			{
				append_pids(alldevices[i]);
			}
			
			if ((4 == DevType) || (26 == DevType))
			{
				var objDuctRelay = alldevices[i].getElementsByTagName('DuctRelay')[0];
				adjust_glob_zones(objDuctRelay);
			}
			//Adjust point type
			if ((18 == DevType) || (19 == DevType))
			{
				var objInputType = alldevices[i].getElementsByTagName('InputType')[0];
				if (1 == objInputType.firstChild.nodeValue)
				{
					var objPT = alldevices[i].getElementsByTagName('PointType')[0];
					if ((0 <= objPT.firstChild.nodeValue) && (5 >= objPT.firstChild.nodeValue))
					{
						objPT.firstChild.nodeValue = 6;
					}
				}
			}
		}
		else
		{	//output devices
			//alert("output devices");
			adjust_glob_zones(alldevices[i]);
		}
	}
}

function convert_MB(tarElem)
{
	var newtags = new Array("CityTieWide,1");
	var CTnode = tarElem.getElementsByTagName('CityTie')[0];
	var CT1node = CTnode.getElementsByTagName('CityTie1')[0];
//	alert("convert_MB");
	update_tags(CTnode, newtags, CT1node);

	if (0 < CTnode.getElementsByTagName('Enable').length)
	{
		var enablenode = CTnode.getElementsByTagName('Enable')[0];
		var installvalue = enablenode.firstChild.nodeValue;
		CTnode.removeChild(enablenode);
		if ("TRUE" == installvalue)
		{
			var installtag = new Array("Installed,TRUE");
		}
		else
		{
			var installtag = new Array("Installed,FALSE");
		}
		var widenode = CTnode.getElementsByTagName('CityTieWide')[0];
		update_tags(CTnode, installtag, widenode);
	}
	
	if (0 < CT1node.getElementsByTagName('Drillenceable').length)
	{
		var drillnode1 = CT1node.getElementsByTagName('Drillenceable')[0];
		var Silencevalue1 = drillnode1.firstChild.nodeValue;
		CT1node.removeChild(drillnode1);
		if ("TRUE" == Silencevalue1)
		{
			var silencetag1 = new Array("Silenceable,TRUE");
		}
		else
		{
			var silencetag1 = new Array("Silenceable,FALSE");
		}
		var Bypnode1 = CT1node.getElementsByTagName('Bypassed')[0];
		update_tags(CT1node, silencetag1, Bypnode1);
	}

	var CT2node = CTnode.getElementsByTagName('CityTie2')[0];
	if (0 < CT2node.getElementsByTagName('Drillenceable').length)
	{
		var drillnode2 = CT2node.getElementsByTagName('Drillenceable')[0];
		var Silencevalue2 = drillnode2.firstChild.nodeValue;
		CT2node.removeChild(drillnode2);
		if ("TRUE" == Silencevalue2)
		{
			var silencetag2 = new Array("Silenceable,TRUE");
		}
		else
		{
			var silencetag2 = new Array("Silenceable,FALSE");
		}
		var Bypnode2 = CT2node.getElementsByTagName('Bypassed')[0];
		update_tags(CT2node, silencetag2, Bypnode2);
	}

	adjust_glob_zones(tarElem);
}

//convert 1.x to 2.01: 
//1:clear the repeat tag to false
//2:clear zone 65~128 
function adjust_OBRepeatLED(nodeobj)
{
	var ann_name = "Ann";
	var anntag = null;
	
	if (null == nodeobj)
	{
		return;
	}
	//for 1.x version the repeat meaning is repeat function,
	//for v2.01, repeat == false:choose 1~128; repeat==true:chosse 129~255
	if ("TRUE" == nodeobj.getElementsByTagName('RepeatLED1to4')[0].firstChild.nodeValue)
	{
		nodeobj.getElementsByTagName('RepeatLED1to4')[0].firstChild.nodeValue = "FALSE";	

		//Please note that option "Repeat zone 1-64" for LED annunciators on V1.xx is no longer available on V2.xx. Zone LEDs will be mapped to zones 1-128 in conversion.
		/*for (var i = 5; i <= 8; i++)
		{
			anntag = ann_name + i;
			var annnodes = nodeobj.getElementsByTagName(anntag)[0];

			if( "TRUE" == annnodes.getElementsByTagName('D7030x')[0].firstChild.nodeValue)
			{
				annnodes.getElementsByTagName('D7030x')[0].firstChild.nodeValue = "FALSE";
			}

			if( "TRUE" == annnodes.getElementsByTagName('D7032')[0].firstChild.nodeValue)
			{
				annnodes.getElementsByTagName('D7032')[0].firstChild.nodeValue = "FALSE";
			}
		}*/
	}	
	
}

function convert_OB(tarElem)
{
	
	adjust_glob_zones(tarElem);
	adjust_OBRepeatLED(tarElem);	
}

function convert_RP(tarElem)
{
	var RP_newtags = new Array("ReportWide, 1");
	var RP_node = tarElem.getElementsByTagName("Reporting")[0];
	update_tags(RP_node, RP_newtags, null);

	if (0 == tarElem.getElementsByTagName("Email").length)
	{
		//append email node
		var emailnode = creat_new_node(new Array("Email"));
		var emailsubtags = new Array("EmailEnable,FALSE",
									 "Addr1,",
									 "Addr2,",
									 "Addr3,",
									 "Addr4,",
									 "SMTPIP,",
									 "SMTPPort,0",
									 "SMTPUser,",
									 "SMTPPwd,");
		update_tags(emailnode, emailsubtags, null);
		tarElem.appendChild(emailnode);
	}
	
    if (0 == tarElem.getElementsByTagName("Line1RingCount").length)
	{
		var PSTN_newtags = new Array("Line1RingCount, 0");
		var PSTN_node = tarElem.getElementsByTagName("PSTN")[0];
		update_tags(PSTN_node, PSTN_newtags, null);
	}
//remove auto dialing type
/*	var dialnode = tarElem.getElementsByTagName("Dialing");
	if (0 < dialnode.length)
	{
		if (2 == dialnode[0].firstChild.nodeValue)
		{
			dialnode[0].firstChild.nodeValue = 0;
		}
	}*/
}

function convert_zones(tarElem)
{
	var zonecp = tarElem.cloneNode(true);
	//clear the target zone tag
	while(tarElem.hasChildNodes())
	{
		tarElem.removeChild(tarElem.lastChild);
	}
	//update global zones
	update_global_zones(zonecp, tarElem);
	//update group zones
	update_group_zones(tarElem);
	//update local zones
	update_local_zones(zonecp, tarElem);
	//update dual zones
	update_dual_zones(zonecp, tarElem);
	//update floors
	update_floors(zonecp, tarElem);
}

function convert_network(tar_xmldoc)
{
    var FPAnode = tar_xmldoc.getElementsByTagName("FPA1000")[0];
	
	if (0 == tar_xmldoc.getElementsByTagName("NETWORK").length)
	{
		var Networknode = creat_new_node(new Array("NETWORK"));
		var Networktags = new Array("SWBInstall,FALSE",
									 "Topology,0",
									 "Supervise1,TRUE",
									 "Supervise2,TRUE",
									 "Supervise3,TRUE",
									 "Supervise4,FALSE",
									 "Supervise5,FALSE",
									 "NetNode,");
		update_tags(Networknode, Networktags, null);
		
		FPAnode.appendChild(Networknode);
	}
}

function update_floors(srcElem, tarElem)
{
    var Maxfloor_old = 32;
    var Maxfloor_new = 64;
    var Fs_node = creat_new_node(new Array("Floors"));
	var old_subtag_list = new Array("Sandwich","Label");
	var updatedFlTags = new Array(2);

    for (var i = 1; i <= Maxfloor_old; i ++)
	{
		var floor_old = srcElem.getElementsByTagName("Floor" + i)[0];
		for (var j = 0; j < old_subtag_list.length; j++)
		{
			var tempnode = floor_old.getElementsByTagName(old_subtag_list[j]);
			if (0 < tempnode.length)
			{
				if (tempnode[0].firstChild)
				{
					var tempvalue = tempnode[0].firstChild.nodeValue;
					updatedFlTags[j] = old_subtag_list[j] + "," + tempvalue;
					continue;
				}
			}
			updatedFlTags[j] = old_subtag_list[j] + ",";
		}
		var floornode = creat_new_node(new Array("Floor" + i));
		update_tags(floornode, updatedFlTags, null);
		Fs_node.appendChild(floornode);
	}

	//append floor node
    for (i = (Maxfloor_old + 1); i <= Maxfloor_new; i ++)
	{
		var floornode = creat_new_node(new Array("Floor" + i));
		var floorsubtags = new Array("Sandwich,FALSE",
									 "Label,");
		update_tags(floornode, floorsubtags, null);
		Fs_node.appendChild(floornode);
	}
	
	tarElem.appendChild(Fs_node);	
}

function update_dual_zones(srcElem, tarElem)
{
    var Dzs_node = creat_new_node(new Array("DualZones"));
    var Max_group = 6;
	var Max_pair = 3;
	var Max_part = 2;
    var Psublist = new Array(12); //new sub lists under group[i]
	var Psubtags = new Array(12); //new sub tags (list and value) under group[i]
	var p_cnt = 0;

	for (var i = 1; i <= Max_group; i++)
	{
		p_cnt = 0;

		/* get value for Group[i]Pair[j][k] from old value in Group[x]Pair[y][z], 
		 * group 1: x = i;   y = j;   z = k;
		 * group 2: x = i-1; y = j+3; z = k;
		 * group 3: x = i-1; y = j;   z = k;
		 * group 4: x = i-2; y = j+3; z = k;
		 * group 5: x = i-2; y = j;   z = k;
		 * group 6: x = i-3; y = j+3; z = k;*/ 
		var x = i - Math.floor(i/2);
		var group_old = srcElem.getElementsByTagName("group" + x)[0];

		for (var j = 1; j <= Max_pair; j++)
		{
			var y = ((0 == (i%2))?(j + Max_pair):j);

			for (var k = 1; k <= Max_part; k++)
			{			
				//list name for Pair
				Psublist[p_cnt] = "Pair" + j + k;
				//tags for Pair (value is from old value)
				var tempnode = group_old.getElementsByTagName("Pair" + y + k);
				if (0 < tempnode.length)
				{
					if (tempnode[0].firstChild)
					{
						var tempvalue = tempnode[0].firstChild.nodeValue;
						Psubtags[p_cnt] = Psublist[p_cnt] + "," + tempvalue;
					}
					else
					{
						Psubtags[p_cnt] = Psublist[p_cnt] + ",";
					}
				}
				else
				{
					Psubtags[p_cnt] = Psublist[p_cnt] + ",";					
				}
				p_cnt++;

				//list name for pID
				Psublist[p_cnt] = "PPid" + j + k;
				//tags for pID (value is 1)
				Psubtags[p_cnt] = Psublist[p_cnt] + "," + 1;
				p_cnt++;					
			}
		}

		var groupnode = creat_new_node(new Array("group" + i));
		update_tags(groupnode, Psubtags, null);
		Dzs_node.appendChild(groupnode);
	}
	tarElem.appendChild(Dzs_node);	
}

function update_local_zones(srcElem, tarElem)
{
	var old_subtag_list = new Array("ZoneNum","Label","Pattern","Counting","Bypassed","Floor");
	var new_subtag_list = new Array("N","L","P","C","B","F");
	var default_value   = new Array("","","0","1","0","0");
	var new_GP_tags = new Array("PID,1",
								"Confirm,TRUE");
	var new_subtag = new Array(6);
	var NewZ = null;
	var tempnode = null;
	var tempvalue = null;	
	var allzones = srcElem.getElementsByTagName("Zone");	
	
	var NewPWZ = creat_new_node(new Array("PanelWideZones"));
	var NewGP = creat_new_node(new Array("GroupPanel"));
	//creat <PID> tag and <Confirm> tag
	update_tags(NewGP, new_GP_tags, null);

	for (var i = 0; i < allzones.length; i++)
	{
		NewZ = creat_new_node(new Array("Z"));
		for (var j = 0; j < old_subtag_list.length; j++)
		{
			tempnode = allzones[i].getElementsByTagName(old_subtag_list[j]);
			if (0 < tempnode.length)
			{
				if (tempnode[0].firstChild)
				{
					tempvalue = tempnode[0].firstChild.nodeValue;
					if ("Bypassed" == old_subtag_list[j]) //bypassed
					{
						if ("FALSE" == tempvalue)
						{
							tempvalue = 0;
						}
						else
						{
							tempvalue = 1;
						}
					}
				}
				else
				{
					tempvalue = default_value[j];
					
					if ("ZoneNum" == old_subtag_list[j]) //zone number
					{
						tempvalue = i + 1;
					}
				}
			}
			else
			{
				tempvalue = default_value[j];
				
				if ("ZoneNum" == old_subtag_list[j]) //zone number
				{
					tempvalue = i + 1;
				}
			}	
			
			new_subtag[j] = new_subtag_list[j] + "," + tempvalue;
			
//			alert(new_subtag[j]);
		}
		update_tags(NewZ, new_subtag, null);	
		NewGP.appendChild(NewZ);
	}
	NewPWZ.appendChild(NewGP);
	tarElem.appendChild(NewPWZ);
}

function update_group_zones(tarElem)
{
	var SWZxmlTags = new Array("N,0",
							   "L,",
							   "P,0", 
							   "C,1",
							   "B,0",
							   "F,0");
	var GP_ZONE_BGN = 129; //group zone begin
	var GP_ZONE_END = 225; //group zone end
	var NewZ = null;
	//creat <GroupPanel> tag
	var NewGP = creat_new_node(new Array("GroupWideZones"));
	//creat 128 <z> tags
	for (var j = GP_ZONE_BGN; j <= GP_ZONE_END; j++)
	{
		NewZ = creat_new_node(new Array("Z"));;
		//creat <N> tag
		SWZxmlTags[0] = "N," + j;
		update_tags(NewZ, SWZxmlTags, null);
		
		NewGP.appendChild(NewZ);
	}	

	tarElem.appendChild(NewGP);		
}

function update_global_zones(srcElem, tarElem)
{
	//global zones
	var globmin = 226;
	var globmax = 234;
	var pattnode = new Array("Pattern,0");
	//update the golbal zones 
	for (var i = globmin; i < globmax; i++)
	{
		var globnode = creat_new_node(new Array("Zone" + i));
		var prezone = srcElem.getElementsByTagName("Zone" + (i - 97));//from 129 to 136
		if (0 < prezone.length)
		{
			//just copy Label and Pattern
			var lable_node = prezone[0].getElementsByTagName("Label");
			if (0 < lable_node.length)
			{
				globnode.appendChild(lable_node[0]);
			}
			
			var pattern_node = prezone[0].getElementsByTagName("Pattern");
			if (0 < pattern_node.length)
			{
				globnode.appendChild(pattern_node[0]);
			}
			
			//globnode.appendChild(pattern_node);
		}
		
		if ((229 <= i) && (232 >= i))
		{
			update_tags(globnode, pattnode, null);
		}	
		tarElem.appendChild(globnode);
	}
}

function adjust_glob_zones(nodeobj)
{
	var zoneprefix = "Zone";
	var zonetag = null;
	var diffvalue = 97;
	
	if (null == nodeobj)
	{
		return;
	}
	
	for (var i = 1; i <= 5; i++)
	{
		zonetag = zoneprefix + i;
		var zonenodes = nodeobj.getElementsByTagName(zonetag);
		//alert("zonenodes length="+zonenodes.length);
		for (var j = 0; j < zonenodes.length; j++)
		{
			var zoneNo = parseInt(zonenodes[j].firstChild.nodeValue);
			if ((129 <= zoneNo) && (136 >= zoneNo))
			{
				zonenodes[j].firstChild.nodeValue = zoneNo + diffvalue;
				//alert("zoneNo before="+zoneNo+"  after="+ zonenodes[j].firstChild.nodeValue);
			}
		}
	}
}

function append_pids(nodeobj)
{	//insert before <Zone1>0</Zone1>
	var pidlist = new Array("PID1,1",
							"PID2,1",
							"PID3,1",
							"PID4,1",
							"PID5,1");
	var afternode = null;
	if (null == nodeobj)
	{
		return;
	}
	
	var node = nodeobj.getElementsByTagName("Zone1");
	if (0 != node.length)
	{
		afternode = node[0];
	}
	update_tags(nodeobj, pidlist, afternode);
}

function is_input_device(dtype)
{	//3 , 4, 5, 6, 7, 8, 9, 10, 11, 18, 19, 20, 21, 26, 27, 28, 
	var dtypeNo = parseInt(dtype);
	if ((3 <= dtypeNo && 11 >= dtypeNo) || 
		(18 <= dtypeNo && 21 >= dtypeNo) ||
		(26 <= dtypeNo && 28 >= dtypeNo))
	{
		return true;
	}
	else
	{
		return false;
	}
}

//update the value of existed tag or creat new tags
function update_tags(xmlElem, taglist, afterNode)
{
	if (null == xmlElem)
	{
		return;	
	}
	
	for (var i = 0; i < taglist.length; i++)
	{
		//alert(taglist[i]);
		var taginfo = taglist[i].split(',');
		
		var tagobj = xmlElem.getElementsByTagName(taginfo[0]);
		if(tagobj.length > 0)
		{	//existed
			tagobj[0].firstChild.nodeValue = taginfo[1];
		}
		else
		{	//not existed, creat a new one
			var newNode = creat_new_node(taginfo);
			xmlElem.insertBefore(newNode,afterNode);
		}
	}
}

function creat_new_node(taginfo)
{
	var xmlDoc = mycreateXMLdoc();
	var newel = null;
	//alert("taginfo.length="+taginfo.length);
	if (2 == taginfo.length)
	{
		newel = xmlDoc.createElement(taginfo[0]);
		var newtext = xmlDoc.createTextNode(taginfo[1]);
		newel.appendChild(newtext);
	}
	else if (1 == taginfo.length)
	{
		//alert("new tagname = "+taginfo[0]);
		newel = xmlDoc.createElement(taginfo[0]);
	}
	else
	{
		//alert("wrong input taginfo");
	}
	return newel;
}

function show_info(id)
{
	DebugField.innerHTML = warnMsg[id-1];
}