function changeDispTitle(groupID, obj){
    var index = obj.selectedIndex;
    var type = obj.options[index].value;
    var paramList = [groupID, "HeaderDisplay", type];

    if(groupID == "CONT-MOD")
        gPageManager.setHeaderDisplay(transtr_dualTitle,transtr_singleTitle);

    gPageManager.process("dtHeaderDisplay", paramList);
}

function initSLCLabel(groupID, obj){
    var type = 2;
    var paramList = [groupID, "Label", type];
    gPageManager.process("dtSLCLabelCtrl", paramList);
}

function changeHeaderDisplay(groupID, obj){

    var index = obj.selectedIndex;
    var type = obj.options[index].value;
        
    var length = gIDs.length; //total group length
    var l_headerDisp = new Array(length);
    l_headerDisp["SMOKE-P"] = ["3","Analog photoelectric smoke detector","27","Analog photoelectric smoke detector","32","Smoke Detector (Smoke-P)","34","Dual-Smoke Detector (Smoke-P)"];
    l_headerDisp["HEAT"] = ["5","Analog heat detector","29","Heat Detector"];
    l_headerDisp["SMOKE-M"] = ["7","Analog multisensor detector","30","Smoke/Heat Detector","31","Smoke/Heat/Chemical Detector","35","Dual-Smoke Heat Detector","36","Dual-Smoke Heat Chemical Detector"];					
    l_headerDisp["BASE-SND"] = ["16","Analog sounder base"];
    l_headerDisp["CONT-MOD"] = ["8","Contact monitor modules","18","Contact monitor 4-inch class A","19","Contact monitor 4-inch class A w/isolator","20","Contact monitor with pigtail class A","21","Contact monitor with pigtail class A w/isolator","11","Dual input monitor","9","Single-action manual station","28","Double-action manual station"];
    l_headerDisp["CONVZ-MOD"] = ["10","Conventional zone module"];
    l_headerDisp["RELAY-MOD"] = ["12","Dual relay module","22","Dual relay module 2A","23","Dual relay module 2A w/isolator","24","Dual relay module 8A","25","Dual relay module 8A w/isolator","17","Analog relay module"];
    l_headerDisp["NAC-MOD"] = ["13","Supervised output module","14","Supervised output module class A","15","Supervised output module classA w/isolator"];
    l_headerDisp["SMOKE-D"] = ["4","Analog duct smoke detector","26","Analog duct smoke detector replacement head","33","Duct Detector (Smoke-D)"];
    l_headerDisp["SMOKE-I"] = ["6","Analog lonization smoke detector"];

    var headWording = processDisplay(l_headerDisp[groupID], type);
    if(headWording != null)
        document.getElementById("ID_DEV_HeaderDisplay").innerHTML = headWording;
}

function processDisplay(defDisps,dtype){
    var dispWording = null;
    for(var i=0; i<(defDisps.length/2); i++){
        var objType = defDisps[2*i];
        var objDisp = defDisps[2*i+1];
        if(parseInt(objType) == parseInt(dtype)){
            dispWording = objDisp;
            break;
        }else{
            continue;
        }
    }
    return dispWording;
}

function changeMultiDevPointType(groupID, obj){
    var smokePTs = "6,Generic;5,Supervisory";
    var index = obj.selectedIndex;
    var type = obj.options[index].value;
    var smokePTObj = document.getElementById("SmokePointType");
    var flag = this.window.dialogArguments.document.getElementById("openWinFlag").value;
    var confSmokePTValue = smokePTObj.value;
    
    changePointType(groupID, obj);
    
    if(type!=null&&type=="0"){
        //clear out children
        while(smokePTObj.hasChildNodes()){
            smokePTObj.removeChild(smokePTObj.lastChild);
		}
        if(smokePTObj!=null){    
            var smokePTPairs = smokePTs.split(";");
            for(var i=0; i<smokePTPairs.length; i++){
                
                var newOp = document.createElement("option");
                newOp.value = smokePTPairs[i].split(",")[0];
                newOp.innerHTML = smokePTPairs[i].split(",")[1];
                
                if(flag != "configOpen"){
                    if(i==0)
                        newOp.selected = "selected";
                }else{
                    if(newOp.value ==confSmokePTValue)
                        newOp.selected = "selected";
                }
                smokePTObj.appendChild(newOp);
            }
        }
        
    }else if(type!=null&&type=="5"){
        while(smokePTObj.hasChildNodes()){
            smokePTObj.removeChild(smokePTObj.lastChild);
		}
        if(smokePTObj!=null){    
        
            var smokePTPairs = smokePTs.split(";");
            
            for(var i=0; i<smokePTPairs.length; i++){
                if(i==0){
                    var newOp = document.createElement("option");
                    newOp.value = smokePTPairs[i].split(",")[0];
                    newOp.innerHTML = smokePTPairs[i].split(",")[1];
                    newOp.selected = "selected";
                    smokePTObj.appendChild(newOp);
                }else{
                    break;
                }
            }
        }
    }
	workingModeChangeAV(document.getElementById("WorkingMode").value, document.getElementById("WorkingDayMode").value);
}
function workingModeChangeAV(wMode, wDayMode)
{
	var AVObj = document.getElementById("AV");
	var PSObj = document.getElementById("PS");
	
	if (("0" == wMode) && ("0" == wDayMode))		
	{
		if("0" == document.getElementById("PointType").value)
		{
			AVObj.disabled = "";
			PSObj.disabled = "";
		}		
	}
	else 
	{
		AVObj.disabled = "disabled";
		if (true == AVObj.checked)
		{
			document.getElementById("NO_Delay").checked = true;
			AVObj.checked = false;
		}
		
		PSObj.disabled = "disabled";
		if (true == PSObj.checked)
		{
			document.getElementById("PAS").checked = true;
			PSObj.checked = false;
		}
	}
}

function changeWorkingMode(groupID, obj){
    var srcObj = obj;
    var tarObj = null;
    
    if(srcObj.name.toString().search("Day")!=-1)
        tarObj = document.getElementById("WorkingMode");
    else
        tarObj = document.getElementById("WorkingDayMode");
    
    var srcValue = srcObj.value;
    var tarValue = tarObj.value;
    
    if(tarValue == "0"){
        if(srcValue == "0"){
            document.getElementById("SmokeLabel").readOnly = true;
            document.getElementById("SmokePointType").disabled = "disabled";
			
        }else{
            document.getElementById("SmokeLabel").removeAttribute("readOnly");
            document.getElementById("SmokePointType").removeAttribute("disabled");
        }
    }
	
	workingModeChangeAV(srcValue,tarValue);
}

function changeDeviceType(groupID, obj)
{
	//alert(obj);
    var selIndex = obj.selectedIndex;
	var type = obj.options[selIndex].value;

	var SensOpt0 = document.createElement('option');
    SensOpt0.text = '0.90%/ft, 2.95%/m';
    var SensOpt1 = document.createElement('option');
    SensOpt1.text = '1.00%/ft, 3.30%/m';

	var DaySensOpt0 = document.createElement('option');
    DaySensOpt0.text = '0.90%/ft, 2.95%/m';
    var DaySensOpt1 = document.createElement('option');
    DaySensOpt1.text = '1.00%/ft, 3.30%/m';

	switch (groupID)
	{
		case "CONT-MOD":
			changeDIVsDisplay(groupID, obj);
			if (11 == parseInt(type))
			{
				changeMultiPointType(groupID, document.getElementById("Input1_PointType"));
				changeMultiPointType(groupID, document.getElementById("Input2_PointType"));
			}
			else
			{
				changeMultiPointType(groupID, document.getElementById("PointType"));
			}
			
			if(3 == selIndex)//FLM-325-2i4
			{
				document.getElementById("DIV_FLM2I1LB").style.display = "";	
			}
			else
			{
				document.getElementById("DIV_FLM2I1LB").style.display = "none";
			}
			loadInputType(type);
			
			InitPIDfield();
			break;
		
		case "RELAY-MOD":
			changeDIVsDisplay(groupID, obj);		
			break;
       
		case "SMOKE-M":
			var Sensobj = document.getElementById("SmokeSensitivity");
			var Daysensobj = document.getElementById("SmokeDaySensitivity");

			changeDIVsDisplay(groupID, obj);
			if (0 == selIndex)
			{
				if (10 == Sensobj.length)
				{				
					try
					{					
						Sensobj.add(SensOpt1, Sensobj.options[0]); // standards compliant						
						Sensobj.add(SensOpt0, Sensobj.options[0]); // standards compliant
					}
					catch(ex)
					{						
						Sensobj.add(SensOpt1, 0); // IE only						
						Sensobj.add(SensOpt0, 0); // IE only
					}
				}
				Sensobj.selectedIndex = 7;

				if (10 == Daysensobj.length)
				{
					try
					{					
						Daysensobj.add(DaySensOpt1, Daysensobj.options[0]); // standards compliant						
						Daysensobj.add(DaySensOpt0, Daysensobj.options[0]); // standards compliant
					}
					catch(ex)
					{					
						Daysensobj.add(DaySensOpt1, 0); // IE only						
						Daysensobj.add(DaySensOpt0, 0); // IE only
					}
				}
				Daysensobj.selectedIndex = 7;
			}
			else //remove 0,1
			{
				if (12 == Sensobj.length)
				{
					Sensobj.remove(1);
					Sensobj.remove(0);
				}
				Sensobj.selectedIndex = 5;
				
				
				if (12 == Daysensobj.length)
				{
					Daysensobj.remove(1);
					Daysensobj.remove(0);
				}
				Daysensobj.selectedIndex = 5;
			}
			
			
			break;
		
		case "SMOKE-P":
			var Sensobj = document.getElementById("Sensitivity");
			var Daysensobj = document.getElementById("DaySensitivity");

			changeDIVsDisplay(groupID, obj);
			
			if ((2 == selIndex)||(3 == selIndex))
			{
				if (12 == Sensobj.length)
				{				
					Sensobj.remove(1);
					Sensobj.remove(0);
				}
				
				if (12 == Daysensobj.length)
				{					
					Daysensobj.remove(1);
					Daysensobj.remove(0);
				}
				Sensobj.selectedIndex = 5;
				Daysensobj.selectedIndex = 5;
			}
			else
			{
				if (10 == Sensobj.length)
				{				
					try
					{						
						Sensobj.add(SensOpt1, Sensobj.options[0]); // standards compliant						
						Sensobj.add(SensOpt0, Sensobj.options[0]); // standards compliant
						
					}
					catch(ex)
					{						
						Sensobj.add(SensOpt1, 0); // IE only					
						Sensobj.add(SensOpt0, 0); // IE only
						
					}					
				}
				Sensobj.selectedIndex = 7;
				if (10 == Daysensobj.length)
				{				
					try
					{						
						Daysensobj.add(DaySensOpt1, Daysensobj.options[0]); // standards compliant					
						Daysensobj.add(DaySensOpt0, Daysensobj.options[0]); // standards compliant
						
					}
					catch(ex)
					{					
						Daysensobj.add(DaySensOpt1, 0); // IE only					
						Daysensobj.add(DaySensOpt0, 0); // IE only
						
					}
				}
				
				Daysensobj.selectedIndex = 7;
			}
			break;

		case "HEAT":
			changeDIVsDisplay(groupID, obj);
			if(selIndex == 0)
			{
		    	document.getElementById("DIV_Sensi440").style.display = "none";	
			}
			else
			{
				document.getElementById("DIV_Sensi440").style.display = "";
			}
			break;
		
		case "NAC-MOD":
			var type = obj.value;
			var paramList = [groupID, "DeviceType", type];
			gPageManager.process("deviceCtrl", paramList);
			break;
		
		case "SMOKE-D":
			//alert("changeDIVsDisplay");
			changeDIVsDisplay(groupID, obj);
			if(selIndex == 0)
			{
				document.getElementById("DIV_Sensi440").style.display = "none";
				document.getElementById("DIV_DaySensi440").style.display = "none";
				//document.getElementById("DIV_Bypass").style.display = "none";
				//document.getElementById("DIV_LedFlashLY").style.display = "none";
				//document.getElementById("DIV_Zones440").style.display = "none";
			}
			else
			{
				document.getElementById("DIV_Sensi440").style.display = "";
				document.getElementById("DIV_DaySensi440").style.display = "";
				//document.getElementById("DIV_Bypass").style.display = "";
				//document.getElementById("DIV_LedFlashLY").style.display = "";
				//document.getElementById("DIV_Zones440").style.display = "";
			}
			changeName();
			FAD_RLY_Supervisory();
			break;
		
		default:
		//one device only
			break;
	}
	
    changeHeaderDisplay(groupID, obj);
	
	//page related component validation
	changeDeviceTypeByDefault(obj.id.toString(), groupID, obj);
	
	//when device type change, the address will be reset to 1
	var flag = this.window.dialogArguments.document.getElementById("openWinFlag").value;
	if ("specificOpen" == flag)
	{
		try
		{
			var checkEntry = eval("checkEditDeivceWrapper");
			var result = checkEntry(document.getElementById('Address'),document.getElementById('DeviceType'));
		}
		catch(errCheckEditDeviceWrapper)
		{
			//no handling process defined for this entry
		}
	}
}

function changeDeviceTypeByDefault(mid, gid, obj){
	
	var relatedObjs = new Array(1); //["Address"];
	relatedObjs["DeviceType"] = ["Address"];
	
	var objs = null;
	
	var methodMgrs = new Array(1);
	methodMgrs["Address"] = eval("addressMgr");

	var relatedObj = relatedObjs[mid];
	for(var i=0; i<relatedObj.length; i++){
		var obj = relatedObjs[i];
		var methodMgr = methodMgrs[obj];
		
		if(methodMgr != null){
			//such element is valid to apply for method manager : ***
			methodMgr(mid, gid, obj);
		}
		
	}

}

function addressMgr(docElemID, groupID, obj){
	
	var type = parseInt(obj.value);
	var relatedDocValue = parseInt(document.getElementById(docElemID).value);
	var defaultDocValue = null;
	
	var min_add = GetDevMinAddr(type);
	var max_add = GetDevMaxAddr(type);
	if (relatedDocValue < min_add || relatedDocValue > max_add)
	{
		defaultDocValue = min_add;
	}
	document.getElementById(docElemID).value = defaultDocValue;
	
}

//generate change display divs control from SLC devices page to gPageManager ruler
function changeDIVsDisplay(groupID, obj){
    var index = obj.selectedIndex;
    var type = obj.options[index].value;
    var paramList = [groupID, "DeviceType", type];
    gPageManager.process("displayDIVsCtrl", paramList);
}

function changeMultiDeviceType(groupID, obj){
    
    var index = obj.selectedIndex;
    var type = obj.options[index].value;

    if(type == "11"){
        
        changeDeviceType(groupID, obj);
        
        var invalidStr = gPageManager.actionObjs[groupID]["DeviceType"][2];
        var invalidPLs = invalidStr.split(";");
        var objs = invalidPLs[0].split(",");
        for(var i=0; i<objs.length; i++){
            document.getElementById(objs[i].toString()).style.display = "none";
        }
        changeMultiPointType(groupID, document.getElementById("Input1_PointType"));
        changeMultiPointType(groupID, document.getElementById("Input2_PointType"));
        
    }else{
        
        changeDeviceType(groupID, obj);
        
        var invalidStr = gPageManager.actionObjs[groupID]["DeviceType"][1];
        var invalidPLs = invalidStr.split(";");
        var objs = invalidPLs[0].split(",");
        for(var i=0; i<objs.length; i++){
            document.getElementById(objs[i].toString()).style.display = "none";
        }
        changeMultiPointType(groupID, document.getElementById("PointType"));
        
    }
    
    
}

function changePointType(groupID, obj){
    var index = obj.selectedIndex;
    var ptype = obj.options[index].value;
    var paramList = [groupID, "PointType", ptype];
    gPageManager.process("pointTypeCtrl", paramList);
}

function changeMultiPointType(groupID, obj){
    var index = obj.selectedIndex;
    var ptype = obj.options[index].value;
    var name = obj.name;
    var flag = 0;

    if(name.toString().search("Input1") != -1)
        flag = 1;
    else if(name.toString().search("Input2") != -1)
        flag = 2;
    else 
        flag = "";

    var ptValue = "PointType"+flag.toString();
    var paramList = [groupID, ptValue, ptype];
    gPageManager.process("pointTypeCtrl", paramList);
}

/**
* @changeTitleDT
* @interface when the device edit page "title changeing" event triggered on each of the device pages when
*    when device type has been changed.
* @param 
*        groupID - the group id value such as "SMOKE-P", "SMOKE-M" and so on.
*        obj - the current combo box element which is the target of this event.
* @return 

    History:   
        09/08/21 Wang Yujing
        Generate event handler for the title display for different device type on the same web page.
*/
function changeTitleDT(groupID, obj){
    var index = obj.selectedIndex;
    var type = obj.options[index].value;
    var paramList = [groupID, "TITLEDISPLAY", type];
    gPageManager.process("dtTitleCtrl", paramList);
}

function changeDSTitleDT(groupID, obj){
    var index = obj.selectedIndex;
    var type = obj.options[index].value;
    var paramList = [groupID, "TitleDisp", type];
    gPageManager.process("dtDSTitleCtrl", paramList);

}

//called in each of the group devices web page for initializing the sub type list
function InitSubTypes(groupID, elemID){

    var curGroup = dGroups[groupID];
    var parentObj = document.getElementById(elemID);

    while(parentObj.hasChildNodes()){
        parentObj.removeChild(parentObj.lastChild);
    }

    for(var i=0; i<curGroup.length; i++){
        var curSubStr = curGroup[i].split(',');
        var type = curSubStr[0];
        var name = curSubStr[1];
        var newElem = document.createElement("option");
        newElem.value = type;
        newElem.innerHTML = name;
        //End of add tip shown
        parentObj.appendChild(newElem);
    }

}

/*function changeInputType(groupID, obj)
{
	var objValue = obj.value;
	var dtype = document.getElementById("DeviceType").value;
	
	if(groupID == "CONT-MOD"){
		if((parseInt(dtype) == 8)||(parseInt(dtype) == 11)){
			//no change
		}else{
			if(parseInt(objValue) >= 1){
				//class A is disabled
				var wtTypeObj = null;
				var curWtTypeObj = null;
				try{ // except 11, all are signle object
					wtTypeObj = document.getElementsByName("InputType");
					for(var i=0; i<wtTypeObj.length; i++){
						curWtTypeObj = wtTypeObj[i];
						if(curWtTypeObj.selected == true)
							break;
					}
					//retrieved current selected object
					if(parseInt(curWtTypeObj.value) == 1){
						//class A matched
						document.getElementById("WiringType_B").selected = true;
						curWtTypeObj.selected = false;
						curWtTypeObj.disabled = "disabled";
					}
				}catch(err1){
					//unexcepted exception occurs
				}
			}else{
				//enable class A
				var wtTypeObj = document.getElementById("WiringType_A");
				wtTypeObj.removeAttribute("disabled");
			}
		}
	}
}*/

function changeInputType(obj)
{
	var objValue = obj.value;
	var dtype = document.getElementById("DeviceType").value;
	
	if ((18 == parseInt(dtype)) || (19 == parseInt(dtype)))
	{
		var opjPT = document.getElementById("DIV_SinglePT");
		if (1 == parseInt(objValue))
		{	//NC with EOL
			opjPT.innerHTML = document.getElementById("VIEW_SinglePT_NC").innerHTML;
			changeMultiPointType('CONT-MOD',document.getElementById("PointType"));
		}
		else
		{
			opjPT.innerHTML = document.getElementById("VIEW_SinglePT").innerHTML;
		}
	}
}

function checkChkValidation(defChkStr, chkStrs){
    
    var chks = chkStrs.split(",");
    
    for(var i=0; i<chks.length; i++){

        var chkStr = chks[i];
        var chkObj = document.getElementById(chkStr);
        
        if(chkObj.checked=="checked"){
            document.getElementById(defChkStr).checked = "checked";
            chkObj.removeAttribute("checked");
            return true;
        }else{
            continue;
        } 
    }
    return false;
}

//change wiring type controlled by device control rule
function changeWiringType(obj){
    var wtObjVal = obj.value;
	var groupID = document.getElementById("groupFlag");
	if(groupID != null){
		if(groupID.value == "CONT-MOD"){
			var dtypeObj = document.getElementById("DeviceType");
    		if(dtypeObj != null)
			{
				loadInputType(dtypeObj.value);
				changeInputType(document.getElementById("InputType"));
			}
		}
	}
}

var maxHeaderCount = 4;

//Adapter Object Generation Section
function DeviceScopeObj(){

    //Rule Manager Object
    this.totalActionObjs = 10;
    this.actionObjs = new Array(this.totalActionObjs);
    this.actionObjs["SLC"] = new Array(1);
    this.actionObjs["SLC"]["Label"] = new Array(1);
    this.actionObjs["SLC"]["Label"][0] = "Label;3";
    
    this.actionObjs["SMOKE-P"] = new Array(2);
    this.actionObjs["SMOKE-P"]["DeviceType"]=new Array(1);
    this.actionObjs["SMOKE-P"]["DeviceType"][0] = "LedFlashLY;27,32,34"; //,LedOnAtAlarmLY
    this.actionObjs["SMOKE-P"]["PointType"]=new Array(1);
    this.actionObjs["SMOKE-P"]["PointType"][0] = "NO_Delay,AV,PAS,PS;0";
    
    this.actionObjs["SMOKE-M"] = new Array(2);
	this.actionObjs["SMOKE-M"]["DeviceType"]=new Array(1);//add by Felicia
	this.actionObjs["SMOKE-M"]["DeviceType"][0] = "FAP440SPH,FAP440DSH;30,31,35,36"; //add by Felicia for new device
    this.actionObjs["SMOKE-M"]["PointType"] =new Array(1);
    this.actionObjs["SMOKE-M"]["PointType"][0] = "NO_Delay,AV,PAS,PS;0";
    
    this.actionObjs["HEAT"] = new Array(2);
	this.actionObjs["HEAT"]["DeviceType"] = new Array(2);
	this.actionObjs["HEAT"]["DeviceType"][0] = "Sensi325;5"; //add by Felicia for new device
	this.actionObjs["HEAT"]["DeviceType"][1] = "Sensi440,LedFlashLY,FAHRoR;29"; //add by Felicia for new device, remove FAHRTI for 440 device by HuYing
    this.actionObjs["HEAT"]["PointType"] = new Array(1);
    this.actionObjs["HEAT"]["PointType"][0] = "NO_Delay,PAS;0";
    
    this.actionObjs["CONT-MOD"] = new Array(1);
    this.actionObjs["CONT-MOD"]["DeviceType"] = new Array(3);
    this.actionObjs["CONT-MOD"]["DeviceType"][0] = "WiringType;18,19,20,21";
    this.actionObjs["CONT-MOD"]["DeviceType"][1] = "FLM2I2PT,FLM2I2IT,FLM2I2ZONES,FLM2I2LB,FLM2I2BYPASSED,FLM2I1PT,FLM2I1IT,FLM2I1ZONES,FLM2I1LB,FLM2I1BYPASSED,FLM2I1DELAYMOD,FLM2I2DELAYMOD;11";
    this.actionObjs["CONT-MOD"]["DeviceType"][2] = "SPLDLB,SinglePT,SingleZS,SingleBP,SingleDELAYMOD,SingleDELAYMOD,SingleIT;8,18,19,20,21"; //9,28
    this.actionObjs["CONT-MOD"]["HeaderDisplay"] = new Array(1);
    this.actionObjs["CONT-MOD"]["HeaderDisplay"][0] = "ID_DEV_HeaderDisplay;11";
    //this.actionObjs["CONT-MOD"]["InputType"] = new Array(1);
    //this.actionObjs["CONT-MOD"]["InputType"][0] = "LB_WiringTypeA;0";
    this.actionObjs["CONT-MOD"]["WiringType"] = new Array(1);
    this.actionObjs["CONT-MOD"]["WiringType"][0] = "Input1_NEOL,Input1_WOEOL,Input2_NEOL,Input2_WOEOL,IT_NEOL,IT_WOEOL;0";
    this.actionObjs["CONT-MOD"]["PointType"] = new Array(1);
    this.actionObjs["CONT-MOD"]["PointType"][0] = "NO_Delay,PAS;0"; //remove AV,PS
    this.actionObjs["CONT-MOD"]["PointType1"] = new Array(1);
    this.actionObjs["CONT-MOD"]["PointType1"][0] = "Input1_NO_Delay,Input1_PAS;0";//remove Input1_AV,Input1_PS
    this.actionObjs["CONT-MOD"]["PointType2"] = new Array(1);
    this.actionObjs["CONT-MOD"]["PointType2"][0] = "Input2_NO_Delay,Input2_PAS;0";//remove Input2_AV,Input2_PS
    //this.actionObjs["CONT-MOD"]["InputType"] = new Array(1);
	//this.actionObjs["CONT-MOD"]["InputType"][0] = "Input2_IT_WOEOL;8,11";
    
    this.actionObjs["NAC-MOD"] = new Array(1);
    this.actionObjs["NAC-MOD"]["DeviceType"] = "WiringType;43,44";
    
    this.actionObjs["SMOKE-D"] = new Array(2);
	this.actionObjs["SMOKE-D"]["DeviceType"] = new Array(2);
	this.actionObjs["SMOKE-D"]["DeviceType"][0] = "Sensi325,DaySensi325;4,26"; //add by Felicia for new device
	this.actionObjs["SMOKE-D"]["DeviceType"][1] = "Bypass,sequAndSil,Sensi440,DaySensi440;33"; //add by Felicia for new device
    this.actionObjs["SMOKE-D"]["PointType"] = new Array(1);
    this.actionObjs["SMOKE-D"]["PointType"][0] = "NO_Delay,AV,PAS,PS;0";
    
    this.actionObjs["SMOKE-I"] = new Array(1);
    this.actionObjs["SMOKE-I"]["PointType"] = new Array(1);
    this.actionObjs["SMOKE-I"]["PointType"][0] = "NO_Delay,AV,PAS,PS;0";
    
    this.actionObjs["CONVZ-MOD"] = new Array(1);
    this.actionObjs["CONVZ-MOD"]["PointType"] = new Array(1);
    this.actionObjs["CONVZ-MOD"]["PointType"][0] = "NO_Delay,AV,PAS,PS;0";
    
    this.actionObjs["RELAY-MOD"] = new Array(1);
    this.actionObjs["RELAY-MOD"]["DeviceType"] = new Array(2);
    this.actionObjs["RELAY-MOD"]["DeviceType"][0] = "SingleZS,SingleChks;17";
    this.actionObjs["RELAY-MOD"]["DeviceType"][1] = "R1LB,R1ZS,R2LB,R2ZS,R1Chks,R2Chks;12,22,23,24,25";
	
    //member variants
    this.gID = 0;
    this.dID = 0;
    this.adapterID = 0;
    this.headerDisplay = new Array(maxHeaderCount);
    
    this.setHeaderDisplay = function(dualTitleDisplay,singleTitleDisplay){
        this.headerDisplay[0] = dualTitleDisplay;
        this.headerDisplay[1] = singleTitleDisplay;
    }
    
    this.getHeaderDisplay = function(index){
        return this.headerDisplay[index];
    }
    
    //initialization process
    this.init = function(gID, dID){
        if(gID != null)
            this.gID = gID;
        if(dID != null)
            this.dID = dID;
    }
    
    //handler regist and auto parameters adaption process
    this.process = function(handler, paramList){         
                
        var resultCommand = "this."+handler+"(";
        var executeResult = "";
        
        for(var i=0; i<(paramList.length-1); i++){
            resultCommand += "'"+paramList[i]+"',";
        }
        resultCommand += "'"+paramList[i]+"')";
        executeResult = eval(resultCommand);
        if(executeResult != null)
            return executeResult;
    }
    
    //start: handler/Technition definitions
    this.dtTitleCtrl = function(gName, ctrName, val){
        var titles = new Array(6);
        titles["12"] = "Dual Relay Module (2 x 1 Amp)";
        titles["22"] = "Dual Relay Module (2 x 2 Amps)";
        titles["23"] = "Dual Relay Module (2 x 2 Amps with Isolator)";
        titles["24"] = "Dual Relay Module (2 x 8 Amps)";
        titles["25"] = "Dual Relay Module (2 x 8 Amps with Isolator)";
        titles["17"] = "Single Relay Module (D328A Analog Relay Module)";
        
        var ctrledObj = document.getElementById(ctrName);
        ctrledObj.innerHTML = titles[val.toString()];
        
        
    }
    
    //title switch for CONT-MOD, RELAY-NAC, and others if provided
    this.dtDSTitleCtrl = function(gName, ctrlName, val){
        this.adapterID = 3;
        this.splitLogicCtrl(gName, ctrlName, val);
    }
    
    //init SLC loop device label value
    this.dtSLCLabelCtrl = function(gName, ctrlName, val){
        this.adapterID = 4;
        this.splitLogicCtrl(gName, ctrlName, val);
    }

    //device ctrl forward request to device type
    this.splitLogicCtrl = function(gName, ctrlName, val){
        
        var ifValidVal = false;
        var dTypeIndex = null;
        var dType = null;
        
        try{
            dTypeIndex = document.getElementById("DeviceType").selectedIndex;
            dType = document.getElementById("DeviceType").options[dTypeIndex].value;
        }catch(error){
            //No rule for this DeviceType constraint.
        }
        
        try{
            var group = this.actionObjs[gName];
            var control = group[ctrlName];
            
            for(var j = 0; j<control.length; j++){ 
                var elems = control[j].split(';');
                var ctrlIDs = elems[0].split(',');
                var validVals = elems[1].split(',');
                
                for(var i=0; i<validVals.length; i++){
                    if(validVals[i].toString() == val.toString()){
                        ifValidVal = true;
                        break;
                    }else{
                        ifValidVal = false;
                    }
                }
                
                this.processAdapter(ctrlIDs, this.adapterID, ifValidVal);
            }
            
        }catch(err){
            ifValidVal = false;
        }
        
        return ifValidVal;
    }
    
    this.processAdapter = function(ctrlIDs, adapterID, flag){
        
        switch(adapterID){
            case 0:
                break;
            case 1: 
                if(flag == true){
                    for(var k=0; k<ctrlIDs.length; k++)
                        document.getElementById(ctrlIDs[k].toString()).style.display = "";
                }else{
                    for(var k=0; k<ctrlIDs.length; k++)
                        document.getElementById(ctrlIDs[k].toString()).style.display = "none";
                }
                break;
            case 2:
                if(flag == true){
                    for(var k=0; k<ctrlIDs.length; k++)
                        document.getElementById(ctrlIDs[k].toString()).removeAttribute("disabled");
                }else{
                    for(var k=0; k<ctrlIDs.length; k++)
                        document.getElementById(ctrlIDs[k].toString()).disabled = "disabled";
					document.getElementById(ctrlIDs[0].toString()).checked = "checked";
                }
                break;
            case 3:
                if(flag == true){
                    for(var k=0; k<ctrlIDs.length; k++)
                        document.getElementById(ctrlIDs[k].toString()).innerHTML = transtr_dualTitle;//
                }else{
                    for(var k=0; k<ctrlIDs.length; k++)
                        document.getElementById(ctrlIDs[k].toString()).innerHTML = transtr_singleTitle;
                }
                break;
            case 4:
                if(flag == true){
                    var lt = window.dialogArguments.looptag;
                    if(lt == "LOOP1"){
                        for(var k=0; k<ctrlIDs.length; k++)
                            document.getElementById(ctrlIDs[k].toString()).value += " 1";
                    }else if(lt == "LOOP2"){
                        for(var k=0; k<ctrlIDs.length; k++)
                            document.getElementById(ctrlIDs[k].toString()).value += " 2";
                    }
                }
                break;
            case 5:
                if(flag == true){
                    for(var k=0; k<ctrlIDs.length; k++){
                        //apply aother rule control
                        var srcName = "VIEW_"+ctrlIDs[k].toString();
                        var tarName = "DIV_"+ctrlIDs[k].toString();
                        var srcDIV = document.getElementById(srcName);
                        var tarDIV = document.getElementById(tarName);
                        tarDIV.innerHTML = srcDIV.innerHTML;
                    }
                }else{
                    for(var k=0; k<ctrlIDs.length; k++){
                        //apply aother rule control
                        var srcName = "VIEW_"+ctrlIDs[k].toString();
                        var tarName = "DIV_"+ctrlIDs[k].toString();
                        var srcDIV = document.getElementById(srcName);
                        var tarDIV = document.getElementById(tarName);
                        tarDIV.innerHTML = "";
                    }
                }
                break;
            default:
                break;
    }
        
}
    
    
    this.smokePTPLCtrl = function(gName, ctrlName, val){
        this.adapterID = 2;
        var flag = this.splitLogicCtrl(gName, ctrlName, val);
        return flag;
    }
    
    this.modeCtrl = function(gName, ctrlName, val){
        this.adapterID = 2;
        var flag = this.splitLogicCtrl(gName, ctrlName, val);
        return flag;
    }
    
    this.deviceCtrl = function(gName, ctrlName, val){
        this.adapterID = 1;
        return this.splitLogicCtrl(gName, ctrlName, val);
    }
    
    this.displayDIVsCtrl = function(gName, ctrlName, val){
        this.adapterID = 5;
        return this.splitLogicCtrl(gName, ctrlName, val);
    }
    
    this.pointTypeCtrl = function(gName, ctrlName, val){
        this.adapterID = 2;
        this.splitLogicCtrl(gName, ctrlName, val);
    }

    this.dtHeaderDisplay = function(gName, ctrlName, val){
        this.adapterID = 3;
        this.splitLogicCtrl(gName, ctrlName, val);
    }

    this.addDeviceCtrl = function(gName, ctrlName, val){
        
        this.deviceCtrl(gName, ctrlName, val);
        
        var flag = flagTEMPLETE;
        if(flag == "GROUP_TEMPLETE"){
            var devicexml = window.dialogArguments.currentDeviceDOMtree[parseInt(val)];
            myxml2form(devicexml, document.forms[0]);
            var addr = document.getElementById("DeviceType").value;
            window.dialogArguments.addDeviceAt(parseInt(val), addr, 1, false);
        }
    }
}

//Global Page Manager Generation Section (Manager vs Technition Pair)
var gPageManager = new DeviceScopeObj();
