// JavaScript Document
MaxGroupNO = 6;
MaxPairNO = 3;
partnerNO = 2;
Pfix = "pid_";
Gfix = "DualZones_group";
PRfix = "_Pair";

//get part ID for DualZones_group[x]_Pair[y][z]
function GetPartID(id)
{
	var partID = null;
	var group = id.substring(Gfix.length,(Gfix.length+1));
    var zone = id.substring((id.length-2),(id.length-1));
    var selfID = id.substring((id.length-1),id.length);

    if(1 == selfID)
	{
		partID = Gfix + group + PRfix + zone + 2;
	}
	else
	{
		partID = Gfix + group + PRfix + zone + 1;
	}
	
	return partID;
}

//clean the four values to 0 if there is more than one 0 in the pair before save to panel
function CleanInvalidZone()
{
	for (var i = 1; i <= MaxGroupNO; i++)
	{
		for (var j = 1; j <= MaxPairNO; j++)
		{
			for (var k = 1; k <= partnerNO; k++)
			{
				var zoneID = Gfix + i + PRfix + j + k;
				var zone_value = parseInt(document.getElementById(zoneID).value, 10);

				var part_zoneID = GetPartID(zoneID);
				var part_zone_value = parseInt(document.getElementById(part_zoneID).value, 10);
				
				if ((0 == zone_value) || (0 == part_zone_value))
			    {
					var panelID = Pfix + zoneID;
					var part_panelID = Pfix + part_zoneID;
					
					document.getElementById(panelID).value = 0;
					document.getElementById(zoneID).value = 0;
					document.getElementById(part_panelID).value = 0;
					document.getElementById(part_zoneID).value = 0;	
				}
			}
		}
	}
    ConFileButtonEvent_Apply(ZONES);
	ProgramChangeFlag = 0;
}

//check both panelID and DualZone number when either of them change
function PidDualZoneCheck(panel, zone)
{
	var times = 0;// displayed times about the number;
    var valid = false;

    //get decimal value to avoid style difference
    var zone_value = parseInt(zone.value, 10);
    var part_zoneID = GetPartID(zone.id);
	var part_zone_value = parseInt(document.getElementById(part_zoneID).value, 10);

    var panel_value = parseInt(panel.value, 10);
    var part_panelID = Pfix + part_zoneID;
	var part_panel_value = parseInt(document.getElementById(part_panelID).value, 10);

	if ((0 == panel_value)&&(0 == zone_value)) //allow any return to default
	{
		preInputValue = 0;
		return false;	
	}

    //alert if both panel value and zone number same in a pair
    if ((panel_value == part_panel_value)&&(zone_value == part_zone_value))
	{
		//alert("The zone numbers in a pair can not be same!");
		alert(warningHandler(70));
        return false;
	}
	else
	{
		for (var i = 1; i <= MaxGroupNO; i++)
		{
		    for (var j = 1; j <= MaxPairNO; j++)
			{
			    for (var k = 1; k <= partnerNO; k++)
				{
				    var temp_zoneID = Gfix + i + "_Pair" + j + k;
					var temp_zone_value = parseInt(document.getElementById(temp_zoneID).value, 10);
					var temp_panel_value = parseInt(document.getElementById(Pfix + temp_zoneID).value, 10);
					if ((zone.id == temp_zoneID) || (part_zoneID == temp_zoneID))
						continue;
					else
					{
					    //find the same pID + zone number
						if ((panel_value == temp_panel_value)&&(zone_value == temp_zone_value))
						{
	    					var temp_part_zoneID = GetPartID(temp_zoneID);
							var temp_part_panelID = Pfix + temp_part_zoneID;
							var temp_part_zone_value = parseInt(document.getElementById(temp_part_zoneID).value, 10);
							var temp_part_panel_value = parseInt(document.getElementById(temp_part_panelID).value, 10);
						
							if ((part_panel_value == temp_part_panel_value)
								&&(part_zone_value == temp_part_zone_value))
							{
							    //alert("This pair existed!");
								alert(warningHandler(71));
							    return false;
							}
							else
							{
								times ++;
							}
  							
						}
					
					}
				
				}
			
			}
			
		}
		
		if (4 <= times)
		{
			//alert("A zone number can only exist in four pairs!");
			alert(warningHandler(72));
			return false;
		}
	}
	return true;	
}

//check if panel ID meets zone number
function DZ_Pid_Check(panel)
{
	if (preInputValue == panel.value)
        return;

    var valid = GeneralPidCheck(panel);
	if (false == valid)
		return;

    var zoneID = panel.id.substring(Pfix.length);

	var dual_valid = PidDualZoneCheck(panel, document.getElementById(zoneID));	
	if (false == dual_valid)
	{
		panel.value = preInputValue;
	}
}

//check if zone number meets panel ID
function DZ_ZoneNo_Check(zone)
{
	if ((preInputValue == zone.value)
		&&((SubPreInputValue == zone.value)
		   ||(SubPreZoneID != zone.id)))  //add sub device zone change zone number
	{
        return;
	}

	var valid = InputZoneCheck(zone);
	if (false == valid)
	{
		return;
	}

    var panelID = Pfix + zone.id;

	var dual_valid = PidDualZoneCheck(document.getElementById(panelID), zone);	
    if (false == dual_valid)
	{
		if (SubPreZoneID == zone.id)
		{
			zone.value = SubPreInputValue;
		}
		else
		{
			zone.value = preInputValue;
		}
	}
}
