function Errorhandler (errorno) {
    
    var transtr_errMsg=null;
    switch (errorno){
        case "100":
            transtr_errMsg="Invalid PIN. \n A PIN must be a four digit number. Please check that number lock is turned on!";
            break;
        case "101":
            transtr_errMsg="A level 3 user is already logged in!";
            break;
        case "102":
            transtr_errMsg="System is reinitializing. Please try later!";
            break;
        case "103":
            transtr_errMsg="Login expired. Please login again!";
            break;
        case "104":
            transtr_errMsg="Invalid PIN. \n A PIN must be a four digit number. Please check that number lock is turned on!";
            break;
        case "105":
            transtr_errMsg="Internal error. Please reset panel with factory Default settings.\n If problem occurs again, please contact technical support.";
            break;
        case "106":
            transtr_errMsg="Internal error. Please reset panel.\nIf problem occurs again, please contact technical support.";
            break;
        case "107":
            transtr_errMsg="Login with Level 3 is blocked when operating bypass on local keypad!";
            break;
        case "201":
            transtr_errMsg="Login has expired\n Please login!";
            break;
        case "202":
            transtr_errMsg="Login is expired!";
            break;
        case "203":
            transtr_errMsg="Login read failed, please reboot the panel.\n If problem occurs again, please contact technical support.";
            break;
        case "204":
            transtr_errMsg="Login write failed, please reboot the panel.\n If problem occurs again, please contact technical support.";
            break;
        case "205":
            transtr_errMsg="Internal error:\n Failed to send message!";
            break;
        case "301":
            transtr_errMsg="User authority level is too low, Level 3 is required!";
            break;
        case "302":
            transtr_errMsg="Communication failed, please try again!";
            break;
        case "303":
            transtr_errMsg="Memory overflow, please reboot the panel.\nIf problem occurs again, please contact technical support.";
            break;
        case "401":
            transtr_errMsg="User authority level is too low, Level 2 or higher is required!";
            break;
        case "402":
            transtr_errMsg="Communication failed, please try again. Check connection to the panel.";
            break;
        case "403":
            transtr_errMsg="Communication failed, please try again.";
            break;
        case "404":
            transtr_errMsg="Walk test is already in process!";
            break;
        case "501":
            transtr_errMsg="Please check configuration file. File size reached maximum.";
            break;
        case "502":
            transtr_errMsg="Please check SW application file for panel update. File size reached maximum.";
            break;
        case "503":
            transtr_errMsg="Invalid entry!";
            break;
        case "504":
            transtr_errMsg="Please choose a file to upload first!";
            break;
        case "505":
            transtr_errMsg="Please try again.\nIf problem occures again, please reboot the panel.";
            break;
        case "506":
            transtr_errMsg="Incorrect file type. Configuration file must be .xml, SW update must be of .bin type!";
            break;
        case "507":
            transtr_errMsg="File check failed, please reboot the panel.\nIf problem occurs again, please contact technical support.";
            break;
        case "508":
            transtr_errMsg="Incorrect file type. SW updated must be .zip!";
            break;
        case "520":
			transtr_errMsg = "Please have someone at panel enter confirmation password within 3 minutes. Processing now, please waiting ?";
            return transtr_errMsg;
        case "522":
			transtr_errMsg = "Password entered at panel successfully, you will be forwarded to remote programming soon.";
            return transtr_errMsg;
        case "525":
            transtr_errMsg = "Another request is in progress. Please try later.";
			return transtr_errMsg;
        case "526":
            transtr_errMsg = "Unknown panel error has occured, please retry later.";
			return transtr_errMsg;
        case "527":
            transtr_errMsg = "Invalid password has been entered at the panel.";
			return transtr_errMsg;
        case "536":
			transtr_errMsg = "Remote panel access has been disabled.";
            return transtr_errMsg;
        case "538":
            transtr_errMsg = "You have been removed from access list.";
			return transtr_errMsg;
        case "539":
            transtr_errMsg = "Invalid request ID has been received at server side.";
            return transtr_errMsg;
        case "540": //web only
            transtr_errMsg = "Client side timeout!";
            return transtr_errMsg;
        default:
            transtr_errMsg="Please reopen the web browser. If it happends again, please reset the panel.";
            break;
    }

	alert(transtr_errMsg);
	return transtr_errMsg;
}


function warningHandler(warnNo){
    return warningHandlerEntry(warnNo, null);
}

function warningHandlerWithParams(warnNo, num){
    return warningHandlerEntry(warnNo, num);
}

function warningHandlerEntry(warnNo, params){
        
        var transtr_warnMsg=null;
        
        switch(parseInt(warnNo)){
            case 0: 
                transtr_warnMsg="No more address can be assigned to the current device!";
                break;
            case 1:
                transtr_warnMsg="Device configuration file is missing. Please contact technical support!";
                break;
            case 2:
                transtr_warnMsg="Invalid parameter! Device type not allowed at this address.";
                break;
            case 3:
                transtr_warnMsg="Device type limited to maximum "+params+" per SLC, application will add till "+params+" and throw away the ones over "+params+" automatically.";
				break;
            case 4:
                transtr_warnMsg="Invalid parameter! Device type not allowed at this address. Use address range 128-254.";
                break;
            case 5:
                transtr_warnMsg="Base device requires to attach to a host detector.";
                break;
            case 6:
                transtr_warnMsg="The detector hosts a sounder base (FAA-325-B6S). Do you want to remove the FAA-325-B6S as well?";
                break;
            case 7:
                transtr_warnMsg="You have made some changes to the configuration, do you want to save them to the panel?\n Press OK to save, or cancel to quit.";
                break;
            case 8:
                transtr_warnMsg="Enter new PIN for Level ";
                transtr_warnMsg+=params+"!";
                break;
            case 9:
                transtr_warnMsg="Enter new PIN for web operator!";
                break;
            case 10:
                transtr_warnMsg="Web browser is not compatible, please update to recommended web browser version.";
                break;
            case 11:
                transtr_warnMsg="No response from panel. Please check if login is correct.";
                break;
            case 12:
                transtr_warnMsg="Done!";
                break;
            case 13:
                transtr_warnMsg="No XML configuration file from server!";
                break;
            case 14:
                transtr_warnMsg="CMD is sending...";
                break;
            case 15:
                transtr_warnMsg="Please enable cookies from your browser for successful login.";
                break;
            case 16:
                transtr_warnMsg="This page does not work without cookies. Cookies don't work in this browser.";
                break;
            case 17:
                transtr_warnMsg="Can not print this page, please check your page settings!";
                break;
            case 18:
                transtr_warnMsg="Zone and DelayMode are mis-match, please check if the zone is already set to counting zone!";
                break;
            case 19:
                transtr_warnMsg="Press OK to confirm and activate changes, then the panel will reinitialize.\nPress Cancel to discarded all changes since login.";
                break;
            case 20:
                transtr_warnMsg="You can log in now! Enter PIN!";
                break;
            case 21:
                transtr_warnMsg="Window is closing now!";
                break;
            case 22:
                transtr_warnMsg="Please remember that your valid login session will expire in 1 minute!";
                break;
            case 23:
                transtr_warnMsg="File format is invalid, please select a valid xml configuration file!";
                break;
            case 24:
                transtr_warnMsg="Please enable cookies to support the logic control processes!";
                break;
            case 25:
				transtr_warnMsg="To replace existing devices, click 'OK' , otherwise skip!";
                break;
            case 26:
                transtr_warnMsg="Does not have enough space for adding devices in current loop. The application can only add to count "+params+". ";
                break;
            case 27:
                transtr_warnMsg="Ending address can not be larger than the starting address. Please try again!";
                break;
            case 28:
                transtr_warnMsg="This add quantity will be greater than the max 254/loop. Please verify your input!";
                break;
            case 29:
                transtr_warnMsg="Address of 'from' field must be smaller than address of 'to' field";
                break;
            case 30:
				transtr_warnMsg="Address of this device can only be addressed with in the range "+params+"!";
                break;
            case 31:
                transtr_warnMsg = "Please refresh the web page or retry later.";
				break;
            case 32:
                transtr_warnMsg="IP Address is invalid. It should be four numbers between 0 and 254, separated with symbol '.' !";
                break;
            case 33:
                transtr_warnMsg="Current Netmask value is invalid!";
                break;
            case 34:
                transtr_warnMsg="Address, Quantity, Group Device ID, and Device ID fields must be filled!";
                break;
            case 35:
                transtr_warnMsg="There is already a device at the current address, please change another address!";
                break;
            case 36:
              	transtr_warnMsg="Phone Number must be 20 digits or less and be numbers only!";
              	break;
            case 37:
                transtr_warnMsg="Waiting";
                transtr_warnMsg+=" ... ... ";
                break;
            case 38:
                transtr_warnMsg="Please reset your login password, or you can not login in the next time!";
                break;
            case 39:
                transtr_warnMsg="Please enter your user name!";
                break;
            case 40:
                transtr_warnMsg="Please enter your password!";
                break;
            case 41:
                transtr_warnMsg="Remote access validation message";
                break;
            case 42:
                transtr_warnMsg="from "+params[0]+" to "+params[1];
                break;
            case 43:
                transtr_warnMsg="Test is in progress!";
                break;
            case 44:
                transtr_warnMsg="Invalid response from server. Validation timeout, please try later!";
                break;
            case 45:
                transtr_warnMsg = "Please refresh the web page or retry later.";
				break;
            case 46:
                transtr_warnMsg = "SLC1 must exist in device list, make sure your panel configuration file is correct!";
                break;
            case 47:
                transtr_warnMsg = "This add quantity will be greater than the max 254/loop. Please verify your input!";
				break;
			case 48:
				transtr_warnMsg = "Warning: Your PC cache may not have enough memory. Please empty your cache and then download and save the software configuration.";
				break;
			case 49:	
				transtr_warnMsg = "Can not retrieve related quick help page!";
                break;
			case 50:
				transtr_warnMsg = "Word List initialized successfully!";
				break;
			case 51:
				transtr_warnMsg = "No file to edit, Please create or load file first!";
				break;
			case 52:
				transtr_warnMsg = "Compare configuration failed!";
				break;
			case 53:
				transtr_warnMsg = "Compare process now, please wait ... ...";
				break;
			case 54:
				transtr_warnMsg = "Your browser does not support AxtiveXObject, please install Firefox above 3.5 version, or IE above 7 version!";
				break;
			case 55: //Mozilla version upgrade noticification
				transtr_warnMsg = "Your browser Firefox needs to be upgraded to above 3.5 version or your web pages will display incorrectly!";
				break;
			case 56:
				transtr_warnMsg = "Your browser IE needs to be upgraded to above 7 version or your web pages will display incorrectly!";
				break;
			case 57:
				var str = "";
				if(params == 0){
					str += "English";
				}else if(params == 1){ 
					str += "Portuguese";
				}else if(params == 2){
					str += "Spanish";
				}
				transtr_warnMsg = "Currently configured language setting:<font color='blue'>"+str+"</font>";
				break;
			case 58:
			    transtr_warnMsg = "The value has to be in the range of "+params+"!";
                break;
			case 59:
			    transtr_warnMsg = "Save Failed! All the encryption key must be in valid range (0-9 A-F)!";
                break;
			case 60:
				transtr_warnMsg = "Please input a valid E-mail address!";
				break;
			case 61:
				transtr_warnMsg = "This Panel ID is already in the panel list table!";
				break;
			case 62:
				transtr_warnMsg = "Panel ID cannot be null, please fill it for this operation!";/*"Panel ID and Group ID can not be null, please fill them for this operation!";*/
				break;
			case 63:
				transtr_warnMsg = "Please input a valid panel ID!";
				break;
			case 64:
				transtr_warnMsg = "Do you really want to remove this panel from network?";
				break;
			case 66:
				transtr_warnMsg = "Exceed the maximum of 9 panels in one group, please register to another group.";
				break;
			case 67:
				transtr_warnMsg = "Please input a valid device address!";
				break;
			case 68:
				transtr_warnMsg = "This zone will be changed into a counting zone, some delayed point features of input point assigned to this zone will not work!";
				break;
			case 69:
				transtr_warnMsg = "Networking features will be removed, all the zones with panel ID will be reset to default. Are you sure you want to do this?";
				break;
			case 70:
				transtr_warnMsg = "Two identical zone numbers cannot exist in one pair!";
				break;
			case 71:
				transtr_warnMsg = "This pair exists!";
				break;
			case 72:
				transtr_warnMsg = "One zone number can only exist in 4 pairs!";
				break;
			case 73:
				transtr_warnMsg = "Please input a valid account number!";
				break;
			case 74:
				transtr_warnMsg = "Contact ID account number: 4 digits (0-9, B-F).";
				break;
			case 75:
				transtr_warnMsg = "SIA-DCS 300 account number: <= 6 digits (0-9, A-F).";
				break;
			case 76:
				transtr_warnMsg = "Modem IIIa2 account number: 4,6,8 or 10 digits (0-9, A-F).";
				break;
			case 77:
				transtr_warnMsg = "Save failed! Receiver IP addresses of primary and secondary account cannot be the same!";
				break;
			case 78:
				transtr_warnMsg = "If the fire network ID is changed, the panel will reboot after implementing configuration!";
				break;
			case 79:
				transtr_warnMsg = "Cannot add more than 9 panels in this fire network!";
				break;
			default:
				transtr_warnMsg = "";
				break;
        }
        
        return transtr_warnMsg;
}

function multiWarnHandler(warnMsgList, paramList){
    var mList = warnMsgList;
    var pList = paramList;
    var warnMsg=null;

    for(var i=0; i<pList.length; i++){
        warnMsg+=mList[i]+pList[i];
    }
    //Or alert
    return warnMsg;
}

function warnMsg_Offline(id){
	var warnMsg = "";
	
	switch(id){
	case 0:
	case 1:
		warnMsg	+= "Loaded configuration file is invalid!";
		break;
	case 2:
		warnMsg += "Loading of configuration file failed!";
		break;
	case 3:
		warnMsg += "Loading of configuration file successful!";
		break;
	case 4:
	    warnMsg = "Please specify the local file to load!";
		break;
	case 5:
		warnMsg = "Loading of language from configuration file failed!";
		break;
	case 6: 
		warnMsg = "No file to edit, Please create or load file first!";
		break;
	case 7:
		warnMsg = "No configuration file available, please create or load a file first!" ;
		break;
	case 8:
		warnMsg = "Please specify the local file to be replaced by current configuration!";
		break;
	case 9:
		warnMsg = "File successfully saved!"
		break;
	case 10:
		warnMsg = "File successfully saved to default folder";
		break;
	case 11:
        warnMsg = "You have made some changes to the configuration.\n Press OK to save, or cancel to quit.";
        break;
	default:
		break;
	}
	
	return warnMsg;
}
