// JavaScript Document
var html2word_def;
function loadXML(confPath){  	
	try{
		if (window.ActiveXObject){ 
            xmlDoc=new ActiveXObject("Microsoft.XMLDOM");
        }else if (document.implementation && document.implementation.createDocument){  
			xmlDoc=document.implementation.createDocument("","",null);  
		}else{  
            alert('Your browser cannot handle this script');  
			return null;
        }	
		
		xmlDoc.async=false; 
        xmlDoc.load(confPath);	
		
        return xmlDoc;
	}catch(err){
		alert("exception occurs in loadXML function!");
		return null;
	}	
}

function loadFromStr(str){
	var parser = null;
	var xmldoc = null;
	
	try{
		parser = new DOMParser();
		xmldoc = parser.parseFromString(str, "text/xml");
		return xmldoc;
	}catch(err){
		alert(err.message);
		return null;
	}
}

function getNodes(node, nodePath){
	if(node != null){
		var resultNodes = node.selectNodes(nodePath);
		if(resultNodes.length == 0){
			return null;
		}else{
			return resultNodes;
		}
	}
}


//-------------------------------------------
// Function: compConfig()
// Description: 
//			combine the compHeader, compDevices together --> extend
// Return: null
//-------------------------------------------
function compConfig(o_confElem, m_confElem, html2word_var){
	
	compHeader(o_confElem, m_confElem, html2word_var);
	compDevices(o_confElem, m_confElem, html2word_var);
	
}

function compHeader(o_confElem, m_confElem, html2word_var){
	
	var o_header;
	var m_header;
	var html2word_path;
	var output = "";
	var message = "";

	try{
		//alert(o_confElem.nodeName);
		//alert(m_confElem.nodeName);
		
		o_header = o_confElem.getElementsByTagName("GENERAL")[0];
		m_header = m_confElem.getElementsByTagName("GENERAL")[0];
		html2word_path += "GENERAL";
		//alert("debug 1");
		for(var i=0; i<o_header.childNodes.length; i++){
			var o_child = o_header.childNodes[i];
			var m_child = m_header.getElementsByTagName(o_child.nodeName)[0];
			html2word_path +="_"+o_child.nodeName;
			//alert("debug 2: o_child.nodeValue="+o_child.firstChild.nodeValue+", m_child.nodeValue="+m_child.firstChild.nodeValue);
			if((o_child.firstChild == null)&&(m_child.firstChild == null)){
				//matched
				continue;
			}else if((m_child.firstChild != null)&&(o_child.firstChild == null)){
				//not matched and print out message
				output += "<TR><TD>"+o_child.nodeName+"</TD><TD>null</TD><TD>"+m_child.firstChild.nodeValue+"</TD></TR>";
			}else if((m_child.firstChild == null)&&(o_child.firstChild != null)){
				output += "<TR><TD>"+o_child.nodeName+"</TD><TD>"+o_child.firstChild.nodeValue+"</TD><TD>null</TD></TR>";
			}else{
				//original not matched the current node.
				if(o_child.firstChild.nodeValue != m_child.firstChild.nodeValue){
				output += "<TR><TD>"+o_child.nodeName+"</TD><TD>"+o_child.firstChild.nodeValue+"</TD><TD>"+m_child.firstChild.nodeValue+"</TD></TR>";
				}
			}
		}//end of for loop
		message +="<TABLE border=&quot;1&quot;><TR><TH>Configure Item</TH><TH>Original Setting</TH><TH>Current Setting</TH></TR>"+output+"</TABLE>"
		document.getElementById("ID_Config").innerHTML = message;
	}catch(err){
		alert("exception occurs!");	
	}
}//end of parseHeader


//compare single nodes
//MAINBOARD:
//	Relay1 - Relay3: Path "MAINBOARD/Relay1" - "MAINBOARD/Relay3"
//	NAC1 - NAC2: Path "MAINBOARD/NAC1" - "MAINBOARD/NAC2"
//  CityTie - "MAINBOARD/CityTie/Enable", "MAINBOARD/CityTie/CityTie1/", "MAINBOARD/CityTie/CityTie2"
function compSingle(o_confElem, m_confElem, html2word_var){
	
	var o_header;
	var m_header;
	var html2word_path;
	var output = "";
	var message = "";
	
	try{
		//alert(o_confElem.nodeName);
		//alert(m_confElem.nodeName);
		
		//o_header = o_confElem.getElementsByTagName("GENERAL")[0];
		//m_header = m_confElem.getElementsByTagName("GENERAL")[0];
		html2word_path += "GENERAL";
		//alert("debug 1");
		for(var i=0; i<o_header.childNodes.length; i++){
			var o_child = o_header.childNodes[i];
			var m_child = m_header.getElementsByTagName(o_child.nodeName)[0];
			html2word_path +="_"+o_child.nodeName;
			//alert("debug 2: o_child.nodeValue="+o_child.firstChild.nodeValue+", m_child.nodeValue="+m_child.firstChild.nodeValue);
			if((o_child.firstChild == null)&&(m_child.firstChild == null)){
				//matched
				continue;
			}else if((m_child.firstChild != null)&&(o_child.firstChild == null)){
				//not matched and print out message
				output += "<TR><TD>"+o_child.nodeName+"</TD><TD>null</TD><TD>"+m_child.firstChild.nodeValue+"</TD></TR>";
			}else if((m_child.firstChild == null)&&(o_child.firstChild != null)){
				output += "<TR><TD>"+o_child.nodeName+"</TD><TD>"+o_child.firstChild.nodeValue+"</TD><TD>null</TD></TR>";
			}else{
				//original not matched the current node.
				if(o_child.firstChild.nodeValue != m_child.firstChild.nodeValue){
				output += "<TR><TD>"+o_child.nodeName+"</TD><TD>"+o_child.firstChild.nodeValue+"</TD><TD>"+m_child.firstChild.nodeValue+"</TD></TR>";
				}
			}
		}//end of for loop
		//message +="<TABLE border=&quot;1&quot;><TR><TH>Configure Item</TH><TH>Original Setting</TH><TH>Current Setting</TH></TR>"+output+"</TABLE>"
		document.getElementById("ID_Config").innerHTML = message; //just list the bodys
	}catch(err){
		alert("exception occurs!");	
	}
}//end of parseHeader

function compMainboard(o_mainboard, m_mainboard, html2word){
	
	var output_msg = "";
	
	var o_relay = o_mainboard.getElementsByTagName("MAINBOARD")[0].getElementsByTagName("Relay1")[0];
	var m_relay = m_mainboard.getElementsByTagName("MAINBOARD")[0].getElementsByTagName("Relay1")[0];

	output_msg += compSingle(o_relay, m_relay, html2word);
	
	o_relay = o_mainboard.getElementsByTagName("MAINBOARD")[0].getElementsByTagName("Relay2")[0];
	m_relay = m_mainboard.getElementsByTagName("MAINBOARD")[0].getElementsByTagName("Relay2")[0];
	
	output_msg += compSingle(o_relay, m_relay, html2word);
	
	//MAINBOARD/CityTie/Enable
	var o_citytie_enable = o_mainboard.getElementsByTagName("MAINBOARD")[0].getElementsByTagName("CityTie")[0].getElementsByTagName("Enable")[0];
	var m_citytie_enable = m_mainboard.getElementsByTagName("MAINBOARD")[0].getElementsByTagName("CityTie")[0].getElementsByTagName("Enable")[0];
	if((o_citytie_enable.firstChild != null)&&(m_citytie_enable.firstChild != null)){
		if(o_citytie_enable.firstChild.nodeValue != m_citytie_enable.firstChild.nodeValue){
			output_msg += "<TR><TD>"+document.getElementById("WORD_CITYTIE_ENABLE").value+"</TD><TD>"+o_citytie_enable.firstChild.nodeValue+"</TD><TD>"+m_citytie_enable.firstChild.nodeValue+"</TD></TR>";
		}
	}else if((o_citytie_enable.firstChild != null)&&(m_citytie_enable.firstChild == null)){
		output_msg += "<TR><TD>"+document.getElementById("WORD_CITYTIE_ENABLE").value+"</TD><TD>"+o_citytie_enable.firstChild.nodeValue+"</TD><TD>null</TD></TR>";	
	}else if((o_citytie_enable.firstChild == null)&&(m_citytie_enable.firstChild != null)){
		output_msg += "<TR><TD>"+document.getElementById("WORD_CITYTIE_ENABLE").value+"</TD><TD>null</TD><TD>"+m_citytie_enable.firstChild.nodeValue+"</TD></TR>";
	}else{
		//do nothing in this case
	}
	
	//MAINBOARD/
	var o_citytie_1 = o_mainboard.getElementsByTagName("MAINBOARD")[0].getElementsByTagName("CityTie")[0].getElementsByTagName("CityTie1")[0];
	var m_citytie_1 = m_mainboard.getElementsByTagName("MAINBOARD")[0].getElementsByTagName("CityTie")[0].getElementsByTagName("CityTie1")[0];
	
	output_msg += compSingle(o_citytie_1, m_citytie_1, html2word);
	
	var o_citytie_2 = o_mainboard.getElementsByTagName("MAINBOARD")[0].getElementsByTagName("CityTie")[0].getElementsByTagName("CityTie2")[0];
	var m_citytie_2 = m_mainboard.getElementsByTagName("MAINBOARD")[0].getElementsByTagName("CityTie")[0].getElementsByTagName("CityTie2")[0];
	
	output_msg += compSingle(o_citytie_2, m_citytie_2, html2word);
	
	return output_msg;

}// end of compMainboard

function compOptionBus(o_optionbus, m_optionbus, html2word){
	
	var output_msg = "";
	
	var o_repeatLED1to4 = o_optionbus.getElementsByTagName("OPTIONBUS")[0].getElementsByTagName("RepeatLED1to4")[0];	
	var m_repeatLED1to4 = m_optionbus.getElementsByTagName("OPTIONBUS")[0].getElementsByTagName("RepeatLED1to4")[0];
	if((o_repeatLED1to4.firstChild != null)&&(m_repeatLED1to4.firstChild != null)){
		if(o_repeatLED1to4.firstChild.nodeValue != m_repeatLED1to4.firstChild.nodeValue){
			output_msg += "<TR><TD>"+document.getElementById("WORD_CITYTIE_LED1TO4").value+"</TD><TD>"+o_repeatLED1to4.firstChild.nodeValue+"</TD><TD>"+m_repeatLED1to4.firstChild.nodeValue+"</TD></TR>";
		}
	}else if((o_repeatLED1to4.firstChild != null)&&(m_repeatLED1to4.firstChild == null)){
		output_msg += "<TR><TD>"+document.getElementById("WORD_CITYTIE_LED1TO4").value+"</TD><TD>"+o_repeatLED1to4.firstChild.nodeValue+"</TD><TD>null</TD></TR>";
	}else if((o_repeatLED1to4.firstChild == null)&&(m_repeatLED1to4.firstChild != null)){
		output_msg += "<TR><TD>"+document.getElementById("WORD_CITYTIE_LED1TO4").value+"</TD><TD>null</TD><TD>"+m_repeatLED1to4.firstChild.nodeValue+"</TD></TR>";
	}else{
		//nothing to do when them match.
	}
	
	//for Ann1 - Ann8
	for(var i=1; i<9; i++){
		var ann_name = "Ann"+i;
		var o_ann = o_optionbus.getElementsByTagName("OPTIONBUS")[0].getElementsByTagName(ann_name)[0];
		var m_ann = m_optionbus.getElementsByTagName("OPTIONBUS")[0].getElementsByTagName(ann_name)[0];

		output_msg += compSingle(o_ann, m_ann, html2word);

	}
	
	//for Ann16 - Ann23
	for(var i=16; i<24; i++){
		var ann_name = "Ann"+i;
		var o_ann = o_optionbus.getElementsByTagName("OPTIONBUS")[0].getElementsByTagName(ann_name)[0];
		var m_ann = m_optionbus.getElementsByTagName("OPTIONBUS")[0].getElementsByTagName(ann_name)[0];

		output_msg += compSingle(o_ann, m_ann, html2word);

	}
	
	//for outputMod9-10
	//TODO: call another function to handle the output mod
	
	return output_msg;
	
}

function compCityTieOutputMod(o_output_mod, m_output_mod, html2word){
	
	var output_msg = "";
	
	var o_enable = o_output_mod.getElementsByTagName("Enable")[0];
	var m_enable = m_output_mod.getElementsByTagName("Enable")[0];
	if((o_enable.firstChild != null)&&(m_enable.firstChild != null)){
		if(o_enable.firstChild.nodeValue != m_enable.firstChild.nodeValue){
			output_msg += "<TR><TD>"+document.getElementById("ID_CITYTIE_ENABLE").value+"</TD><TD>"+o_enable.firstChild.nodeValue+"</TD><TD>"+m_enable.firstChild.nodeValue+"</TD></TR>";
		}else if((o_enable.firstChild != null)&&(m_enable.firstChild == null)){
			output_msg += "<TR><TD>"+document.getElementById("ID_CITYTIE_ENABLE").value+"</TD><TD>"+o_enable.firstChild.nodeValue+"</TD><TD>null</TD></TR>";
		}else if((o_enable.firstChild == null)&&(m_enable.firstChild != null)){
			output_msg += "<TR><TD>"+document.getElementById("ID_CITYTIE_ENABLE").value+"</TD><TD>null</TD><TD>"+m_enable.firstChild.nodeValue+"</TD></TR>";
		}else{
			//do nothing in this case.
		}
	}
	
	return output_msg;
}

function compReport(o_reports, m_reports, html2word){
	var output_msg = "";
	
	// REPORT/Primary
	var o_report = o_reports.getElementsByTagName("REPORT")[0].getElementsByTagName("Primary")[0];
	var m_report = m_reports.getElementsByTagName("REPORT")[0].getElementsByTagName("Primary")[0];
	output_msg += compSingle(o_report, m_report, html2word);
	
	// REPORT/Secondary
	o_report = o_reports.getElementsByTagName("REPORT")[0].getElementsByTagName("Secondary")[0];
	m_report = m_reports.getElementsByTagName("REPORT")[0].getElementsByTagName("Secondary")[0];
	output_msg += compSingle(o_report, m_report, html2word);
	
	// REPORT/PSTN
	o_report = o_reports.getElementsByTagName("REPORT")[0].getElementsByTagName("PSTN")[0];
	m_report = m_reports.getElementsByTagName("REPORT")[0].getElementsByTagName("PSTN")[0];
	output_msg += compSingle(o_report, m_report, html2word);
	
	// REPORT/Reporting
	o_report = o_reports.getElementsByTagName("REPORT")[0].getElementsByTagName("Reporting")[0];
	m_report = m_reports.getElementsByTagName("REPORT")[0].getElementsByTagName("Reporting")[0];
	output_msg += compSingle(o_report, m_report, html2word);
	
	return outpur_msg;
}// end of compReport


//should input the number for comparation (from 129 to 136)
function compZones(o_zones, m_zones, startIndex, endIndex, html2word){
	
	var output_msg = "";
	
	// ZONES/Zone129 - ZONES/Zone136
	for(var i=startIndex; i<endIndex; i++){
		var zones = "Zone"+i;
		var o_zone = o_zones.getElementsByTagName("ZONES")[0].getElementsByTagName(zones)[0];
		var m_zone = m_zones.getElementsByTagName("ZONES")[0].getElementsByTagName(zones)[0];
		output_msg += compSingle(o_zone, m_zone, html2word);
	}
	
	// ZONES/Zone1-128 List
	
	
}// end of compZones

function compDevices(o_devices, m_devices, html2word){
	
	var output_msg = "";
	
	if((null==o_devices)||(null==m_devices)||(null==html2word)){
		alert("configuration is invalid or not complete!");
		return false;
	}else{
		//get configurations
		
		output_msg += "<TABLE border=&quot;1&quot;><TR><TH>"+document.getElementById("ID_ITEM").value+"</TH><TH>"+document.getElementById("ID_OCONF").value+"</TH><TH>"+document.getElementById("ID_CCONF").value+"</TH></TR>";
		
		var o_len = o_devices.length;
		var m_len = m_devices.length;
		var flag = false; //to distinguish whether the current devices get the same output or not.
		for(var i=0,j=0, flag=1; i<o_len, j<m_len;flag++){
			
			var o_device = o_devices[i];
			var m_device = m_devices[j];
			//alert("debug 1 : current o_device.nodeName="+o_device.nodeName+", m_device.nodeName="+m_device.nodeName);
			//alert("current i="+i+", j="+j);
			if(i<o_len){
				//i<o_len
				if(j<m_len){
					//i<o_len, j<m_len: comp the current i list devices with the j list devices
					var o_addr = o_device.getElementsByTagName("Address");
					var m_addr = m_device.getElementsByTagName("Address");
					
					if(parseInt(o_addr[0].firstChild.nodeValue) == parseInt(m_addr[0].firstChild.nodeValue)){
						if(matchDevice(o_device, m_device)){
							//nothing to do here 
						}else{
							//alert("find output device! not matched!");
							output_msg += "<TR><TD>"+o_addr[0].firstChild.nodeValue+"</TD><TD>"+printDevice(o_device)+"</TD><TD>"+printDevice(m_device)+"</TD></TR>";
						}
						i++;
						j++;
					}else if(parseInt(o_addr[0].firstChild.nodeValue) < parseInt(m_addr[0].firstChild.nodeValue)){
							//the original and current device info are not matched : add the original one and i++
							var device_info = printDevice(o_device);
							output_msg += "<TR><TD>"+o_addr[0].firstChild.nodeValue+"</TD><TD>"+device_info+"</TD><TD></TD></TR>";
							i++;
					}else{
							//the current device info added to the output and j++
							var device_info = printDevice(m_device);
							output_msg += "<TR><TD>"+m_addr[0].firstChild.nodeValue+"</TD><TD></TD><TD>"+device_info+"</TD></TR>";
							j++;
					}
				}else{
					//i<o_len, j>=m_len: add all i loop devices to the output
					//alert("debug 4 : loop end i="+i+", o_len="+o_len);
					output_msg += printMultiDevices(o_devices, i, o_len, true);
					break;
				}
			}else{
				//i>=o_len
				if(j<m_len){
					//i>o_len, j<m_len: add all the devices in the m_devices list.
					//alert("debug 2 : loop end j="+j+", m_len="+m_len);
					output_msg += printMultiDevices(m_devices, j, m_len, false);
					break;
				}else{
					//i>o_len, j>m_len: finished loop travel
					//alert("compared completed!");
					break;
				}
			}
		}//end of for loop
		
		output_msg += "</TABLE>";
		alert("output message : "+output_msg);
		document.getElementById("ID_Config").innerHTML = output_msg;
	}
	
}//end of compDevices

//match two devices with the same address value (original, current)
function matchDevice(o_device, m_device){
	
	var flag = true;
	
	try{ //if type is not matched then return false;
		var o_deviceType = o_device.getElementsByTagName("DeviceType")[0];
		var m_deviceType = m_device.getElementsByTagName("DeviceType")[0];
		
		alert("debug : oDeviceName="+o_deviceType.nodeName+", mDeviceName="+m_deviceType.nodeName);
		
		if(o_deviceType.firstChild.nodeValue == m_deviceType.firstChild.nodeValue){
			//get the same device type.
			for(var k=0; k<o_device.childNodes.length; k++){
				//loop the original and current device attributes.
				var oc_device = o_device.childNodes[k];
				//alert("debug : original matched device nodeName="+oc_device.nodeName);
				var mc_device = m_device.getElementsByTagName(oc_device.nodeName)[0];
				alert("device : oc_device.nodeName="+oc_device.nodeName+", mc_device.nodeName="+mc_device.nodeName);
				if(mc_device == null){
					//do not find the matched node.
					return false;
				}
			
				if((oc_device.firstChild != null)&&(mc_device.firstChild != null)){
					if(oc_device.firstChild.nodeValue != mc_device.firstChild.nodeValue){
						//match the same node with the same values.
						alert("device : find the unequals device will be output!");
						return false;
					}else{
						continue;
					}
				}else if((oc_device.firstChild == null)&&(mc_device.firstChild == null)){
					alert("find node without text child node! null node!");
					continue;
				}else{  
					//if one of them equals null, it comes out to be not equal.
					flag = false;
					break;
				}
			
			}
		}else{
			//different devices
			flag = false;
		}
		
		return flag;
	}catch(err){
		//TODO: device type not equals must taken into handle
		alert("the current device get child with null value");
		return true;
	}
}//end of matchDevice

//TODO: separate printOneDevice
//function printOneDevice(device){
function printDevice(device){
	var output_msg = "";
	
	try{
		for(var k=0; k<device.childNodes.length; k++){
			var child_device = device.childNodes[k];
			if(child_device.firstChild != null)
				output_msg += child_device.nodeName + " : "+child_device.firstChild.nodeValue+"<br/>";
			else
				output_msg += child_device.nodeName+ " : null<br/>";
		}//end of for loop
		return output_msg;
	}catch(err){
		alert("exception catched in printDevice!");
		return null;
	}
}

//flag: true - the original device list;
//		false - the current device list;
function printMultiDevices(devices, start, end, flag){
	var output_msg = ""; 
	alert("output multiple devices!");
	
	try{
		for(var device_index = start; device_index < end; device_index++){
			var device_info = printDevice(devices[device_index]);
			if(flag){ //output the left line
				//alert(devices[device_index].getElementsByTagName("Address")[0].firstChild.nodeValue);
				output_msg += "<TR><TD>"+devices[device_index].getElementsByTagName("Address")[0].firstChild.nodeValue+"</TD><TD>"+device_info+"</TD><TD></TD></TR>";
			}else{ //output the right line
				//alert(devices[device_index].getElementsByTagName("Address")[0].firstChild.nodeValue);
				output_msg += "<TR><TD>"+devices[device_index].getElementsByTagName("Address")[0].firstChild.nodeValue+"</TD><TD></TD><TD>"+device_info+"</TD></TR>";
			}
		}
		return output_msg;
	}catch(err){
		alert("exception catched in printMultiDevices!");
		return null;
	}
}