<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:template match="/FPA1000">
<html>
	<head>
		<style type="text/css">
			.ConfContent {font-size:12px; font-weight:normal; color:blue;}
		</style>
	</head>
<body>
    <div id="DISPLAY_CONFFILE" style="font-family:'Times New Roman', Times, serif; font-size:12px;">
        <xsl:apply-templates select="HEADER" />
        <xsl:apply-templates select="GENERAL"></xsl:apply-templates>
		<table border="1" style="color:black; width:800px; left:50px;">
        <tr align="center" style="background:black; color:white; font-size:14px; font-weight:bold;" >
            <td colspan="9">SLC 1 Settings</td>
        </tr>
		</table>
        <xsl:apply-templates select="LOOP1"></xsl:apply-templates>
		<table border="1" style="color:black; width:800px; left:50px;">
        <tr align="center" style="background:black; color:white; font-size:14px; font-weight:bold;" >
            <td colspan="9">SLC 2 Settings</td>
        </tr>
		</table>
		<xsl:apply-templates select="LOOP2"></xsl:apply-templates>
        <xsl:apply-templates select="MAINBOARD"></xsl:apply-templates>
        <xsl:apply-templates select="OPTIONBUS"></xsl:apply-templates>
        <xsl:apply-templates select="REPORT"></xsl:apply-templates>
        <xsl:apply-templates select="ZONES"></xsl:apply-templates>
		<xsl:apply-templates select="NETWORK"></xsl:apply-templates>
    </div>
    </body>
</html>
</xsl:template>

<xsl:template name="LevelTP" match="HistoryLv|WalktestLv|TestLv|DateLv|BypassLv">
	<xsl:choose>
		<xsl:when test=". = '1'"><xsl:text>Level 1</xsl:text></xsl:when>
		<xsl:when test=". = '2'"><xsl:text>Level 2</xsl:text></xsl:when>
		<xsl:when test=". = '3'"><xsl:text>Level 3</xsl:text></xsl:when>
		<xsl:otherwise></xsl:otherwise>
	</xsl:choose>
</xsl:template>

<xsl:template name="Bypass" match="B">
	<xsl:choose>
		<xsl:when test=". = '0'"><xsl:text>FALSE</xsl:text></xsl:when>
		<xsl:when test=". = '1'"><xsl:text>TRUE</xsl:text></xsl:when>
	</xsl:choose>
</xsl:template>

<xsl:template name="workWide" match="PrintWide|CityTieWide|ReportWide">
	<xsl:choose>
		<xsl:when test=". = '1'"><xsl:text>Panel wide</xsl:text></xsl:when>
		<xsl:when test=". = '2'"><xsl:text>Group wide</xsl:text></xsl:when>
		<xsl:when test=". = '3'"><xsl:text>Network wide</xsl:text></xsl:when>
		<xsl:otherwise></xsl:otherwise>
	</xsl:choose>
</xsl:template>

<!-- start of Define Header Section -->
<xsl:template match="HEADER" >
<table border="1" style="color:black; width:800px; left:50px;" >
        <tr>
            <th colspan="4" style=" background:black; color:white; font-weight:bold; font-size:14px; text-align:center; " >Header Settings</th>
        </tr>
        <tr>
            <td colspan="4" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">Header</td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">File Name</td>
            <td style="font-size:12px; font-weight:bold;">Version Number</td>
            <td style="font-size:12px; font-weight:bold;">Last Modified Date</td>
            <td style="font-size:12px; font-weight:bold;">Data Version</td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:normal; color:blue;">
                <xsl:value-of select="Filename" /></td>
            <td style="font-size:12px; font-weight:normal; color:blue;">
                <xsl:value-of select="RevNumber" /></td>    
            <td style="font-size:12px; font-weight:normal; color:blue;">
                <xsl:value-of select="LastModified" /></td>
            <td style="font-size:12px; font-weight:normal; color:blue;">
                <xsl:value-of select="DataVersion" /></td>
        </tr>
    </table>
</xsl:template>

<xsl:template match="GENERAL">
    <table border="1" style="color:black; width:800px; left:50px;">
        <tr>
            <th colspan="8" style="background:black; color:white; font-weight:bold; font-size:14px; text-align:center; ">General Settings</th>
        </tr>
            <tr>
                <td colspan="8" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">Basic Settings</td>
            </tr>
            <tr>
                <td style="font-size:12px; font-weight:bold;"><xsl:text>Banner</xsl:text> (1. <xsl:text>line</xsl:text>)</td>
                <td style="font-size:12px; font-weight:bold;"><xsl:text>Banner</xsl:text> (2. <xsl:text>line</xsl:text>)</td>
                <td style="font-size:12px; font-weight:bold;">Language</td>
				<td style="font-size:12px; font-weight:bold;">Panel ID</td>
                <td style="font-size:12px; font-weight:bold;">Panel IP Address</td>
                <td style="font-size:12px; font-weight:bold;">Gateway</td>
                <td style="font-size:12px; font-weight:bold;">Netmask</td>
				<td style="font-size:12px; font-weight:bold;">Fire Network ID</td>
                             
            </tr>
            <tr>
                <td style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:value-of select="Banner1st" /></td>
                <td style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:value-of select="Banner2nd" /></td>
                <td style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:apply-templates select="Language" /></td>
				<td style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:value-of select="PanelID" /></td>	
                <td style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:value-of select="PanelIP" /></td>
                <td style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:value-of select="Gateway" /></td>
                <td style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:value-of select="Netmask" /></td>
				<td style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:value-of select="NetworkID" /></td>	
            </tr>
			 <tr>
			  	<td style="font-size:12px; font-weight:bold;">Printer IP Address</td>  
                <td style="font-size:12px; font-weight:bold;">Printer FTP User</td>
				<td style="font-size:12px; font-weight:bold;">Printer FTP Password</td>
				<td style="font-size:12px; font-weight:bold;">Printer FTP Port</td>
                <td colspan="4" style="font-size:12px; font-weight:bold;"><xsl:text>Print events/operations from</xsl:text>: </td>
            </tr>
			<tr>
				<td style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:value-of select="PrinterIP" /></td> 
				<td style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:value-of select="FTPuser" /></td>
                <td style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:value-of select="FTPpwd" /></td>
                <td style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:value-of select="FTPport" /></td>
                <td colspan="4" style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:apply-templates select="PrintWide"></xsl:apply-templates></td>
			</tr>
        </table>
       
        <table border="1" style="color:black; width:800px; left:50px;">
            <tr>
                <td colspan="9" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;" >System Settings, Time Format, Units and Silence</td>
        </tr>
        <tr>
                <td style="font-size:12px; font-weight:bold;">Sandwich Enabled</td>
                <td style="font-size:12px; font-weight:bold;">Aux Power Reset</td>
                <td style="font-size:12px; font-weight:bold;" >Supervisory Latching</td>
                <td style="font-size:12px; font-weight:bold;">External Power Supply</td>
                <td style="font-size:12px; font-weight:bold;">Time Format</td>
                <td style="font-size:12px; font-weight:bold;">Unit Format</td>
                <td style="font-size:12px; font-weight:bold;">Silence</td>
                <td style="font-size:12px; font-weight:bold;">Enable Silence</td>
                <td style="font-size:12px; font-weight:bold;">Enable Drill</td>
        </tr>
        <tr>
                <td style="font-size:12px; font-weight:normal; color:blue;">
                    <xsl:value-of select="EnableSandwich" /></td>
                <td style="font-size:12px; font-weight:normal; color:blue;">
                    <xsl:value-of select="AuxPowerReset" /></td>
                <td style="font-size:12px; font-weight:normal; color:blue;">
                    <xsl:value-of select="SupLatching" /></td>
                <td style="font-size:12px; font-weight:normal; color:blue;">
                    <xsl:value-of select="ExtPower" /></td>    
                <td style="font-size:12px; font-weight:normal; color:blue;">
                    <xsl:apply-templates select="TimeFormat" /></td>
                <td style="font-size:12px; font-weight:normal; color:blue;">
                    <xsl:apply-templates select="UnitFormat" /></td>
                <td style="font-size:12px; font-weight:normal; color:blue;">
                    <xsl:apply-templates select="Silence" /></td>
                <td style="font-size:12px; font-weight:normal; color:blue;">
                    <xsl:value-of select="EnableSilence" /></td>
                <td style="font-size:12px; font-weight:normal; color:blue;">
                    <xsl:value-of select="EnableDrill" /></td>
        </tr>
        </table>
        
        <table border="1" style="color:black; width:800px; left:50px;">
            <tr>
                <td colspan="6" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">Level Needed for Operation</td>
            </tr>
            <tr>
			    <td style="font-size:12px; font-weight:bold;">PIN for reset/silence/drill</td>
                <td style="font-size:12px; font-weight:bold;">History </td>
                <td style="font-size:12px; font-weight:bold;">Walktest  </td>
                <td style="font-size:12px; font-weight:bold;">Test </td>
                <td style="font-size:12px; font-weight:bold;">Date </td>
                <td style="font-size:12px; font-weight:bold;">Bypass </td>
            </tr>
            <tr style="font-size:12px; font-weight:normal; color:blue;">
				<td><xsl:value-of select="Pin4rsd" /></td>
                <td><xsl:apply-templates select="HistoryLv"></xsl:apply-templates></td>
                <td><xsl:apply-templates select="WalktestLv"></xsl:apply-templates></td>
                <td><xsl:apply-templates select="TestLv"></xsl:apply-templates></td>
                <td><xsl:apply-templates select="DateLv"></xsl:apply-templates></td>
                <td><xsl:apply-templates select="BypassLv"></xsl:apply-templates></td>
            </tr>
        </table>

        <table border="1" style="color:black; width:800px; left:50px;">
            <tr>
                <td colspan="2" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">Time Scheduled</td>
            </tr>
            <tr>
                <td style="font-size:12px; font-weight:bold;">Daylight Enabled</td>
                <td style="font-size:12px; font-weight:normal; color:blue;">
                    <xsl:value-of select="DayLightSaving" /></td>
            </tr>
            <tr>
                <td style="font-size:12px; font-weight:bold;">Daylight Time</td>
                <td style="font-size:12px; font-weight:normal; color:blue;">
                    Start from  <xsl:for-each select="StartWeek">
					                <xsl:call-template name="Week"></xsl:call-template>
								</xsl:for-each>
                    week of  <xsl:for-each select="StartMonth">
					                <xsl:call-template name="Month"></xsl:call-template>
								</xsl:for-each><br/>
                    End of <xsl:for-each select="EndWeek">
					                <xsl:call-template name="Week"></xsl:call-template>
							</xsl:for-each> 
                    week of <xsl:for-each select="EndMonth">
					                <xsl:call-template name="Month"></xsl:call-template>
							</xsl:for-each><br/>
                </td>
            </tr>
            <tr>
                <td style="font-size:12px; font-weight:bold;">Detector Day Sensitivity</td>
                <td style="font-size:12px; font-weight:normal; color:blue;">
                <table width="100%" align="left">
                <tr>
                    <td style="font-size:12px; font-weight:bold; text-align:right;"><xsl:text>Su</xsl:text>:</td>
                    <td style="font-size:12px; font-weight:normal; color:blue;  text-align:left;">
                        <xsl:value-of select="AutoDMSu" /></td>
                    <td style="font-size:12px; font-weight:bold; text-align:right;">, <xsl:text>Mo</xsl:text>:</td> 
                    <td style="font-size:12px; font-weight:normal; color:blue;  text-align:left;">
                        <xsl:value-of select="AutoDMMo" /></td>
                    <td style="font-size:12px; font-weight:bold; text-align:right;">, <xsl:text>Tu</xsl:text>:</td>
                    <td style="font-size:12px; font-weight:normal; color:blue;  text-align:left;">
                        <xsl:value-of select="AutoDMTu" /></td>
                    <td style="font-size:12px; font-weight:bold;  text-align:right;">, <xsl:text>We</xsl:text>:</td>
                    <td style="font-size:12px; font-weight:normal; color:blue;  text-align:left;">
                        <xsl:value-of select="AutoDMWe" /></td>
                    <td style="font-size:12px; font-weight:bold;  text-align:right;">, <xsl:text>Th</xsl:text>:</td>
                    <td style="font-size:12px; font-weight:normal; color:blue;  text-align:left;">
                        <xsl:value-of select="AutoDMTh" /></td>
                    <td style="font-size:12px; font-weight:bold;  text-align:right;">, <xsl:text>Fr</xsl:text>:</td>
                    <td style="font-size:12px; font-weight:normal; color:blue;  text-align:left;">
                        <xsl:value-of select="AutoDMFr" /></td>
                    <td style="font-size:12px; font-weight:bold;  text-align:right;">, <xsl:text>Sa</xsl:text>:</td>
                    <td style="font-size:12px; font-weight:normal; color:blue;  text-align:left;">
                        <xsl:value-of select="AutoDMSa" /></td>
                </tr>
                <tr>
                    <td colspan="3" style="font-size:12px; font-weight:bold;  text-align:right;">
                        Start time: </td>
                    <td colspan="3" style="font-size:12px; font-weight:normal; text-align:left; color:blue;">
                        <xsl:value-of select="DMStartHour" />:<xsl:value-of select="DMStartMin" />
                        <xsl:choose> 
                            <xsl:when test="DMStartPM = 'FALSE'"><xsl:text> AM</xsl:text></xsl:when>
                            <xsl:otherwise><xsl:text> PM</xsl:text></xsl:otherwise> 
                        </xsl:choose></td>
					<td colspan="3" style="font-size:12px; font-weight:bold;  text-align:right;">
                        End time: </td>
                    <td colspan="3" style="font-size:12px; font-weight:normal; text-align:left; color:blue;">
                        <xsl:value-of select="DMEndHour" />:<xsl:value-of select="DMEndMin" />
                        <xsl:choose> 
                            <xsl:when test="DMEndPM = 'FALSE'"><xsl:text> AM</xsl:text></xsl:when>
                            <xsl:otherwise><xsl:text> PM</xsl:text></xsl:otherwise> 
                        </xsl:choose></td> 
					<td colspan="2"></td>	           
                </tr>
                </table>
            </td>
        </tr>
        </table>

        <table border="1" style="color:black; width:800px; left:50px;">
            <tr>
                <td colspan="2" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">Timer Settings</td>
            </tr>
            <tr>
                <td style="font-size:12px; font-weight:bold;" width="20%">Day Mode</td>    
                <td style="font-size:12px; font-weight:normal; color:blue;" width="80%">
                    <xsl:apply-templates select="GlobalDelayMode" /></td>
            </tr>
			<tr>
                <td style="font-size:12px; font-weight:bold;" width="20%">Global Delay Mode</td>    
                <td style="font-size:12px; font-weight:normal; color:blue;" width="80%">
                    <xsl:apply-templates select="DelayModeOption" /></td>
            </tr>
            <tr>
                <td style="font-size:12px; font-weight:bold;" width="20%">Investigation Time</td>
                <td style="font-size:12px; font-weight:normal; color:blue;">
                    <xsl:value-of select="GlobalDelayTime" /> s</td>
            </tr>
            <tr>
                <td style="font-size:12px; font-weight:bold;" width="20%">Alarm Verification Delay</td>
                <td style="font-size:12px; font-weight:normal; color:blue;">
                    <xsl:value-of select="AVDelay" /> s</td>
            </tr>
            <tr>
                <td style="font-size:12px; font-weight:bold;" width="20%">AC Failure Delay</td>
                <td style="font-size:12px; font-weight:normal; color:blue;">
                    <xsl:value-of select="ACDelay" /> h</td>
            </tr>
			<tr>
				<td style="font-size:12px; font-weight:bold;" width="20%">Waterflow Silenceable</td>
				<td style="font-size:12px; font-weight:normal; color:blue;"><xsl:value-of select="WFSilenceable" /></td>
			</tr>
            <tr>
                <td style="font-size:12px; font-weight:bold;" width="20%">Waterflow Delay</td>
                <td style="font-size:12px; font-weight:normal; color:blue;"><xsl:value-of select="WFDelay" /> s</td>
            </tr>
            <tr>
                <td style="font-size:12px; font-weight:bold;" width="20%">Auto Silence Delay</td>
                <td style="font-size:12px; font-weight:normal; color:blue;">
                    <xsl:text>Enabled</xsl:text>: <xsl:value-of select="ASDEnable" /><br/>
                    <xsl:text>Delay Time</xsl:text>: <xsl:value-of select="ASDelay" /> min</td>
            </tr>
            <tr>
                <td style="font-size:12px; font-weight:bold;" width="20%">Silence Inhibit</td>
                <td style="font-size:12px; font-weight:normal; color:blue;">
                    <xsl:value-of select="SilenceInhibit" /> min</td>
            </tr>
            <tr>
                <td style="font-size:12px; font-weight:bold;" width="20%">Dual-zone first alarm reset</td>
                <td style="font-size:12px; font-weight:normal; color:blue;">
                    <xsl:text>Enabled</xsl:text>: <xsl:value-of select="DualZoneLatching" /><br/>
                    <xsl:text>Delay Time</xsl:text>: <xsl:value-of select="DZFirstAlarm" /> s</td>
            </tr>
            <tr>
                <td style="font-size:12px; font-weight:bold;" width="20%">Sandwich Delay</td>
                <td style="font-size:12px; font-weight:normal; color:blue;">
					<xsl:text>Enabled</xsl:text>: <xsl:value-of select="EnableSandwich" /><br/>
                    <xsl:text>Delay Time</xsl:text>: <xsl:value-of select="SandwichDelay" /> min</td>
            </tr>
            <tr>
                <td style="font-size:12px; font-weight:bold;" width="20%">Sequential Reset Delay</td>
                <td style="font-size:12px; font-weight:normal; color:blue;">
                    <xsl:value-of select="StaggeredDelay" /> s</td>
            </tr>
			 <tr>
                <td style="font-size:12px; font-weight:bold;" width="20%">Time Synchronization</td>
                <td style="font-size:12px; font-weight:normal; color:blue;">
					<xsl:text>Enabled</xsl:text>: <xsl:value-of select="TimeSyncEnable" /><br/>
                    <xsl:text>NTP Server IP</xsl:text>: <xsl:value-of select="NTPIP" /><br/>
					<xsl:text>NTP Server Port</xsl:text>: <xsl:value-of select="NTPPort" /></td>
            </tr>
        </table>
</xsl:template>

<xsl:template match="Silence">
    <xsl:choose>
        <xsl:when test=". = 0"><xsl:text>Audible Only</xsl:text></xsl:when>
        <xsl:when test=". = 1"><xsl:text>Audible And Visible</xsl:text></xsl:when>
        <xsl:otherwise><xsl:text>Invalid Silence</xsl:text></xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="UnitFormat">
    <xsl:choose>
        <xsl:when test=". = 0"><xsl:text>F</xsl:text>, <xsl:text>ft</xsl:text></xsl:when>
        <xsl:when test=". = 1"><xsl:text>C</xsl:text>, <xsl:text>m</xsl:text></xsl:when>
        <xsl:otherwise><xsl:text>Invalid Unit Format</xsl:text></xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="GlobalDelayMode">
    <xsl:choose>
        <xsl:when test=".=0"><xsl:text>No delay</xsl:text></xsl:when>
        <xsl:when test=".=1"><xsl:text>PAS</xsl:text></xsl:when>
        <xsl:when test=".=2"><xsl:text>Presignal</xsl:text></xsl:when>
        <xsl:otherwise><xsl:text>Invalid Global Delay Mode</xsl:text></xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="DelayModeOption">
    <xsl:choose>
        <xsl:when test=".=0"><xsl:text>AV/PAS/Pre-signal</xsl:text></xsl:when>
        <xsl:when test=".=1"><xsl:text>Sandwich/Dual-zone</xsl:text></xsl:when>
    </xsl:choose>
</xsl:template>

<xsl:template match="Language" >
    <xsl:choose>
        <xsl:when test=". = 0"><xsl:text>English</xsl:text></xsl:when>
        <xsl:when test=". = 1"><xsl:text>Spanish</xsl:text></xsl:when>
        <xsl:when test=". = 2"><xsl:text>Portugues</xsl:text></xsl:when>
    </xsl:choose>
</xsl:template>

<xsl:template name="Glob_Zone" >
 	<tr style="color:blue; font-size:12px; font-weight:normal;">
		<td><xsl:value-of select="Label" /></td>
		<td><xsl:for-each select="Pattern">
			<xsl:call-template name="ID_PATTERN" />
			</xsl:for-each></td>
    </tr>
</xsl:template>

<xsl:template match="ZONES">
    <table border="1" style="color:black; width:800px; left:50px;">
        <tr>
            <th colspan="3" style="background:black; color:white; font-weight:bold; font-size:14px; text-align:center; ">ZONES</th>
        </tr>
        <tr>
            <td colspan="3" style="background:#CCCCCC; font-size:12px; font-weight:bold;">Global Zones</td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;" width="30%">Zone Label</td>
            <td style="font-size:12px; font-weight:bold;" width="25%">Pattern</td>
        </tr>
        <xsl:for-each select="Zone226">
            <xsl:call-template name="Glob_Zone" />
        </xsl:for-each>
        
        <xsl:for-each select="Zone227">
        	<xsl:call-template name="Glob_Zone" />
        </xsl:for-each>

        <xsl:for-each select="Zone228">
           <xsl:call-template name="Glob_Zone" />
        </xsl:for-each>

        <xsl:for-each select="Zone229">
        	<xsl:call-template name="Glob_Zone" />
        </xsl:for-each>
        
        <xsl:for-each select="Zone230">
        	<xsl:call-template name="Glob_Zone" />
        </xsl:for-each>

        <xsl:for-each select="Zone231">
			<xsl:call-template name="Glob_Zone" />
        </xsl:for-each>

        <xsl:for-each select="Zone232">
        	<xsl:call-template name="Glob_Zone" />
        </xsl:for-each>

        <xsl:for-each select="Zone233">
        	<xsl:call-template name="Glob_Zone" />
        </xsl:for-each>
		
		<xsl:for-each select="Zone234">
        	<xsl:call-template name="Glob_Zone" />
        </xsl:for-each>
    </table>
	
    <!-- Group Zones -->
	<table border="1" style="color:black; width:800px; left:50px;">
    <tr>        
        <th colspan="6" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">Zones (129~225)</th>
    </tr>
    <tr>
        <td style="font-size:12px; font-weight:bold;">Zone No.</td>
        <td style="font-size:12px; font-weight:bold;">Zone Label</td>
        <td style="font-size:12px; font-weight:bold;">Pattern</td>
        <td style="font-size:12px; font-weight:bold;">Counting</td>
        <td style="font-size:12px; font-weight:bold;">Floor</td>
        <td style="font-size:12px; font-weight:bold;">Bypassed</td>
    </tr>
    <xsl:for-each select="GroupWideZones">
    	<xsl:apply-templates select="."/>
	</xsl:for-each>
    </table>
	
	<!-- Local Zones -->
	<table border="1" style="color:black; width:800px; left:50px;">
    <tr>        
        <th colspan="6" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">Zones (1~128)</th>
    </tr>
	 <xsl:for-each select="PanelWideZones">
    	<xsl:apply-templates select="."/>
	</xsl:for-each>
	</table>
	
	<!-- Dual-zones -->
    <table border="1" style="color:black; width:800px; left:50px;">
    <tr>        
        <th colspan="13" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">Dual-zone (18 pairs)</th>
    </tr>
 
    <xsl:for-each select="DualZones">
        <xsl:apply-templates select="." />
    </xsl:for-each>
    </table>

	 <!-- Floors -->
    <table border="1" style="color:black; width:800px; left:50px; font-size:12px;">
    <tr>        
        <th colspan="6" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">Floors (64 floors)</th>
    </tr>
    
    <xsl:for-each select="Floors">
        <xsl:apply-templates select="."></xsl:apply-templates>
    </xsl:for-each>
    </table>
</xsl:template>

<xsl:template match="NETWORK">
	<table border="1" style="color:black; width:800px; left:50px;">
    	<tr>
            <th colspan="10" style="background:black; color:white; font-weight:bold; font-size:14px; text-align:center; ">Networking</th>
        </tr>
		<tr>
        	<td colspan="10" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">Basic Settings</td>
        </tr>
		<tr>
        	<td style="font-size:12px; font-weight:bold;">Networking card installed</td>
			<td style="font-size:12px; font-weight:bold;">Ethernet IN,Ethernet IN,Wired IN</td>
			<td style="font-size:12px; font-weight:bold;">Ethernet OUT,Fiber IN,Wired OUT</td>
			<td style="font-size:12px; font-weight:bold;">Ethernet,Fiber OUT,Ethernet IN</td>
            <td style="font-size:12px; font-weight:bold;">Topology</td>
		</tr>
        <tr>
            <td style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:value-of select="SWBInstall" /></td>
            <td style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:value-of select="Supervise1" /></td>
            <td style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:value-of select="Supervise2" /></td>
            <td style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:value-of select="Supervise3" /></td>
            <td style="font-size:12px; font-weight:normal; color:blue;" >
					<xsl:for-each select="Topology">
                    	<xsl:call-template name="Net_Topology"></xsl:call-template>
					</xsl:for-each>
			</td>	
        </tr>
	</table>
	<xsl:apply-templates select="NetNode"></xsl:apply-templates>
</xsl:template>

<xsl:template name="NetNode" match="NetNode">
    <table border="1" style="color:black; width:800px; left:50px;">
		<tr>
        	<td colspan="2" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">Panel List</td>
        </tr>
		<tr>
            <td style="font-size:12px; font-weight:bold;" width="10%">Panel ID</td>
            <td style="font-size:12px; font-weight:bold; display:none;" width="30%">Group ID</td>
        </tr>
        <xsl:for-each select="Panel">
			<xsl:call-template name="Panel"></xsl:call-template>
		</xsl:for-each>
	</table>	
</xsl:template>

<xsl:template name="Panel">
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <td><xsl:value-of select="ID" ></xsl:value-of></td>
        <td style="display:none"><xsl:value-of select="GID" ></xsl:value-of></td>
    </tr>
</xsl:template>

<xsl:template name="Net_Topology">
 <xsl:choose>
        <xsl:when test=". = 0"><xsl:text>Class A</xsl:text></xsl:when>
        <xsl:when test=". = 1"><xsl:text>Class B</xsl:text></xsl:when>
 </xsl:choose>
</xsl:template>

<xsl:template match="Floors">
    <tr>
        <td style="font-size:12px; font-weight:bold;">Floor</td>
		<td style="font-size:12px; font-weight:bold;">Label</td>
		<td style="font-size:12px; font-weight:bold;">Sandwich</td>
		<td style="font-size:12px; font-weight:bold;">Floor</td>
		<td style="font-size:12px; font-weight:bold;">Label</td>
		<td style="font-size:12px; font-weight:bold;">Sandwich</td>
	</tr>
	<tr>
		<td>1st</td>
		<xsl:for-each select="Floor1">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
		<td>33rd</td>
		<xsl:for-each select="Floor33">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td>2nd</td>
		<xsl:for-each select="Floor2">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
		<td>34th</td>
		<xsl:for-each select="Floor34">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td>3rd</td>
		<xsl:for-each select="Floor3">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
		<td>35th</td>
		<xsl:for-each select="Floor35">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td>4th</td>
		<xsl:for-each select="Floor4">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
		<td>36th</td>
		<xsl:for-each select="Floor36">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td>5th</td>
		<xsl:for-each select="Floor5">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
		<td>37th</td>
		<xsl:for-each select="Floor37">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td>6th</td>
		<xsl:for-each select="Floor6">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
		<td>38th</td>
		<xsl:for-each select="Floor38">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td>7th</td>
		<xsl:for-each select="Floor7">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
		<td>39th</td>
		<xsl:for-each select="Floor39">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td>8th</td>
		<xsl:for-each select="Floor8">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
		<td>40th</td>
		<xsl:for-each select="Floor40">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td>9th</td>
		<xsl:for-each select="Floor9">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
		<td>41st</td>
		<xsl:for-each select="Floor41">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td>10th</td>
		<xsl:for-each select="Floor10">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
		<td>42nd</td>
		<xsl:for-each select="Floor42">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
	</tr>
		<tr>
		<td>11st</td>
		<xsl:for-each select="Floor11">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
		<td>43rd</td>
		<xsl:for-each select="Floor43">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td>12nd</td>
		<xsl:for-each select="Floor12">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
		<td>44th</td>
		<xsl:for-each select="Floor44">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td>13rd</td>
		<xsl:for-each select="Floor13">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
		<td>45th</td>
		<xsl:for-each select="Floor45">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td>14th</td>
		<xsl:for-each select="Floor14">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
		<td>46th</td>
		<xsl:for-each select="Floor46">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td>15th</td>
		<xsl:for-each select="Floor15">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
		<td>47th</td>
		<xsl:for-each select="Floor47">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td>16th</td>
		<xsl:for-each select="Floor16">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
		<td>48th</td>
		<xsl:for-each select="Floor48">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td>17th</td>
		<xsl:for-each select="Floor17">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
		<td>49th</td>
		<xsl:for-each select="Floor49">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td>18th</td>
		<xsl:for-each select="Floor18">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
		<td>50th</td>
		<xsl:for-each select="Floor50">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td>19th</td>
		<xsl:for-each select="Floor19">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
		<td>51st</td>
		<xsl:for-each select="Floor51">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td>20th</td>
		<xsl:for-each select="Floor20">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
		<td>52nd</td>
		<xsl:for-each select="Floor52">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
	</tr>
		<tr>
		<td>21st</td>
		<xsl:for-each select="Floor21">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
		<td>53rd</td>
		<xsl:for-each select="Floor53">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td>22nd</td>
		<xsl:for-each select="Floor22">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
		<td>54th</td>
		<xsl:for-each select="Floor54">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td>23rd</td>
		<xsl:for-each select="Floor23">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
		<td>55th</td>
		<xsl:for-each select="Floor55">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td>24th</td>
		<xsl:for-each select="Floor24">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
		<td>56th</td>
		<xsl:for-each select="Floor56">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td>25th</td>
		<xsl:for-each select="Floor25">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
		<td>57th</td>
		<xsl:for-each select="Floor57">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td>26th</td>
		<xsl:for-each select="Floor26">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
		<td>58th</td>
		<xsl:for-each select="Floor58">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td>27th</td>
		<xsl:for-each select="Floor27">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
		<td>59th</td>
		<xsl:for-each select="Floor59">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td>28th</td>
		<xsl:for-each select="Floor28">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
		<td>60th</td>
		<xsl:for-each select="Floor60">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td>29th</td>
		<xsl:for-each select="Floor29">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
		<td>61st</td>
		<xsl:for-each select="Floor61">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td>30th</td>
		<xsl:for-each select="Floor30">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
		<td>62nd</td>
		<xsl:for-each select="Floor62">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
	</tr>
		<tr>
		<td>31st</td>
		<xsl:for-each select="Floor31">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
		<td>63rd</td>
		<xsl:for-each select="Floor63">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td>32nd</td>
		<xsl:for-each select="Floor32">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
		<td>64th</td>
		<xsl:for-each select="Floor64">
			<xsl:call-template name="Flr"></xsl:call-template>
		</xsl:for-each>
	</tr>
</xsl:template>

<xsl:template match="GroupWideZones">
	<xsl:for-each select="Z">
		 <xsl:call-template name="Zone" />
	</xsl:for-each>
</xsl:template>

<xsl:template match="PanelWideZones">
	<xsl:for-each select="GroupPanel">
		 <xsl:call-template name="GroupPanel" />
	</xsl:for-each>
</xsl:template>

<xsl:template name="GroupPanel">
	<tr style="font-size:12px;">        
        <td align="left" style="font-weight:bold;">Panel ID</td>
		<td colspan="2" style="color:blue;"><xsl:value-of select="PID"/></td>
		<td align="left" style="font-weight:bold;">Confirm</td>
		<td colspan="2" style="color:blue;"><xsl:value-of select="Confirm"/></td>
    </tr>
    <tr>
        <td style="font-size:12px; font-weight:bold;">Zone No.</td>
        <td style="font-size:12px; font-weight:bold;">Zone Label</td>
        <td style="font-size:12px; font-weight:bold;">Pattern</td>
        <td style="font-size:12px; font-weight:bold;">Counting</td>
        <td style="font-size:12px; font-weight:bold;">Floor</td>
        <td style="font-size:12px; font-weight:bold;">Bypassed</td>
    </tr>
	<xsl:for-each select="Z">
		 <xsl:call-template name="Zone" />
	</xsl:for-each>
</xsl:template>

<xsl:template match="DualZones">
      <tr align="center">
        <td colspan="2" style="font-size:12px; font-weight:bold;">Pair 1</td>
        <td colspan="2" style="font-size:12px; font-weight:bold;">Pair 2</td>
        <td colspan="2" style="font-size:12px; font-weight:bold;">Pair 3</td>
        <td colspan="2" style="font-size:12px; font-weight:bold;">Pair 4</td>
        <td colspan="2" style="font-size:12px; font-weight:bold;">Pair 5</td>
        <td colspan="2" style="font-size:12px; font-weight:bold;">Pair 6</td>
    </tr>
	<tr>
    <xsl:for-each select="group1">
        <xsl:call-template name="PairTemplate" />
    </xsl:for-each>
	<xsl:for-each select="group2">
        <xsl:call-template name="PairTemplate" />
    </xsl:for-each>
	 </tr>
	   <tr align="center">
        <td colspan="2" style="font-size:12px; font-weight:bold;">Pair 7</td>
        <td colspan="2" style="font-size:12px; font-weight:bold;">Pair 8</td>
        <td colspan="2" style="font-size:12px; font-weight:bold;">Pair 9</td>
        <td colspan="2" style="font-size:12px; font-weight:bold;">Pair 10</td>
        <td colspan="2" style="font-size:12px; font-weight:bold;">Pair 11</td>
        <td colspan="2" style="font-size:12px; font-weight:bold;">Pair 12</td>
    </tr>
    <tr>
    <xsl:for-each select="group3">
        <xsl:call-template name="PairTemplate" />
    </xsl:for-each>
	<xsl:for-each select="group4">
        <xsl:call-template name="PairTemplate" />
    </xsl:for-each>
	 </tr>
    <tr align="center">
		<td colspan="2" style="font-size:12px; font-weight:bold;">Pair 13</td>
		<td colspan="2" style="font-size:12px; font-weight:bold;">Pair 14</td>
		<td colspan="2" style="font-size:12px; font-weight:bold;">Pair 15</td>
		<td colspan="2" style="font-size:12px; font-weight:bold;">Pair 16</td>
		<td colspan="2" style="font-size:12px; font-weight:bold;">Pair 17</td>
		<td colspan="2" style="font-size:12px; font-weight:bold;">Pair 18</td>
    </tr>
    <tr>
    <xsl:for-each select="group5">
        <xsl:call-template name="PairTemplate" />
    </xsl:for-each>
	<xsl:for-each select="group6">
        <xsl:call-template name="PairTemplate" />
    </xsl:for-each>
	 </tr>
</xsl:template>

<xsl:template name="PairTemplate">
    <td style=" color:blue;"><xsl:value-of select="PPid11" />-<xsl:value-of select="Pair11" /></td>
    <td style=" color:blue;"><xsl:value-of select="PPid12" />-<xsl:value-of select="Pair12" /></td>
    <td style=" color:blue;"><xsl:value-of select="PPid21" />-<xsl:value-of select="Pair21" /></td>
    <td style=" color:blue;"><xsl:value-of select="PPid22" />-<xsl:value-of select="Pair22" /></td>
    <td style=" color:blue;"><xsl:value-of select="PPid31" />-<xsl:value-of select="Pair31" /></td>
    <td style=" color:blue;"><xsl:value-of select="PPid32" />-<xsl:value-of select="Pair32" /></td>
</xsl:template>

<xsl:template name="Flr">
    <td style="font-size:12px; font-weight:normal; color:blue;"><xsl:value-of select="Label" /></td>
	<td style="font-size:12px; font-weight:normal; color:blue;"><xsl:value-of select="Sandwich" /></td>
</xsl:template>

<xsl:template match="TimeFormat">
    <xsl:choose>
        <xsl:when test=". = 0"><xsl:text>12</xsl:text> <xsl:text>h</xsl:text></xsl:when>
        <xsl:when test=". = 1"><xsl:text>24</xsl:text> <xsl:text>h</xsl:text></xsl:when>
        <xsl:otherwise><xsl:text>Invalid Time Format</xsl:text></xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template name="Zone" >
    <tr style="color:blue; font-size:12px; font-weight:normal;">
        <td width="10%"><xsl:value-of select="N" /></td>
        <td width="20%"><xsl:value-of select="L" /></td>
        <td width="20%"><xsl:for-each select="P">
                        <xsl:call-template name="ID_PATTERN" />
                        </xsl:for-each></td>
        <td width="20%"><xsl:value-of select="C" /></td>
        <td width="10%"><xsl:value-of select="F" /></td>
        <td width="20%"><xsl:for-each select="B">
                        <xsl:call-template name="Bypass" />
                        </xsl:for-each></td>
    </tr>
</xsl:template>

<xsl:template match="REPORT">
    <table border="1" style="color:black; width:800px; left:50px;">
        <tr>
            <th colspan="3" style="background:black; color:white; font-weight:bold; font-size:14px; text-align:center; ">Report</th>
        </tr>
        <tr>
            <td colspan="3" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">Primary Account Settings</td>
        </tr> 
        <xsl:apply-templates select="Primary" />
        
        <tr>
            <td colspan="3" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">Secondary Account Settings</td>
        </tr> 
        <xsl:apply-templates select="Secondary" />
        
        <xsl:apply-templates select="PSTN" />
        
        <xsl:apply-templates select="Reporting" />
		<xsl:apply-templates select="Email" />
    </table>    
</xsl:template>

<xsl:template match="Primary|Secondary" >
        <tr>
            <td rowspan="6" style="font-size:12px; font-weight:bold; text-align:center; ">Basic Data</td>
            <td width="25%" style="font-size:12px; font-weight:bold;">
                Selection PSTN/IP/Disable</td>  
            <td width="75%" style="font-size:12px; font-weight:12px; color:blue;">        
                <xsl:apply-templates select="AccountAttr" /></td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Account Number</td>
            <td style="font-size:12px; font-weight:12px; color:blue;">
                <xsl:value-of select="AccountNum" /></td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Reporting Format</td>
            <td style="font-size:12px; font-weight:12px; color:blue;">
                <xsl:apply-templates select="RepFormat" /></td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Auto Test Time</td>
            <td style="font-size:12px; font-weight:12px; color:blue;">
                <xsl:value-of select="AutoTestHour" />:
                <xsl:value-of select="AutoTestMin" />
                <xsl:choose>
                    <xsl:when test="AutoTestPM = 'FALSE'"><xsl:text> AM</xsl:text></xsl:when>
                    <xsl:otherwise><xsl:text> PM</xsl:text></xsl:otherwise>
                </xsl:choose>
            </td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Auto Test Interval</td>
            <td style="font-size:12px; font-weight:12px; color:blue;">
                <xsl:apply-templates select="AutoTestIntervall" /></td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Max. Attempts</td>
            <td style="font-size:12px; font-weight:12px; color:blue;">
                <xsl:value-of select="MaxAttempt" /></td>
        </tr>
        <tr>
            <td rowspan="1" style="font-size:12px; text-align:center; font-weight:bold;">PSTN</td>
            <td style="font-size:12px; font-weight:bold;">Phone Number</td>
            <td style="font-size:12px; font-weight:12px; color:blue;">
                <xsl:value-of select="PhoneNum" /></td>
        </tr>
        <tr>
            <td rowspan="7" style="font-size:12px; text-align:center; font-weight:bold;" width="15%">IP Reporting Conettix</td>
            <td style="font-size:12px; font-weight:bold;" width="20%">Receiver IP Address</td>
            <td style="font-size:12px; font-weight:12px; color:blue;" width="65%">
                <xsl:value-of select="IPAddr" /></td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Port Number</td>
            <td style="font-size:12px; font-weight:12px; color:blue;">
                <xsl:value-of select="Port" /></td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Anti-replay</td>
            <td style="font-size:12px; font-weight:12px; color:blue;">
                <xsl:value-of select="AntiReplay" /></td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Polling Interval</td>
            <td style="font-size:12px; font-weight:12px; color:blue;">
                <xsl:value-of select="PollInt" /> s</td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Acknowledge Wait Time</td>
            <td style="font-size:12px; font-weight:12px; color:blue;">
                <xsl:value-of select="AckTime" /> s</td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Encryption Enabled</td>
            <td style="font-size:12px; font-weight:12px; color:blue;">
                <xsl:value-of select="Encryption" /></td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Key String</td>
            <td style="font-size:12px; font-weight:12px; color:blue;"><div id="keystring_value"><xsl:text>********************************</xsl:text></div><div id="keystring_encrypted"><xsl:text> (Encrypted)</xsl:text></div><!-- <xsl:value-of select="KeyString" /> --></td>
        </tr>
</xsl:template>

<xsl:template match="AccountAttr" >
    <xsl:choose>
        <xsl:when test=". = 0"><xsl:text>PSTN</xsl:text></xsl:when>
        <xsl:when test=". = 1"><xsl:text>IP</xsl:text></xsl:when>
        <xsl:when test=". = 2"><xsl:text>Disable</xsl:text></xsl:when>
        <xsl:otherwise><xsl:text>Invalid</xsl:text></xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="RepFormat">
    <xsl:choose>
        <xsl:when test=". = 1"><xsl:text>SIA-DCS 300 No Text</xsl:text></xsl:when>
        <xsl:when test=". = 2"><xsl:text>Contact ID</xsl:text></xsl:when>
        <xsl:when test=". = 3"><xsl:text>Modem IIIa2 No Text</xsl:text></xsl:when>
        <xsl:when test=". = 4"><xsl:text>SIA-DCS 300 With Text</xsl:text></xsl:when>
        <xsl:when test=". = 5"><xsl:text>Modem IIIa2 With Text</xsl:text></xsl:when>
        <xsl:otherwise><xsl:text>Invalid Reporting Format</xsl:text></xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="AutoTestIntervall">
    <xsl:choose>
        <xsl:when test=". = 0"><xsl:text>Disable</xsl:text></xsl:when>
        <xsl:when test=". = 1"><xsl:text>4</xsl:text> <xsl:text> h</xsl:text></xsl:when>
        <xsl:when test=". = 2"><xsl:text>12</xsl:text> <xsl:text> h</xsl:text></xsl:when>
        <xsl:when test=". = 3"><xsl:text>24</xsl:text> <xsl:text> h</xsl:text></xsl:when>
        <xsl:when test=". = 4"><xsl:text>7</xsl:text> <xsl:text> days</xsl:text></xsl:when>
        <xsl:when test=". = 5"><xsl:text>28</xsl:text> <xsl:text> days</xsl:text></xsl:when>
        <xsl:otherwise><xsl:text>Invalid Auto Test Intervals</xsl:text></xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="Dialing">
    <xsl:choose>
        <xsl:when test=". = 0"><xsl:text>Tone</xsl:text></xsl:when>
        <xsl:when test=". = 1"><xsl:text>Pulse</xsl:text></xsl:when>
        <xsl:when test=". = 2"><xsl:text>Auto</xsl:text></xsl:when>
    </xsl:choose>
</xsl:template>

<xsl:template match="PSTN">
        <tr>
            <td style="font-size:12px; font-weight:bold; background:#CCCCCC; border:1; " colspan="3">PSTN Communicator Settings</td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Dialing Type</td>
            <td style="font-size:12px; font-weight:normal; color:blue;" colspan="2"><xsl:apply-templates select="Dialing" /></td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Monitor Line 1</td>
            <td style="font-size:12px; font-weight:normal; color:blue;" colspan="2">
                <xsl:value-of select="Line1" /></td>
        </tr>
		<tr>
            <td style="font-size:12px; font-weight:bold;">Line 1 Ring Count</td>
            <td style="font-size:12px; font-weight:normal; color:blue;" colspan="2">
                <xsl:value-of select="Line1RingCount" /></td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Monitor Line 2</td>
            <td style="font-size:12px; font-weight:normal; color:blue;" colspan="2">
                <xsl:value-of select="Line2" /></td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Redial Interval</td>
            <td style="font-size:12px; font-weight:normal; color:blue;" colspan="2"><xsl:value-of select="DialInterval" /> s</td>
        </tr>
</xsl:template>

<xsl:template match="Reporting">
    <tr>
        <td style="font-size:12px; font-weight:bold;">Alarms</td>
        <td colspan="2" style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:apply-templates select="FireAlarm" /></td>
    </tr>
    <tr>
        <td style="font-size:12px; font-weight:bold;">Supervisory</td>
        <td colspan="2" style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:apply-templates select="Supervisory" /></td>
    </tr>
    <tr>
        <td style="font-size:12px; font-weight:bold;">Alarm restorals</td>
        <td colspan="2" style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:apply-templates select="FireRestore" /></td>
    </tr>
    <tr>
        <td style="font-size:12px; font-weight:bold;">Supervisory restoral</td>
        <td colspan="2" style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:apply-templates select="SupervRestore" /></td>
    </tr>
    <tr>
        <td style="font-size:12px; font-weight:bold;">Trouble/Restoral</td>
        <td colspan="2" style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:apply-templates select="TroubleRes" /></td>
    </tr>
    <tr>
        <td style="font-size:12px; font-weight:bold;">Test</td>
        <td colspan="2" style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:apply-templates select="Test" /></td>
    </tr>
    <tr>
        <td style="font-size:12px; font-weight:bold;">Silence</td>
        <td colspan="2" style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:apply-templates select="RepSilence" /></td>
    </tr>
    <tr>
        <td style="font-size:12px; font-weight:bold;">Reset</td>
        <td colspan="2" style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:apply-templates select="Reset" /></td>
    </tr>
    <tr>
        <td style="font-size:12px; font-weight:bold;">Fire drill</td>
        <td colspan="2" style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:apply-templates select="FireDrill" /></td>
    </tr>
	<tr>
        <td style="font-size:12px; font-weight:bold;"><xsl:text>Report events/operations from</xsl:text>:</td>
        <td colspan="2" style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:apply-templates select="ReportWide" /></td>
    </tr>
</xsl:template>
	
<xsl:template match="Email">
	 <tr>
     	<td style="font-size:12px; font-weight:bold; background:#CCCCCC; border:1; " colspan="3">E-mail Settings</td>
     </tr>
	 <tr>
        <td colspan="1" style="font-size:12px; font-weight:bold;">E-mail notification enable</td>
        <td style="font-size:12px; font-weight:12px; color:blue;">
                <xsl:value-of select="EmailEnable" /></td>
    </tr>
    <tr>
        <td rowspan="4" style="font-size:12px; font-weight:bold;">E-mail customization</td>
       	<td width="25%" style="font-size:12px; font-weight:bold;">To address 1</td>
	    <td width="75%" style="font-size:12px; font-weight:12px; color:blue;">
                <xsl:value-of select="Addr1" /></td>
    </tr>
    <tr>
        <td style="font-size:12px; font-weight:bold;">To address 2</td>
        <td style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:value-of select="Addr2" /></td>
    </tr>
	 <tr>
        <td style="font-size:12px; font-weight:bold;">To address 3</td>
        <td style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:value-of select="Addr3" /></td>
    </tr>
	 <tr>
        <td style="font-size:12px; font-weight:bold;">To address 4</td>
        <td style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:value-of select="Addr4" /></td>
    </tr>
    <tr>
        <td rowspan="4"  style="font-size:12px; font-weight:bold;">SMTP server settings</td>
       	<td width="25%"  style="font-size:12px; font-weight:bold;">IP address</td>
	    <td width="75%" style="font-size:12px; font-weight:12px; color:blue;">
                <xsl:value-of select="SMTPIP" /></td>
    </tr>
	<tr>
        <td style="font-size:12px; font-weight:bold;">Port</td>
        <td style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:value-of select="SMTPPort" /></td>
    </tr>
	<tr>
        <td style="font-size:12px; font-weight:bold;">User name</td>
        <td style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:value-of select="SMTPUser" /></td>
    </tr>
	<tr>
        <td style="font-size:12px; font-weight:bold;">Password</td>
        <td style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:value-of select="SMTPPwd" /></td>
    </tr>
</xsl:template>

<xsl:template match="FireAlarm|Supervisory|FireRestore|SupervRestore|TroubleRes|Test|RepSilence|Reset|FireDrill">
    <xsl:choose>
        <xsl:when test=". = 0"><xsl:text>Primary only</xsl:text></xsl:when>
        <xsl:when test=". = 1"><xsl:text>Secondary only</xsl:text></xsl:when>
        <xsl:when test=". = 2"><xsl:text>Primary and secondary</xsl:text></xsl:when>
        <xsl:when test=". = 3"><xsl:text>Secondary as backup</xsl:text></xsl:when>
        <xsl:when test=". = 4"><xsl:text>No report</xsl:text></xsl:when>
    </xsl:choose>
</xsl:template>

<xsl:template name="T_LOOPS" match="LOOP1|LOOP2">

    <table border="1" style="color:black; width:800px; left:50px;">
        <xsl:for-each select="Device">
            <xsl:choose>
                <xsl:when test="DeviceType = '2'">
                    <xsl:call-template name="DEV_SLC"></xsl:call-template>
                </xsl:when>
                <xsl:when test="DeviceType = '3' or DeviceType = '27' or DeviceType = '32' or DeviceType = '34'">
                    <xsl:call-template name="DEV_SMOKE_P"></xsl:call-template>
                </xsl:when>
                <xsl:when test="DeviceType = '4' or DeviceType = '26' or DeviceType = '33'">
                    <xsl:call-template name="DEV_SMOKE_D"></xsl:call-template>
                </xsl:when>
                <xsl:when test="DeviceType = '5' or DeviceType = '29'">
                    <xsl:call-template name="DEV_HEAT"></xsl:call-template>
                </xsl:when>
                <xsl:when test="DeviceType = '6'">
                    <xsl:call-template name="DEV_SMOKE_I"></xsl:call-template>
                </xsl:when>
                <xsl:when test="DeviceType = '7' or DeviceType = '30' or DeviceType = '31' or DeviceType = '35' or DeviceType = '36'">
                    <xsl:call-template name="DEV_SMOKE_M" ></xsl:call-template>
                </xsl:when>
                <xsl:when test="DeviceType = '10'">
                    <xsl:call-template name="DEV_CONVZ_MOD"></xsl:call-template>
                </xsl:when>
                <xsl:when test="DeviceType = '8' or DeviceType = '11' or DeviceType = '18' or DeviceType = '19' or DeviceType = '20' or DeviceType = '21'">
                    <xsl:call-template name="DEV_CONT_MOD"></xsl:call-template>
                </xsl:when>
                <xsl:when test="DeviceType = '12' or DeviceType = '17' or DeviceType = '22' or DeviceType = '23' or DeviceType = '24' or DeviceType = '25'">
                    <xsl:call-template name="DEV_RELAY_MOD"></xsl:call-template>
                </xsl:when>
				<xsl:when test="DeviceType = '13' or DeviceType = '14' or DeviceType = '15'">
					<xsl:call-template name="DEV_NAC_MOD"></xsl:call-template>
				</xsl:when>
				<xsl:when test="DeviceType = '16'">
					<xsl:call-template name="DEV_BASE_SND"></xsl:call-template>
				</xsl:when>
            </xsl:choose>
        </xsl:for-each>
    </table>
	
</xsl:template>

<xsl:template name="DEV_SLC">
    <tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th>Address</th>
        <th>Device Type</th>
        <th>Label</th>
        <th>Bypassed</th>
        <th>Enable</th>
        <th>Topology</th>
        <th>Loop Type</th>
        <th colspan="2">Number of Elements</th>
    </tr>
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <td><xsl:value-of select="Address" ></xsl:value-of></td>
        <td><xsl:apply-templates select="DeviceType"></xsl:apply-templates></td>
        <td><xsl:value-of select="Label" ></xsl:value-of></td>
        <td><xsl:value-of select="Bypassed" ></xsl:value-of></td>
        <td><xsl:value-of select="Enable" ></xsl:value-of></td>
        <td><xsl:apply-templates select="Topology" ></xsl:apply-templates></td>
        <td><xsl:call-template name="DEV_LOOPTYPE"></xsl:call-template></td>
        <td colspan="2"><xsl:value-of select="NumElements" ></xsl:value-of></td>
    </tr>
	<tr style="background-color:#000000; height:6px;">
	<td colspan="9"></td>
	</tr>    
</xsl:template>

<xsl:template name="DEV_LOOPTYPE" match="LoopType">
	<!-- LoopType -->
	<xsl:choose>
		<xsl:when test="LoopType = 0">SLC Loop</xsl:when>
		<xsl:otherwise></xsl:otherwise>
	</xsl:choose>
</xsl:template>

<xsl:template name="DEV_SMOKE_P" match="Device">
    <!--line 1 for DEV_SMOKE_P-->
    <tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th>Address</th>
        <th>Device Type</th>
        <th colspan="2">Label</th>
        <th>Bypassed</th>
        <th>Point Type</th>
        <th colspan="2">Zones</th>
        <th>Delay Mode</th>
    </tr>
	
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <td><xsl:value-of select="Address" ></xsl:value-of></td>
        <td><xsl:apply-templates select="DeviceType"></xsl:apply-templates></td>
        <td colspan="2"><xsl:value-of select="Label" ></xsl:value-of></td>
        <td><xsl:value-of select="Bypassed" ></xsl:value-of></td>
       <td>
		   <xsl:for-each select="PointType">
			   <xsl:call-template name="PointType"></xsl:call-template>
		   </xsl:for-each>
		</td>
        <td colspan="2"><xsl:call-template name="Zone1_5" ></xsl:call-template></td>
        <td>
		   <xsl:for-each select="DelayMode">
			   <xsl:call-template name="DelayMode"></xsl:call-template>
		   </xsl:for-each>
		</td>
    </tr>	
	
    <!--line 2 for DEV_SMOKE_P-->
    <tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
		<th colspan="2">Sensitivity</th>
        <th colspan="2">Day Sensitivity</th>

	    <xsl:choose>
            <xsl:when test="DeviceType = '27' or DeviceType = '32' or DeviceType = '34'">
            <th>Led Flashing</th>
	        </xsl:when>
	        <xsl:otherwise>
			</xsl:otherwise>
        </xsl:choose>
	</tr>
	      
	<tr style="font-size:12px; font-weight:normal; color:blue;">
        <td colspan="2"><xsl:call-template name="TP_Sensitivity"></xsl:call-template></td>
        <td colspan="2"><xsl:call-template name="TP_DaySensitivity"></xsl:call-template></td>

	    <xsl:choose>
            <xsl:when test="DeviceType = '27' or DeviceType = '32' or DeviceType = '34'">
            <td><xsl:value-of select="LedFlash" ></xsl:value-of></td>
	        </xsl:when>
	        <xsl:otherwise>
			</xsl:otherwise>
        </xsl:choose>
    </tr>
   
	<!--line 3 for DEV_SMOKE_P-->	
	<tr style="background-color:#000000; height:6px;">
	<td colspan="9"></td>
	</tr>    
</xsl:template>

<xsl:template name="DEV_SMOKE_D">
    <!--line 1 for DEV_SMOKE_D-->
    <tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th>Address</th>
        <th>Device Type</th>
        <th colspan="2">Label</th>
        <th>Bypassed</th>
        <th>Point Type</th>
        <th colspan="2">Zones</th>
        <th>Delay Mode</th>
    </tr>
	
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <td><xsl:value-of select="Address" ></xsl:value-of></td>
        <td><xsl:apply-templates select="DeviceType"></xsl:apply-templates></td>
        <td colspan="2"><xsl:value-of select="Label" ></xsl:value-of></td>
        <td><xsl:value-of select="Bypassed" ></xsl:value-of></td>
        <td><xsl:for-each select="PointType">
			   <xsl:call-template name="PointType"></xsl:call-template>
		    </xsl:for-each>
		</td>
        <td colspan="2"><xsl:call-template name="Zone1_5"></xsl:call-template></td>
        <td><xsl:for-each select="DelayMode">
			   <xsl:call-template name="DelayMode"></xsl:call-template>
		    </xsl:for-each>
		</td>
    </tr>
		
    <!--line 2 for DEV_SMOKE_D-->	
    <tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th colspan="2">Sensitivity</th>
        <th colspan="2">Day Sensitivity</th>

        <th>Relay</th>
		
	    <xsl:choose>
		<xsl:when test="DeviceType = '33'">
		<th>Led Flashing</th>
		<th colspan="3"></th>
        </xsl:when>
   		<xsl:otherwise>
		<th colspan="4"></th>
   		</xsl:otherwise>
        </xsl:choose> 
    </tr>

	<tr style="font-size:12px; color:blue; font-weight:normal;">
		<td colspan="2"><xsl:call-template name="TP_Sensitivity"></xsl:call-template></td>
		<td colspan="2"><xsl:call-template name="TP_DaySensitivity"></xsl:call-template></td>

		<xsl:choose>
		<xsl:when test="Relay = 'TRUE'">
			<td>TRUE</td>
		</xsl:when>
		<xsl:otherwise>
			<td>FALSE</td>
		</xsl:otherwise>
	    </xsl:choose> 

		<xsl:choose>
			<xsl:when test="DeviceType = '33'">
			<td><xsl:value-of select="LedFlash" ></xsl:value-of></td>
			<td colspan="3"></td>
			</xsl:when>
			<xsl:otherwise>
			<td colspan="4"></td>
			</xsl:otherwise>
		 </xsl:choose> 
	</tr>

    <!--line 3 for DEV_SMOKE_D-->	
	<xsl:choose>
		<xsl:when test="Relay = 'TRUE'">
		<tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
			<th style="background-color:white;" rowspan="2"></th>
			<th rowspan="2" style="color:blue; background:white;">Duct Relay</th>
			<th colspan="2">Label</th>
			<th>Bypassed</th>
			<th colspan="2">Zones</th>
			<xsl:choose>
			<xsl:when test="DeviceType = '33'">
				<th>Sequential</th>
			</xsl:when>
			<xsl:otherwise></xsl:otherwise>
			</xsl:choose> 
		</tr>
			<xsl:call-template name="SMOKE_D_RELAY"></xsl:call-template>
		</xsl:when>
		<xsl:otherwise></xsl:otherwise>
	</xsl:choose>
    
	<!--line 4 for DEV_SMOKE_D-->	
	<tr style="background-color:#000000; height:6px;">
	<td colspan="9"></td>
	</tr>    
</xsl:template>

<xsl:template name="SMOKE_D_RELAY" match="DuctRelay|DuctRelay440">
	  <xsl:for-each select="DuctRelay|DuctRelay440">
	  <tr style="font-size:12px; font-weight:normal; color:blue;">
		<td colspan="2"><xsl:value-of select="Label"></xsl:value-of></td>
		<td><xsl:value-of select="Bypassed"></xsl:value-of></td>
		<td colspan="2"><xsl:call-template name="RelayZone1_5"></xsl:call-template></td>
		<td><xsl:value-of select="Sequential"></xsl:value-of></td> 
	 </tr>
	 </xsl:for-each>
</xsl:template>

<xsl:template name="DEV_HEAT">
    <!--line 1 for DEV_HEAT-->	
	<tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th>Address</th>
        <th>Device Type</th>
        <th colspan="2">Label</th>
        <th>Bypassed</th>
        <th>Point Type</th>
        <th colspan="2">Zones</th>
        <th>Delay Mode</th>
    </tr>
	
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <td><xsl:value-of select="Address" ></xsl:value-of></td>
        <td><xsl:apply-templates select="DeviceType"></xsl:apply-templates></td>
        <td colspan="2"><xsl:value-of select="Label" ></xsl:value-of></td>
        <td><xsl:value-of select="Bypassed" ></xsl:value-of></td>
        <td>
		   <xsl:for-each select="PointType">
			   <xsl:call-template name="PointType"></xsl:call-template>
		   </xsl:for-each>
		</td>
        <td colspan="2"><xsl:call-template name="Zone1_5" ></xsl:call-template></td>
        <td>
		   <xsl:for-each select="DelayMode">
			   <xsl:call-template name="DelayMode"></xsl:call-template>
		   </xsl:for-each>
		</td>
    </tr>

    <!--line 2 for DEV_HEAT-->	
	<tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th colspan="2">Sensitivity</th>
        <th colspan="2">Day Sensitivity</th>
		<xsl:choose>
			<xsl:when test="DeviceType = '29'">
			<th>Led Flashing</th>
			<th>RTI rating</th>
			<th>RoR</th>
			<th>Day RoR</th>
			</xsl:when>
			<xsl:otherwise>
			</xsl:otherwise>
		</xsl:choose> 
    </tr>

    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <td colspan="2"><xsl:call-template name="TP_Sensitivity"></xsl:call-template></td>
        <td colspan="2"><xsl:call-template name="TP_DaySensitivity"></xsl:call-template></td>
		<xsl:choose>
			<xsl:when test="DeviceType = '29'">
			<td><xsl:value-of select="LedFlash" ></xsl:value-of></td>
			<td><xsl:apply-templates select="RTI"></xsl:apply-templates></td>
			<td><xsl:value-of select="RoR"></xsl:value-of></td>
			<td><xsl:value-of select="DayRoR"></xsl:value-of></td>
			</xsl:when>
			<xsl:otherwise>
			</xsl:otherwise>
   		</xsl:choose> 
    </tr>
		
	<!--line 3 for DEV_HEAT-->	
	<tr style="background-color:#000000; height:6px;">
	<td colspan="9"></td>
	</tr>    
</xsl:template>

<xsl:template name="DEV_SMOKE_I">
	<!--line 1 for DEV_SMOKE_I-->	
    <tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th>Address</th>
        <th>Device Type</th>
        <th colspan="2">Label</th>
        <th>Bypassed</th>
        <th>Point Type</th>
        <th colspan="2">Zones</th>
        <th>Delay Mode</th>
    </tr>
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <td><xsl:value-of select="Address" ></xsl:value-of></td>
        <td><xsl:apply-templates select="DeviceType"></xsl:apply-templates></td>
        <td colspan="2"><xsl:value-of select="Label" ></xsl:value-of></td>
        <td><xsl:value-of select="Bypassed" ></xsl:value-of></td>
        <td>
		   <xsl:for-each select="PointType">
			   <xsl:call-template name="PointType"></xsl:call-template>
		   </xsl:for-each>
		</td>
        <td colspan="2"><xsl:call-template name="Zone1_5" ></xsl:call-template></td>
        <td>
		   <xsl:for-each select="DelayMode">
			   <xsl:call-template name="DelayMode"></xsl:call-template>
		   </xsl:for-each>
		</td>
    </tr>

	<!--line 2 for DEV_SMOKE_I-->	
    <tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th colspan="2">Sensitivity</th>
        <th colspan="2">Day Sensitivity</th>
    </tr>
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <td colspan="2"><xsl:call-template name="TP_Sensitivity"></xsl:call-template></td>
        <td colspan="2"><xsl:call-template name="TP_DaySensitivity"></xsl:call-template></td>
    </tr>
	
	<!--line 3 for DEV_SMOKE_I-->	
	<tr style="background-color:#000000; height:6px;">
	<td colspan="9"></td>
	</tr>    
</xsl:template>

<xsl:template name="DEV_SMOKE_M">
    <!--line 1 for DEV_SMOKE_M-->
	<tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th>Address</th>
        <th>Device Type</th>
        <th colspan="2">Label</th>
        <th>Bypassed</th>
        <th>Point Type</th>
        <th colspan="2">Zones</th>
        <th>Delay Mode</th>
    </tr>
    
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <td><xsl:value-of select="Address" ></xsl:value-of></td>
        <td><xsl:apply-templates select="DeviceType"></xsl:apply-templates></td>
        <td colspan="2"><xsl:value-of select="Label" ></xsl:value-of></td>
        <td><xsl:value-of select="Bypassed" ></xsl:value-of></td>
        <td>
		   <xsl:for-each select="PointType">
			   <xsl:call-template name="PointType"></xsl:call-template>
		   </xsl:for-each>
		</td>
        <td colspan="2"><xsl:call-template name="Zone1_5" ></xsl:call-template></td>
        <td>
		   <xsl:for-each select="DelayMode">
			   <xsl:call-template name="DelayMode"></xsl:call-template>
		   </xsl:for-each>
		</td>
    </tr>
	
    <!--line 2 for DEV_SMOKE_M-->
	<tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th>Smoke Label</th>
        <th>Smoke Point Type</th>
        <th>Working Mode</th>
        <th colspan="2">Working Day Mode</th>
        <th colspan="2">Smoke Sensitivity</th>
        <th colspan="2">Smoke Day Sensitivity</th>
    </tr>
	
	<tr style="font-size:12px; font-weight:normal; color:blue;">
        <td><xsl:value-of select="SmokeLabel" ></xsl:value-of></td>
        <td>
		   <xsl:for-each select="SmokePointType">
				  <xsl:call-template name="PointType"></xsl:call-template>
		   </xsl:for-each>
		</td>
		<td>
		   <xsl:for-each select="WorkingMode">
				  <xsl:call-template name="WorkingMode"></xsl:call-template>
		   </xsl:for-each>
		</td>
        <td  colspan="2">
		   <xsl:for-each select="WorkingDayMode">
				  <xsl:call-template name="WorkingMode"></xsl:call-template>
		   </xsl:for-each>
		</td>
        <td colspan="2"><xsl:call-template name="TP_Sensitivity"></xsl:call-template></td>
        <td colspan="2"><xsl:call-template name="TP_DaySensitivity"></xsl:call-template></td>
    </tr>
	
    <!--line 3 for DEV_SMOKE_M-->
	<tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
		<th>Led Flashing</th>
		<xsl:choose>
			<xsl:when test="DeviceType = '30' or DeviceType = '31' or DeviceType = '35' or DeviceType = '36'">
			<th colspan="2">Heat Sensitivity</th>
        	<th colspan="2">Heat Day Sensitivity</th>
			<th>RoR</th>
        	<th>Day RoR</th>
			</xsl:when>
			<xsl:otherwise></xsl:otherwise>
		</xsl:choose> 
	</tr>
     	  
	<tr style="font-size:12px; font-weight:normal; color:blue;">
		<td><xsl:value-of select="LedFlash" ></xsl:value-of></td>
		<xsl:choose>
			<xsl:when test="DeviceType = '30' or DeviceType = '31' or DeviceType = '35' or DeviceType = '36'">
			<td colspan="2"><xsl:for-each select="HeatSensitivity">
				<xsl:call-template name="FixSensitivity"></xsl:call-template>
			</xsl:for-each></td>
			<td colspan="2"><xsl:for-each select="HeatDaySensitivity">
				<xsl:call-template name="FixSensitivity"></xsl:call-template>
			</xsl:for-each></td>
			<td><xsl:value-of select="RoR" ></xsl:value-of></td>
			<td><xsl:value-of select="DayRoR"></xsl:value-of></td>
			</xsl:when>
			<xsl:otherwise></xsl:otherwise>
		</xsl:choose> 
	</tr>

    <!--line 4 for DEV_SMOKE_M-->
	<tr style="background-color:#000000; height:6px;">
	<td colspan="9"></td>
	</tr>    
</xsl:template>

<xsl:template name="DEV_CONVZ_MOD">
    <tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th>Address</th>
        <th>Device Type</th>
        <th colspan="2">Label</th>
        <th>Bypassed</th>
        <th>Point Type</th>
        <th colspan="2">Zones</th>
        <th>Delay Mode</th>
    </tr>
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <td><xsl:value-of select="Address" ></xsl:value-of></td>
        <td><xsl:apply-templates select="DeviceType"></xsl:apply-templates></td>
        <td colspan="2"><xsl:value-of select="Label" ></xsl:value-of></td>
        <td><xsl:value-of select="Bypassed" ></xsl:value-of></td>
        <td>
		   <xsl:for-each select="PointType">
			   <xsl:call-template name="PointType"></xsl:call-template>
		   </xsl:for-each>
		</td>
        <td colspan="2"><xsl:call-template name="Zone1_5" ></xsl:call-template></td>
        <td>
		   <xsl:for-each select="DelayMode">
			   <xsl:call-template name="DelayMode"></xsl:call-template>
		   </xsl:for-each>
		</td>
    </tr>
	
	<tr style="background-color:#000000; height:6px;">
	<td colspan="9"></td>
	</tr>    
</xsl:template>

<xsl:template name="DEV_CONT_MOD">
    <xsl:choose>
        <xsl:when test="DeviceType = '11'">
            <xsl:call-template name="DEV_CONT_MOD_DUAL"></xsl:call-template>
        </xsl:when>
        <xsl:otherwise>
            <xsl:call-template name="DEV_CONT_MOD_SINGLE"></xsl:call-template>
        </xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template name="DEV_CONT_MOD_DUAL">
    <!--line 1 for DEV_CONT_MOD_DUAL-->	
	<tr  style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th>Address</th>
        <th>Device Type</th>
        <th>Label</th>
        <th colspan="6"></th>
    </tr>
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <td><xsl:value-of select="Address" ></xsl:value-of></td>
        <td><xsl:apply-templates select="DeviceType"></xsl:apply-templates></td>
        <td><xsl:value-of select="Label" ></xsl:value-of></td>
        <td colspan="6"></td>
    </tr>

    <!--line 2 for DEV_CONT_MOD_DUAL-->	
    <xsl:for-each select="Input1">
    <tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
		<th style="background-color:white;" rowspan="2"></th>
        <th style="color:blue; background-color:white;" rowspan="2">Input 1</th>
        <th>Label</th>
        <th>Bypassed</th>
        <th>Point Type</th>
        <th>Input Type</th>
        <th colspan="2">Zones</th>
        <th>Delay Mode</th>
    </tr>
	
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <td><xsl:value-of select="Label" ></xsl:value-of></td>
        <td><xsl:value-of select="Bypassed" ></xsl:value-of></td>
        <td>
		   <xsl:for-each select="PointType">
			   <xsl:call-template name="PointType"></xsl:call-template>
		   </xsl:for-each>
		</td>
		<td><xsl:apply-templates select="InputType" ></xsl:apply-templates></td>
        <td colspan="2"><xsl:call-template name="Zone1_5" ></xsl:call-template></td>
        <td>
		   <xsl:for-each select="DelayMode">
			   <xsl:call-template name="DelayMode"></xsl:call-template>
		   </xsl:for-each>
		</td>
    </tr>
    </xsl:for-each>
    <xsl:for-each select="Input2">
    <tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th style="background-color:white;" rowspan="2"></th>
		<th style="color:blue; background-color:white;" rowspan="2">Input 2</th>
        <th>Label</th>
        <th>Bypassed</th>
        <th>Point Type</th>
        <th>Input Type</th>
        <th colspan="2">Zones</th>
        <th>Delay Mode</th>
    </tr>
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <td><xsl:value-of select="Label" ></xsl:value-of></td>
        <td><xsl:value-of select="Bypassed" ></xsl:value-of></td>
        <td>
		   <xsl:for-each select="PointType">
			   <xsl:call-template name="PointType"></xsl:call-template>
		   </xsl:for-each>
		</td>
        <td><xsl:apply-templates select="InputType" ></xsl:apply-templates></td>
        <td colspan="2"><xsl:call-template name="Zone1_5" ></xsl:call-template></td>
        <td>
		   <xsl:for-each select="DelayMode">
			   <xsl:call-template name="DelayMode"></xsl:call-template>
		   </xsl:for-each>
		</td>
    </tr>
    </xsl:for-each>
    <!--line 3 for DEV_CONT_MOD_DUAL-->	
	<tr style="background-color:#000000; height:6px;">
	<td colspan="9"></td>
	</tr>    
</xsl:template>

<xsl:template name="DEV_CONT_MOD_SINGLE">
	<tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th>Address</th>
        <th>Device Type</th>
        <th colspan="2">Label</th>
        <th>Bypassed</th>
        <th>Point Type</th>
        <th>Input Type</th>
		<th colspan="2">Zones</th>
    </tr>
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <td><xsl:value-of select="Address" ></xsl:value-of></td>
        <td><xsl:apply-templates select="DeviceType"></xsl:apply-templates></td>
        <td colspan="2"><xsl:value-of select="Label" ></xsl:value-of></td>
        <td><xsl:value-of select="Bypassed" ></xsl:value-of></td>
        <td>
		   <xsl:for-each select="PointType">
			   <xsl:call-template name="PointType"></xsl:call-template>
		   </xsl:for-each>
		</td>
        <td><xsl:apply-templates select="InputType" ></xsl:apply-templates></td>
		<td colspan="2"><xsl:call-template name="Zone1_5" ></xsl:call-template></td>
    </tr>

	<tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
		<th>Delay Mode</th>
		<xsl:choose>
			<xsl:when test="DeviceType = '8'">
			</xsl:when>
			<xsl:otherwise>
        	<th>Wiring Type</th>
			</xsl:otherwise>
		</xsl:choose>
	</tr>

	<tr style="font-size:12px; font-weight:normal; color:blue;">
		<td>
		   <xsl:for-each select="DelayMode">
			   <xsl:call-template name="DelayMode"></xsl:call-template>
		   </xsl:for-each>
		</td>
		<xsl:choose>
			<xsl:when test="DeviceType = '8'">
			</xsl:when>
			<xsl:otherwise>
				<td>
				<xsl:apply-templates select="WiringType" ></xsl:apply-templates>
				</td>
			</xsl:otherwise>
		</xsl:choose>
	</tr>

	<tr style="background-color:#000000; height:6px;">
	<td colspan="9"></td>
	</tr>    
</xsl:template>

<xsl:template name="DEV_NAC_MOD">
	<!-- table column count == 9 -->
	<tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
		<th>Address</th>
		<th>Device Type</th>
		<th colspan="2">Label</th>
		<th>Bypassed</th>
		<th>Silenceable</th>
		<th colspan="2">Zones</th>
		<th>Pattern</th>
	</tr>
	<tr style="font-size:12px; font-weight:normal; color:blue;">
		<td><xsl:value-of select="Address"></xsl:value-of></td>
		<td><xsl:apply-templates select="DeviceType"></xsl:apply-templates></td>
		<td colspan="2"><xsl:value-of select="Label"></xsl:value-of></td>
		<td><xsl:value-of select="Bypassed"></xsl:value-of></td>
		<td><xsl:value-of select="Drillenceable"></xsl:value-of></td>
		<td colspan="2"><xsl:call-template name="OutputZone1_5"></xsl:call-template></td>
		<td><xsl:value-of select="Pattern"></xsl:value-of></td>
	</tr>

	<tr style="background-color:#000000; height:6px;">
	<td colspan="9"></td>
	</tr>    
</xsl:template>

<xsl:template name="DEV_BASE_SND">
	<tr  style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
		<th>Address</th>
		<th>Device Type</th>
		<th colspan="2">Label</th>
		<th>Bypassed</th>
		<th>Silenceable</th>
		<th>Zone</th>
		<th>Pattern</th>
		<th>Activated By Host</th>
	</tr>
	<tr style="font-size:12px; font-weight:normal; color:blue;">
		<td><xsl:value-of select="Address"></xsl:value-of></td>
		<td><xsl:apply-templates select="DeviceType"></xsl:apply-templates></td>
		<td colspan="2"><xsl:value-of select="Label"></xsl:value-of></td>
		<td><xsl:value-of select="Bypassed"></xsl:value-of></td>
		<td><xsl:value-of select="Drillenceable"></xsl:value-of></td>
		<td><xsl:value-of select="Zone1"></xsl:value-of></td>
		<td><xsl:value-of select="Pattern"></xsl:value-of></td>
		<td><xsl:value-of select="ActivatedbyHost"></xsl:value-of></td>
	</tr>

	<tr style="background-color:#000000; height:6px;">
	<td colspan="9"></td>
	</tr>    
</xsl:template>

<xsl:template name="DEV_RELAY_MOD">
    <xsl:choose>
        <xsl:when test="DeviceType = '17'">
            <xsl:call-template name="DEV_RELAY_MOD_SINGLE"></xsl:call-template>
        </xsl:when>
        <xsl:otherwise>
            <xsl:call-template name="DEV_RELAY_MOD_DUAL"></xsl:call-template>
        </xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template name="DEV_RELAY_MOD_DUAL">
    <tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th>Address</th>
        <th>Device Type</th>
        <th colspan="2">Device Label</th>
        <th colspan="5"></th>
    </tr>
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <td><xsl:value-of select="Address" ></xsl:value-of></td>
        <td><xsl:apply-templates select="DeviceType"></xsl:apply-templates></td>
        <td colspan="2"><xsl:value-of select="Label" ></xsl:value-of></td>
        <td colspan="5"></td>
    </tr>
    <xsl:for-each select="Relay1">
    <tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
		<th style="background-color:white;" rowspan="2"></th>
        <th style="color:blue; background-color:white;" rowspan="2">Relay 1</th>
        <th colspan="2">Label</th>
        <th>Bypassed</th>
        <th>Drillable</th>
        <th colspan="2">Zones</th>
        <th>Sequential</th>
    </tr>
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <!-- <td colspan="2"></td> -->
        <td colspan="2"><xsl:value-of select="Label" ></xsl:value-of></td>
        <td><xsl:value-of select="Bypassed" ></xsl:value-of></td>
        <td><xsl:value-of select="Drillenceable" ></xsl:value-of></td>
        <td colspan="2"><xsl:call-template name="OutputZone1_5" ></xsl:call-template></td>
        <td><xsl:value-of select="Sequential" ></xsl:value-of></td>
    </tr>
    </xsl:for-each>
    <xsl:for-each select="Relay2">
    <tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th style="background-color:white;" rowspan="2"></th>
		<th style="color:blue; background-color:white;" rowspan="2">Relay 2</th>
        <th colspan="2">Label</th>
        <th>Bypassed</th>
        <th>Drillable</th>
        <th colspan="2">Zones</th>
        <th>Sequential</th>
    </tr>
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <!-- <td colspan="2"></td> -->
        <td colspan="2"><xsl:value-of select="Label" ></xsl:value-of></td>
        <td><xsl:value-of select="Bypassed" ></xsl:value-of></td>
        <td><xsl:value-of select="Drillenceable" ></xsl:value-of></td>
        <td colspan="2"><xsl:call-template name="OutputZone1_5" ></xsl:call-template></td>
        <td><xsl:value-of select="Sequential" ></xsl:value-of></td>
    </tr>
    </xsl:for-each>

	<tr style="background-color:#000000; height:6px;">
	<td colspan="9"></td>
	</tr>    
</xsl:template>

<xsl:template name="DEV_RELAY_MOD_SINGLE">
    <tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th>Address</th>
        <th>Device Type</th>
        <th colspan="2">Label</th>
        <th>Bypassed</th>
        <th>Drillable</th>
        <th colspan="2">Zones</th>
        <th>Sequential</th>
    </tr>
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <td><xsl:value-of select="Address"></xsl:value-of></td>
        <td><xsl:apply-templates select="DeviceType" ></xsl:apply-templates></td>
        <td colspan="2"><xsl:value-of select="Label" ></xsl:value-of></td>
        <td><xsl:value-of select="Bypassed"></xsl:value-of></td>
        <td><xsl:value-of select="Drillenceable"></xsl:value-of></td>
        <td colspan="2"><xsl:call-template name="OutputZone1_5"></xsl:call-template></td>
        <td><xsl:value-of select="Sequential"></xsl:value-of></td>
    </tr>

	<tr style="background-color:#000000; height:6px;">
	<td colspan="9"></td>
	</tr>    
</xsl:template>

<xsl:template match="Topology" >
    <xsl:choose>
        <xsl:when test=". = 0"><xsl:text>class</xsl:text> <xsl:text>A</xsl:text></xsl:when>
        <xsl:when test=". = 1"><xsl:text>1 x </xsl:text> <xsl:text>class</xsl:text> <xsl:text>B</xsl:text></xsl:when>
        <xsl:when test=". = 2"><xsl:text>2 x </xsl:text> <xsl:text>class</xsl:text> <xsl:text>B</xsl:text></xsl:when>
        <xsl:otherwise><xsl:text>Invalid Topology Type</xsl:text></xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="DeviceType">
    <xsl:choose>
        <xsl:when test=". = '2'">SLC</xsl:when>
        <xsl:when test=". = '3'">FAP-325</xsl:when>
        <xsl:when test=". = '4'">FAD-325</xsl:when>
        <xsl:when test=". = '5'">FAH-325</xsl:when>
        <xsl:when test=". = '6'">FAI-325</xsl:when>
        <xsl:when test=". = '7'">FAP-325-T</xsl:when>
        <xsl:when test=". = '8'">FLM-325-I4</xsl:when>
        <xsl:when test=". = '9'">FMM-325-A</xsl:when>
        <xsl:when test=". = '10'">FLM-325-CZM4</xsl:when>
        <xsl:when test=". = '11'">FLM-325-2I4</xsl:when>
        <xsl:when test=". = '12'">FLM-325-2R4</xsl:when>
        <xsl:when test=". = '13'">FLM-325-N4</xsl:when>
        <xsl:when test=". = '14'">FLM-325-NA4</xsl:when>
        <xsl:when test=". = '15'">FLM-325-NAI4</xsl:when>
        <xsl:when test=". = '16'">FAA-325-B6S</xsl:when>
        <xsl:when test=". = '17'">D328A</xsl:when>
        <xsl:when test=". = '18'">FLM-325-I4-A</xsl:when>
        <xsl:when test=". = '19'">FLM-325-I4-AI</xsl:when>
        <xsl:when test=". = '20'">FLM-325-IW-A</xsl:when>
        <xsl:when test=". = '21'">FLM-325-IW-AI</xsl:when>
        <xsl:when test=". = '22'">FLM-325-2R4-2A</xsl:when>
        <xsl:when test=". = '23'">FLM-325-2R4-2AI</xsl:when>
        <xsl:when test=". = '24'">FLM-325-2R4-8A</xsl:when>
        <xsl:when test=". = '25'">FLM-325-2R4-8AI</xsl:when>   
        <xsl:when test=". = '26'">FAD-325-DH</xsl:when>
        <xsl:when test=". = '27'">FAP-325-V2</xsl:when>
        <xsl:when test=". = '28'">FMM-325A-D</xsl:when>
		<xsl:when test=". = '29'">FAH-440</xsl:when>
        <xsl:when test=". = '30'">FAP-440-T</xsl:when>
        <xsl:when test=". = '31'">FAP-440-TC</xsl:when>
        <xsl:when test=". = '32'">FAP-440</xsl:when>
        <xsl:when test=". = '33'">FAD-440-DH</xsl:when>   
        <xsl:when test=". = '34'">FAP-440-D</xsl:when>
        <xsl:when test=". = '35'">FAP-440-DT</xsl:when>
        <xsl:when test=". = '36'">FAP-440-DTC</xsl:when>
    </xsl:choose>
</xsl:template>

<xsl:template name="DelayMode" >
    <xsl:choose>
        <xsl:when test=". = 0"><xsl:text>No Delay</xsl:text></xsl:when>
        <xsl:when test=". = 1"><xsl:text>Alarm Verification</xsl:text></xsl:when>
        <xsl:when test=". = 2"><xsl:text>PAS/Presignal</xsl:text></xsl:when>
        <xsl:when test=". = 3"><xsl:text>PAS(day)/AV(night)</xsl:text></xsl:when>
        <xsl:otherwise><xsl:text>Invalid Delay Mode</xsl:text></xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template name="TP_Sensitivity">
	<xsl:choose>
		<xsl:when test="DeviceType = '5'">
			<xsl:for-each select="Sensitivity">
				<xsl:call-template name="TemperatureSensitivity"></xsl:call-template>
			</xsl:for-each>
		</xsl:when>
		<xsl:otherwise>
			<xsl:for-each select="Sensitivity|SmokeSensitivity">
				<xsl:call-template name="LengthSensitivity"></xsl:call-template>
			</xsl:for-each>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>

<xsl:template name="TP_DaySensitivity">
	<xsl:choose>
		<xsl:when test="DeviceType = '5'">
			<xsl:for-each select="DaySensitivity">
				<xsl:call-template name="TemperatureSensitivity"></xsl:call-template>
			</xsl:for-each>
		</xsl:when>
		<xsl:otherwise>
			<xsl:for-each select="DaySensitivity|SmokeDaySensitivity">
				<xsl:call-template name="LengthSensitivity"></xsl:call-template>
			</xsl:for-each>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>

<xsl:template name="TemperatureSensitivity">
    <xsl:choose>
	    	<xsl:when test=". = 0">135&#176;F/57&#176;C</xsl:when>
        	<xsl:when test=". = 1">137&#176;F/58&#176;C</xsl:when>
        	<xsl:when test=". = 2">139&#176;F/59&#176;C</xsl:when>
        	<xsl:when test=". = 3">141&#176;F/61&#176;C</xsl:when>
        	<xsl:when test=". = 4">143&#176;F/62&#176;C</xsl:when>
        	<xsl:when test=". = 5">145&#176;F/63&#176;C</xsl:when>
        	<xsl:when test=". = 6">147&#176;F/64&#176;C</xsl:when>
        	<xsl:when test=". = 7">149&#176;F/65&#176;C</xsl:when>
        	<xsl:when test=". = 8">150&#176;F/66&#176;C</xsl:when>
        	<xsl:otherwise></xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template name="FixSensitivity">
    <xsl:choose>
	    	<xsl:when test=". = 0">135&#176;F/57&#176;C ROR enabled</xsl:when>
        	<xsl:otherwise></xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template name="LengthSensitivity">
    <xsl:choose>
	    	<xsl:when test=". = 0">0.90%/ft, 2.95%/m</xsl:when>
        	<xsl:when test=". = 1">1.00%/ft, 3.30%/m</xsl:when>
        	<xsl:when test=". = 2">1.25%/ft, 4.10%/m</xsl:when>
        	<xsl:when test=". = 3">1.50%/ft, 4.90%/m</xsl:when>
        	<xsl:when test=". = 4">1.75%/ft, 5.75%/m</xsl:when>
        	<xsl:when test=". = 5">2.00%/ft, 6.55%/m</xsl:when>
        	<xsl:when test=". = 6">2.25%/ft, 7.40%/m</xsl:when>
        	<xsl:when test=". = 7">2.50%/ft, 8.20%/m</xsl:when>
        	<xsl:when test=". = 8">2.75%/ft, 9.00%/m</xsl:when>
			<xsl:when test=". = 9">3.00%/ft, 9.85%/m</xsl:when>
			<xsl:when test=". = 10">3.25%/ft, 10.65%/m</xsl:when>
			<xsl:when test=". = 11">3.50%/ft, 11.50%/m</xsl:when>
        	<xsl:otherwise></xsl:otherwise>
    </xsl:choose>
</xsl:template>



<xsl:template match="InputType" >
    <xsl:choose>
        <xsl:when test=". = 0"><xsl:text>NO with EOL</xsl:text></xsl:when>
        <xsl:when test=". = 1"><xsl:text>NC with EOL</xsl:text></xsl:when>
        <xsl:when test=". = 2"><xsl:text>NC w/o EOL</xsl:text></xsl:when>
        <xsl:otherwise><xsl:text>Invalid Input Type</xsl:text></xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="WiringType" >
    <xsl:choose>
        <xsl:when test=". = 0"><xsl:text>Class B</xsl:text></xsl:when>
        <xsl:when test=". = 1"><xsl:text>Class A</xsl:text></xsl:when>
        <xsl:otherwise><xsl:text>Invalid Wiring Type</xsl:text></xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="Bypassed|Drillenceable" >
    <xsl:choose>
        <xsl:when test=". = FALSE"><xsl:text>Disabled</xsl:text></xsl:when>
        <xsl:when test=". = TRUE"><xsl:text>Enabled</xsl:text></xsl:when>
        <xsl:otherwise><xsl:text>No Status</xsl:text></xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template name="Zone1_5">
	<xsl:value-of select="PID1"/>-<xsl:value-of select="Zone1"/><xsl:text>,</xsl:text>
	<xsl:value-of select="PID2"/>-<xsl:value-of select="Zone2"/><xsl:text>,</xsl:text>
	<xsl:value-of select="PID3"/>-<xsl:value-of select="Zone3"/><xsl:text>,</xsl:text>
	<xsl:value-of select="PID4"/>-<xsl:value-of select="Zone4"/><xsl:text>,</xsl:text>
	<xsl:value-of select="PID5"/>-<xsl:value-of select="Zone5"/>
</xsl:template>

<xsl:template name="OutputZone1_5">
	<xsl:value-of select="Zone1"/><xsl:text>-</xsl:text>
	<xsl:value-of select="Zone2"/><xsl:text>-</xsl:text>
	<xsl:value-of select="Zone3"/><xsl:text>-</xsl:text>
	<xsl:value-of select="Zone4"/><xsl:text>-</xsl:text>
	<xsl:value-of select="Zone5"/>
</xsl:template>

<xsl:template name="RelayZone1_5">
	<xsl:call-template name="OutputZone1_5"/>
</xsl:template>


<xsl:template match="Relay1|Relay2" >
        Relay1,Relay2 Settings[
        Label:<xsl:value-of select="Label" /> 
        Zones:<xsl:call-template name="Zone1_5" />
        Bypassed: <xsl:value-of select="Bypassed" />
        Energized in Normal:<xsl:value-of select="ENormal" /> 
        Drillable:<xsl:value-of select="Drillenceable" />
        ]<br/>
</xsl:template>

<xsl:template match="DuctRelay">
        Duct Relay Settings[
        Label:<xsl:value-of select="Label" /> 
        Zones:<xsl:call-template name="Zone1_5" />
        Bypassed:<xsl:value-of select="Bypassed" />
    ]<br/>
</xsl:template>

<xsl:template match="Input1|Input2" >
    Input1, Input2 Settings[
        Label:<xsl:value-of select="Label" />
        Zones:<xsl:call-template name="Zone1_5" />
        Bypassed:<xsl:value-of select="Bypassed" /> 
        Point Type:><xsl:call-template name="PointType" /> 
        Input Type:<xsl:apply-templates select="InputType" />
    ]<br/>
</xsl:template>

<xsl:template name="PointType">
    <xsl:choose>
        <xsl:when test=". = 0"><xsl:text>Fire automatic</xsl:text></xsl:when>
        <xsl:when test=". = 1"><xsl:text>Fire alarm manual</xsl:text></xsl:when>
        <xsl:when test=". = 2"><xsl:text>Waterflow</xsl:text></xsl:when>
        <xsl:when test=". = 3"><xsl:text>Waterflow delay</xsl:text></xsl:when>
        <xsl:when test=". = 4"><xsl:text>Gas alarm</xsl:text></xsl:when>
        <xsl:when test=". = 5"><xsl:text>Supervisory</xsl:text></xsl:when>
        <xsl:when test=". = 6"><xsl:text>Generic</xsl:text></xsl:when>
        <xsl:when test=". = 7"><xsl:text>Trouble</xsl:text></xsl:when>
        <xsl:when test=". = 8"><xsl:text>AC Failure</xsl:text></xsl:when>
        <xsl:when test=". = 9"><xsl:text>Battery Failure</xsl:text></xsl:when>
        <xsl:when test=". = 10"><xsl:text>Reset</xsl:text></xsl:when>
        <xsl:when test=". = 11"><xsl:text>Silence</xsl:text></xsl:when>
        <xsl:when test=". = 12"><xsl:text>Drill</xsl:text></xsl:when>
        <xsl:when test=". = 13"><xsl:text>Acknowledge</xsl:text></xsl:when>
		<xsl:when test=". = 14"><xsl:text>Alarm General</xsl:text></xsl:when>
    </xsl:choose>
</xsl:template>

<xsl:template name="WorkingMode">
    <xsl:choose>
        <xsl:when test=". = 0"><xsl:text>Multi-combined</xsl:text></xsl:when>
        <xsl:when test=". = 1"><xsl:text>Multi-separated</xsl:text></xsl:when>
    </xsl:choose>
</xsl:template>

<xsl:template name="Week">
		<xsl:choose>
            <xsl:when test=". = 1"><xsl:text>1st</xsl:text></xsl:when>
            <xsl:when test=". = 2"><xsl:text>2nd</xsl:text></xsl:when>
			<xsl:when test=". = 3"><xsl:text>3rd</xsl:text></xsl:when>
            <xsl:when test=". = 4"><xsl:text>4th</xsl:text></xsl:when>
			<xsl:when test=". = 5"><xsl:text>last</xsl:text></xsl:when>
        </xsl:choose>
</xsl:template>

<xsl:template name="Month">
   		<xsl:choose>
            <xsl:when test=". = 1"><xsl:text>January</xsl:text></xsl:when>
            <xsl:when test=". = 2"><xsl:text>February</xsl:text></xsl:when>
			<xsl:when test=". = 3"><xsl:text>March</xsl:text></xsl:when>
            <xsl:when test=". = 4"><xsl:text>April</xsl:text></xsl:when>
			<xsl:when test=". = 5"><xsl:text>May</xsl:text></xsl:when>
			<xsl:when test=". = 6"><xsl:text>June</xsl:text></xsl:when>
            <xsl:when test=". = 7"><xsl:text>July</xsl:text></xsl:when>
			<xsl:when test=". = 8"><xsl:text>August</xsl:text></xsl:when>
            <xsl:when test=". = 9"><xsl:text>September</xsl:text></xsl:when>
			<xsl:when test=". = 10"><xsl:text>October</xsl:text></xsl:when>
			<xsl:when test=". = 11"><xsl:text>November</xsl:text></xsl:when>
			<xsl:when test=". = 12"><xsl:text>December</xsl:text></xsl:when>
        </xsl:choose>
</xsl:template>

<xsl:template match="MAINBOARD" >
    <table border="1" style="color:black; width:800px; left:50px;">
        <tr>
            <th colspan="9" style=" background-color:black; color:white; font-weight:bold; font-size:14px; text-align:center; ">Mainboard</th>
        </tr>
        <tr>
            <td colspan="9" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">Relays</td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Relays</td>
            <td style="font-size:12px; font-weight:bold;">Relay Type</td>
            <td style="font-size:12px; font-weight:bold;">Zones</td>
            <td style="font-size:12px; font-weight:bold;">Drillable</td>
			<td style="font-size:12px; font-weight:bold;">Ext. signaling</td>
            <td style="font-size:12px; font-weight:bold;">Bypassed</td>
            <td style="font-size:12px; font-weight:bold;">ENormal</td>
            <td style="font-size:12px; font-weight:bold;">Sequential</td>
            <td style="font-size:12px; font-weight:bold;">Label</td>
        </tr>
        
        <xsl:for-each select="Relay1">
        <tr style="font-size:12px; font-weight:normal; color:blue;">
            <td style="color:black;">Relay 1</td>
            <td><xsl:for-each select="RelayType">
                    <xsl:call-template name="MAINBOARD_RELAYTYPE"/>
                </xsl:for-each></td>
            <td><xsl:call-template name="OutputZone1_5" /></td>
            <td><xsl:value-of select="Drillenceable" /></td>
			<td><xsl:value-of select="Silenceable" /></td>
            <td><xsl:value-of select="Bypassed" /></td>
            <td><xsl:value-of select="ENormal" /></td>
            <td><xsl:value-of select="Sequential" /></td>
            <td><xsl:value-of select="Label" /></td>
        </tr>
        </xsl:for-each>
        
        <xsl:for-each select="Relay2">
        <tr style="font-size:12px; font-weight:normal; color:blue;">
            <td style="color:black;">Relay 2</td>
            <td><xsl:for-each select="RelayType">
                <xsl:call-template name="MAINBOARD_RELAYTYPE"/>
                </xsl:for-each></td>
            <td><xsl:call-template name="OutputZone1_5" /></td>
            <td><xsl:value-of select="Drillenceable" /></td>
			<td><xsl:value-of select="Silenceable" /></td>
            <td><xsl:value-of select="Bypassed" /></td>
            <td><xsl:value-of select="ENormal" /></td>
            <td><xsl:value-of select="Sequential" /></td>
            <td><xsl:value-of select="Label" /></td>
        </tr>
        </xsl:for-each>
        
        <xsl:for-each select="Relay3">
        <tr style="font-size:12px; font-weight:normal; color:blue;">
            <td style="color:black;">Relay 3</td>
            <td><xsl:for-each select="RelayType">
                    <xsl:call-template name="MAINBOARD_RELAYTYPE"/>
                </xsl:for-each></td>
            <td><xsl:call-template name="OutputZone1_5" /></td>
            <td><xsl:value-of select="Drillenceable" /></td>
			<td><xsl:value-of select="Silenceable" /></td>
            <td><xsl:value-of select="Bypassed" /></td>
            <td><xsl:value-of select="ENormal" /></td>
            <td><xsl:value-of select="Sequential" /></td>
            <td><xsl:value-of select="Label" /></td>
        </tr>
        </xsl:for-each>
    </table>    
    
    <table border="1" style="color:black; width:800px; left:50px;">
        <tr align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">
            <td colspan="6" style="background:#CCCCCC; font-size:12px; font-weight:bold;">NACs</td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">NACs</td>
            <td style="font-size:12px; font-weight:bold;">Pattern</td>
            <td style="font-size:12px; font-weight:bold;">Zones</td>
            <td style="font-size:12px; font-weight:bold;">Silence</td>
            <td style="font-size:12px; font-weight:bold;">Bypassed</td>
            <td style="font-size:12px; font-weight:bold;">Label</td>
        </tr>
        <tr style="font-size:12px; font-weight:normal; color:blue;">
            <td style="color:black;">NAC 1</td>    
            <xsl:for-each select="NAC1">
                <xsl:call-template name="MAINBOARD_NACS" />
            </xsl:for-each>
        </tr>
        <tr style="font-size:12px; font-weight:normal; color:blue;">
            <td style="color:black;">NAC 2</td>
            <xsl:for-each select="NAC2">
                <xsl:call-template name="MAINBOARD_NACS" />
            </xsl:for-each>
        </tr>
    </table>
    
    <table border="1" style="color:black; width:800px; left:50px;">
        <tr align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">
            <td colspan="6" style="background:#CCCCCC; font-size:12px; font-weight:bold;">City Tie</td>
        </tr>
        <tr>
            <td colspan="1" style="font-size:12px; font-weight:bold;">City Tie Installed: </td>
			<td style="font-size:12px; font-weight:normal; color:blue;"><xsl:value-of select="CityTie/Installed" /></td>
        </tr>
		 <tr>
            <td colspan="1" style="font-size:12px; font-weight:bold;">Activated by events from: </td>
			<td style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:apply-templates select="CityTie/CityTieWide"></xsl:apply-templates></td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">City Tie</td>
            <td style="font-size:12px; font-weight:bold;">Disabled</td>
            <td style="font-size:12px; font-weight:bold;">Type</td>
            <td style="font-size:12px; font-weight:bold;">Bypassed</td>
            <td style="font-size:12px; font-weight:bold;">Silenceable</td>
            <td style="font-size:12px; font-weight:bold;">Label</td>
        </tr>
        <xsl:for-each select="CityTie/CityTie1">
        <tr>
            <td style="font-size:12px; font-weight:normal;">City Tie 1</td>
            <td style="font-size:12px; font-weight:normal; color:blue;">
                <xsl:if test="TieMode = 2"><xsl:text>TRUE</xsl:text></xsl:if>
				<xsl:if test="TieMode = 1"><xsl:text>FALSE</xsl:text></xsl:if>
                <xsl:if test="TieMode = 0"><xsl:text>FALSE</xsl:text></xsl:if></td>
            <td style="font-size:12px; font-weight:normal; color:blue;">
                <xsl:for-each select="RelayType">
                    <xsl:call-template name="CITYTIE_RELAYTYPE"/>
                </xsl:for-each></td>
            <td style="font-size:12px; font-weight:normal; color:blue;">
                <xsl:value-of select="Bypassed" /></td>
            <td style="font-size:12px; font-weight:normal; color:blue;">
                <xsl:value-of select="Silenceable" /></td>
            <td style="font-size:12px; font-weight:normal; color:blue;">
                <xsl:value-of select="Label" /></td>
        </tr>
        </xsl:for-each>
        <xsl:for-each select="CityTie/CityTie2">
        <tr>
            <td style="font-size:12px; font-weight:normal;">City Tie 2</td>
            <td style="font-size:12px; font-weight:normal; color:blue;">
                <xsl:if test="TieMode = 2"><xsl:text>TRUE</xsl:text></xsl:if>
				<xsl:if test="TieMode = 1"><xsl:text>FALSE</xsl:text></xsl:if>
                <xsl:if test="TieMode = 0"><xsl:text>FALSE</xsl:text></xsl:if></td>
            <td style="font-size:12px; font-weight:normal; color:blue;">
                <xsl:for-each select="RelayType">
                    <xsl:call-template name="CITYTIE_RELAYTYPE"/>
                </xsl:for-each></td>
            <td style="font-size:12px; font-weight:normal; color:blue;">
                <xsl:value-of select="Bypassed" /></td>
            <td style="font-size:12px; font-weight:normal; color:blue;">
                <xsl:value-of select="Silenceable" /></td>
            <td style="font-size:12px; font-weight:normal; color:blue;">
                <xsl:value-of select="Label" /></td>
        </tr>
        </xsl:for-each>
    </table>            
</xsl:template>

<xsl:template name="CITYTIE_RELAYTYPE">
    <xsl:choose>
        <xsl:when test=". = 0"><xsl:text>Fire alarm</xsl:text></xsl:when>
        <xsl:when test=". = 1"><xsl:text>Trouble</xsl:text></xsl:when>
        <xsl:when test=". = 2"><xsl:text>Supervisory</xsl:text></xsl:when>
        <xsl:when test=". = 3"><xsl:text>Gas Alarm</xsl:text></xsl:when>
    </xsl:choose>
</xsl:template>

<xsl:template name="LED_ZoneRange">
    <xsl:choose>
		<xsl:when test=". = 'FALSE'"><xsl:text>Zone 1-128</xsl:text></xsl:when>
        <xsl:when test=". = 'TRUE'"><xsl:text>Zone 129-225</xsl:text></xsl:when>
    </xsl:choose>
</xsl:template>

<xsl:template name="MAINBOARD_NACS">
        <td style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:for-each select="Pattern">
            <xsl:call-template name="ID_MAINPATTERN" />
            </xsl:for-each></td>
        <td style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:call-template name="OutputZone1_5" /></td>
        <td style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:value-of select="Drillenceable" /></td>
        <td style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:value-of select="Bypassed" /></td>
        <td style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:value-of select="Label" /></td>
</xsl:template>

<xsl:template name="MB_ANNs">
	<tr style="font-weight:normal; color:black;">
		<td>1</td>
		<td>Zone 1-8</td>
		<td style="color:blue;"><xsl:value-of select="Ann1/D7030x" /></td>
		<td>Zone 9-16</td>
		<td style="color:blue;"><xsl:value-of select="Ann1/D7032" /></td>
		<td>5</td>
		<td>Zone 65-72</td>
		<td style="color:blue;"><xsl:value-of select="Ann5/D7030x" /></td>
		<td>Zone 73-80</td>
		<td style="color:blue;"><xsl:value-of select="Ann5/D7032" /></td>
	</tr>
	<tr style="font-weight:normal; color:black;">
		<td>2</td>
		<td>Zone 17-24</td>
		<td style="color:blue;"><xsl:value-of select="Ann2/D7030x" /></td>
		<td>Zone 25-32</td>
		<td style="color:blue;"><xsl:value-of select="Ann2/D7032" /></td>
		<td>6</td>
		<td>Zone 81-88</td>
		<td style="color:blue;"><xsl:value-of select="Ann6/D7030x" /></td>
		<td>Zone 89-96</td>
		<td style="color:blue;"><xsl:value-of select="Ann6/D7032" /></td>
	</tr>
	<tr style="font-weight:normal; color:black;">
		<td>3</td>
		<td>Zone 33-41</td>
		<td style="color:blue;"><xsl:value-of select="Ann3/D7030x" /></td>
		<td>Zone 42-49</td>
		<td style="color:blue;"><xsl:value-of select="Ann3/D7032" /></td>
		<td>7</td>
		<td>Zone 97-104</td>
		<td style="color:blue;"><xsl:value-of select="Ann7/D7030x" /></td>
		<td>Zone 105-112</td>
		<td style="color:blue;"><xsl:value-of select="Ann7/D7032" /></td>
	</tr>
	<tr style="font-weight:normal; color:black;">
		<td>4</td>
		<td>Zone 50-57</td>
		<td style="color:blue;"><xsl:value-of select="Ann4/D7030x" /></td>
		<td>Zone 58-65</td>
		<td style="color:blue;"><xsl:value-of select="Ann4/D7032" /></td>
		<td>8</td>
		<td>Zone 113-120</td>
		<td style="color:blue;"><xsl:value-of select="Ann8/D7030x" /></td>
		<td>Zone 121-128</td>
		<td style="color:blue;"><xsl:value-of select="Ann8/D7032" /></td>
	</tr>
</xsl:template>

<xsl:template name="MB_ANNs_HIGH">
	<tr style="font-weight:normal; color:black;">
		<td>1</td>
		<td>Zone 129-136</td>
		<td style="color:blue;"><xsl:value-of select="Ann1/D7030x" /></td>
		<td>Zone 137-144</td>
		<td style="color:blue;"><xsl:value-of select="Ann1/D7032" /></td>
		<td>5</td>
		<td>Zone 193-200</td>
		<td style="color:blue;"><xsl:value-of select="Ann5/D7030x" /></td>
		<td>Zone 201-208</td>
		<td style="color:blue;"><xsl:value-of select="Ann5/D7032" /></td>
	</tr>
	<tr style="font-weight:normal; color:black;">
		<td>2</td>
		<td>Zone 145-152</td>
		<td style="color:blue;"><xsl:value-of select="Ann2/D7030x" /></td>
		<td>Zone 153-160</td>
		<td style="color:blue;"><xsl:value-of select="Ann2/D7032" /></td>
		<td>6</td>
		<td>Zone 209-216</td>
		<td style="color:blue;"><xsl:value-of select="Ann6/D7030x" /></td>
		<td>Zone 217-224</td>
		<td style="color:blue;"><xsl:value-of select="Ann6/D7032" /></td>
	</tr>
	<tr style="font-weight:normal; color:black;">
		<td>3</td>
		<td>Zone 161-168</td>
		<td style="color:blue;"><xsl:value-of select="Ann3/D7030x" /></td>
		<td>Zone 169-176</td>
		<td style="color:blue;"><xsl:value-of select="Ann3/D7032" /></td>
		<td>7</td>
		<td>Zone 225</td>
		<td style="color:blue;"><xsl:value-of select="Ann7/D7030x" /></td>
	</tr>
	<tr style="font-weight:normal; color:black;">
		<td>4</td>
		<td>Zone 177-184</td>
		<td style="color:blue;"><xsl:value-of select="Ann4/D7030x" /></td>
		<td>Zone 185-192</td>
		<td style="color:blue;"><xsl:value-of select="Ann4/D7032" /></td>
	</tr>
</xsl:template>

<xsl:template match="OPTIONBUS">
	<table border="1" style="color:black; font-size:12px; width:800px; left:50px;">
        <tr>
            <th colspan="10" style="background-color:black; color:white; font-weight:bold; font-size:14px; text-align:center; ">Option Bus</th>
        </tr>
		<tr>
			<td colspan="10" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">LED Annunciators</td>
		</tr>
		<tr>
			<td style="color:blue;" colspan="10"><xsl:for-each select="RepeatLED1to4">
					<xsl:call-template name="LED_ZoneRange" /></xsl:for-each></td>
		</tr>
		<tr style="font-weight:bold; color:black;">
			<td>Address</td>
			<td colspan="2">D7030X</td>
			<td colspan="2">D7032</td>
			<td>Address</td>
			<td colspan="2">D7030X</td>
			<td colspan="2">D7032</td>
		</tr>
		<xsl:choose>
			<xsl:when test="RepeatLED1to4 = 'FALSE'">
				<xsl:call-template name="MB_ANNs"></xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="MB_ANNs_HIGH"></xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</table>
	
	<table border="1" style="color:black; width:800px; font-size:12px; left:50px;">
		<tr>
			<td colspan="15" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">LCD Annunciators/Command Centers (FMR-1000)</td>
		</tr>
		<tr></tr>
		<tr style="font-weight:bold;">
			<td>Address</td>
			<td>Enabled</td>
			<td></td>
			<td>Address</td>
			<td>Enabled</td>
			<td></td>
			<td>Address</td>
			<td>Enabled</td>
			<td></td>
			<td>Address</td>
			<td>Enabled</td>
		</tr>
		<tr>
			<td>16</td>
			<td style="color:blue;"><xsl:value-of select="Ann16" /></td>
			<td></td>
			<td>17</td>
			<td style="color:blue;"><xsl:value-of select="Ann17" /></td>
			<td></td>
			<td>18</td>
			<td style="color:blue;"><xsl:value-of select="Ann18" /></td>
			<td></td>
			<td>19</td>
			<td style="color:blue;"><xsl:value-of select="Ann19" /></td>
		</tr>
		<tr>
			<td>20</td>
			<td style="color:blue;"><xsl:value-of select="Ann20" /></td>
			<td></td>
			<td>21</td>
			<td style="color:blue;"><xsl:value-of select="Ann21" /></td>
			<td></td>
			<td>22</td>
			<td style="color:blue;"><xsl:value-of select="Ann22" /></td>
			<td></td>
			<td>23</td>
			<td style="color:blue;"><xsl:value-of select="Ann23" /></td>
		</tr>
	</table>
	
	<table border="1" style="color:black; width:800px; left:50px;">
        <tr>
            <td colspan="9" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">D7035 Octal Relay Modules, D7048 Octal Driver Modules</td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;" rowspan="11" width="10%">Address 9</td>
			<td style="font-size:12px; font-weight:bold;">Label</td>
			<td style="font-size:12px; font-weight:normal; color:blue;" colspan="7"><xsl:value-of select="OutputMod9/Label" /></td>
            
        </tr>
		<tr>
			<td style="font-size:12px; font-weight:bold;">Installed</td>
			<td style="font-size:12px; font-weight:normal; color:blue;" colspan="7"><xsl:value-of select="OutputMod9/Enable" /></td>
		</tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;" width="5%">Output</td>
            <td style="font-size:12px; font-weight:bold;" width="15%">Zones</td>
            <td style="font-size:12px; font-weight:bold;" width="10%">Drillable</td>
			<td style="font-size:12px; font-weight:bold;" width="10%">Ext. signaling</td>
            <td style="font-size:12px; font-weight:bold;" width="10%">Bypassed</td>
            <td style="font-size:12px; font-weight:bold;" width="10%">ENormal</td>
            <td style="font-size:12px; font-weight:bold;" width="10%">Sequential</td>
            <td style="font-size:12px; font-weight:bold;" width="20%">Label</td>
        </tr>
        <xsl:apply-templates select="OutputMod9" />
         <tr>
            <td style="font-size:12px; font-weight:bold;" rowspan="11" width="10%">Address 10</td>
			<td style="font-size:12px; font-weight:bold;">Label</td>
			<td style="font-size:12px; font-weight:normal; color:blue;" colspan="7"><xsl:value-of select="OutputMod10/Label" /></td>
            
        </tr>
		<tr>
			<td style="font-size:12px; font-weight:bold;">Installed</td>
			<td style="font-size:12px; font-weight:normal; color:blue;" colspan="7"><xsl:value-of select="OutputMod10/Enable" /></td>
		</tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;" width="5%">Output</td>
            <td style="font-size:12px; font-weight:bold;" width="15%">Zones</td>
            <td style="font-size:12px; font-weight:bold;" width="10%">Drillable</td>
			<td style="font-size:12px; font-weight:bold;" width="10%">Ext. signaling</td>
            <td style="font-size:12px; font-weight:bold;" width="10%">Bypassed</td>
            <td style="font-size:12px; font-weight:bold;" width="10%">ENormal</td>
            <td style="font-size:12px; font-weight:bold;" width="10%">Sequential</td>
            <td style="font-size:12px; font-weight:bold;" width="20%">Label</td>
        </tr>
        <xsl:apply-templates select="OutputMod10" />
    </table>
	
	
	
    <table border="1" style="color:black; width:800px; left:50px;">
        <tr>
            <td colspan="7" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">
                FPP-RNAC-8A-4A Remote NAC Power Supply
            </td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;" rowspan="7" width="10%">Address 11</td>
			<td style="font-size:12px; font-weight:bold;">Label</td>
			<td style="font-size:12px; font-weight:normal; color:blue;" colspan="5"><xsl:value-of select="RNAC11/Label" /></td>
            
        </tr>
		<tr>
			<td style="font-size:12px; font-weight:bold;">Installed</td>
			<td style="font-size:12px; font-weight:normal; color:blue;" colspan="5"><xsl:value-of select="RNAC11/Enable" /></td>
		</tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;" width="10%">Output</td>
            <td style="font-size:12px; font-weight:bold;" width="15%">Zones</td>
            <td style="font-size:12px; font-weight:bold;" width="15%">Pattern</td>
            <td style="font-size:12px; font-weight:bold;" width="10%">Silence</td>
            <td style="font-size:12px; font-weight:bold;" width="10%">Bypassed</td>
            <td style="font-size:12px; font-weight:bold;" width="20%">Label</td>
        </tr>
        <xsl:apply-templates select="RNAC11" />
       <tr>
            <td style="font-size:12px; font-weight:bold;" rowspan="7" width="10%">Address 12</td>
			<td style="font-size:12px; font-weight:bold;">Label</td>
			<td style="font-size:12px; font-weight:normal; color:blue;" colspan="5"><xsl:value-of select="RNAC12/Label" /></td>
            
        </tr>
		<tr>
			<td style="font-size:12px; font-weight:bold;">Installed</td>
			<td style="font-size:12px; font-weight:normal; color:blue;" colspan="5"><xsl:value-of select="RNAC12/Enable" /></td>
		</tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;" width="10%">Output</td>
            <td style="font-size:12px; font-weight:bold;" width="15%">Zones</td>
            <td style="font-size:12px; font-weight:bold;" width="15%">Pattern</td>
            <td style="font-size:12px; font-weight:bold;" width="10%">Silence</td>
            <td style="font-size:12px; font-weight:bold;" width="10%">Bypassed</td>
            <td style="font-size:12px; font-weight:bold;" width="20%">Label</td>
        </tr>        
        <xsl:apply-templates select="RNAC12" />
           <tr>
            <td style="font-size:12px; font-weight:bold;" rowspan="7" width="10%">Address 13</td>
			<td style="font-size:12px; font-weight:bold;">Label</td>
			<td style="font-size:12px; font-weight:normal; color:blue;" colspan="5"><xsl:value-of select="RNAC13/Label" /></td>
            
        </tr>
		<tr>
			<td style="font-size:12px; font-weight:bold;">Installed</td>
			<td style="font-size:12px; font-weight:normal; color:blue;" colspan="5"><xsl:value-of select="RNAC13/Enable" /></td>
		</tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;" width="10%">Output</td>
            <td style="font-size:12px; font-weight:bold;" width="15%">Zones</td>
            <td style="font-size:12px; font-weight:bold;" width="15%">Pattern</td>
            <td style="font-size:12px; font-weight:bold;" width="10%">Silence</td>
            <td style="font-size:12px; font-weight:bold;" width="10%">Bypassed</td>
            <td style="font-size:12px; font-weight:bold;" width="20%">Label</td>
        </tr>
        <xsl:apply-templates select="RNAC13" />
        <tr>
            <td style="font-size:12px; font-weight:bold;" rowspan="7" width="10%">Address 14</td>
			<td style="font-size:12px; font-weight:bold;">Label</td>
			<td style="font-size:12px; font-weight:normal; color:blue;" colspan="5"><xsl:value-of select="RNAC14/Label" /></td>
            
        </tr>
		<tr>
			<td style="font-size:12px; font-weight:bold;">Installed</td>
			<td style="font-size:12px; font-weight:normal; color:blue;" colspan="5"><xsl:value-of select="RNAC14/Enable" /></td>
		</tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;" width="10%">Output</td>
            <td style="font-size:12px; font-weight:bold;" width="15%">Zones</td>
            <td style="font-size:12px; font-weight:bold;" width="15%">Pattern</td>
            <td style="font-size:12px; font-weight:bold;" width="10%">Silence</td>
            <td style="font-size:12px; font-weight:bold;" width="10%">Bypassed</td>
            <td style="font-size:12px; font-weight:bold;" width="20%">Label</td>
        </tr>
        <xsl:apply-templates select="RNAC14" />
    </table>
</xsl:template>

<xsl:template match="FPA1000/OPTIONBUS/RNAC11|RNAC12|RNAC13|RNAC14" >
    <tr style="color:blue; font-size:12px; font-weight:normal;">
        <td>1</td>
        <xsl:for-each select="NAC1">
            <xsl:call-template name="RNAC_NACS" />
        </xsl:for-each>
    </tr>
    <tr style="color:blue; font-size:12px; font-weight:normal;">
        <td>2</td>
        <xsl:for-each select="NAC2">
            <xsl:call-template name="RNAC_NACS" />
        </xsl:for-each>
    </tr>
    <tr style="color:blue; font-size:12px; font-weight:normal;">
        <td>3</td>
        <xsl:for-each select="NAC3">
            <xsl:call-template name="RNAC_NACS" />
        </xsl:for-each>
    </tr>
    <tr style="color:blue; font-size:12px; font-weight:normal;">
        <td>4</td>
        <xsl:for-each select="NAC4">
            <xsl:call-template name="RNAC_NACS" />
        </xsl:for-each>
    </tr>
</xsl:template>

<xsl:template name="RNAC_NACS">
    <td style="color:blue; font-size:12px; font-weight:normal;">
        <xsl:call-template name="OutputZone1_5" /></td>
    <td style="font-size:12px; font-weight:normal; color:blue;">
        <xsl:for-each select="Pattern">
        <xsl:call-template name="ID_MAINPATTERN" />
        </xsl:for-each></td>
    <td style="font-size:12px; font-weight:normal; color:blue;">
        <xsl:value-of select="Drillenceable" /></td>
    <td style="font-size:12px; font-weight:normal; color:blue;">
        <xsl:value-of select="Bypassed" /></td>
    <td style="font-size:12px; font-weight:normal; color:blue;">
        <xsl:value-of select="Label" /></td>
</xsl:template>





<xsl:template match="OutputMod9|OutputMod10" >
    <tr>
        <td style="font-size:12px; font-weight:normal; color:blue;">1</td>
        <xsl:for-each select="Relay1">
            <xsl:call-template name="OUTPUT_RELAYS" />
        </xsl:for-each>
    </tr>
    <tr>
        <td style="font-size:12px; font-weight:normal; color:blue;">2</td>
        <xsl:for-each select="Relay2">
            <xsl:call-template name="OUTPUT_RELAYS" />
        </xsl:for-each>    
    </tr>
    <tr>
        <td style="font-size:12px; font-weight:normal; color:blue;">3</td>
        <xsl:for-each select="Relay3">
            <xsl:call-template name="OUTPUT_RELAYS" />
        </xsl:for-each>
    </tr>
    <tr>
        <td style="font-size:12px; font-weight:normal; color:blue;">4</td>
        <xsl:for-each select="Relay4">
            <xsl:call-template name="OUTPUT_RELAYS" />
        </xsl:for-each>
    </tr>
    <tr>
        <td style="font-size:12px; font-weight:normal; color:blue;">5</td>
        <xsl:for-each select="Relay5">
            <xsl:call-template name="OUTPUT_RELAYS" />
        </xsl:for-each>    
    </tr>
    <tr>
        <td style="font-size:12px; font-weight:normal; color:blue;">6</td>
        <xsl:for-each select="Relay6">
            <xsl:call-template name="OUTPUT_RELAYS" />
        </xsl:for-each>
    </tr>
    <tr>
        <td style="font-size:12px; font-weight:normal; color:blue;">7</td>
        <xsl:for-each select="Relay7">
            <xsl:call-template name="OUTPUT_RELAYS" />
        </xsl:for-each>
    </tr>
    <tr>
        <td style="font-size:12px; font-weight:normal; color:blue;">8</td>
        <xsl:for-each select="Relay8">
            <xsl:call-template name="OUTPUT_RELAYS" />
        </xsl:for-each>
    </tr>
</xsl:template>

<xsl:template name="OUTPUT_RELAYS" >
    <td style="font-size:12px; font-weight:normal; color:blue;">
        <xsl:call-template name="OutputZone1_5" /></td>
    <td style="font-size:12px; font-weight:normal; color:blue;">
        <xsl:value-of select="Drillenceable" /></td>
	<td style="font-size:12px; font-weight:normal; color:blue;">
		<xsl:value-of select="Silenceable" /></td>	
    <td style="font-size:12px; font-weight:normal; color:blue;">
        <xsl:value-of select="Bypassed" /></td>
    <td style="font-size:12px; font-weight:normal; color:blue;">
        <xsl:value-of select="ENormal" /></td>
    <td style="font-size:12px; font-weight:normal; color:blue;">
        <xsl:value-of select="Sequential" /></td>
    <td style="font-size:12px; font-weight:normal; color:blue;">
        <xsl:value-of select="Label" /></td>
</xsl:template>

<xsl:template name="MAINBOARD_RELAYTYPE">
    <xsl:choose>
		<xsl:when test=". = 0"><xsl:text>Fire alarm</xsl:text></xsl:when>
		<xsl:when test=". = 1"><xsl:text>Trouble</xsl:text></xsl:when>
		<xsl:when test=". = 2"><xsl:text>Supervisory</xsl:text></xsl:when>
		<xsl:when test=". = 3"><xsl:text>Gas Alarm</xsl:text></xsl:when>
		<xsl:when test=". = 4"><xsl:text>By Zone</xsl:text></xsl:when>
    </xsl:choose>
</xsl:template>

<xsl:template name="ID_MAINPATTERN">
    <xsl:choose>
        <xsl:when test=". = 1" ><xsl:text>Steady</xsl:text></xsl:when>
        <xsl:when test=". = 2" ><xsl:text>Pulsing</xsl:text></xsl:when>
        <xsl:when test=". = 3" ><xsl:text>Temporal Code 3</xsl:text></xsl:when>
		<xsl:when test=". = 4" ><xsl:text>Temporal Code 4</xsl:text></xsl:when>
        <xsl:when test=". = 5" ><xsl:text>Wheelock</xsl:text></xsl:when>
        <xsl:when test=". = 6" ><xsl:text>Gentex</xsl:text></xsl:when>
        <xsl:when test=". = 7" ><xsl:text>System Sensor</xsl:text></xsl:when>
		<xsl:when test=". = 8" ><xsl:text>Power Supply Mode</xsl:text></xsl:when>
		<xsl:otherwise></xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template name="ID_PATTERN">
    <xsl:choose>
		<xsl:when test=". = 0"><xsl:text>Default</xsl:text></xsl:when>
		<xsl:when test=". = 1"><xsl:text>Steady</xsl:text></xsl:when>
		<xsl:when test=". = 2"><xsl:text>Pulsing</xsl:text></xsl:when>
		<xsl:when test=". = 3"><xsl:text>Temporal Code 3</xsl:text></xsl:when>
		<xsl:when test=". = 4"><xsl:text>Temporal Code 4</xsl:text></xsl:when>
		<xsl:when test=". = 5"><xsl:text>Wheelock</xsl:text></xsl:when>
		<xsl:when test=". = 6"><xsl:text>Gentex</xsl:text></xsl:when>
		<xsl:when test=". = 7"><xsl:text>System Sensor</xsl:text></xsl:when>
		<xsl:when test=". = 8"><xsl:text>Power Supply Mode</xsl:text></xsl:when>
		<xsl:otherwise></xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="RTI">
    <xsl:choose>
		<xsl:when test=". = 1"><xsl:text>Standard</xsl:text></xsl:when>
		<xsl:when test=". = 2"><xsl:text>Quick</xsl:text></xsl:when>
		<xsl:otherwise></xsl:otherwise>
    </xsl:choose>
</xsl:template>

</xsl:stylesheet>

