<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:template match="/FPA1000">
<html>
<body>
    <div id="DISPLAY_CONFFILE" style="font-family:'Times New Roman', Times, serif; font-size:12px;">
        <xsl:apply-templates select="HEADER" />
        <xsl:apply-templates select="GENERAL"></xsl:apply-templates>
		<table border="1" style="color:black; width:800px; left:50px;">
        <tr align="center" style="background:black; color:white; font-size:14px; font-weight:bold;" >
            <td colspan="9">SLC 1 Settings</td>
        </tr>
		</table>
        <xsl:apply-templates select="LOOP1"></xsl:apply-templates>
		<table border="1" style="color:black; width:800px; left:50px;">
        <tr align="center" style="background:black; color:white; font-size:14px; font-weight:bold;" >
            <td colspan="9">SLC 2 Settings</td>
        </tr>
		</table>
		<xsl:apply-templates select="LOOP2"></xsl:apply-templates>
        <xsl:apply-templates select="MAINBOARD"></xsl:apply-templates>
        <xsl:apply-templates select="OPTIONBUS"></xsl:apply-templates>
        <xsl:apply-templates select="REPORT"></xsl:apply-templates>
        <xsl:apply-templates select="ZONES"></xsl:apply-templates>
		<xsl:apply-templates select="NETWORK"></xsl:apply-templates>
    </div>
    </body>
</html>
</xsl:template>

<xsl:template name="LevelTP" match="HistoryLv/pre|HistoryLv/post|WalktestLv/pre|WalktestLv/post|TestLv/pre|TestLv/post|DateLv/pre|DateLv/post|BypassLv/pre|BypassLv/post">
	<xsl:choose>
		<xsl:when test=". = '1'"><xsl:text>Level 1</xsl:text></xsl:when>
		<xsl:when test=". = '2'"><xsl:text>Level 2</xsl:text></xsl:when>
		<xsl:when test=". = '3'"><xsl:text>Level 3</xsl:text></xsl:when>
		<xsl:otherwise></xsl:otherwise>
	</xsl:choose>
</xsl:template>

<xsl:template name="workWide" match="PrintWide/pre|PrintWide/post|CityTieWide/pre|CityTieWide/post|ReportWide/pre|ReportWide/post">
	<xsl:choose>
		<xsl:when test=". = '1'"><xsl:text>Panel wide</xsl:text></xsl:when>
		<xsl:when test=". = '2'"><xsl:text>Group wide</xsl:text></xsl:when>
		<xsl:when test=". = '3'"><xsl:text>Network wide</xsl:text></xsl:when>
		<xsl:otherwise></xsl:otherwise>
	</xsl:choose>
</xsl:template>

<xsl:template name="Bypass" match="B/pre|B/post">
	<xsl:choose>
		<xsl:when test=". = '0'"><xsl:text>FALSE</xsl:text></xsl:when>
		<xsl:when test=". = '1'"><xsl:text>TRUE</xsl:text></xsl:when>
	</xsl:choose>
</xsl:template>
<!-- start of Define Header Section -->
<xsl:template match="HEADER" >
<table border="1" style="color:black; width:800px; left:50px;" >
        <tr>
            <th colspan="4" style=" background:black; color:white; font-weight:bold; font-size:14px; text-align:center; " >Header Settings</th>
        </tr>
        <tr>
            <td colspan="4" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">Header</td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">File Name</td>
            <td style="font-size:12px; font-weight:bold;">Version Number</td>
            <td style="font-size:12px; font-weight:bold;">Last Modified Date</td>
            <td style="font-size:12px; font-weight:bold;">Data Version</td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:normal; color:blue;">
                <xsl:value-of select="Filename/pre" /></td>
            <td style="font-size:12px; font-weight:normal; color:blue;">
                <xsl:value-of select="RevNumber/pre" /></td>    
            <td style="font-size:12px; font-weight:normal; color:blue;">
                <xsl:value-of select="LastModified/pre" /></td>
            <td style="font-size:12px; font-weight:normal; color:blue;">
                <xsl:value-of select="DataVersion/pre" /></td>
        </tr>
		<tr style="background-color:yellow;">
            <td style="font-size:12px; font-weight:normal; color:red;">
                <xsl:value-of select="Filename/post" /></td>
            <td style="font-size:12px; font-weight:normal; color:red;">
                <xsl:value-of select="RevNumber/post" /></td>    
            <td style="font-size:12px; font-weight:normal; color:red;">
                <xsl:value-of select="LastModified/post" /></td>
            <td style="font-size:12px; font-weight:normal; color:red;">
                <xsl:value-of select="DataVersion/post" /></td>
        </tr>
    </table>
</xsl:template>

<xsl:template match="GENERAL">
    <table border="1" style="color:black; width:800px; left:50px;">
        <tr>
            <th colspan="10" style="background:black; color:white; font-weight:bold; font-size:14px; text-align:center; ">General Settings</th>
        </tr>
            <tr>
                <td colspan="10" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">Basic Settings</td>
            </tr>
            <tr>
                <td style="font-size:12px; font-weight:bold;"><xsl:text>Banner</xsl:text> (1. <xsl:text>line</xsl:text>)</td>
                <td style="font-size:12px; font-weight:bold;"><xsl:text>Banner</xsl:text> (2. <xsl:text>line</xsl:text>)</td>
                <td style="font-size:12px; font-weight:bold;">Language</td>
				<td style="font-size:12px; font-weight:bold;">Panel ID</td>
                <td style="font-size:12px; font-weight:bold;">Panel IP Address</td>
                <td style="font-size:12px; font-weight:bold;">Gateway</td>
                <td style="font-size:12px; font-weight:bold;">Netmask</td>
				<td style="font-size:12px; font-weight:bold;">Fire Network ID</td>
            </tr>
            <tr>
                <td style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:value-of select="Banner1st/pre" /></td>
                <td style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:value-of select="Banner2nd/pre" /></td>
                <td style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:apply-templates select="Language/pre" /></td>
				<td style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:value-of select="PanelID/pre" /></td>
                <td style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:value-of select="PanelIP/pre" /></td>
                <td style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:value-of select="Gateway/pre" /></td>
                <td style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:value-of select="Netmask/pre" /></td>
				<td style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:value-of select="NetworkID/pre" /></td>
               
                
            </tr>
			<tr style="background-color:yellow;">
                <td style="font-size:12px; font-weight:normal; color:red;" >
                    <xsl:value-of select="Banner1st/post" /></td>
                <td style="font-size:12px; font-weight:normal; color:red;" >
                    <xsl:value-of select="Banner2nd/post" /></td>
                <td style="font-size:12px; font-weight:normal; color:red;" >
                    <xsl:apply-templates select="Language/post" /></td>
				<td style="font-size:12px; font-weight:normal; color:red;" >
                    <xsl:value-of select="PanelID/post" /></td>
                <td style="font-size:12px; font-weight:normal; color:red;" >
                    <xsl:value-of select="PanelIP/post" /></td>
                <td style="font-size:12px; font-weight:normal; color:red;" >
                    <xsl:value-of select="Gateway/post" /></td>
                <td style="font-size:12px; font-weight:normal; color:red;" >
                    <xsl:value-of select="Netmask/post" /></td>
				<td style="font-size:12px; font-weight:normal; color:red;" >
                    <xsl:value-of select="NetworkID/post" /></td>
               
            </tr>
			<tr>
                <td style="font-size:12px; font-weight:bold;">Printer IP Address</td>  
				<td style="font-size:12px; font-weight:bold;">Printer FTP User</td>
				<td style="font-size:12px; font-weight:bold;">Printer FTP Password</td>
				<td style="font-size:12px; font-weight:bold;">Printer FTP Port</td>
                <td colspan="4" style="font-size:12px; font-weight:bold;"><xsl:text>Print events/operations from</xsl:text>: </td>
            </tr>
			<tr>
				<td style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:value-of select="PrinterIP/pre" /></td>
				<td style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:value-of select="FTPuser/pre" /></td>
			    <td style="font-size:12px; font-weight:normal; color:blue;" >
               		<xsl:value-of select="FTPpwd/pre" /></td>
                <td style="font-size:12px; font-weight:normal; color:blue;" >
                	<xsl:value-of select="FTPport/pre" /></td>
				
                <td colspan="4" style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:apply-templates select="PrintWide/pre"></xsl:apply-templates></td>
			</tr>
			<tr style="background-color:yellow;">
				<td style="font-size:12px; font-weight:normal; color:red;" >
                    <xsl:value-of select="PrinterIP/post" /></td>
				<td style="font-size:12px; font-weight:normal; color:red;" >
                    <xsl:value-of select="FTPuser/post" /></td>
			    <td style="font-size:12px; font-weight:normal; color:red;" >
               		<xsl:value-of select="FTPpwd/post" /></td>
                <td style="font-size:12px; font-weight:normal; color:red;" >
                	<xsl:value-of select="FTPport/post" /></td>
                <td colspan="4" style="font-size:12px; font-weight:normal; color:red;" >
                    <xsl:apply-templates select="PrintWide/post"></xsl:apply-templates></td>
			</tr>
        </table>
        
        <table border="1" style="color:black; width:800px; left:50px;">
            <tr>
                <td colspan="9" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;" >System Settings, Time Format, Units and Silence</td>
        </tr>
        <tr>
                <td style="font-size:12px; font-weight:bold;">Sandwich Enabled</td>
                <td style="font-size:12px; font-weight:bold;">Aux Power Reset</td>
                <td style="font-size:12px; font-weight:bold;">Supervisory Latching</td>
                <td style="font-size:12px; font-weight:bold;">External Power Supply</td>
                <td style="font-size:12px; font-weight:bold;">Time Format</td>
                <td style="font-size:12px; font-weight:bold;">Unit Format</td>
                <td style="font-size:12px; font-weight:bold;">Silence</td>
                <td style="font-size:12px; font-weight:bold;">Enable Silence</td>
                <td style="font-size:12px; font-weight:bold;">Enable Drill</td>
        </tr>
        <tr>
                <td style="font-size:12px; font-weight:normal; color:blue;">
                    <xsl:value-of select="EnableSandwich/pre" /></td>
                <td style="font-size:12px; font-weight:normal; color:blue;">
                    <xsl:value-of select="AuxPowerReset/pre" /></td>
                <td style="font-size:12px; font-weight:normal; color:blue;">
                    <xsl:value-of select="SupLatching/pre" /></td>
                <td style="font-size:12px; font-weight:normal; color:blue;">
                    <xsl:value-of select="ExtPower/pre" /></td>    
                <td style="font-size:12px; font-weight:normal; color:blue;">
                    <xsl:apply-templates select="TimeFormat/pre" /></td>
                <td style="font-size:12px; font-weight:normal; color:blue;">
                    <xsl:apply-templates select="UnitFormat/pre" /></td>
                <td style="font-size:12px; font-weight:normal; color:blue;">
                    <xsl:apply-templates select="Silence/pre" /></td>
                <td style="font-size:12px; font-weight:normal; color:blue;">
                    <xsl:value-of select="EnableSilence/pre" /></td>
                <td style="font-size:12px; font-weight:normal; color:blue;">
                    <xsl:value-of select="EnableDrill/pre" /></td>
        </tr>
		<tr style="background-color:yellow;">
                <td style="font-size:12px; font-weight:normal; color:red;">
                    <xsl:value-of select="EnableSandwich/post" /></td>
                <td style="font-size:12px; font-weight:normal; color:red;">
                    <xsl:value-of select="AuxPowerReset/post" /></td>
                <td style="font-size:12px; font-weight:normal; color:red;">
                    <xsl:value-of select="SupLatching/post" /></td>
                <td style="font-size:12px; font-weight:normal; color:red;">
                    <xsl:value-of select="ExtPower/post" /></td>    
                <td style="font-size:12px; font-weight:normal; color:red;">
                    <xsl:apply-templates select="TimeFormat/post" /></td>
                <td style="font-size:12px; font-weight:normal; color:red;">
                    <xsl:apply-templates select="UnitFormat/post" /></td>
                <td style="font-size:12px; font-weight:normal; color:red;">
                    <xsl:apply-templates select="Silence/post" /></td>
                <td style="font-size:12px; font-weight:normal; color:red;">
                    <xsl:value-of select="EnableSilence/post" /></td>
                <td style="font-size:12px; font-weight:normal; color:red;">
                    <xsl:value-of select="EnableDrill/post" /></td>
        </tr>
        </table>
        
        <table border="1" style="color:black; width:800px; left:50px;">
            <tr>
                <td colspan="6" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">Level Needed for Operation</td>
            </tr>
            <tr>
			    <td style="font-size:12px; font-weight:bold;">PIN for reset/silence/drill</td>
                <td style="font-size:12px; font-weight:bold;">History </td>
                <td style="font-size:12px; font-weight:bold;">Walktest  </td>
                <td style="font-size:12px; font-weight:bold;">Test </td>
                <td style="font-size:12px; font-weight:bold;">Date </td>
                <td style="font-size:12px; font-weight:bold;">Bypass </td>
            </tr>
            <tr style="font-size:12px; font-weight:normal; color:blue;">
				<td><xsl:value-of select="Pin4rsd/pre" /></td>
                <td><xsl:apply-templates select="HistoryLv/pre"></xsl:apply-templates></td>
                <td><xsl:apply-templates select="WalktestLv/pre"></xsl:apply-templates></td>
                <td><xsl:apply-templates select="TestLv/pre"></xsl:apply-templates></td>
                <td><xsl:apply-templates select="DateLv/pre"></xsl:apply-templates></td>
                <td><xsl:apply-templates select="BypassLv/pre"></xsl:apply-templates></td>
            </tr>
			<tr style=" background-color:yellow; font-size:12px; font-weight:normal; color:red;">
				<td><xsl:value-of select="Pin4rsd/post" /></td>
                <td><xsl:apply-templates select="HistoryLv/post"></xsl:apply-templates></td>
                <td><xsl:apply-templates select="WalktestLv/post"></xsl:apply-templates></td>
                <td><xsl:apply-templates select="TestLv/post"></xsl:apply-templates></td>
                <td><xsl:apply-templates select="DateLv/post"></xsl:apply-templates></td>
                <td><xsl:apply-templates select="BypassLv/post"></xsl:apply-templates></td>
            </tr>
        </table>

        <table border="1" style="color:black; width:800px; left:50px;">
            <tr>
                <td colspan="3" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">Time Scheduled</td>
            </tr>
            <tr>
                <td style="font-size:12px; font-weight:bold;">Daylight Enabled</td>
                <td style="font-size:12px; font-weight:normal; color:blue;">
                    <xsl:value-of select="DayLightSaving/pre" /></td>
				<td style=" background-color:yellow; font-size:12px; font-weight:normal; color:red;">
                    <xsl:value-of select="DayLightSaving/post" /></td>
            </tr>
            <tr>
                <td style="font-size:12px; font-weight:bold;">Daylight Time</td>
                <td style="font-size:12px; font-weight:normal;">
					<table width="100%" align="left">
					<tr>
					<td style="font-size:12px; font-weight:normal;">Start from </td>
					<td style="font-size:12px; font-weight:normal; color:blue;">
						<xsl:for-each select="StartWeek/pre">
					         <xsl:call-template name="Week"></xsl:call-template>
						</xsl:for-each>
					</td>
					<td style="font-size:12px; font-weight:normal;"> week of </td>
					<td style="font-size:12px; font-weight:normal; color:blue;">
						<xsl:for-each select="StartMonth/pre">
					         <xsl:call-template name="Month"></xsl:call-template>
						</xsl:for-each><br/>
					</td>
					</tr>
					<tr>
					<td style="font-size:12px; font-weight:normal;">End of </td>
					<td style="font-size:12px; font-weight:normal; color:blue;">
						<xsl:for-each select="EndWeek/pre">
					        <xsl:call-template name="Week"></xsl:call-template>
						</xsl:for-each>
					</td>
					<td style="font-size:12px; font-weight:normal;"> week of </td>
					<td style="font-size:12px; font-weight:normal; color:blue;">
						<xsl:for-each select="EndMonth/pre">
					         <xsl:call-template name="Month"></xsl:call-template>
						</xsl:for-each><br/>
					</td>
					</tr>
					</table>
                </td>
				<td style=" background-color:yellow; font-size:12px; font-weight:normal; color:black;">
                    <table width="100%" align="left">
					<tr>
					<td style="font-size:12px; font-weight:normal;">Start from </td>
					<td style="font-size:12px; font-weight:normal; color:red;">
						<xsl:for-each select="StartWeek/post">
					         <xsl:call-template name="Week"></xsl:call-template>
						</xsl:for-each>
					</td>
					<td align="left" style="font-size:12px; font-weight:normal;"> week of </td>
					<td style="font-size:12px; font-weight:normal; color:red;">
						<xsl:for-each select="StartMonth/post">
					         <xsl:call-template name="Month"></xsl:call-template>
						</xsl:for-each><br/>
					</td>
					</tr>
					<tr>
					<td style="font-size:12px; font-weight:normal;">End of </td>
					<td style="font-size:12px; font-weight:normal; color:red;">
						<xsl:for-each select="EndWeek/post">
					        <xsl:call-template name="Week"></xsl:call-template>
						</xsl:for-each>
					</td>
					<td align="left" style="font-size:12px; font-weight:normal;"> week of </td>
					<td style="font-size:12px; font-weight:normal; color:red;">
						<xsl:for-each select="EndMonth/post">
					         <xsl:call-template name="Month"></xsl:call-template>
						</xsl:for-each><br/>
					</td>
					</tr>
					</table>
                </td>
            </tr>
            <tr>
                <td width="20%" style="font-size:12px; font-weight:bold;">Detector Day Sensitivity</td>
                <td width="40%" style="font-size:12px; font-weight:normal; color:black;">
					<table width="100%" align="left">
					<tr>
						<td style="font-size:12px; font-weight:bold; text-align:right;"> Su:</td>
						<td style="font-size:12px; font-weight:normal; color:blue;  text-align:left;">
							<xsl:value-of select="AutoDMSu/pre" /></td>
						<td style="font-size:12px; font-weight:bold; text-align:right;"> Mo:</td> 
						<td style="font-size:12px; font-weight:normal; color:blue;  text-align:left;">
							<xsl:value-of select="AutoDMMo/pre" /></td>
						<td style="font-size:12px; font-weight:bold; text-align:right;"> Tu:</td>
						<td style="font-size:12px; font-weight:normal; color:blue;  text-align:left;">
							<xsl:value-of select="AutoDMTu/pre" /></td>
						<td style="font-size:12px; font-weight:bold;  text-align:right;"> We:</td>
						<td style="font-size:12px; font-weight:normal; color:blue;  text-align:left;">
							<xsl:value-of select="AutoDMWe/pre" /></td>
					</tr>
					<tr>
						<td style="font-size:12px; font-weight:bold;  text-align:right;"> Th:</td>
						<td style="font-size:12px; font-weight:normal; color:blue;  text-align:left;">
							<xsl:value-of select="AutoDMTh/pre" /></td>
						<td style="font-size:12px; font-weight:bold;  text-align:right;"> Fr:</td>
						<td style="font-size:12px; font-weight:normal; color:blue;  text-align:left;">
							<xsl:value-of select="AutoDMFr/pre" /></td>
						<td style="font-size:12px; font-weight:bold;  text-align:right;"> Sa:</td>
						<td style="font-size:12px; font-weight:normal; color:blue;  text-align:left;">
							<xsl:value-of select="AutoDMSa/pre" /></td>
						<td style="font-size:12px; font-weight:bold;  text-align:right;"></td>
						<td style="font-size:12px; font-weight:normal; color:blue;  text-align:left;"></td>
					</tr>
					<tr>
						<td colspan="2" style="font-size:12px; font-weight:bold; color:black; text-align:right; ">
                        Start time: </td>
                        <td colspan="1" style="font-size:12px; font-weight:normal; text-align:left; color:blue;">
                        <xsl:value-of select="DMStartHour/pre" />:<xsl:value-of select="DMStartMin/pre" />
                        <xsl:apply-templates select="DMStartPM/pre" />
						</td>
					    <td colspan="2" style="font-size:12px; font-weight:bold; color:black; text-align:right; ">
                        End time: </td>
                        <td colspan="2" style="font-size:12px; font-weight:normal; text-align:left; color:blue;">
                        <xsl:value-of select="DMEndHour/pre" />:<xsl:value-of select="DMEndMin/pre" />
						<xsl:apply-templates select="DMStartPM/pre" />
                        </td>             
					</tr>
					</table>
            </td>
			<td width="40%" style=" background-color:yellow; font-size:12px; font-weight:normal; color:black;">
					<table width="100%" align="left">
					<tr>
						<td style="font-size:12px; font-weight:bold; text-align:right;"> Su:</td>
						<td style="font-size:12px; font-weight:normal; color:red;  text-align:left;">
							<xsl:value-of select="AutoDMSu/post" /></td>
						<td style="font-size:12px; font-weight:bold; text-align:right;"> Mo:</td> 
						<td style="font-size:12px; font-weight:normal; color:red;  text-align:left;">
							<xsl:value-of select="AutoDMMo/post" /></td>
						<td style="font-size:12px; font-weight:bold; text-align:right;"> Tu:</td>
						<td style="font-size:12px; font-weight:normal; color:red;  text-align:left;">
							<xsl:value-of select="AutoDMTu/post" /></td>
						<td style="font-size:12px; font-weight:bold;  text-align:right;"> We:</td>
						<td style="font-size:12px; font-weight:normal; color:red;  text-align:left;">
							<xsl:value-of select="AutoDMWe/post" /></td>
					</tr>
					<tr>
						<td style="font-size:12px; font-weight:bold;  text-align:right;"> Th:</td>
						<td style="font-size:12px; font-weight:normal; color:red;  text-align:left;">
							<xsl:value-of select="AutoDMTh/post" /></td>
						<td style="font-size:12px; font-weight:bold;  text-align:right;"> Fr:</td>
						<td style="font-size:12px; font-weight:normal; color:red;  text-align:left;">
							<xsl:value-of select="AutoDMFr/post" /></td>
						<td style="font-size:12px; font-weight:bold;  text-align:right;"> Sa:</td>
						<td style="font-size:12px; font-weight:normal; color:red;  text-align:left;">
							<xsl:value-of select="AutoDMSa/post" /></td>
						<td style="font-size:12px; font-weight:bold;  text-align:right;"></td>
						<td style="font-size:12px; font-weight:normal; color:blue;  text-align:left;"></td>
					</tr>
					<tr>
						<td colspan="2" style="font-size:12px; font-weight:bold; color:black; text-align:right; ">
                        Start time: </td>
                        <td colspan="2" style="font-size:12px; font-weight:normal; text-align:left; color:red;">
                        <xsl:value-of select="DMStartHour/post" />:<xsl:value-of select="DMStartMin/post" />
                        <xsl:apply-templates select="DMStartPM/post" /></td>
					    <td colspan="2" style="font-size:12px; font-weight:bold; color:black; text-align:right; ">
                        End time: </td>
                        <td colspan="2" style="font-size:12px; font-weight:normal; text-align:left; color:red;">
                        <xsl:value-of select="DMEndHour/post" />:<xsl:value-of select="DMEndMin/post" />
                        <xsl:apply-templates select="DMStartPM/post" /></td> 
					</tr>
					</table>
            </td>
        </tr>
        </table>

        <table border="1" style="color:black; width:800px; left:50px;">
            <tr>
                <td colspan="3" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">Timer Settings</td>
            </tr>
            <tr>
                <td style="font-size:12px; font-weight:bold;" width="20%">Day Mode</td>    
                <td style="font-size:12px; font-weight:normal; color:blue;" width="40%">
                    <xsl:apply-templates select="GlobalDelayMode/pre" /></td>
				<td style="background-color:yellow; font-size:12px; font-weight:normal; color:red;" width="40%">
                    <xsl:apply-templates select="GlobalDelayMode/post" /></td>
            </tr>
			<tr>
                <td style="font-size:12px; font-weight:bold;" width="20%">Global Delay Mode</td>    
                <td style="font-size:12px; font-weight:normal; color:blue;" width="40%">
                    <xsl:apply-templates select="DelayModeOption/pre" /></td>
				<td style="background-color:yellow; font-size:12px; font-weight:normal; color:red;" width="40%">
                    <xsl:apply-templates select="DelayModeOption/post" /></td>	
            </tr>
            <tr>
                <td style="font-size:12px; font-weight:bold;" width="20%">Investigation Time</td>
                <td style="font-size:12px; font-weight:normal; color:blue;">
                    <xsl:value-of select="GlobalDelayTime/pre" /> <font color="black"> s</font></td>
				<td style=" background-color:yellow; font-size:12px; font-weight:normal; color:red;">
                    <xsl:value-of select="GlobalDelayTime/post" /><font color="black"> s</font></td>
            </tr>
            <tr>
                <td style="font-size:12px; font-weight:bold;" width="20%">Alarm Verification Delay</td>
                <td style="font-size:12px; font-weight:normal; color:blue;">
                    <xsl:value-of select="AVDelay/pre" /><font color="black"> s</font></td>
				<td style=" background-color:yellow; font-size:12px; font-weight:normal; color:red;">
                    <xsl:value-of select="AVDelay/post" /><font color="black"> s</font></td>
            </tr>
            <tr>
                <td style="font-size:12px; font-weight:bold;" width="20%">AC Failure Delay</td>
                <td style="font-size:12px; font-weight:normal; color:blue;">
                    <xsl:value-of select="ACDelay/pre" /><font color="black"> h</font></td>
				<td style=" background-color:yellow; font-size:12px; font-weight:normal; color:red;">
                    <xsl:value-of select="ACDelay/post" /><font color="black"> h</font></td>
            </tr>
			<tr>
				<td style="font-size:12px; font-weight:bold;" width="20%">Waterflow Silenceable</td>
				<td style="font-size:12px; font-weight:normal; color:blue;"><xsl:value-of select="WFSilenceable/pre" /></td>
				<td style=" background-color:yellow; font-size:12px; font-weight:normal; color:red;"><xsl:value-of select="WFSilenceable/post" /></td>
			</tr>
            <tr>
                <td style="font-size:12px; font-weight:bold;" width="20%">Waterflow Delay</td>
                <td style="font-size:12px; font-weight:normal; color:blue;"><xsl:value-of select="WFDelay/pre" /><font color="black"> s</font></td>
				<td style=" background-color:yellow; font-size:12px; font-weight:normal; color:red;"><xsl:value-of select="WFDelay/post" /><font color="black"> s</font></td>
            </tr>
            <tr>
                <td style="font-size:12px; font-weight:bold;" width="20%">Auto Silence Delay</td>
                <td style="font-size:12px; font-weight:normal; color:black;">
                    <xsl:text>Enabled</xsl:text>: <font color="blue"><xsl:value-of select="ASDEnable/pre" /></font><br/>
                    <xsl:text>Delay Time</xsl:text>: <font color="blue"><xsl:value-of select="ASDelay/pre" /></font> min</td>
				<td style=" background-color:yellow; font-size:12px; font-weight:normal; color:black;">
                    <xsl:text>Enabled</xsl:text>: <font color="red"><xsl:value-of select="ASDEnable/post" /></font><br/>
                    <xsl:text>Delay Time</xsl:text>: <font color="red"><xsl:value-of select="ASDelay/post" /></font> min</td>
            </tr>
            <tr>
                <td style="font-size:12px; font-weight:bold;" width="20%">Silence Inhibit</td>
                <td style="font-size:12px; font-weight:normal; color:blue;">
                    <xsl:value-of select="SilenceInhibit/pre" /><font color="black"> min</font></td>
				<td style=" background-color:yellow; font-size:12px; font-weight:normal; color:red;">
                    <xsl:value-of select="SilenceInhibit/post" /><font color="black"> min</font></td>
            </tr>
            <tr>
                <td style="font-size:12px; font-weight:bold;" width="20%">Dual-zone first alarm reset</td>
                <td style="font-size:12px; font-weight:normal; color:black;">
                    <xsl:text>Enabled</xsl:text>: <font color="blue"><xsl:value-of select="DualZoneLatching/pre" /></font><br/>
                    <xsl:text>Delay Time</xsl:text>: <font color="blue"><xsl:value-of select="DZFirstAlarm/pre" /></font> s</td>
				<td style="font-size:12px; font-weight:normal; color:black; background-color:yellow;">
                    <xsl:text>Enabled</xsl:text>: <font color="red"><xsl:value-of select="DualZoneLatching/post" /></font><br/>
                    <xsl:text>Delay Time</xsl:text>: <font color="red"><xsl:value-of select="DZFirstAlarm/post" /></font> s</td>
            </tr>
            <tr>
                <td style="font-size:12px; font-weight:bold;" width="20%">Sandwich Delay</td>
                <td style="font-size:12px; font-weight:normal; color:black;">
					<xsl:text>Enabled</xsl:text>: <font color="blue"><xsl:value-of select="EnableSandwich/pre" /></font><br/>
                    <xsl:text>Delay Time</xsl:text>: <font color="blue"><xsl:value-of select="SandwichDelay/pre" /></font> min</td>
				<td style=" background-color:yellow; font-size:12px; font-weight:normal; color:black;">
					<xsl:text>Enabled</xsl:text>: <font color="red"><xsl:value-of select="EnableSandwich/post" /></font><br/>
                    <xsl:text>Delay Time</xsl:text>: <font color="red"><xsl:value-of select="SandwichDelay/post" /></font> min</td>
            </tr>
            <tr>
                <td style="font-size:12px; font-weight:bold;" width="20%">Sequential Reset Delay</td>
                <td style="font-size:12px; font-weight:normal; color:blue;">
                    <xsl:value-of select="StaggeredDelay/pre" /><font color="black"> s</font></td>
				<td style=" background-color:yellow; font-size:12px; font-weight:normal; color:red;">
                    <xsl:value-of select="StaggeredDelay/post" /><font color="black"> s</font></td>
            </tr>
			<tr>
                <td style="font-size:12px; font-weight:bold;" width="20%">Time Synchronization</td>
                <td style="font-size:12px; font-weight:normal; color:black;">
					<xsl:text>Enabled</xsl:text>: <font color="blue"><xsl:value-of select="TimeSyncEnable/pre" /></font><br/>
                    <xsl:text>NTP Server IP</xsl:text>: <font color="blue"><xsl:value-of select="NTPIP/pre" /></font><br/>
					<xsl:text>NTP Server Port</xsl:text>: <font color="blue"><xsl:value-of select="NTPPort/pre" /></font></td>
				<td style="font-size:12px; font-weight:normal; color:black; background-color:yellow;">
					<xsl:text>Enabled</xsl:text>: <font color="red"><xsl:value-of select="TimeSyncEnable/post" /></font><br/>
                    <xsl:text>NTP Server IP</xsl:text>: <font color="red"><xsl:value-of select="NTPIP/post" /></font><br/>
					<xsl:text>NTP Server Port</xsl:text>: <font color="red"><xsl:value-of select="NTPPort/post" /></font></td>
            </tr>
        </table>
</xsl:template>

<xsl:template match="Silence/pre|Silence/post">
    <xsl:choose>
        <xsl:when test=". = 0"><xsl:text>Audible Only</xsl:text></xsl:when>
        <xsl:when test=". = 1"><xsl:text>Audible And Visible</xsl:text></xsl:when>
        <xsl:otherwise><xsl:text>Invalid Silence</xsl:text></xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="UnitFormat/pre|UnitFormat/post">
    <xsl:choose>
        <xsl:when test=". = 0"><xsl:text>F</xsl:text>, <xsl:text>ft</xsl:text></xsl:when>
        <xsl:when test=". = 1"><xsl:text>C</xsl:text>, <xsl:text>m</xsl:text></xsl:when>
        <xsl:otherwise><xsl:text>Invalid Unit Format</xsl:text></xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="GlobalDelayMode/pre|GlobalDelayMode/post">
    <xsl:choose>
        <xsl:when test=".=0"><xsl:text>No delay</xsl:text></xsl:when>
        <xsl:when test=".=1"><xsl:text>PAS</xsl:text></xsl:when>
        <xsl:when test=".=2"><xsl:text>Presignal</xsl:text></xsl:when>
        <xsl:otherwise><xsl:text>Invalid Global Delay Mode</xsl:text></xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="Language/pre|Language/post" >
    <xsl:choose>
        <xsl:when test=". = 0"><xsl:text>English</xsl:text></xsl:when>
        <xsl:when test=". = 1"><xsl:text>Spanish</xsl:text></xsl:when>
        <xsl:when test=". = 2"><xsl:text>Portugues</xsl:text></xsl:when>
    </xsl:choose>
</xsl:template>

<xsl:template match="DMStartPM/pre|DMStartPM/post|AutoTestPM/pre|AutoTestPM/post">
 	<xsl:choose> 
        <xsl:when test=". = 'FALSE'"><xsl:text> AM</xsl:text></xsl:when>
        <xsl:when test=". = 'TRUE'"><xsl:text> PM</xsl:text></xsl:when>
    </xsl:choose>
</xsl:template>

<xsl:template name="Glob_Zone" >
 	<tr style="font-size:12px; font-weight:normal;">
		<td width="30%" style="color:blue;"><xsl:value-of select="Label/pre" /></td>
		<td width="30%" style="color:red; background-color:yellow"><xsl:value-of select="Label/post" /></td>
		<td width="20%" style="color:blue;" ><xsl:for-each select="Pattern/pre">
			<xsl:call-template name="ID_PATTERN" />
			</xsl:for-each></td>
		<td width="20%" style="color:red; background-color:yellow" ><xsl:for-each select="Pattern/post">
			<xsl:call-template name="ID_PATTERN" />
			</xsl:for-each></td>
    </tr>
</xsl:template>

<xsl:template match="ZONES">
    <table border="1" style="color:black; width:800px; left:50px;">
        <tr>
            <th colspan="4" style="background:black; color:white; font-weight:bold; font-size:14px; text-align:center; ">ZONES</th>
        </tr>
        <tr>
            <td colspan="4" style="background:#CCCCCC; font-size:12px; font-weight:bold;">Global Zones</td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;" width="60%" colspan="2" align="center">Zone Label</td>
            <td style="font-size:12px; font-weight:bold;" width="40%" colspan="2" align="center">Pattern</td>
        </tr>
        <xsl:for-each select="Zone226">
            <xsl:call-template name="Glob_Zone" />
        </xsl:for-each>
        
        <xsl:for-each select="Zone227">
        	<xsl:call-template name="Glob_Zone" />
        </xsl:for-each>

        <xsl:for-each select="Zone228">
           <xsl:call-template name="Glob_Zone" />
        </xsl:for-each>

        <xsl:for-each select="Zone229">
        	<xsl:call-template name="Glob_Zone" />
        </xsl:for-each>
        
        <xsl:for-each select="Zone230">
        	<xsl:call-template name="Glob_Zone" />
        </xsl:for-each>

        <xsl:for-each select="Zone231">
			<xsl:call-template name="Glob_Zone" />
        </xsl:for-each>

        <xsl:for-each select="Zone232">
        	<xsl:call-template name="Glob_Zone" />
        </xsl:for-each>

        <xsl:for-each select="Zone233">
        	<xsl:call-template name="Glob_Zone" />
        </xsl:for-each>
		
		<xsl:for-each select="Zone234">
        	<xsl:call-template name="Glob_Zone" />
        </xsl:for-each>
    </table>
	
    <!-- Group Zones -->
	<table border="1" style="color:black; font-size:12px; width:800px; left:50px;word-break: break-all;word-wrap:break-word;table-layout:fixed;">
		<tr>        
			<th colspan="6" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">Zones (129~225)</th>
		</tr>
		<tr>
			<td style="font-size:12px; font-weight:bold;">Zone No.</td>
			<td style="font-size:12px; font-weight:bold;">Zone Label</td>
			<td style="font-size:12px; font-weight:bold;">Pattern</td>
			<td style="font-size:12px; font-weight:bold;">Counting</td>
			<td style="font-size:12px; font-weight:bold;">Floor</td>
			<td style="font-size:12px; font-weight:bold;">Bypassed</td>
		</tr>
		<xsl:for-each select="GroupWideZones">
			<xsl:apply-templates select="."/>
		</xsl:for-each>
    </table>
	
	<!-- Local Zones -->
	<table border="1" style="color:black; width:800px; left:50px;">
    <tr>        
        <th colspan="6" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">Zones (1~128)</th>
    </tr>
	 <xsl:for-each select="PanelWideZones">
    	<xsl:apply-templates select="."/>
	</xsl:for-each>
	</table>

	<!-- Dual-zones -->
    <table border="1" style="color:black; width:800px; left:50px;">
    <tr>        
        <th colspan="13" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">Dual-zone (18 pairs)</th>
    </tr>
 
    <xsl:for-each select="DualZones">
        <xsl:apply-templates select="." />
    </xsl:for-each>
    </table>
    
     <!-- Floors -->
    <table border="1" style="color:black; width:800px; left:50px;">
		<tr>        
			<th colspan="6" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">Floors (64 floors)</th>
		</tr>
		
		<xsl:for-each select="Floors">
			<xsl:apply-templates select="."></xsl:apply-templates>
		</xsl:for-each>
    </table>
</xsl:template>

<xsl:template match="NETWORK">
	<table border="1" style="color:black; width:800px; left:50px;">
    	<tr>
            <th colspan="10" style="background:black; color:white; font-weight:bold; font-size:14px; text-align:center; ">Networking</th>
        </tr>
		<tr>
        	<td colspan="10" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">Basic Settings</td>
        </tr>
		<tr>
        	<td style="font-size:12px; font-weight:bold;">Networking card installed</td>
			<td style="font-size:12px; font-weight:bold;">Ethernet IN,Ethernet IN,Wired IN</td>
			<td style="font-size:12px; font-weight:bold;">Ethernet OUT,Fiber IN,Wired OUT</td>
			<td style="font-size:12px; font-weight:bold;">Ethernet,Fiber OUT,Ethernet IN</td>
            <td style="font-size:12px; font-weight:bold;">Topology</td>
		</tr>
        <tr>
            <td style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:value-of select="SWBInstall/pre" /></td>
            <td style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:value-of select="Supervise1/pre" /></td>
            <td style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:value-of select="Supervise2/pre" /></td>
            <td style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:value-of select="Supervise3/pre" /></td>
            <td style="font-size:12px; font-weight:normal; color:blue;" >
					<xsl:for-each select="Topology/pre">
                    	<xsl:call-template name="Net_Topology"></xsl:call-template>
					</xsl:for-each>
			</td>	
        </tr>
		 <tr style="background-color:yellow;">
            <td style="font-size:12px; font-weight:normal; color:red;" >
                    <xsl:value-of select="SWBInstall/post" /></td>
            <td style="font-size:12px; font-weight:normal; color:red;" >
                    <xsl:value-of select="Supervise1/post" /></td>
            <td style="font-size:12px; font-weight:normal; color:red;" >
                    <xsl:value-of select="Supervise2/post" /></td>
            <td style="font-size:12px; font-weight:normal; color:red;" >
                    <xsl:value-of select="Supervise3/post" /></td>
            <td style="font-size:12px; font-weight:normal; color:red;" >
					<xsl:for-each select="Topology/post">
                    	<xsl:call-template name="Net_Topology"></xsl:call-template>
					</xsl:for-each>
			</td>	
        </tr>
	</table>
	<xsl:apply-templates select="NetNode"></xsl:apply-templates>
</xsl:template>

<!--
<xsl:template match="ExternPort/pre | ExternPort/post">
	<xsl:choose>
        <xsl:when test=". = 0">None</xsl:when>
		<xsl:when test=". = 1">Port A</xsl:when>
		<xsl:when test=". = 2">Port B</xsl:when>
		<xsl:when test=". = 3">Port C</xsl:when>
    </xsl:choose>
</xsl:template>
-->

<xsl:template name="NetNode" match="NetNode">
   <table border="1" style="color:black; width:800px; left:50px;">
		<tr>
        	<td colspan="3" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">Panel List</td>
        </tr>
		<tr>
		    <td></td>
            <td style="font-size:12px; font-weight:bold;" >Panel ID</td>
            <td style="font-size:12px; font-weight:bold; display:none;" >Group ID</td>
        </tr>
	        <xsl:for-each select="Modified">
			<tr>
	    		<td  rowspan="2" style="font-weight:bold; width:100px; font-size:12px; color:orange;">Modified</td>
				<xsl:for-each select="./pre/Panel">
							<td style="color:black; width:350px; left:50px;">
							<xsl:value-of select="ID"></xsl:value-of>
							</td>
							</xsl:for-each>
				<xsl:for-each select="./pre/Panel">
							<td style="color:black; width:350px; left:50px; display:none;">
						    <xsl:value-of select="GID"></xsl:value-of>
							</td>
							</xsl:for-each>
			</tr>
			<tr > 
							<xsl:for-each select="./post/Panel">
							<td style="background-color:yellow;color:black; width:350px; left:50px;">
							<xsl:value-of select="ID"></xsl:value-of>
							</td>
							</xsl:for-each>
				<xsl:for-each select="./post/Panel">
							<td style="background-color:yellow;color:black; width:350px; left:50px; display:none;">
						    <xsl:value-of select="GID"></xsl:value-of>
							</td>
							</xsl:for-each>
			</tr>
			</xsl:for-each>
			<xsl:for-each select="Removed">
			<tr>
				<td style="font-weight:bold; width:100px; font-size:12px; color:red;">Removed</td>
			   <xsl:for-each select="./pre/Panel"> 
				<td  style="width:350px; left:50px;font-size:12px; color:red;" >
				<xsl:value-of select="ID"></xsl:value-of>
				</td>
				</xsl:for-each> 
			   <xsl:for-each select="./pre/Panel"> 
				<td  style="width:350px; left:50px;font-size:12px; color:red; display:none;" >
				<xsl:value-of select="GID"></xsl:value-of>
				</td>
				</xsl:for-each> 
			</tr>
			</xsl:for-each>		
			<xsl:for-each select="New"> 
			<tr>
			<td style="font-weight:bold; width:100px; font-size:12px; color:green;">New</td>
			<xsl:for-each select="./post/Panel">  
			<td  style="background-color:yellow; color:green; width:350px; font-size:12px;left:50px;">	
		    <xsl:value-of select="ID"></xsl:value-of>
			</td>
			</xsl:for-each>
			<xsl:for-each select="./post/Panel">  
			<td  style="background-color:yellow; color:green; width:350px; font-size:12px;left:50px; display:none;">	
		    <xsl:value-of select="GID"></xsl:value-of>
			</td>
			</xsl:for-each>
			</tr>
			</xsl:for-each> 
	</table>
</xsl:template>

<xsl:template name="Panel">
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <td><xsl:value-of select="ID"></xsl:value-of></td>
        <td style="display:none;"><xsl:value-of select="GID"></xsl:value-of></td>
    </tr>
</xsl:template>

<xsl:template name="Net_Topology">
 <xsl:choose>
        <xsl:when test=". = 0"><xsl:text>Class A</xsl:text></xsl:when>
        <xsl:when test=". = 1"><xsl:text>Class B</xsl:text></xsl:when>
 </xsl:choose>
</xsl:template>

<xsl:template match="Floors">
    <tr>
        <td style="font-weight:bold;" width="10%">Floor</td>
		<td style="font-weight:bold;" width="25%">Label</td>
		<td style="font-weight:bold;" width="15%">Sandwich</td>
		<td style="font-weight:bold;" width="10%">Floor</td>
		<td style="font-weight:bold;" width="25%">Label</td>
		<td style="font-weight:bold;" width="15%">Sandwich</td>
	</tr>
	<tr>
		<td rowspan="2">1st</td>
		<xsl:for-each select="Floor1">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
		<td rowspan="2">33rd</td>
		<xsl:for-each select="Floor33">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr bgcolor="yellow">
		<xsl:for-each select="Floor1">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
		<xsl:for-each select="Floor33">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td rowspan="2">2nd</td>
		<xsl:for-each select="Floor2">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
		<td rowspan="2">34th</td>
		<xsl:for-each select="Floor34">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr bgcolor="yellow">
		<xsl:for-each select="Floor2">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
		<xsl:for-each select="Floor34">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td rowspan="2">3rd</td>
		<xsl:for-each select="Floor3">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
		<td rowspan="2">35th</td>
		<xsl:for-each select="Floor35">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr bgcolor="yellow">
		<xsl:for-each select="Floor3">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
		<xsl:for-each select="Floor35">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td rowspan="2">4th</td>
		<xsl:for-each select="Floor4">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
		<td rowspan="2">36th</td>
		<xsl:for-each select="Floor36">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr bgcolor="yellow">
		<xsl:for-each select="Floor4">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
		<xsl:for-each select="Floor36">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td rowspan="2">5th</td>
		<xsl:for-each select="Floor5">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
		<td rowspan="2">37th</td>
		<xsl:for-each select="Floor37">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr bgcolor="yellow">
		<xsl:for-each select="Floor5">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
		<xsl:for-each select="Floor37">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td rowspan="2">6th</td>
		<xsl:for-each select="Floor6">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
		<td rowspan="2">38th</td>
		<xsl:for-each select="Floor38">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr bgcolor="yellow">
		<xsl:for-each select="Floor6">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
		<xsl:for-each select="Floor38">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td rowspan="2">7th</td>
		<xsl:for-each select="Floor7">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
		<td rowspan="2">39th</td>
		<xsl:for-each select="Floor39">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr bgcolor="yellow">
		<xsl:for-each select="Floor7">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
		<xsl:for-each select="Floor39">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td rowspan="2">8th</td>
		<xsl:for-each select="Floor8">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
		<td rowspan="2">40th</td>
		<xsl:for-each select="Floor40">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr bgcolor="yellow">
		<xsl:for-each select="Floor8">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
		<xsl:for-each select="Floor40">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td rowspan="2">9th</td>
		<xsl:for-each select="Floor9">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
		<td rowspan="2">41st</td>
		<xsl:for-each select="Floor41">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr bgcolor="yellow">
		<xsl:for-each select="Floor9">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
		<xsl:for-each select="Floor41">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td rowspan="2">10th</td>
		<xsl:for-each select="Floor10">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
		<td rowspan="2">42nd</td>
		<xsl:for-each select="Floor42">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr bgcolor="yellow">
		<xsl:for-each select="Floor10">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
		<xsl:for-each select="Floor42">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td rowspan="2">11st</td>
		<xsl:for-each select="Floor11">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
		<td rowspan="2">43rd</td>
		<xsl:for-each select="Floor43">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr bgcolor="yellow"> 
		<xsl:for-each select="Floor11">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
		<xsl:for-each select="Floor43">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td rowspan="2">12nd</td>
		<xsl:for-each select="Floor12">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
		<td rowspan="2">44th</td>
		<xsl:for-each select="Floor44">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr bgcolor="yellow">
		<xsl:for-each select="Floor12">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
		<xsl:for-each select="Floor44">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td rowspan="2">13rd</td>
		<xsl:for-each select="Floor13">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
		<td rowspan="2">45th</td>
		<xsl:for-each select="Floor45">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr bgcolor="yellow">
		<xsl:for-each select="Floor13">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
		<xsl:for-each select="Floor45">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td rowspan="2">14th</td>
		<xsl:for-each select="Floor14">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
		<td rowspan="2">46th</td>
		<xsl:for-each select="Floor46">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr bgcolor="yellow">
		<xsl:for-each select="Floor14">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
		<xsl:for-each select="Floor46">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td rowspan="2">15th</td>
		<xsl:for-each select="Floor15">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
		<td rowspan="2">47th</td>
		<xsl:for-each select="Floor47">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr bgcolor="yellow">
		<xsl:for-each select="Floor15">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
		<xsl:for-each select="Floor47">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td rowspan="2">16th</td>
		<xsl:for-each select="Floor16">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
		<td rowspan="2">48th</td>
		<xsl:for-each select="Floor48">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr bgcolor="yellow">
		<xsl:for-each select="Floor16">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
		<xsl:for-each select="Floor48">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td rowspan="2">17th</td>
		<xsl:for-each select="Floor17">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
		<td rowspan="2">49th</td>
		<xsl:for-each select="Floor49">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr bgcolor="yellow">
		<xsl:for-each select="Floor17">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
		<xsl:for-each select="Floor49">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td rowspan="2">18th</td>
		<xsl:for-each select="Floor18">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
		<td rowspan="2">50th</td>
		<xsl:for-each select="Floor50">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr bgcolor="yellow">
		<xsl:for-each select="Floor18">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
		<xsl:for-each select="Floor50">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td rowspan="2">19th</td>
		<xsl:for-each select="Floor19">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
		<td rowspan="2">51st</td>
		<xsl:for-each select="Floor51">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr bgcolor="yellow">
		<xsl:for-each select="Floor19">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
		<xsl:for-each select="Floor51">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td rowspan="2">20th</td>
		<xsl:for-each select="Floor20">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
		<td rowspan="2">52nd</td>
		<xsl:for-each select="Floor52">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr bgcolor="yellow">
		<xsl:for-each select="Floor20">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
		<xsl:for-each select="Floor52">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td rowspan="2">21st</td>
		<xsl:for-each select="Floor21">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
		<td rowspan="2">53rd</td>
		<xsl:for-each select="Floor53">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr bgcolor="yellow">
		<xsl:for-each select="Floor21">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
		<xsl:for-each select="Floor53">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td rowspan="2">22nd</td>
		<xsl:for-each select="Floor22">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
		<td rowspan="2">54th</td>
		<xsl:for-each select="Floor54">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr bgcolor="yellow">
		<xsl:for-each select="Floor22">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
		<xsl:for-each select="Floor54">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td rowspan="2">23rd</td>
		<xsl:for-each select="Floor23">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
		<td rowspan="2">55th</td>
		<xsl:for-each select="Floor55">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr bgcolor="yellow">
		<xsl:for-each select="Floor23">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
		<xsl:for-each select="Floor55">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td rowspan="2">24th</td>
		<xsl:for-each select="Floor24">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
		<td rowspan="2">56th</td>
		<xsl:for-each select="Floor56">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr bgcolor="yellow">
		<xsl:for-each select="Floor24">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
		<xsl:for-each select="Floor56">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td rowspan="2">25th</td>
		<xsl:for-each select="Floor25">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
		<td rowspan="2">57th</td>
		<xsl:for-each select="Floor57">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr bgcolor="yellow">
		<xsl:for-each select="Floor25">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
		<xsl:for-each select="Floor57">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td rowspan="2">26th</td>
		<xsl:for-each select="Floor26">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
		<td rowspan="2">58th</td>
		<xsl:for-each select="Floor58">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr bgcolor="yellow">
		<xsl:for-each select="Floor26">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
		<xsl:for-each select="Floor58">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td rowspan="2">27th</td>
		<xsl:for-each select="Floor27">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
		<td rowspan="2">59th</td>
		<xsl:for-each select="Floor59">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr bgcolor="yellow">
		<xsl:for-each select="Floor27">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
		<xsl:for-each select="Floor59">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td rowspan="2">28th</td>
		<xsl:for-each select="Floor28">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
		<td rowspan="2">60th</td>
		<xsl:for-each select="Floor60">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr bgcolor="yellow">
		<xsl:for-each select="Floor28">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
		<xsl:for-each select="Floor60">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td rowspan="2">29th</td>
		<xsl:for-each select="Floor29">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
		<td rowspan="2">61st</td>
		<xsl:for-each select="Floor61">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr bgcolor="yellow">
		<xsl:for-each select="Floor29">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
		<xsl:for-each select="Floor61">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td rowspan="2">30th</td>
		<xsl:for-each select="Floor30">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
		<td rowspan="2">62nd</td>
		<xsl:for-each select="Floor62">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr bgcolor="yellow">
		<xsl:for-each select="Floor30">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
		<xsl:for-each select="Floor62">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td rowspan="2">31st</td>
		<xsl:for-each select="Floor31">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
		<td rowspan="2">63rd</td>
		<xsl:for-each select="Floor63">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr bgcolor="yellow">
		<xsl:for-each select="Floor31">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
		<xsl:for-each select="Floor63">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr>
		<td rowspan="2">32nd</td>
		<xsl:for-each select="Floor32">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
		<td rowspan="2">64th</td>
		<xsl:for-each select="Floor64">
			<xsl:call-template name="FlrPre"></xsl:call-template>
		</xsl:for-each>
	</tr>
	<tr bgcolor="yellow">
		<xsl:for-each select="Floor32">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
		<xsl:for-each select="Floor64">
			<xsl:call-template name="FlrPost"></xsl:call-template>
		</xsl:for-each>
	</tr>
</xsl:template>

<xsl:template name="FlrPre">
    <td style="font-size:12px; font-weight:normal; color:blue;"><xsl:value-of select="Label/pre" /><br/></td>
	<td style="font-size:12px; font-weight:normal; color:blue;"><xsl:value-of select="Sandwich/pre" /></td>
</xsl:template>

<xsl:template name="FlrPost">
    <td style="font-size:12px; font-weight:normal; color:red;"><xsl:value-of select="Label/post" /><br/></td>
	<td style="font-size:12px; font-weight:normal; color:red;"><xsl:value-of select="Sandwich/post" /></td>
</xsl:template>

<xsl:template match="DualZones">
      <tr align="center">
        <td colspan="2" style="font-size:12px; font-weight:bold;">Pair 1</td>
        <td colspan="2" style="font-size:12px; font-weight:bold;">Pair 2</td>
        <td colspan="2" style="font-size:12px; font-weight:bold;">Pair 3</td>
        <td colspan="2" style="font-size:12px; font-weight:bold;">Pair 4</td>
        <td colspan="2" style="font-size:12px; font-weight:bold;">Pair 5</td>
        <td colspan="2" style="font-size:12px; font-weight:bold;">Pair 6</td>
    </tr>
	<tr>
		<xsl:for-each select="group1">
			<xsl:call-template name="PairTemplatePre" />
		</xsl:for-each>
		<xsl:for-each select="group2">
			<xsl:call-template name="PairTemplatePre" />
		</xsl:for-each>
	 </tr>
	 <tr style=" background-color:yellow; color:red; font-size:12px; font-weight:normal;">
		<xsl:for-each select="group1">
			<xsl:call-template name="PairTemplatePost" />
		</xsl:for-each>
		<xsl:for-each select="group2">
			<xsl:call-template name="PairTemplatePost" />
		</xsl:for-each>
	 </tr>
	 
	<tr align="center">
        <td colspan="2" style="font-size:12px; font-weight:bold;">Pair 7</td>
        <td colspan="2" style="font-size:12px; font-weight:bold;">Pair 8</td>
        <td colspan="2" style="font-size:12px; font-weight:bold;">Pair 9</td>
        <td colspan="2" style="font-size:12px; font-weight:bold;">Pair 10</td>
        <td colspan="2" style="font-size:12px; font-weight:bold;">Pair 11</td>
        <td colspan="2" style="font-size:12px; font-weight:bold;">Pair 12</td>
    </tr>
    <tr>
		<xsl:for-each select="group3">
			<xsl:call-template name="PairTemplatePre" />
		</xsl:for-each>
		<xsl:for-each select="group4">
			<xsl:call-template name="PairTemplatePre" />
		</xsl:for-each>
	</tr>
	 <tr style=" background-color:yellow; color:red; font-size:12px; font-weight:normal;">
		<xsl:for-each select="group3">
			<xsl:call-template name="PairTemplatePost" />
		</xsl:for-each>
		<xsl:for-each select="group4">
			<xsl:call-template name="PairTemplatePost" />
		</xsl:for-each>
	 </tr>
	 
    <tr align="center">
		<td colspan="2" style="font-size:12px; font-weight:bold;">Pair 13</td>
		<td colspan="2" style="font-size:12px; font-weight:bold;">Pair 14</td>
		<td colspan="2" style="font-size:12px; font-weight:bold;">Pair 15</td>
		<td colspan="2" style="font-size:12px; font-weight:bold;">Pair 16</td>
		<td colspan="2" style="font-size:12px; font-weight:bold;">Pair 17</td>
		<td colspan="2" style="font-size:12px; font-weight:bold;">Pair 18</td>
    </tr>
    <tr>
		<xsl:for-each select="group5">
			<xsl:call-template name="PairTemplatePre" />
		</xsl:for-each>
		<xsl:for-each select="group6">
			<xsl:call-template name="PairTemplatePre" />
		</xsl:for-each>
	 </tr>
	 <tr style=" background-color:yellow; color:red; font-size:12px; font-weight:normal;">
		<xsl:for-each select="group5">
			<xsl:call-template name="PairTemplatePost" />
		</xsl:for-each>
		<xsl:for-each select="group6">
			<xsl:call-template name="PairTemplatePost" />
		</xsl:for-each>
	 </tr>
</xsl:template>

<xsl:template name="PairTemplatePre">
    <td style=" color:blue;"><xsl:value-of select="PPid11/pre" />-<xsl:value-of select="Pair11/pre" /></td>
    <td style=" color:blue;"><xsl:value-of select="PPid12/pre" />-<xsl:value-of select="Pair12/pre" /></td>
    <td style=" color:blue;"><xsl:value-of select="PPid21/pre" />-<xsl:value-of select="Pair21/pre" /></td>
    <td style=" color:blue;"><xsl:value-of select="PPid22/pre" />-<xsl:value-of select="Pair22/pre" /></td>
    <td style=" color:blue;"><xsl:value-of select="PPid31/pre" />-<xsl:value-of select="Pair31/pre" /></td>
    <td style=" color:blue;"><xsl:value-of select="PPid32/pre" />-<xsl:value-of select="Pair32/pre" /></td>
</xsl:template>

<xsl:template name="PairTemplatePost">
    <td><xsl:value-of select="PPid11/post" />-<xsl:value-of select="Pair11/post" /></td>
    <td><xsl:value-of select="PPid12/post" />-<xsl:value-of select="Pair12/post" /></td>
    <td><xsl:value-of select="PPid21/post" />-<xsl:value-of select="Pair21/post" /></td>
    <td><xsl:value-of select="PPid22/post" />-<xsl:value-of select="Pair22/post" /></td>
    <td><xsl:value-of select="PPid31/post" />-<xsl:value-of select="Pair31/post" /></td>
    <td><xsl:value-of select="PPid32/post" />-<xsl:value-of select="Pair32/post" /></td>
</xsl:template>

<xsl:template match="TimeFormat">
    <xsl:choose>
        <xsl:when test=". = 0"><xsl:text>12</xsl:text> <xsl:text>h</xsl:text></xsl:when>
        <xsl:when test=". = 1"><xsl:text>24</xsl:text> <xsl:text>h</xsl:text></xsl:when>
        <xsl:otherwise><xsl:text>Invalid Time Format</xsl:text></xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="GroupWideZones">
	<xsl:for-each select="Z">
		 <xsl:call-template name="ZoneDiff" />
	</xsl:for-each>
</xsl:template>

<xsl:template match="PanelWideZones">
	<xsl:for-each select="GroupPanel">
		<!--<tr><td><xsl:value-of select="@flag"/></td></tr>-->
		<xsl:choose>
			<xsl:when test="@flag = 'new'">
				<tr><td colspan="6" style="color:green; font-size:12px; font-weight:bold;">New</td></tr>  
				<tr style="font-size:12px; border-color:green;">    
					<td align="left" style="font-weight:bold; color:black">Panel ID</td>
					<td colspan="5" style="color:green;"><xsl:value-of select="PID"/></td>
    			</tr>
		 		<xsl:call-template name="GroupPanel" />
			</xsl:when>
			<xsl:when test="@flag = 'removed'">
				<tr><td colspan="6" style="color:red; font-size:12px; font-weight:bold;">Removed</td></tr> 
				<tr  style="font-size:12px; border-color:red;">   
        			<td align="left" style="font-weight:bold; color:black">Panel ID</td>
					<td colspan="5" style="color:red;"><xsl:value-of select="PID"/></td>
    			</tr>
		 		<xsl:call-template name="GroupPanel" />
			</xsl:when>
			<xsl:when test="@flag = 'modified'">
		 		<xsl:call-template name="GroupPanelDiff" />
			</xsl:when>
			<xsl:otherwise><xsl:text></xsl:text></xsl:otherwise>
		 </xsl:choose>
	</xsl:for-each>
</xsl:template>

<xsl:template name="GroupPanel">
    <tr>
        <td style="font-size:12px; font-weight:bold;">Zone No.</td>
        <td style="font-size:12px; font-weight:bold;">Zone Label</td>
        <td style="font-size:12px; font-weight:bold;">Pattern</td>
        <td style="font-size:12px; font-weight:bold;">Counting</td>
        <td style="font-size:12px; font-weight:bold;">Floor</td>
        <td style="font-size:12px; font-weight:bold;">Bypassed</td>
    </tr>
	<xsl:for-each select="Z">
		 <xsl:call-template name="Zone" />
	</xsl:for-each>
</xsl:template>

<xsl:template name="Zone" >
    <tr style="color:blue; font-size:12px; font-weight:normal;">
        <td width="10%"><xsl:value-of select="N" /></td>
        <td width="20%"><xsl:value-of select="L" /></td>
        <td width="20%"><xsl:for-each select="P">
                        <xsl:call-template name="ID_PATTERN" />
                        </xsl:for-each></td>
        <td width="20%"><xsl:value-of select="C" /></td>
        <td width="10%"><xsl:value-of select="F" /></td>
        <td width="20%"><xsl:for-each select="B">
                        <xsl:call-template name="Bypass" />
                        </xsl:for-each></td>
    </tr>
</xsl:template>

<xsl:template name="GroupPanelDiff">
	<tr>        
        <td align="left" style="font-size:12px; font-weight:bold;">Panel ID</td>
		<td colspan="5" style="color:blue;"><xsl:value-of select="PID"/></td>
    </tr>
    <tr>
        <td style="font-size:12px; font-weight:bold;">Zone No.</td>
        <td style="font-size:12px; font-weight:bold;">Zone Label</td>
        <td style="font-size:12px; font-weight:bold;">Pattern</td>
        <td style="font-size:12px; font-weight:bold;">Counting</td>
        <td style="font-size:12px; font-weight:bold;">Floor</td>
        <td style="font-size:12px; font-weight:bold;">Bypassed</td>
    </tr>
	<xsl:for-each select="Z">
		 <xsl:call-template name="ZoneDiff" />
	</xsl:for-each>
</xsl:template>

<xsl:template name="ZoneDiff" >
	<xsl:for-each select=".">
		<xsl:choose>
			<xsl:when test="./L/pre|./P/pre|./C/pre|./F/pre|./B/pre">
				<tr style="color:blue; font-size:12px; font-weight:normal;">
					<td style="color:black;" width="10%"><xsl:value-of select="N" /></td>
					<td width="20%"><xsl:value-of select="L/pre" /></td>
					<td width="20%"><xsl:for-each select="P/pre">
									<xsl:call-template name="ID_PATTERN" />
									</xsl:for-each></td>
					<td width="20%"><xsl:value-of select="C/pre" /></td>
					<td width="10%"><xsl:value-of select="F/pre" /></td>
					<td width="20%"><xsl:for-each select="B/pre">
                        <xsl:call-template name="Bypass" />
                        </xsl:for-each></td>
				</tr>
				<tr style="background-color:yellow; color:red; font-size:12px; font-weight:normal;">
					<td style="color:black;" width="10%"><xsl:value-of select="N" /></td>
					<td width="20%"><xsl:value-of select="L/post" /></td>
					<td width="20%"><xsl:for-each select="P/post">
									<xsl:call-template name="ID_PATTERN" />
									</xsl:for-each></td>
					<td width="20%"><xsl:value-of select="C/post" /></td>
					<td width="10%"><xsl:value-of select="F/post" /></td>
					<td width="20%"><xsl:for-each select="B/post">
                        <xsl:call-template name="Bypass" />
                        </xsl:for-each></td>
				</tr>
			</xsl:when>
		</xsl:choose>
	</xsl:for-each>
</xsl:template>

<xsl:template match="REPORT">
    <table border="1" style="color:black; width:800px; left:50px;">
        <tr>
            <th colspan="4" style="background:black; color:white; font-weight:bold; font-size:14px; text-align:center; ">Report</th>
        </tr>
        <tr>
            <td colspan="4" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">Primary Account Settings</td>
        </tr> 
    	<xsl:apply-templates select="Primary" />
        <tr>
            <td colspan="4" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">Secondary Account Settings</td>
        </tr> 
        <xsl:apply-templates select="Secondary" />
	</table>
	<table border="1" style="color:black; width:800px; left:50px;">
        <xsl:apply-templates select="PSTN" />
    </table>
	<table border="1" style="color:black; width:800px; left:50px;">    
        <xsl:apply-templates select="Reporting" />
    </table> 
	<table border="1" style="color:black; width:800px; left:50px;">    
		<xsl:apply-templates select="Email" /> 
	</table> 
</xsl:template>

<xsl:template match="Primary|Secondary" >
        <tr>
            <td rowspan="6" width="20%" style=" font-size:12px; text-align:left; font-weight:bold;">Basic Data</td>
            <td width="20%" style="font-size:12px; font-weight:bold;">
                Selection PSTN/IP/Disable</td>  
            <td width="30%" style="font-size:12px; font-weight:12px; color:blue;">        
                <xsl:apply-templates select="AccountAttr/pre" /></td>
			<td width="30%" style=" background-color:yellow; font-size:12px; font-weight:12px; color:red;">        
                <xsl:apply-templates select="AccountAttr/post" /></td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Account Number</td>
            <td style="font-size:12px; font-weight:12px; color:blue;">
                <xsl:value-of select="AccountNum/pre" /></td>
			<td style=" background-color:yellow; font-size:12px; font-weight:12px; color:red;">
                <xsl:value-of select="AccountNum/post" /></td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Reporting Format</td>
            <td style="font-size:12px; font-weight:12px; color:blue;">
                <xsl:apply-templates select="RepFormat/pre" /></td>
			<td style=" background-color:yellow; font-size:12px; font-weight:12px; color:red;">
                <xsl:apply-templates select="RepFormat/post" /></td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Auto Test Time</td>
            <td style="font-size:12px; font-weight:12px; color:blue;">
                <xsl:value-of select="AutoTestHour/pre" />:
                <xsl:value-of select="AutoTestMin/pre" />
                <xsl:apply-templates select="AutoTestPM/pre" />
            </td>
			<td style=" background-color:yellow; font-size:12px; font-weight:12px; color:red;">
                <xsl:value-of select="AutoTestHour/post" />:
                <xsl:value-of select="AutoTestMin/post" />
                <xsl:apply-templates select="AutoTestPM/post" />
            </td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Auto Test Interval</td>
            <td style="font-size:12px; font-weight:12px; color:blue;">
                <xsl:apply-templates select="AutoTestIntervall/pre" /></td>
			<td style=" background-color:yellow; font-size:12px; font-weight:12px; color:red;">
                <xsl:apply-templates select="AutoTestIntervall/post" /></td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Max. Attempts</td>
            <td style="font-size:12px; font-weight:12px; color:blue;">
                <xsl:value-of select="MaxAttempt/pre" /></td>
			<td style=" background-color:yellow; font-size:12px; font-weight:12px; color:red;">
                <xsl:value-of select="MaxAttempt/post" /></td>
        </tr>
	    <tr>
            <td width="20%" style=" font-size:12px; text-align:left; font-weight:bold;">PSTN</td>
            <td width="20%" style="font-size:12px; font-weight:bold;">Phone Number</td>
            <td width="30%" style="font-size:12px; font-weight:12px; color:blue;">
                <xsl:value-of select="PhoneNum/pre" /></td>
			<td width="30%" style=" background-color:yellow; font-size:12px; font-weight:12px; color:red;">
                <xsl:value-of select="PhoneNum/post" /></td>
        </tr>
        <tr>
            <td rowspan="7" style=" font-size:12px; text-align:left; font-weight:bold;" width="20%">IP Reporting Conettix</td>
            <td width="20%" style="font-size:12px; font-weight:bold;">Receiver IP Address</td>
            <td width="30%" style="font-size:12px; font-weight:12px; color:blue;">
                <xsl:value-of select="IPAddr/pre" /></td>
			<td width="30%" style=" background-color:yellow; font-size:12px; font-weight:12px; color:red;">
                <xsl:value-of select="IPAddr/post" /></td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Port Number</td>
            <td style="font-size:12px; font-weight:12px; color:blue;">
                <xsl:value-of select="Port/pre" /></td>
			<td style=" background-color:yellow; font-size:12px; font-weight:12px; color:red;">
                <xsl:value-of select="Port/post" /></td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Anti-replay</td>
            <td style="font-size:12px; font-weight:12px; color:blue;">
                <xsl:value-of select="AntiReplay/pre" /></td>
			<td style=" background-color:yellow; font-size:12px; font-weight:12px; color:red;">
                <xsl:value-of select="AntiReplay/post" /></td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Polling Interval</td>
            <td style="font-size:12px; font-weight:12px; color:blue;">
                <xsl:value-of select="PollInt/pre" /><font color="black"> s</font></td>
			<td style=" background-color:yellow; font-size:12px; font-weight:12px; color:red;">
                <xsl:value-of select="PollInt/post" /><font color="black"> s</font></td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Acknowledge Wait Time</td>
            <td style="font-size:12px; font-weight:12px; color:blue;">
                <xsl:value-of select="AckTime/pre" /><font color="black"> s</font></td>
			<td style=" background-color:yellow; font-size:12px; font-weight:12px; color:red;">
                <xsl:value-of select="AckTime/post" /><font color="black"> s</font></td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Encryption Enabled</td>
            <td style="font-size:12px; font-weight:12px; color:blue;">
                <xsl:value-of select="Encryption/pre" /></td>
			<td style=" background-color:yellow; font-size:12px; font-weight:12px; color:red;">
                <xsl:value-of select="Encryption/post" /></td>
        </tr>
        <tr>
            <td width="20%" style="font-size:12px; font-weight:bold;">Key String</td>
            <td colspan="2" width="50%" style="font-size:12px; font-weight:12px; color:blue;"><xsl:text>******************************** (Encrypted)</xsl:text></td>
        </tr>
</xsl:template>

<xsl:template match="AccountAttr/pre|AccountAttr/post" >
    <xsl:choose>
        <xsl:when test=". = 0"><xsl:text>PSTN</xsl:text></xsl:when>
        <xsl:when test=". = 1"><xsl:text>IP</xsl:text></xsl:when>
        <xsl:when test=". = 2"><xsl:text>Disable</xsl:text></xsl:when>
        <xsl:otherwise><xsl:text>Invalid</xsl:text></xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="RepFormat/pre|RepFormat/post">
    <xsl:choose>
        <xsl:when test=". = 1"><xsl:text>SIA-DCS 300 No Text</xsl:text></xsl:when>
        <xsl:when test=". = 2"><xsl:text>Contact ID</xsl:text></xsl:when>
        <xsl:when test=". = 3"><xsl:text>Modem IIIa2 No Text</xsl:text></xsl:when>
        <xsl:when test=". = 4"><xsl:text>SIA-DCS 300 With Text</xsl:text></xsl:when>
        <xsl:when test=". = 5"><xsl:text>Modem IIIa2 With Text</xsl:text></xsl:when>
        <xsl:otherwise><xsl:text>Invalid Reporting Format</xsl:text></xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="AutoTestIntervall/pre|AutoTestIntervall/post">
    <xsl:choose>
        <xsl:when test=". = 0"><xsl:text>Disable</xsl:text></xsl:when>
        <xsl:when test=". = 1"><xsl:text>4</xsl:text> <xsl:text> h</xsl:text></xsl:when>
        <xsl:when test=". = 2"><xsl:text>12</xsl:text> <xsl:text> h</xsl:text></xsl:when>
        <xsl:when test=". = 3"><xsl:text>24</xsl:text> <xsl:text> h</xsl:text></xsl:when>
        <xsl:when test=". = 4"><xsl:text>7</xsl:text> <xsl:text> days</xsl:text></xsl:when>
        <xsl:when test=". = 5"><xsl:text>28</xsl:text> <xsl:text> days</xsl:text></xsl:when>
        <xsl:otherwise><xsl:text>Invalid Auto Test Intervals</xsl:text></xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="Dialing/pre|Dialing/post">
    <xsl:choose>
        <xsl:when test=". = 0"><xsl:text>Tone</xsl:text></xsl:when>
        <xsl:when test=". = 1"><xsl:text>Pulse</xsl:text></xsl:when>
        <xsl:when test=". = 2"><xsl:text>Auto</xsl:text></xsl:when>
    </xsl:choose>
</xsl:template>

<xsl:template match="PSTN">
        <tr>
            <td style="font-size:12px; font-weight:bold; background:#CCCCCC; border:1; " colspan="5">PSTN Communicator Settings</td>
        </tr>
        <tr>
            <td width="20%" style="font-size:12px; font-weight:bold;">Dialing Type</td>
            <td width="40%" style="font-size:12px; font-weight:normal; color:blue;" colspan="2"><xsl:apply-templates select="Dialing/pre" /></td>
			<td width="40%" style=" background-color:yellow; font-size:12px; font-weight:normal; color:red;" colspan="2"><xsl:apply-templates select="Dialing/post" /></td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Monitor Line 1</td>
            <td style="font-size:12px; font-weight:normal; color:blue;" colspan="2">
                <xsl:value-of select="Line1/pre" /></td>
			<td style=" background-color:yellow; font-size:12px; font-weight:normal; color:red;" colspan="2">
                <xsl:value-of select="Line1/post" /></td>
        </tr>
		<tr>
            <td style="font-size:12px; font-weight:bold;">Line 1 Ring Count</td>
            <td style="font-size:12px; font-weight:normal; color:blue;" colspan="2">
                <xsl:value-of select="Line1RingCount/pre" /></td>
			<td style=" background-color:yellow; font-size:12px; font-weight:normal; color:red;" colspan="2">
                <xsl:value-of select="Line1RingCount/post" /></td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Monitor Line 2</td>
            <td style="font-size:12px; font-weight:normal; color:blue;" colspan="2">
                <xsl:value-of select="Line2/pre" /></td>
			<td style=" background-color:yellow; font-size:12px; font-weight:normal; color:red;" colspan="2">
                <xsl:value-of select="Line2/post" /></td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Redial Interval</td>
            <td style="font-size:12px; font-weight:normal; color:blue;" colspan="2"><xsl:value-of select="DialInterval/pre" /><font color="black"> s</font></td>
			<td style=" background-color:yellow; font-size:12px; font-weight:normal; color:red;" colspan="2"><xsl:value-of select="DialInterval/post" /><font color="black"> s</font></td>
        </tr>
</xsl:template>

<xsl:template match="Reporting">
    <tr>
        <td style=" font-weight:bold; background:#CCCCCC; font:Arial; border:1; font-size:12px;" colspan="5">Reporting</td>
    </tr>
    <tr>
        <td width="20%" style="font-size:12px; font-weight:bold;">Alarms</td>
        <td width="40%" colspan="2" style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:apply-templates select="FireAlarm/pre" /></td>
		<td width="40%" colspan="2" style=" background-color:yellow; font-size:12px; font-weight:normal; color:red;">
            <xsl:apply-templates select="FireAlarm/post" /></td>
    </tr>
    <tr>
        <td style="font-size:12px; font-weight:bold;">Supervisory</td>
        <td colspan="2" style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:apply-templates select="Supervisory/pre" /></td>
		<td colspan="2" style=" background-color:yellow; font-size:12px; font-weight:normal; color:red;">
            <xsl:apply-templates select="Supervisory/post" /></td>
    </tr>
    <tr>
        <td style="font-size:12px; font-weight:bold;">Alarm restorals</td>
        <td colspan="2" style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:apply-templates select="FireRestore/pre" /></td>
		<td colspan="2" style=" background-color:yellow; font-size:12px; font-weight:normal; color:red;">
            <xsl:apply-templates select="FireRestore/post" /></td>
    </tr>
    <tr>
        <td style="font-size:12px; font-weight:bold;">Supervisory restoral</td>
        <td colspan="2" style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:apply-templates select="SupervRestore/pre" /></td>
		<td colspan="2" style=" background-color:yellow; font-size:12px; font-weight:normal; color:red;">
            <xsl:apply-templates select="SupervRestore/post" /></td>
    </tr>
    <tr>
        <td style="font-size:12px; font-weight:bold;">Trouble/Restoral</td>
        <td colspan="2" style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:apply-templates select="TroubleRes/pre" /></td>
		<td colspan="2" style=" background-color:yellow; font-size:12px; font-weight:normal; color:red;">
            <xsl:apply-templates select="TroubleRes/post" /></td>
    </tr>
    <tr>
        <td style="font-size:12px; font-weight:bold;">Test</td>
        <td colspan="2" style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:apply-templates select="Test/pre" /></td>
		<td colspan="2" style=" background-color:yellow; font-size:12px; font-weight:normal; color:red;">
            <xsl:apply-templates select="Test/post" /></td>
    </tr>
    <tr>
        <td style="font-size:12px; font-weight:bold;">Silence</td>
        <td colspan="2" style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:apply-templates select="RepSilence/pre" /></td>
		<td colspan="2" style=" background-color:yellow; font-size:12px; font-weight:normal; color:red;">
            <xsl:apply-templates select="RepSilence/post" /></td>
    </tr>
    <tr>
        <td style="font-size:12px; font-weight:bold;">Reset</td>
        <td colspan="2" style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:apply-templates select="Reset/pre" /></td>
		<td colspan="2" style=" background-color:yellow; font-size:12px; font-weight:normal; color:red;">
            <xsl:apply-templates select="Reset/post" /></td>
    </tr>
    <tr>
        <td style="font-size:12px; font-weight:bold;">Fire drill</td>
        <td colspan="2" style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:apply-templates select="FireDrill/pre" /></td>
		<td colspan="2" style=" background-color:yellow; font-size:12px; font-weight:normal; color:red;">
            <xsl:apply-templates select="FireDrill/post" /></td>
    </tr>
</xsl:template>

<xsl:template match="Email">
	 <tr>
     	<td style="font-size:12px; font-weight:bold; background:#CCCCCC; border:1; " colspan="4">E-mail Settings</td>
     </tr>
	 <tr>
        <td colspan="1" style="font-size:12px; font-weight:bold;">E-mail notification enable</td>
        <td colspan="2" style="font-size:12px; font-weight:12px; color:blue;">
                <xsl:value-of select="EmailEnable/pre" /></td>
		<td style="font-size:12px; font-weight:12px; color:red; background-color:yellow;">
                <xsl:value-of select="EmailEnable/post" /></td>
    </tr>
    <tr>
        <td rowspan="4"	width="20%" style="font-size:12px; font-weight:bold;">E-mail customization</td>
       	<td width="20%" style="font-size:12px; font-weight:bold;">To address 1</td>
	    <td width="30%" style="font-size:12px; font-weight:12px; color:blue;">
                <xsl:value-of select="Addr1/pre" /></td>
		<td width="30%" style="font-size:12px; font-weight:12px; color:red; background-color:yellow;">
                <xsl:value-of select="Addr1/post" /></td>
	</tr>
    <tr>
        <td style="font-size:12px; font-weight:bold;">To address 2</td>
        <td style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:value-of select="Addr2/pre" /></td>
		<td width="30%" style="font-size:12px; font-weight:12px; color:red; background-color:yellow;">
            <xsl:value-of select="Addr2/post" /></td>
    </tr>
	 <tr>
        <td style="font-size:12px; font-weight:bold;">To address 3</td>
        <td style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:value-of select="Addr3/pre" /></td>
		<td style="font-size:12px; font-weight:12px; color:red; background-color:yellow;">
            <xsl:value-of select="Addr3/post" /></td>
    </tr>
	 <tr>
        <td style="font-size:12px; font-weight:bold;">To address 4</td>
        <td style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:value-of select="Addr4/pre" /></td>
		<td style="font-size:12px; font-weight:12px; color:red; background-color:yellow;">
            <xsl:value-of select="Addr4/post" /></td>
    </tr>		
    <tr>
        <td rowspan="4"  style="font-size:12px; font-weight:bold;">SMTP server settings</td>
       	<td width="20%"  style="font-size:12px; font-weight:bold;">IP address</td>
	    <td width="30%" style="font-size:12px; font-weight:12px; color:blue;">
                <xsl:value-of select="SMTPIP/pre" /></td>
		<td width="30%" style="font-size:12px; font-weight:12px; color:red; background-color:yellow;">
                <xsl:value-of select="SMTPIP/post" /></td>
    </tr>
	<tr>
        <td style="font-size:12px; font-weight:bold;">Port</td>
        <td style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:value-of select="SMTPPort/pre" /></td>
		<td style="font-size:12px; font-weight:normal; color:red; background-color:yellow;">
            <xsl:value-of select="SMTPPort/post" /></td>
    </tr>
	<tr>
        <td style="font-size:12px; font-weight:bold;">User name</td>
        <td style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:value-of select="SMTPUser/pre" /></td>
		<td style="font-size:12px; font-weight:normal; color:red; background-color:yellow;">
            <xsl:value-of select="SMTPUser/post" /></td>
    </tr>
	<tr>
        <td style="font-size:12px; font-weight:bold;">Password</td>
        <td style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:value-of select="SMTPPwd/pre" /></td>
		<td style="font-size:12px; font-weight:normal; color:red; background-color:yellow;">
            <xsl:value-of select="SMTPPwd/post" /></td>
    </tr>
</xsl:template>

<xsl:template match="FireAlarm|Supervisory|FireRestore|SupervRestore|TroubleRes|Test|RepSilence|Reset|FireDrill">
    <xsl:choose>
        <xsl:when test=". = 0"><xsl:text>Primary only</xsl:text></xsl:when>
        <xsl:when test=". = 1"><xsl:text>Secondary only</xsl:text></xsl:when>
        <xsl:when test=". = 2"><xsl:text>Primary and secondary</xsl:text></xsl:when>
        <xsl:when test=". = 3"><xsl:text>Secondary as backup</xsl:text></xsl:when>
        <xsl:when test=". = 4"><xsl:text>No report</xsl:text></xsl:when>
    </xsl:choose>
</xsl:template>

<xsl:template name="DeviceDetailTemplate">
		 <xsl:choose>
                <xsl:when test="DeviceType = '2'">
                    <xsl:call-template name="DEV_SLC"></xsl:call-template>
                </xsl:when>
                <xsl:when test="DeviceType = '3' or DeviceType = '27' or DeviceType = '32' or DeviceType = '34'">
                    <xsl:call-template name="DEV_SMOKE_P"></xsl:call-template>
                </xsl:when>
                <xsl:when test="DeviceType = '4' or DeviceType = '26' or DeviceType = '33'">
                    <xsl:call-template name="DEV_SMOKE_D"></xsl:call-template>
                </xsl:when>
                <xsl:when test="DeviceType = '5' or DeviceType = '29'">
                    <xsl:call-template name="DEV_HEAT"></xsl:call-template>
                </xsl:when>
                <xsl:when test="DeviceType = '6'">
                    <xsl:call-template name="DEV_SMOKE_I"></xsl:call-template>
                </xsl:when>
                <xsl:when test="DeviceType = '7' or DeviceType = '30' or DeviceType = '31' or DeviceType = '35' or DeviceType = '36'">
                    <xsl:call-template name="DEV_SMOKE_M" ></xsl:call-template>
                </xsl:when>
                <xsl:when test="DeviceType = '10'">
                    <xsl:call-template name="DEV_CONVZ_MOD"></xsl:call-template>
                </xsl:when>
                <xsl:when test="DeviceType = '8' or DeviceType = '11' or DeviceType = '18' or DeviceType = '19' or DeviceType = '20' or DeviceType = '21'">
                    <xsl:call-template name="DEV_CONT_MOD"></xsl:call-template>
                </xsl:when>
                <xsl:when test="DeviceType = '12' or DeviceType = '17' or DeviceType = '22' or DeviceType = '23' or DeviceType = '24' or DeviceType = '25'">
                    <xsl:call-template name="DEV_RELAY_MOD"></xsl:call-template>
                </xsl:when>
				<xsl:when test="DeviceType = '13' or DeviceType = '14' or DeviceType = '15'">
					<xsl:call-template name="DEV_NAC_MOD"></xsl:call-template>
				</xsl:when>
				<xsl:when test="DeviceType = '16'">
					<xsl:call-template name="DEV_BASE_SND"></xsl:call-template>
				</xsl:when>
            </xsl:choose>
</xsl:template>


<xsl:template name="T_LOOPS" match="LOOP1|LOOP2">
    <table border="1" style="color:black; width:800px; left:50px;">
	        <xsl:for-each select="Modified">
			<tr>
	    		<td style="font-weight:bold; width:100px; font-size:12px; color:orange;">Modified</td>
						<td>
							<xsl:for-each select="./pre/Device">
								<table border="1" style=" color:black; width:700px; left:50px;">
									<xsl:call-template name="DeviceDetailTemplate"></xsl:call-template>
								</table>
							</xsl:for-each>
							<xsl:for-each select="./post/Device">
								<table border="1" style=" background-color:yellow; color:black; width:700px; left:50px;">
									<xsl:call-template name="DeviceDetailTemplate"></xsl:call-template>
								</table>
							</xsl:for-each>
						</td>
				</tr>
				</xsl:for-each>
				<xsl:for-each select="Removed">
				<tr>
					<td style="font-weight:bold; width:100px; font-size:12px; color:red;">Removed</td>
							<td>
								 <xsl:for-each select="./pre/Device"> 
									<table border="1" style=" color:black; width:700px; left:50px;">
										<xsl:call-template name="DeviceDetailTemplate"></xsl:call-template>
									</table>
								 </xsl:for-each> 
							</td>
				</tr>
				</xsl:for-each>		
				<xsl:for-each select="New"> 
				<tr>
						<td style="font-weight:bold; width:100px; font-size:12px; color:green;">New</td>
						<td>	
								    <xsl:for-each select="./post/Device">  
										<table border="1" style="background-color:yellow; color:black; width:700px; left:50px;">
											<xsl:call-template name="DeviceDetailTemplate"></xsl:call-template>
										</table>
									</xsl:for-each>
						</td>
				</tr>
				</xsl:for-each> 
	</table>
</xsl:template>


<xsl:template name="DEV_SLC">
    <tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th>Address</th>
        <th>Device Type</th>
        <th>Label</th>
        <th>Bypassed</th>
        <th>Enable</th>
        <th>Topology</th>
        <th>Loop Type</th>
        <th colspan="2">Number of Elements</th>
    </tr>
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <td><xsl:value-of select="Address" ></xsl:value-of></td>
        <td><xsl:apply-templates select="DeviceType"></xsl:apply-templates></td>
        <td><xsl:value-of select="Label" ></xsl:value-of></td>
        <td><xsl:value-of select="Bypassed" ></xsl:value-of></td>
        <td><xsl:value-of select="Enable" ></xsl:value-of></td>
        <td><xsl:apply-templates select="Topology" ></xsl:apply-templates></td>
        <td><xsl:call-template name="DEV_LOOPTYPE"></xsl:call-template></td>
        <td colspan="2"><xsl:value-of select="NumElements" ></xsl:value-of></td>
    </tr>
</xsl:template>

<xsl:template name="DEV_LOOPTYPE" match="LoopType">
	<!-- LoopType -->
	<xsl:choose>
		<xsl:when test="LoopType = 0">SLC Loop</xsl:when>
		<xsl:otherwise></xsl:otherwise>
	</xsl:choose>
</xsl:template>

<xsl:template name="DEV_SMOKE_P" match="Device">
    <!--line 1 for DEV_SMOKE_P-->
    <tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th>Address</th>
        <th>Device Type</th>
        <th colspan="2">Label</th>
        <th>Bypassed</th>
        <th>Point Type</th>
        <th colspan="2">Zones</th>
        <th>Delay Mode</th>
    </tr>
	
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <td><xsl:value-of select="Address" ></xsl:value-of></td>
        <td><xsl:apply-templates select="DeviceType"></xsl:apply-templates></td>
        <td colspan="2"><xsl:value-of select="Label" ></xsl:value-of></td>
        <td><xsl:value-of select="Bypassed" ></xsl:value-of></td>
       <td>
		   <xsl:for-each select="PointType">
			   <xsl:call-template name="PointType"></xsl:call-template>
		   </xsl:for-each>
		</td>
        <td colspan="2"><xsl:call-template name="Zone1_5" ></xsl:call-template></td>
        <td>
		   <xsl:for-each select="DelayMode">
			   <xsl:call-template name="DelayMode"></xsl:call-template>
		   </xsl:for-each>
		</td>
    </tr>
	
    <!--line 2 for DEV_SMOKE_P-->
    <tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
		<th colspan="2">Sensitivity</th>
        <th colspan="2">Day Sensitivity</th>

	<xsl:choose>
        <xsl:when test="DeviceType = '27' or DeviceType = '32' or DeviceType = '34'">
            <th>Led Flashing</th>
	        </xsl:when>
	        <xsl:otherwise>
			</xsl:otherwise>
        </xsl:choose>
    </tr>
	      
	<tr style="font-size:12px; font-weight:normal; color:blue;">
        <td colspan="2"><xsl:call-template name="TP_Sensitivity"></xsl:call-template></td>
        <td colspan="2"><xsl:call-template name="TP_DaySensitivity"></xsl:call-template></td>

	    <xsl:choose>
            <xsl:when test="DeviceType = '27' or DeviceType = '32' or DeviceType = '34'">
            <td><xsl:value-of select="LedFlash" ></xsl:value-of></td>
	   		</xsl:when>
	        <xsl:otherwise>
			</xsl:otherwise>
   		</xsl:choose> 
    </tr>
</xsl:template>

<xsl:template name="DEV_SMOKE_D">
    <!--line 1 for DEV_SMOKE_D-->
    <tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th>Address</th>
        <th>Device Type</th>
        <th colspan="2">Label</th>
        <th>Bypassed</th>
        <th>Point Type</th>
        <th colspan="2">Zones</th>
        <th>Delay Mode</th>
    </tr>
		
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <td><xsl:value-of select="Address" ></xsl:value-of></td>
        <td><xsl:apply-templates select="DeviceType"></xsl:apply-templates></td>
        <td colspan="2"><xsl:value-of select="Label" ></xsl:value-of></td>
        <td><xsl:value-of select="Bypassed" ></xsl:value-of></td>
        <td><xsl:for-each select="PointType">
			   <xsl:call-template name="PointType"></xsl:call-template>
		   </xsl:for-each>
		</td>
        <td colspan="2"><xsl:call-template name="Zone1_5"></xsl:call-template></td>
        <td><xsl:for-each select="DelayMode">
			   <xsl:call-template name="DelayMode"></xsl:call-template>
		   </xsl:for-each>
		</td>
    </tr>
	
    <!--line 2 for DEV_SMOKE_D-->	
    <tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th colspan="2">Sensitivity</th>
        <th colspan="2">Day Sensitivity</th>

        <th>Relay</th>
		
		<xsl:choose>
		<xsl:when test="DeviceType = '33'">
		<th>Led Flashing</th>
		<th colspan="3"></th>
        </xsl:when>
   		<xsl:otherwise>
		<th colspan="4"></th>
   		</xsl:otherwise>
        </xsl:choose> 
    </tr>

	<tr style="font-size:12px; color:blue; font-weight:normal;">
		<td colspan="2"><xsl:call-template name="TP_Sensitivity"></xsl:call-template></td>
		<td colspan="2"><xsl:call-template name="TP_DaySensitivity"></xsl:call-template></td>

		<xsl:choose>
		<xsl:when test="Relay = 'TRUE'">
			<td>TRUE</td>
		</xsl:when>
		<xsl:otherwise>
			<td>FALSE</td>
		</xsl:otherwise>
	    </xsl:choose> 

		<xsl:choose>
			<xsl:when test="DeviceType = '33'">
			<td><xsl:value-of select="LedFlash" ></xsl:value-of></td>
			<td colspan="3"></td>
		    </xsl:when>
			<xsl:otherwise>
			<td colspan="4"></td>
			</xsl:otherwise>
		</xsl:choose> 
	</tr>

    <!--line 3 for DEV_SMOKE_D-->	
	<xsl:choose>
		<xsl:when test="Relay = 'TRUE'">
		<tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
			<th style="background-color:white;" rowspan="2"></th>
			<th rowspan="2" style="color:blue; background:white;">Duct Relay</th>
			<th colspan="2">Label</th>
			<th>Bypassed</th>
			<th colspan="2">Zones</th>
			<xsl:choose>
			<xsl:when test="DeviceType = '33'">
				<th>Sequential</th>
		    </xsl:when>
		    <xsl:otherwise></xsl:otherwise>
		    </xsl:choose> 
		</tr>
			<xsl:call-template name="SMOKE_D_RELAY"></xsl:call-template>
		</xsl:when>
		<xsl:otherwise></xsl:otherwise>
	</xsl:choose> 
</xsl:template>

<xsl:template name="SMOKE_D_RELAY" match="DuctRelay|DuctRelay440">
	  <xsl:for-each select="DuctRelay|DuctRelay440">
	  <tr style="font-size:12px; font-weight:normal; color:blue;">
		<td colspan="2"><xsl:value-of select="Label"></xsl:value-of></td>
		<td><xsl:value-of select="Bypassed"></xsl:value-of></td>
		<td colspan="2"><xsl:call-template name="RelayZone1_5"></xsl:call-template></td>
		<td><xsl:value-of select="Sequential"></xsl:value-of></td> 
	 </tr>
	 </xsl:for-each>
</xsl:template>

<xsl:template name="DEV_HEAT">
    <!--line 1 for DEV_HEAT-->	
    <tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th>Address</th>
        <th>Device Type</th>
        <th colspan="2">Label</th>
        <th>Bypassed</th>
        <th>Point Type</th>
        <th colspan="2">Zones</th>
        <th>Delay Mode</th>
    </tr>
	
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <td><xsl:value-of select="Address" ></xsl:value-of></td>
        <td><xsl:apply-templates select="DeviceType"></xsl:apply-templates></td>
        <td colspan="2"><xsl:value-of select="Label" ></xsl:value-of></td>
        <td><xsl:value-of select="Bypassed" ></xsl:value-of></td>
        <td>
		   <xsl:for-each select="PointType">
			   <xsl:call-template name="PointType"></xsl:call-template>
		   </xsl:for-each>
		</td>
        <td colspan="2"><xsl:call-template name="Zone1_5" ></xsl:call-template></td>
        <td>
		   <xsl:for-each select="DelayMode">
			   <xsl:call-template name="DelayMode"></xsl:call-template>
		   </xsl:for-each>
		</td>
    </tr>
	
    <!--line 2 for DEV_HEAT-->	
	<tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th colspan="2">Sensitivity</th>
        <th colspan="2">Day Sensitivity</th>
		<xsl:choose>
        <xsl:when test="DeviceType = '29'">
			<th>Led Flashing</th>
			<th>RTI rating</th>
			<th>RoR</th>
			<th>Day RoR</th>
			</xsl:when>
			<xsl:otherwise>
			</xsl:otherwise>
		</xsl:choose> 
    </tr>

	<tr style="font-size:12px; font-weight:normal; color:blue;">
        <td colspan="2"><xsl:call-template name="TP_Sensitivity"></xsl:call-template></td>
        <td colspan="2"><xsl:call-template name="TP_DaySensitivity"></xsl:call-template></td>
		<xsl:choose>
			<xsl:when test="DeviceType = '29'">
			<td><xsl:value-of select="LedFlash" ></xsl:value-of></td>
			<td><xsl:apply-templates select="RTI"></xsl:apply-templates></td>
			<td><xsl:value-of select="RoR"></xsl:value-of></td>
			<td><xsl:value-of select="DayRoR"></xsl:value-of></td>
	   		</xsl:when>
			<xsl:otherwise>
			</xsl:otherwise>
   		</xsl:choose> 
    </tr>
</xsl:template>

<xsl:template name="DEV_SMOKE_I">
	<!--line 1 for DEV_SMOKE_I-->	
    <tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th>Address</th>
        <th>Device Type</th>
        <th colspan="2">Label</th>
        <th>Bypassed</th>
        <th>Point Type</th>
        <th colspan="2">Zones</th>
        <th>Delay Mode</th>
    </tr>
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <td><xsl:value-of select="Address" ></xsl:value-of></td>
        <td><xsl:apply-templates select="DeviceType"></xsl:apply-templates></td>
        <td colspan="2"><xsl:value-of select="Label" ></xsl:value-of></td>
        <td><xsl:value-of select="Bypassed" ></xsl:value-of></td>
        <td>
		   <xsl:for-each select="PointType">
			   <xsl:call-template name="PointType"></xsl:call-template>
		   </xsl:for-each>
		</td>
        <td colspan="2"><xsl:call-template name="Zone1_5" ></xsl:call-template></td>
        <td>
		   <xsl:for-each select="DelayMode">
			   <xsl:call-template name="DelayMode"></xsl:call-template>
		   </xsl:for-each>
		</td>
    </tr>

	<!--line 2 for DEV_SMOKE_I-->	
    <tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th colspan="2">Sensitivity</th>
        <th colspan="2">Day Sensitivity</th>
    </tr>
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <td colspan="2"><xsl:call-template name="TP_Sensitivity"></xsl:call-template></td>
        <td colspan="2"><xsl:call-template name="TP_DaySensitivity"></xsl:call-template></td>
    </tr>
</xsl:template>

<xsl:template name="DEV_SMOKE_M">
    <!--line 1 for DEV_SMOKE_M-->
    <tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th>Address</th>
        <th>Device Type</th>
        <th colspan="2">Label</th>
        <th>Bypassed</th>
        <th>Point Type</th>
        <th colspan="2">Zones</th>
        <th>Delay Mode</th>
		  </tr>
	   
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <td><xsl:value-of select="Address" ></xsl:value-of></td>
        <td><xsl:apply-templates select="DeviceType"></xsl:apply-templates></td>
        <td colspan="2"><xsl:value-of select="Label" ></xsl:value-of></td>
        <td><xsl:value-of select="Bypassed" ></xsl:value-of></td>
        <td>
		   <xsl:for-each select="PointType">
			   <xsl:call-template name="PointType"></xsl:call-template>
		   </xsl:for-each>
		</td>
        <td colspan="2"><xsl:call-template name="Zone1_5" ></xsl:call-template></td>
         <td>
		   <xsl:for-each select="DelayMode">
			   <xsl:call-template name="DelayMode"></xsl:call-template>
		   </xsl:for-each>
		</td>
    </tr>
	
    <!--line 2 for DEV_SMOKE_M-->
	<tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th>Smoke Label</th>
        <th>Smoke Point Type</th>
        <th>Working Mode</th>
        <th colspan="2">Working Day Mode</th>
        <th colspan="2">Smoke Sensitivity</th>
        <th colspan="2">Smoke Day Sensitivity</th>
    </tr>
	
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <td><xsl:value-of select="SmokeLabel" ></xsl:value-of></td>
        <td>
		   <xsl:for-each select="SmokePointType">
				  <xsl:call-template name="PointType"></xsl:call-template>
		   </xsl:for-each>
		</td>
		<td>
		   <xsl:for-each select="WorkingMode">
				  <xsl:call-template name="WorkingMode"></xsl:call-template>
		   </xsl:for-each>
		</td>
        <td  colspan="2">
		   <xsl:for-each select="WorkingDayMode">
				  <xsl:call-template name="WorkingMode"></xsl:call-template>
		   </xsl:for-each>
		</td>
        <td colspan="2"><xsl:call-template name="TP_Sensitivity"></xsl:call-template></td>
        <td colspan="2"><xsl:call-template name="TP_DaySensitivity"></xsl:call-template></td>
    </tr>
	
    <!--line 3 for DEV_SMOKE_M-->
	<tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
		<th>Led Flashing</th>
		<xsl:choose>
        <xsl:when test="DeviceType = '30' or DeviceType = '31' or DeviceType = '35' or DeviceType = '36'">
			<th colspan="2">Heat Sensitivity</th>
        	<th colspan="2">Heat Day Sensitivity</th>
			<th>RoR</th>
        	<th>Day RoR</th>
			</xsl:when>
			<xsl:otherwise></xsl:otherwise>
		</xsl:choose> 
	</tr>
     	  
	<tr style="font-size:12px; font-weight:normal; color:blue;">
		<td><xsl:value-of select="LedFlash" ></xsl:value-of></td>
		<xsl:choose>
			<xsl:when test="DeviceType = '30' or DeviceType = '31' or DeviceType = '35' or DeviceType = '36'">
			<td colspan="2"><xsl:for-each select="HeatSensitivity">
				<xsl:call-template name="FixSensitivity"></xsl:call-template>
			</xsl:for-each></td>
			<td colspan="2"><xsl:for-each select="HeatDaySensitivity">
				<xsl:call-template name="FixSensitivity"></xsl:call-template>
			</xsl:for-each></td>
			<td><xsl:value-of select="RoR" ></xsl:value-of></td>
			<td><xsl:value-of select="DayRoR"></xsl:value-of></td>
	   		</xsl:when>
	   		<xsl:otherwise></xsl:otherwise>
   		</xsl:choose> 
	</tr>
</xsl:template>

<xsl:template name="DEV_CONVZ_MOD">
     <tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th>Address</th>
        <th>Device Type</th>
        <th colspan="2">Label</th>
        <th>Bypassed</th>
        <th>Point Type</th>
        <th colspan="2">Zones</th>
        <th>Delay Mode</th>
    </tr>
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <td><xsl:value-of select="Address" ></xsl:value-of></td>
        <td><xsl:apply-templates select="DeviceType"></xsl:apply-templates></td>
        <td colspan="2"><xsl:value-of select="Label" ></xsl:value-of></td>
        <td><xsl:value-of select="Bypassed" ></xsl:value-of></td>
        <td>
		   <xsl:for-each select="PointType">
			   <xsl:call-template name="PointType"></xsl:call-template>
		   </xsl:for-each>
		</td>
        <td colspan="2"><xsl:call-template name="Zone1_5" ></xsl:call-template></td>
        <td>
		   <xsl:for-each select="DelayMode">
			   <xsl:call-template name="DelayMode"></xsl:call-template>
		   </xsl:for-each>
		</td>
    </tr>
</xsl:template>

<xsl:template name="DEV_CONT_MOD">
    <xsl:choose>
        <xsl:when test="DeviceType = '11'">
            <xsl:call-template name="DEV_CONT_MOD_DUAL"></xsl:call-template>
        </xsl:when>
        <xsl:otherwise>
            <xsl:call-template name="DEV_CONT_MOD_SINGLE"></xsl:call-template>
        </xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template name="DEV_CONT_MOD_DUAL">
    <!--line 1 for DEV_CONT_MOD_DUAL-->	
    <tr  style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th>Address</th>
        <th>Device Type</th>
        <th>Label</th>
        <th colspan="6"></th>
    </tr>
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <td><xsl:value-of select="Address" ></xsl:value-of></td>
        <td><xsl:apply-templates select="DeviceType"></xsl:apply-templates></td>
        <td><xsl:value-of select="Label" ></xsl:value-of></td>
        <td colspan="6"></td>
    </tr>

    <!--line 2 for DEV_CONT_MOD_DUAL-->	
    <xsl:for-each select="Input1">
    <tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
		<th style="background-color:white;" rowspan="2"></th>
        <th style="color:blue; background-color:white;" rowspan="2">Input 1</th>
        <th>Label</th>
        <th>Bypassed</th>
        <th>Point Type</th>
        <th>Input Type</th>
        <th colspan="2">Zones</th>
        <th>Delay Mode</th>
    </tr>
	
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <td><xsl:value-of select="Label" ></xsl:value-of></td>
        <td><xsl:value-of select="Bypassed" ></xsl:value-of></td>
        <td>
		   <xsl:for-each select="PointType">
			   <xsl:call-template name="PointType"></xsl:call-template>
		   </xsl:for-each>
		</td>
		<td><xsl:apply-templates select="InputType" ></xsl:apply-templates></td>
        <td colspan="2"><xsl:call-template name="Zone1_5" ></xsl:call-template></td>
        <td>
		   <xsl:for-each select="DelayMode">
			   <xsl:call-template name="DelayMode"></xsl:call-template>
		   </xsl:for-each>
		</td>
    </tr>
    </xsl:for-each>
    <xsl:for-each select="Input2">
    <tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th style="background-color:white;" rowspan="2"></th>
		<th style="color:blue; background-color:white;" rowspan="2">Input 2</th>
        <th>Label</th>
        <th>Bypassed</th>
        <th>Point Type</th>
        <th>Input Type</th>
        <th colspan="2">Zones</th>
        <th>Delay Mode</th>
    </tr>
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <td><xsl:value-of select="Label" ></xsl:value-of></td>
        <td><xsl:value-of select="Bypassed" ></xsl:value-of></td>
        <td>
		   <xsl:for-each select="PointType">
			   <xsl:call-template name="PointType"></xsl:call-template>
		   </xsl:for-each>
		</td>
        <td><xsl:apply-templates select="InputType" ></xsl:apply-templates></td>
        <td colspan="2"><xsl:call-template name="Zone1_5" ></xsl:call-template></td>
        <td>
		   <xsl:for-each select="DelayMode">
			   <xsl:call-template name="DelayMode"></xsl:call-template>
		   </xsl:for-each>
		</td>
    </tr>
    </xsl:for-each>
</xsl:template>

<xsl:template name="DEV_CONT_MOD_SINGLE">
    <tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th>Address</th>
        <th>Device Type</th>
        <th colspan="2">Label</th>
        <th>Bypassed</th>
        <th>Point Type</th>
        <th>Input Type</th>
		<th colspan="2">Zones</th>
    </tr>
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <td><xsl:value-of select="Address" ></xsl:value-of></td>
        <td><xsl:apply-templates select="DeviceType"></xsl:apply-templates></td>
        <td colspan="2"><xsl:value-of select="Label" ></xsl:value-of></td>
        <td><xsl:value-of select="Bypassed" ></xsl:value-of></td>
        <td>
		   <xsl:for-each select="PointType">
			   <xsl:call-template name="PointType"></xsl:call-template>
		   </xsl:for-each>
		</td>
        <td><xsl:apply-templates select="InputType" ></xsl:apply-templates></td>
		<td colspan="2"><xsl:call-template name="Zone1_5" ></xsl:call-template></td>
    </tr>

	<tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
		<th>Delay Mode</th>
		<xsl:choose>
			<xsl:when test="DeviceType = '8'">
			</xsl:when>
			<xsl:otherwise>
        	<th>Wiring Type</th>
			</xsl:otherwise>
		</xsl:choose>
	</tr>

	<tr style="font-size:12px; font-weight:normal; color:blue;">
		<td>
			<xsl:for-each select="DelayMode">
			<xsl:call-template name="DelayMode"></xsl:call-template>
			</xsl:for-each>
		</td>
		<xsl:choose>
		<xsl:when test="DeviceType = '8'">
		</xsl:when>
		<xsl:otherwise>
			<td>
				<xsl:apply-templates select="WiringType" ></xsl:apply-templates>
			</td>
		</xsl:otherwise>
		</xsl:choose>
	</tr>
</xsl:template>

<xsl:template name="DEV_NAC_MOD">
	<!-- table column count == 9 -->
	<tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
		<th>Address</th>
		<th>Device Type</th>
		<th colspan="2">Label</th>
		<th>Bypassed</th>
		<th>Silenceable</th>
		<th colspan="2">Zones</th>
		<th>Pattern</th>
	</tr>
	<tr style="font-size:12px; font-weight:normal; color:blue;">
		<td><xsl:value-of select="Address"></xsl:value-of></td>
		<td><xsl:apply-templates select="DeviceType"></xsl:apply-templates></td>
		<td colspan="2"><xsl:value-of select="Label"></xsl:value-of></td>
		<td><xsl:value-of select="Bypassed"></xsl:value-of></td>
		<td><xsl:value-of select="Drillenceable"></xsl:value-of></td>
		<td colspan="2"><xsl:call-template name="OutputZone1_5"></xsl:call-template></td>
		<td><xsl:value-of select="Pattern"></xsl:value-of></td>
	</tr>
</xsl:template>

<xsl:template name="DEV_BASE_SND">
	<tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
		<th>Address</th>
		<th>Device Type</th>
		<th colspan="2">Label</th>
		<th>Bypassed</th>
		<th>Silenceable</th>
		<th>Zone</th>
		<th>Pattern</th>
		<th>Activated By Host</th>
	</tr>
	<tr style="font-size:12px; font-weight:normal; color:blue;">
		<td><xsl:value-of select="Address"></xsl:value-of></td>
		<td><xsl:apply-templates select="DeviceType"></xsl:apply-templates></td>
		<td colspan="2"><xsl:value-of select="Label"></xsl:value-of></td>
		<td><xsl:value-of select="Bypassed"></xsl:value-of></td>
		<td><xsl:value-of select="Drillenceable"></xsl:value-of></td>
		<td><xsl:value-of select="Zone1"></xsl:value-of></td>
		<td><xsl:value-of select="Pattern"></xsl:value-of></td>
		<td><xsl:value-of select="ActivatedbyHost"></xsl:value-of></td>
	</tr>    
</xsl:template>

<xsl:template name="DEV_RELAY_MOD">
    <xsl:choose>
        <xsl:when test="DeviceType = '17'">
            <xsl:call-template name="DEV_RELAY_MOD_SINGLE"></xsl:call-template>
        </xsl:when>
        <xsl:otherwise>
            <xsl:call-template name="DEV_RELAY_MOD_DUAL"></xsl:call-template>
        </xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template name="DEV_RELAY_MOD_DUAL">
    <tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th>Address</th>
        <th>Device Type</th>
        <th colspan="2">Device Label</th>
        <th colspan="5"></th>
    </tr>
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <td><xsl:value-of select="Address" ></xsl:value-of></td>
        <td><xsl:apply-templates select="DeviceType"></xsl:apply-templates></td>
        <td colspan="2"><xsl:value-of select="Label" ></xsl:value-of></td>
        <td colspan="5"></td>
    </tr>
    <xsl:for-each select="Relay1">
    <tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
		<th style="background-color:white;" rowspan="2"></th>
        <th style="color:blue; background-color:white;" rowspan="2">Relay 1</th>
        <th colspan="2">Label</th>
        <th>Bypassed</th>
        <th>Drillable</th>
        <th colspan="2">Zones</th>
        <th>Sequential</th>
    </tr>
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <!-- <td colspan="2"></td> -->
        <td colspan="2"><xsl:value-of select="Label" ></xsl:value-of></td>
        <td><xsl:value-of select="Bypassed" ></xsl:value-of></td>
        <td><xsl:value-of select="Drillenceable" ></xsl:value-of></td>
        <td colspan="2"><xsl:call-template name="OutputZone1_5" ></xsl:call-template></td>
        <td><xsl:value-of select="Sequential" ></xsl:value-of></td>
    </tr>
    </xsl:for-each>
    <xsl:for-each select="Relay2">
    <tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th style="background-color:white;" rowspan="2"></th>
		<th style="color:blue; background-color:white;" rowspan="2">Relay 2</th>
        <th colspan="2">Label</th>
        <th>Bypassed</th>
        <th>Drillable</th>
        <th colspan="2">Zones</th>
        <th>Sequential</th>
    </tr>
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <!-- <td colspan="2"></td> -->
        <td colspan="2"><xsl:value-of select="Label" ></xsl:value-of></td>
        <td><xsl:value-of select="Bypassed" ></xsl:value-of></td>
        <td><xsl:value-of select="Drillenceable" ></xsl:value-of></td>
        <td colspan="2"><xsl:call-template name="OutputZone1_5" ></xsl:call-template></td>
        <td><xsl:value-of select="Sequential" ></xsl:value-of></td>
    </tr>
    </xsl:for-each>
</xsl:template>

<xsl:template name="DEV_RELAY_MOD_SINGLE">
    <tr style="color:#000000; background-color:#CCCCCC; font-weight:bold; font-size:12px;">
        <th>Address</th>
        <th>Device Type</th>
        <th colspan="2">Label</th>
        <th>Bypassed</th>
        <th>Drillable</th>
        <th colspan="2">Zones</th>
        <th>Sequential</th>
    </tr>
    <tr style="font-size:12px; font-weight:normal; color:blue;">
        <td><xsl:value-of select="Address" ></xsl:value-of></td>
        <td><xsl:apply-templates select="DeviceType" ></xsl:apply-templates></td>
        <td colspan="2"><xsl:value-of select="Label" ></xsl:value-of></td>
        <td><xsl:value-of select="Bypassed" ></xsl:value-of></td>
        <td><xsl:value-of select="Drillenceable" ></xsl:value-of></td>
		<td colspan="2"><xsl:call-template name="OutputZone1_5"></xsl:call-template></td>
        <td><xsl:value-of select="Sequential"></xsl:value-of></td>
	</tr>
</xsl:template>

<xsl:template match="Topology" >
    <xsl:choose>
        <xsl:when test=". = 0"><xsl:text>class</xsl:text> <xsl:text>A</xsl:text></xsl:when>
        <xsl:when test=". = 1"><xsl:text>1 x </xsl:text> <xsl:text>class</xsl:text> <xsl:text>B</xsl:text></xsl:when>
        <xsl:when test=". = 2"><xsl:text>2 x </xsl:text> <xsl:text>class</xsl:text> <xsl:text>B</xsl:text></xsl:when>
        <xsl:otherwise><xsl:text>Invalid Topology Type</xsl:text></xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="DeviceType">
    <xsl:choose>
        <xsl:when test=". = '2'">SLC</xsl:when>
        <xsl:when test=". = '3'">FAP-325</xsl:when>
        <xsl:when test=". = '4'">FAD-325</xsl:when>
        <xsl:when test=". = '5'">FAH-325</xsl:when>
        <xsl:when test=". = '6'">FAI-325</xsl:when>
        <xsl:when test=". = '7'">FAP-325-T</xsl:when>
        <xsl:when test=". = '8'">FLM-325-I4</xsl:when>
        <xsl:when test=". = '9'">FMM-325-A</xsl:when>
        <xsl:when test=". = '10'">FLM-325-CZM4</xsl:when>
        <xsl:when test=". = '11'">FLM-325-2I4</xsl:when>
        <xsl:when test=". = '12'">FLM-325-2R4</xsl:when>
        <xsl:when test=". = '13'">FLM-325-N4</xsl:when>
        <xsl:when test=". = '14'">FLM-325-NA4</xsl:when>
        <xsl:when test=". = '15'">FLM-325-NAI4</xsl:when>
        <xsl:when test=". = '16'">FAA-325-B6S</xsl:when>
        <xsl:when test=". = '17'">D328A</xsl:when>
        <xsl:when test=". = '18'">FLM-325-I4-A</xsl:when>
        <xsl:when test=". = '19'">FLM-325-I4-AI</xsl:when>
        <xsl:when test=". = '20'">FLM-325-IW-A</xsl:when>
        <xsl:when test=". = '21'">FLM-325-IW-AI</xsl:when>
        <xsl:when test=". = '22'">FLM-325-2R4-2A</xsl:when>
        <xsl:when test=". = '23'">FLM-325-2R4-2AI</xsl:when>
        <xsl:when test=". = '24'">FLM-325-2R4-8A</xsl:when>
        <xsl:when test=". = '25'">FLM-325-2R4-8AI</xsl:when>   
        <xsl:when test=". = '26'">FAD-325-DH</xsl:when>
        <xsl:when test=". = '27'">FAP-325-V2</xsl:when>
        <xsl:when test=". = '28'">FMM-325A-D</xsl:when>
		<xsl:when test=". = '29'">FAH-440</xsl:when>
        <xsl:when test=". = '30'">FAP-440-T</xsl:when>
        <xsl:when test=". = '31'">FAP-440-TC</xsl:when>
        <xsl:when test=". = '32'">FAP-440</xsl:when>
        <xsl:when test=". = '33'">FAD-440-DH</xsl:when>   
        <xsl:when test=". = '34'">FAP-440-D</xsl:when>
        <xsl:when test=". = '35'">FAP-440-DT</xsl:when>
        <xsl:when test=". = '36'">FAP-440-DTC</xsl:when>
    </xsl:choose>
</xsl:template>

<xsl:template name="DelayMode" >
    <xsl:choose>
        <xsl:when test=". = 0"><xsl:text>No Delay</xsl:text></xsl:when>
        <xsl:when test=". = 1"><xsl:text>Alarm Verification</xsl:text></xsl:when>
        <xsl:when test=". = 2"><xsl:text>PAS/Presignal</xsl:text></xsl:when>
        <xsl:when test=". = 3"><xsl:text>PAS(day)/AV(night)</xsl:text></xsl:when>
        <xsl:otherwise><xsl:text>Invalid Delay Mode</xsl:text></xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template name="TP_Sensitivity">
	<xsl:choose>
		<xsl:when test="DeviceType = '5'">
			<xsl:for-each select="Sensitivity">
				<xsl:call-template name="TemperatureSensitivity"></xsl:call-template>
			</xsl:for-each>
		</xsl:when>
		<xsl:otherwise>
			<xsl:for-each select="Sensitivity|SmokeSensitivity">
				<xsl:call-template name="LengthSensitivity"></xsl:call-template>
			</xsl:for-each>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>

<xsl:template name="TP_DaySensitivity">
	<xsl:choose>
		<xsl:when test="DeviceType = '5'">
			<xsl:for-each select="DaySensitivity">
				<xsl:call-template name="TemperatureSensitivity"></xsl:call-template>
			</xsl:for-each>
		</xsl:when>
		<xsl:otherwise>
			<xsl:for-each select="DaySensitivity|SmokeDaySensitivity">
				<xsl:call-template name="LengthSensitivity"></xsl:call-template>
			</xsl:for-each>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>

<xsl:template name="TemperatureSensitivity">
    <xsl:choose>
	    	<xsl:when test=". = 0">135&#176;F/57&#176;C</xsl:when>
        	<xsl:when test=". = 1">137&#176;F/58&#176;C</xsl:when>
        	<xsl:when test=". = 2">139&#176;F/59&#176;C</xsl:when>
        	<xsl:when test=". = 3">141&#176;F/61&#176;C</xsl:when>
        	<xsl:when test=". = 4">143&#176;F/62&#176;C</xsl:when>
        	<xsl:when test=". = 5">145&#176;F/63&#176;C</xsl:when>
        	<xsl:when test=". = 6">147&#176;F/64&#176;C</xsl:when>
        	<xsl:when test=". = 7">149&#176;F/65&#176;C</xsl:when>
        	<xsl:when test=". = 8">150&#176;F/66&#176;C</xsl:when>
        	<xsl:otherwise></xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template name="FixSensitivity">
    <xsl:choose>
	    	<xsl:when test=". = 0">135&#176;F/57&#176;C ROR enabled</xsl:when>
        	<xsl:otherwise></xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template name="LengthSensitivity">
    <xsl:choose>
	    	<xsl:when test=". = 0">0.90%/ft, 2.95%/m</xsl:when>
        	<xsl:when test=". = 1">1.00%/ft, 3.30%/m</xsl:when>
        	<xsl:when test=". = 2">1.25%/ft, 4.10%/m</xsl:when>
        	<xsl:when test=". = 3">1.50%/ft, 4.90%/m</xsl:when>
        	<xsl:when test=". = 4">1.75%/ft, 5.75%/m</xsl:when>
        	<xsl:when test=". = 5">2.00%/ft, 6.55%/m</xsl:when>
        	<xsl:when test=". = 6">2.25%/ft, 7.40%/m</xsl:when>
        	<xsl:when test=". = 7">2.50%/ft, 8.20%/m</xsl:when>
        	<xsl:when test=". = 8">2.75%/ft, 9.00%/m</xsl:when>
			<xsl:when test=". = 9">3.00%/ft, 9.85%/m</xsl:when>
			<xsl:when test=". = 10">3.25%/ft, 10.65%/m</xsl:when>
			<xsl:when test=". = 11">3.50%/ft, 11.50%/m</xsl:when>
        	<xsl:otherwise></xsl:otherwise>
    </xsl:choose>
</xsl:template>



<xsl:template match="InputType" >
    <xsl:choose>
        <xsl:when test=". = 0"><xsl:text>NO with EOL</xsl:text></xsl:when>
        <xsl:when test=". = 1"><xsl:text>NC with EOL</xsl:text></xsl:when>
        <xsl:when test=". = 2"><xsl:text>NC w/o EOL</xsl:text></xsl:when>
        <xsl:otherwise><xsl:text>Invalid Input Type</xsl:text></xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="WiringType" >
    <xsl:choose>
        <xsl:when test=". = 0"><xsl:text>Class B</xsl:text></xsl:when>
        <xsl:when test=". = 1"><xsl:text>Class A</xsl:text></xsl:when>
        <xsl:otherwise><xsl:text>Invalid Wiring Type</xsl:text></xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="Bypassed|Drillenceable" >
    <xsl:choose>
        <xsl:when test=". = FALSE"><xsl:text>Disabled</xsl:text></xsl:when>
        <xsl:when test=". = TRUE"><xsl:text>Enabled</xsl:text></xsl:when>
        <xsl:otherwise><xsl:text>No Status</xsl:text></xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template name="Zone1_5">
	<xsl:value-of select="PID1"/>-<xsl:value-of select="Zone1"/><xsl:text>,</xsl:text>
	<xsl:value-of select="PID2"/>-<xsl:value-of select="Zone2"/><xsl:text>,</xsl:text>
	<xsl:value-of select="PID3"/>-<xsl:value-of select="Zone3"/><xsl:text>,</xsl:text>
	<xsl:value-of select="PID4"/>-<xsl:value-of select="Zone4"/><xsl:text>,</xsl:text>
	<xsl:value-of select="PID5"/>-<xsl:value-of select="Zone5"/>
</xsl:template>

<xsl:template name="OutputZone1_5">
	<xsl:value-of select="Zone1"/><xsl:text>-</xsl:text>
	<xsl:value-of select="Zone2"/><xsl:text>-</xsl:text>
	<xsl:value-of select="Zone3"/><xsl:text>-</xsl:text>
	<xsl:value-of select="Zone4"/><xsl:text>-</xsl:text>
	<xsl:value-of select="Zone5"/>
</xsl:template>

<!-- need improvement to remove the RelayZone1_5 -->
<xsl:template name="Zone1_5Pre">
	<xsl:choose>
	<xsl:when test="Zone1/pre" >
		<xsl:value-of select="Zone1/pre"/><xsl:text>-</xsl:text>
	</xsl:when>
	<xsl:otherwise></xsl:otherwise>
	</xsl:choose>
	<xsl:choose>
	<xsl:when test="Zone2/pre" >
		<xsl:value-of select="Zone2/pre" /><xsl:text>-</xsl:text>
	</xsl:when>
	<xsl:otherwise></xsl:otherwise>
	</xsl:choose>
	<xsl:choose>
	<xsl:when test="Zone3/pre" >
		<xsl:value-of select="Zone3/pre"/><xsl:text>-</xsl:text>
	</xsl:when>
	<xsl:otherwise></xsl:otherwise>
	</xsl:choose>
	<xsl:choose>
	<xsl:when test="Zone4/pre" >
		<xsl:value-of select="Zone4/pre"/><xsl:text>-</xsl:text>
	</xsl:when>
	<xsl:otherwise></xsl:otherwise>
	</xsl:choose>
	<xsl:choose>
	<xsl:when test="Zone5/pre" >
		<xsl:value-of select="Zone5/pre" />
	</xsl:when>
	<xsl:otherwise></xsl:otherwise>
	</xsl:choose>
</xsl:template>

<xsl:template name="Zone1_5Post">
	<xsl:choose>
	<xsl:when test="Zone1/post" >
		<xsl:value-of select="Zone1/post"/><xsl:text>-</xsl:text>
	</xsl:when>
	<xsl:otherwise></xsl:otherwise>
	</xsl:choose>
	<xsl:choose>
	<xsl:when test="Zone2/post" >
		<xsl:value-of select="Zone2/post" /><xsl:text>-</xsl:text>
	</xsl:when>
	<xsl:otherwise></xsl:otherwise>
	</xsl:choose>
	<xsl:choose>
	<xsl:when test="Zone3/post" >
		<xsl:value-of select="Zone3/post"/><xsl:text>-</xsl:text>
	</xsl:when>
	<xsl:otherwise></xsl:otherwise>
	</xsl:choose>
	<xsl:choose>
	<xsl:when test="Zone4/post" >
		<xsl:value-of select="Zone4/post"/><xsl:text>-</xsl:text>
	</xsl:when>
	<xsl:otherwise></xsl:otherwise>
	</xsl:choose>
	<xsl:choose>
	<xsl:when test="Zone5/post" >
		<xsl:value-of select="Zone5/post" />
	</xsl:when>
	<xsl:otherwise></xsl:otherwise>
	</xsl:choose>
</xsl:template>

<xsl:template name="RelayZone1_5">
	<xsl:call-template name="OutputZone1_5"/>
</xsl:template>


<xsl:template match="Relay1|Relay2" >
        Relay1,Relay2 Settings[
        Label:<xsl:value-of select="Label" /> 
        Zones:<xsl:call-template name="Zone1_5" />
        Bypassed: <xsl:value-of select="Bypassed" />
        Energized in Normal:<xsl:value-of select="ENormal" /> 
        Drillable:<xsl:value-of select="Drillenceable" />
        ]<br/>
</xsl:template>

<xsl:template match="DuctRelay">
        Duct Relay Settings[
        Label:<xsl:value-of select="Label" /> 
        Zones:<xsl:call-template name="Zone1_5" />
        Bypassed:<xsl:value-of select="Bypassed" />
    ]<br/>
</xsl:template>

<xsl:template match="Input1|Input2" >
    Input1, Input2 Settings[
        Label:<xsl:value-of select="Label" />
        Zones:<xsl:call-template name="Zone1_5" />
        Bypassed:<xsl:value-of select="Bypassed" /> 
        Point Type:><xsl:call-template name="PointType" /> 
        Input Type:<xsl:apply-templates select="InputType" />
    ]<br/>
</xsl:template>

<xsl:template name="PointType">
    <xsl:choose>
        <xsl:when test=". = 0"><xsl:text>Fire automatic</xsl:text></xsl:when>
        <xsl:when test=". = 1"><xsl:text>Fire alarm manual</xsl:text></xsl:when>
        <xsl:when test=". = 2"><xsl:text>Waterflow</xsl:text></xsl:when>
        <xsl:when test=". = 3"><xsl:text>Waterflow delay</xsl:text></xsl:when>
        <xsl:when test=". = 4"><xsl:text>Gas alarm</xsl:text></xsl:when>
        <xsl:when test=". = 5"><xsl:text>Supervisory</xsl:text></xsl:when>
        <xsl:when test=". = 6"><xsl:text>Generic</xsl:text></xsl:when>
        <xsl:when test=". = 7"><xsl:text>Trouble</xsl:text></xsl:when>
        <xsl:when test=". = 8"><xsl:text>AC Failure</xsl:text></xsl:when>
        <xsl:when test=". = 9"><xsl:text>Battery Failure</xsl:text></xsl:when>
        <xsl:when test=". = 10"><xsl:text>Reset</xsl:text></xsl:when>
        <xsl:when test=". = 11"><xsl:text>Silence</xsl:text></xsl:when>
        <xsl:when test=". = 12"><xsl:text>Drill</xsl:text></xsl:when>
        <xsl:when test=". = 13"><xsl:text>Acknowledge</xsl:text></xsl:when>
		<xsl:when test=". = 14"><xsl:text>Alarm General</xsl:text></xsl:when>
    </xsl:choose>
</xsl:template>

<xsl:template name="WorkingMode">
    <xsl:choose>
        <xsl:when test=". = 0"><xsl:text>Multi-combined</xsl:text></xsl:when>
        <xsl:when test=". = 1"><xsl:text>Multi-separated</xsl:text></xsl:when>
    </xsl:choose>
</xsl:template>

<xsl:template name="Week">
		<xsl:choose>
            <xsl:when test=". = 1"><xsl:text>1st</xsl:text></xsl:when>
            <xsl:when test=". = 2"><xsl:text>2nd</xsl:text></xsl:when>
			<xsl:when test=". = 3"><xsl:text>3rd</xsl:text></xsl:when>
            <xsl:when test=". = 4"><xsl:text>4th</xsl:text></xsl:when>
			<xsl:when test=". = 5"><xsl:text>last</xsl:text></xsl:when>
        </xsl:choose>
</xsl:template>

<xsl:template name="Month">
   		<xsl:choose>
            <xsl:when test=". = 1"><xsl:text>January</xsl:text></xsl:when>
            <xsl:when test=". = 2"><xsl:text>February</xsl:text></xsl:when>
			<xsl:when test=". = 3"><xsl:text>March</xsl:text></xsl:when>
            <xsl:when test=". = 4"><xsl:text>April</xsl:text></xsl:when>
			<xsl:when test=". = 5"><xsl:text>May</xsl:text></xsl:when>
			<xsl:when test=". = 6"><xsl:text>June</xsl:text></xsl:when>
            <xsl:when test=". = 7"><xsl:text>July</xsl:text></xsl:when>
			<xsl:when test=". = 8"><xsl:text>August</xsl:text></xsl:when>
            <xsl:when test=". = 9"><xsl:text>September</xsl:text></xsl:when>
			<xsl:when test=". = 10"><xsl:text>October</xsl:text></xsl:when>
			<xsl:when test=". = 11"><xsl:text>November</xsl:text></xsl:when>
			<xsl:when test=". = 12"><xsl:text>December</xsl:text></xsl:when>
        </xsl:choose>
</xsl:template>

<xsl:template match="MAINBOARD" >
    <table border="1" style="color:black; width:800px; left:50px;">
        <tr>
            <th colspan="9" style=" background-color:black; color:white; font-weight:bold; font-size:14px; text-align:center; ">Mainboard</th>
        </tr>
        <tr>
            <td colspan="9" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">Relays</td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Relays</td>
            <td style="font-size:12px; font-weight:bold;">Relay Type</td>
            <td style="font-size:12px; font-weight:bold;">Zones</td>
            <td style="font-size:12px; font-weight:bold;">Drillable</td>
			<td style="font-size:12px; font-weight:bold;">Ext. signaling</td>
            <td style="font-size:12px; font-weight:bold;">Bypassed</td>
            <td style="font-size:12px; font-weight:bold;">ENormal</td>
            <td style="font-size:12px; font-weight:bold;">Sequential</td>
            <td style="font-size:12px; font-weight:bold;">Label</td>
        </tr>
        
        <xsl:for-each select="Relay1">
        <tr style="font-size:12px; font-weight:normal; color:blue;">
            <td style="color:black;">Relay 1</td>
            <td><xsl:for-each select="RelayType/pre">
                    <xsl:call-template name="MAINBOARD_RELAYTYPE"/>
                </xsl:for-each></td>
            <td><xsl:call-template name="Zone1_5Pre" /></td>
            <td><xsl:value-of select="Drillenceable/pre" /></td>
			<td><xsl:value-of select="Silenceable/pre" /></td>
            <td><xsl:value-of select="Bypassed/pre" /></td>
            <td><xsl:value-of select="ENormal/pre" /></td>
            <td><xsl:value-of select="Sequential/pre" /></td>
            <td><xsl:value-of select="Label/pre" /></td>
        </tr>
		<tr style="font-size:12px; background-color:yellow; font-weight:normal; color:red;">
            <td style="color:black;">Relay 1</td>
            <td><xsl:for-each select="RelayType/post">
                    <xsl:call-template name="MAINBOARD_RELAYTYPE"/>
                </xsl:for-each></td>
            <td><xsl:call-template name="Zone1_5Post" /></td>
            <td><xsl:value-of select="Drillenceable/post" /></td>
			<td><xsl:value-of select="Silenceable/post" /></td>
            <td><xsl:value-of select="Bypassed/post" /></td>
            <td><xsl:value-of select="ENormal/post" /></td>
            <td><xsl:value-of select="Sequential/post" /></td>
            <td><xsl:value-of select="Label/post" /></td>
        </tr>
        </xsl:for-each>
        
        <xsl:for-each select="Relay2">
		<tr style="font-size:12px; font-weight:normal; color:blue;">
            <td style="color:black;">Relay 2</td>
            <td><xsl:for-each select="RelayType/pre">
                <xsl:call-template name="MAINBOARD_RELAYTYPE"/>
                </xsl:for-each></td>
            <td><xsl:call-template name="Zone1_5Pre" /></td>
            <td><xsl:value-of select="Drillenceable/pre" /></td>
			<td><xsl:value-of select="Silenceable/pre" /></td>
            <td><xsl:value-of select="Bypassed/pre" /></td>
            <td><xsl:value-of select="ENormal/pre" /></td>
            <td><xsl:value-of select="Sequential/pre" /></td>
            <td><xsl:value-of select="Label/pre" /></td>
        </tr>
		<tr style=" background-color:yellow; font-size:12px; font-weight:normal; color:red;">
            <td style="color:black;">Relay 2</td>
            <td><xsl:for-each select="RelayType/post">
                <xsl:call-template name="MAINBOARD_RELAYTYPE"/>
                </xsl:for-each></td>
            <td><xsl:call-template name="Zone1_5Post" /></td>
            <td><xsl:value-of select="Drillenceable/post" /></td>
			<td><xsl:value-of select="Silenceable/post" /></td>
            <td><xsl:value-of select="Bypassed/post" /></td>
            <td><xsl:value-of select="ENormal/post" /></td>
            <td><xsl:value-of select="Sequential/post" /></td>
            <td><xsl:value-of select="Label/post" /></td>
        </tr>
        </xsl:for-each>
        
        <xsl:for-each select="Relay3">
		<tr style="font-size:12px; font-weight:normal; color:blue;">
            <td style="color:black;">Relay 3</td>
            <td><xsl:for-each select="RelayType/pre">
                    <xsl:call-template name="MAINBOARD_RELAYTYPE"/>
                </xsl:for-each></td>
            <td><xsl:call-template name="Zone1_5Pre" /></td>
            <td><xsl:value-of select="Drillenceable/pre" /></td>
			<td><xsl:value-of select="Silenceable/pre" /></td>
            <td><xsl:value-of select="Bypassed/pre" /></td>
            <td><xsl:value-of select="ENormal/pre" /></td>
            <td><xsl:value-of select="Sequential/pre" /></td>
            <td><xsl:value-of select="Label/pre" /></td>
        </tr>
		<tr style="font-size:12px; background-color:yellow; font-weight:normal; color:red;">
            <td style="color:black;">Relay 3</td>
            <td><xsl:for-each select="RelayType/post">
                    <xsl:call-template name="MAINBOARD_RELAYTYPE"/>
                </xsl:for-each></td>
            <td><xsl:call-template name="Zone1_5Post" /></td>
            <td><xsl:value-of select="Drillenceable/post" /></td>
			<td><xsl:value-of select="Silenceable/post" /></td>
            <td><xsl:value-of select="Bypassed/post" /></td>
            <td><xsl:value-of select="ENormal/post" /></td>
            <td><xsl:value-of select="Sequential/post" /></td>
            <td><xsl:value-of select="Label/post" /></td>
        </tr>
		</xsl:for-each>
    </table>    
    
    <table border="1" style="color:black; width:800px; left:50px;">
        <tr align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">
            <td colspan="6" style="background:#CCCCCC; font-size:12px; font-weight:bold;">NACs</td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">NACs</td>
            <td style="font-size:12px; font-weight:bold;">Pattern</td>
            <td style="font-size:12px; font-weight:bold;">Zones</td>
            <td style="font-size:12px; font-weight:bold;">Silence</td>
            <td style="font-size:12px; font-weight:bold;">Bypassed</td>
            <td style="font-size:12px; font-weight:bold;">Label</td>
        </tr>
		<xsl:choose>
		<xsl:when test="./NAC1/Pattern/pre|./NAC1/Bypassed/pre|./NAC1/Label/pre|./NAC1/Drillenceable/pre|./NAC1/Silenceable/pre|./NAC1/Zone1/pre|./NAC1/Zone2/pre|./NAC1/Zone3/pre|./NAC1/Zone4/pre|./NAC1/Zone5/pre">
        <tr style="font-size:12px; font-weight:normal; color:blue;">
            <td style="color:black;">NAC 1</td>    
            <xsl:for-each select="NAC1">
                <xsl:call-template name="MAINBOARD_NACSPre" />
            </xsl:for-each>
        </tr>
		<tr style="font-size:12px; background-color:yellow; font-weight:normal; color:red;">
            <td style="color:black;">NAC 1</td>    
            <xsl:for-each select="NAC1">
                <xsl:call-template name="MAINBOARD_NACSPost" />
            </xsl:for-each>
        </tr>
		</xsl:when>
		</xsl:choose>
		<xsl:choose>
		<xsl:when test="./NAC2/Pattern/pre|./NAC2/Bypassed/pre|./NAC2/Label/pre|./NAC2/Pattern/pre|./NAC2/Silenceable/pre|./NAC2/Zone1/pre|./NAC2/Zone2/pre|./NAC2/Zone3/pre|./NAC2/Zone4/pre|./NAC2/Zone5/pre">
        <tr style="font-size:12px; font-weight:normal; color:blue;">
            <td style="color:black;">NAC 2</td>
            <xsl:for-each select="NAC2">
                <xsl:call-template name="MAINBOARD_NACSPre" />
            </xsl:for-each>
        </tr>
		<tr style="font-size:12px; background-color:yellow; font-weight:normal; color:red;">
            <td style="color:black;">NAC 2</td>
            <xsl:for-each select="NAC2">
                <xsl:call-template name="MAINBOARD_NACSPost" />
            </xsl:for-each>
        </tr>
		</xsl:when>
		</xsl:choose>
    </table>
    
    <table border="1" style="color:black; width:800px; left:50px;">
        <tr align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">
            <td colspan="6" style="background:#CCCCCC; font-size:12px; font-weight:bold;">City Tie</td>
        </tr>
        <tr>
            <td colspan="1" style="font-size:12px; font-weight:bold; color:black;">
                City Tie Installed:</td>
			<td colspan="2" style="font-size:12px; font-weight:normal; color:blue;"> 
				<xsl:value-of select="CityTie/Installed/pre" /></td>
			<td colspan="3" style="font-size:12px; background-color:yellow; font-weight:normal; color:red;"> 
				<xsl:value-of select="CityTie/Installed/post" /></td>
        </tr>
		 <tr>
            <td colspan="1" style="font-size:12px; font-weight:bold;">Activated by events from: </td>
			<td colspan="2" style="font-size:12px; font-weight:normal; color:blue;" >
                    <xsl:apply-templates select="CityTie/CityTieWide/pre"></xsl:apply-templates></td>
			<td colspan="3" style="font-size:12px; background-color:yellow; font-weight:normal; color:red;" >
                    <xsl:apply-templates select="CityTie/CityTieWide/post"></xsl:apply-templates></td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">City Tie</td>
            <td style="font-size:12px; font-weight:bold;">Disabled</td>
            <td style="font-size:12px; font-weight:bold;">Type</td>
            <td style="font-size:12px; font-weight:bold;">Bypassed</td>
            <td style="font-size:12px; font-weight:bold;">Silenceable</td>
            <td style="font-size:12px; font-weight:bold;">Label</td>
        </tr>
        <xsl:for-each select="CityTie/CityTie1">
        <tr>
            <td style="font-size:12px; font-weight:normal;">City Tie 1</td>
            <td style="font-size:12px; font-weight:normal; color:blue;">
                <xsl:if test="TieMode/pre = 2"><xsl:text>TRUE</xsl:text></xsl:if>
				<xsl:if test="TieMode/pre = 1"><xsl:text>FALSE</xsl:text></xsl:if>
                <xsl:if test="TieMode/pre = 0"><xsl:text>FALSE</xsl:text></xsl:if></td>
            <td style="font-size:12px; font-weight:normal; color:blue;">
                <xsl:for-each select="RelayType/pre">
                    <xsl:call-template name="CITYTIE_RELAYTYPE"/>
                </xsl:for-each></td>
            <td style="font-size:12px; font-weight:normal; color:blue;">
                <xsl:value-of select="Bypassed/pre" /></td>
            <td style="font-size:12px; font-weight:normal; color:blue;">
                <xsl:value-of select="Silenceable/pre" /></td>
            <td style="font-size:12px; font-weight:normal; color:blue;">
                <xsl:value-of select="Label/pre" /></td>
        </tr>
		<tr style="background-color:yellow;">
            <td style="font-size:12px; font-weight:normal;">City Tie 1</td>
            <td style="font-size:12px; font-weight:normal; color:red;">
                <xsl:if test="TieMode/post = 2"><xsl:text>TRUE</xsl:text></xsl:if>
				<xsl:if test="TieMode/post = 1"><xsl:text>FALSE</xsl:text></xsl:if>
                <xsl:if test="TieMode/post = 0"><xsl:text>FALSE</xsl:text></xsl:if></td>
            <td style="font-size:12px; font-weight:normal; color:red;">
                <xsl:for-each select="RelayType/post">
                    <xsl:call-template name="CITYTIE_RELAYTYPE"/>
                </xsl:for-each></td>
            <td style="font-size:12px; font-weight:normal; color:red;">
                <xsl:value-of select="Bypassed/post" /></td>
            <td style="font-size:12px; font-weight:normal; color:red;">
                <xsl:value-of select="Silenceable/post" /></td>
            <td style="font-size:12px; font-weight:normal; color:red;">
                <xsl:value-of select="Label/post" /></td>
        </tr>
        </xsl:for-each>
        <xsl:for-each select="CityTie/CityTie2">
        <tr>
            <td style="font-size:12px; font-weight:normal;">City Tie 2</td>
            <td style="font-size:12px; font-weight:normal; color:blue;">
                <xsl:if test="TieMode/pre = 2"><xsl:text>TRUE</xsl:text></xsl:if>
				<xsl:if test="TieMode/pre = 1"><xsl:text>FALSE</xsl:text></xsl:if>
                <xsl:if test="TieMode/pre = 0"><xsl:text>FALSE</xsl:text></xsl:if></td>
            <td style="font-size:12px; font-weight:normal; color:blue;">
                <xsl:for-each select="RelayType/pre">
                    <xsl:call-template name="CITYTIE_RELAYTYPE"/>
                </xsl:for-each></td>
            <td style="font-size:12px; font-weight:normal; color:blue;">
                <xsl:value-of select="Bypassed/pre" /></td>
            <td style="font-size:12px; font-weight:normal; color:blue;">
                <xsl:value-of select="Silenceable/pre" /></td>
            <td style="font-size:12px; font-weight:normal; color:blue;">
                <xsl:value-of select="Label/pre" /></td>
        </tr>
		<tr style="background-color:yellow;">
            <td style="font-size:12px; font-weight:normal;">City Tie 2</td>
            <td style="font-size:12px; font-weight:normal; color:red;">
                <xsl:if test="TieMode/post = 2"><xsl:text>TRUE</xsl:text></xsl:if>
				<xsl:if test="TieMode/post = 1"><xsl:text>FALSE</xsl:text></xsl:if>
                <xsl:if test="TieMode/post = 0"><xsl:text>FALSE</xsl:text></xsl:if></td>
            <td style="font-size:12px; font-weight:normal; color:red;">
                <xsl:for-each select="RelayType/post">
                    <xsl:call-template name="CITYTIE_RELAYTYPE"/>
                </xsl:for-each></td>
            <td style="font-size:12px; font-weight:normal; color:red;">
                <xsl:value-of select="Bypassed/post" /></td>
            <td style="font-size:12px; font-weight:normal; color:red;">
                <xsl:value-of select="Silenceable/post" /></td>
            <td style="font-size:12px; font-weight:normal; color:red;">
                <xsl:value-of select="Label/post" /></td>
        </tr>
        </xsl:for-each>
    </table>            
</xsl:template>

<xsl:template name="CITYTIE_RELAYTYPE">
    <xsl:choose>
        <xsl:when test=". = 0"><xsl:text>Fire alarm</xsl:text></xsl:when>
        <xsl:when test=". = 1"><xsl:text>Trouble</xsl:text></xsl:when>
        <xsl:when test=". = 2"><xsl:text>Supervisory</xsl:text></xsl:when>
        <xsl:when test=". = 3"><xsl:text>Gas Alarm</xsl:text></xsl:when>
    </xsl:choose>
</xsl:template>

<xsl:template name="LED_ZoneRange">
    <xsl:choose>
        <xsl:when test=". = 'FALSE'"><xsl:text>Zone 1-128</xsl:text></xsl:when>
        <xsl:when test=". = 'TRUE'"><xsl:text>Zone 129-225</xsl:text></xsl:when>
    </xsl:choose>
</xsl:template>

<xsl:template name="MAINBOARD_NACSPre">
        <td style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:for-each select="Pattern/pre">
            	<xsl:call-template name="ID_MAINPATTERN" />
            </xsl:for-each></td>
        <td style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:call-template name="Zone1_5Pre" /></td>
        <td style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:value-of select="Drillenceable/pre" /></td>
        <td style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:value-of select="Bypassed/pre" /></td>
        <td style="font-size:12px; font-weight:normal; color:blue;">
            <xsl:value-of select="Label/pre" /></td>
</xsl:template>
<xsl:template name="MAINBOARD_NACSPost">
        <td style="font-size:12px; font-weight:normal; color:red;">
            <xsl:for-each select="Pattern/post">
            	<xsl:call-template name="ID_MAINPATTERN" />
            </xsl:for-each></td>
        <td style="font-size:12px; font-weight:normal; color:red;">
            <xsl:call-template name="Zone1_5Post" /></td>
        <td style="font-size:12px; font-weight:normal; color:red;">
            <xsl:value-of select="Drillenceable/post" /></td>
        <td style="font-size:12px; font-weight:normal; color:red;">
            <xsl:value-of select="Bypassed/post" /></td>
        <td style="font-size:12px; font-weight:normal; color:red;">
            <xsl:value-of select="Label/post" /></td>
</xsl:template>

<xsl:template name="MB_ANNs">
	<tr style="font-weight:normal; color:black;">
		<td>1</td>
		<td>Zone 1-8(129-136)</td>
		<td style="color:blue;"><xsl:value-of select="Ann1/D7030x/pre" /></td>
		<td style="color:red; background-color:yellow;"><xsl:value-of select="Ann1/D7030x/post" /></td>
		<td>Zone 9-16(137-144)</td>
		<td style="color:blue;"><xsl:value-of select="Ann1/D7032/pre" /></td>
		<td style="color:red; background-color:yellow;"><xsl:value-of select="Ann1/D7032/post" /></td>
		<td>5</td>
		<td>Zone 65-72(193-200)</td>
		<td style="color:blue;"><xsl:value-of select="Ann5/D7030x/pre" /></td>
		<td style="color:red; background-color:yellow;"><xsl:value-of select="Ann5/D7030x/post" /></td>
		<td>Zone 73-80(201-208)</td>
		<td style="color:blue;"><xsl:value-of select="Ann5/D7032/pre" /></td>
		<td style="color:red; background-color:yellow;"><xsl:value-of select="Ann5/D7032/post" /></td>
	</tr>
	<tr style="font-weight:normal; color:black;">
		<td>2</td>
		<td>Zone 17-24(145-152)</td>
		<td style="color:blue;"><xsl:value-of select="Ann2/D7030x/pre" /></td>
		<td style="color:red; background-color:yellow;"><xsl:value-of select="Ann2/D7030x/post" /></td>
		<td>Zone 25-32(153-160)</td>
		<td style="color:blue;"><xsl:value-of select="Ann2/D7032/pre" /></td>
		<td style="color:red; background-color:yellow;"><xsl:value-of select="Ann2/D7032/post" /></td>
		<td>6</td>
		<td>Zone 81-88(209-216)</td>
		<td style="color:blue;"><xsl:value-of select="Ann6/D7030x/pre" /></td>
		<td style="color:red; background-color:yellow;"><xsl:value-of select="Ann6/D7030x/post" /></td>
		<td>Zone 89-96(217-224)</td>
		<td style="color:blue;"><xsl:value-of select="Ann6/D7032/pre" /></td>
		<td style="color:red; background-color:yellow;"><xsl:value-of select="Ann6/D7032/post" /></td>
	</tr>
	<tr style="font-weight:normal; color:black;">
		<td>3</td>
		<td>Zone 33-41(161-168)</td>
		<td style="color:blue;"><xsl:value-of select="Ann3/D7030x/pre" /></td>
		<td style="color:red; background-color:yellow;"><xsl:value-of select="Ann3/D7030x/post" /></td>
		<td>Zone 42-49(169-176)</td>
		<td style="color:blue;"><xsl:value-of select="Ann3/D7032/pre" /></td>
		<td style="color:red; background-color:yellow;"><xsl:value-of select="Ann3/D7032/post" /></td>
		<td>7</td>
		<td>Zone 97-104(225)</td>
		<td style="color:blue;"><xsl:value-of select="Ann7/D7030x/pre" /></td>
		<td style="color:red; background-color:yellow;"><xsl:value-of select="Ann7/D7030x/post" /></td>
		<td>Zone 105-112</td>
		<td style="color:blue;"><xsl:value-of select="Ann7/D7032/pre" /></td>
		<td style="color:red; background-color:yellow;"><xsl:value-of select="Ann7/D7032/post" /></td>
	</tr>
	<tr style="font-weight:normal; color:black;">
		<td>4</td>
		<td>Zone 50-57(177-184)</td>
		<td style="color:blue;"><xsl:value-of select="Ann4/D7030x/pre" /></td>
		<td style="color:red; background-color:yellow;"><xsl:value-of select="Ann4/D7030x/post" /></td>
		<td>Zone 58-65(185-192)</td>
		<td style="color:blue;"><xsl:value-of select="Ann4/D7032/pre" /></td>
		<td style="color:red; background-color:yellow;"><xsl:value-of select="Ann4/D7032/post" /></td>
		<td>8</td>
		<td>Zone 113-120</td>
		<td style="color:blue;"><xsl:value-of select="Ann8/D7030x/pre" /></td>
		<td style="color:red; background-color:yellow;"><xsl:value-of select="Ann8/D7030x/post" /></td>
		<td>Zone 121-128</td>
		<td style="color:blue;"><xsl:value-of select="Ann8/D7032/pre" /></td>
		<td style="color:red; background-color:yellow;"><xsl:value-of select="Ann8/D7032/post" /></td>
	</tr>
</xsl:template>

<xsl:template match="OPTIONBUS">
	<table border="1" style="color:black; font-size:12px; width:800px; left:50px;">
        <tr>
            <th colspan="14" style="background-color:black; color:white; font-weight:bold; font-size:14px; text-align:center; ">Option Bus</th>
        </tr>
		<tr>
			<td colspan="14" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">LED Annunciators</td>
		</tr>
		<tr>
			<td style="color:blue;" colspan="7"><xsl:for-each select="RepeatLED1to4/pre">
					<xsl:call-template name="LED_ZoneRange" /></xsl:for-each></td>
			<td style="color:red; background-color:yellow;" colspan="7"><xsl:for-each select="RepeatLED1to4/post">
					<xsl:call-template name="LED_ZoneRange" /></xsl:for-each></td>
		</tr>
		<tr style="font-weight:bold; color:black;">
			<td width="6%">Address</td>
			<td width="22%" colspan="3">D7030X</td>
			<td width="22%" colspan="3">D7032</td>
			<td width="6%">Address</td>
			<td width="22%" colspan="3">D7030X</td>
			<td width="22%" colspan="3">D7032</td>
		</tr>
		<xsl:call-template name="MB_ANNs"></xsl:call-template>
	</table>
	
	<table border="1" style="color:black; width:800px; font-size:12px; left:50px;">
		<tr>
			<td colspan="16" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">LCD Annunciators/Command Centers (FMR-1000)</td>
		</tr>
		<tr></tr>
		<tr style="font-weight:bold;">
			<td>Address</td>
			<td colspan="2">Enabled</td>
			<td>Address</td>
			<td colspan="2">Enabled</td>
			<td>Address</td>
			<td colspan="2">Enabled</td>
			<td>Address</td>
			<td colspan="2">Enabled</td>
		</tr>
		<tr>
			<td>16</td>
			<td style="color:blue;"><xsl:value-of select="Ann16/pre" /></td>
			<td style="color:red; background-color:yellow;"><xsl:value-of select="Ann16/post" /></td>
			<td>17</td>
			<td style="color:blue;"><xsl:value-of select="Ann17/pre" /></td>
			<td style="color:red; background-color:yellow;"><xsl:value-of select="Ann17/post" /></td>
			<td>18</td>
			<td style="color:blue;"><xsl:value-of select="Ann18/pre" /></td>
			<td style="color:red; background-color:yellow;"><xsl:value-of select="Ann18/post" /></td>
			<td>19</td>
			<td style="color:blue;"><xsl:value-of select="Ann19/pre" /></td>
			<td style="color:red; background-color:yellow;"><xsl:value-of select="Ann19/post" /></td>
		</tr>
		<tr>
			<td>20</td>
			<td style="color:blue;"><xsl:value-of select="Ann20/pre" /></td>
			<td style="color:red; background-color:yellow;"><xsl:value-of select="Ann20/post" /></td>
			<td>21</td>
			<td style="color:blue;"><xsl:value-of select="Ann21/pre" /></td>
			<td style="color:red; background-color:yellow;"><xsl:value-of select="Ann21/post" /></td>
			<td>22</td>
			<td style="color:blue;"><xsl:value-of select="Ann22/pre" /></td>
			<td style="color:red; background-color:yellow;"><xsl:value-of select="Ann22/post" /></td>
			<td>23</td>
			<td style="color:blue;"><xsl:value-of select="Ann23/pre" /></td>
			<td style="color:red; background-color:yellow;"><xsl:value-of select="Ann23/post" /></td>
		</tr>
	</table>
	
	<table border="1" style="color:black; width:800px; left:50px;">
        <tr>
            <td colspan="9" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">D7035 Octal Relay Modules, D7048 Octal Driver Modules</td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;" rowspan="19">Address 9</td>
			<td style="font-size:12px; font-weight:bold;">Label</td>
			<td colspan="3" style="font-size:12px; font-weight:normal; color:blue;"><xsl:value-of select="OutputMod9/Label/pre" /></td>
			<td colspan="4" style="background-color:yellow;font-size:12px; font-weight:normal; color:red;"><xsl:value-of select="OutputMod9/Label/post" /></td>
				
		</tr>
		<tr>
			<td style="font-size:12px; font-weight:bold;">Installed</td>
			<td colspan="3" style="font-size:12px; font-weight:normal; color:blue;"><xsl:value-of select="OutputMod9/Enable/pre" /></td>
			<td colspan="4" style="background-color:yellow; font-size:12px; font-weight:normal; color:red;"><xsl:value-of select="OutputMod9/Enable/post" /></td>
		</tr>

        <tr>
            <td style="font-size:12px; font-weight:bold;" width="5%">Output</td>
            <td style="font-size:12px; font-weight:bold;" width="15%">Zones</td>
            <td style="font-size:12px; font-weight:bold;" width="10%">Drillable</td>
			<td style="font-size:12px; font-weight:bold;" width="10%">Ext. signaling</td>
            <td style="font-size:12px; font-weight:bold;" width="10%">Bypassed</td>
            <td style="font-size:12px; font-weight:bold;" width="10%">ENormal</td>
            <td style="font-size:12px; font-weight:bold;" width="10%">Sequential</td>
            <td style="font-size:12px; font-weight:bold;" width="20%">Label</td>
        </tr>
        <xsl:apply-templates select="OutputMod9" />
		
        <tr>
            <td style="font-size:12px; font-weight:bold;" rowspan="19">Address 10</td>
			<td style="font-size:12px; font-weight:bold;">Label</td>
			<td colspan="3" style="font-size:12px; font-weight:normal; color:blue;"><xsl:value-of select="OutputMod10/Label/pre" /></td>
			<td colspan="4" style="background-color:yellow;font-size:12px; font-weight:normal; color:red;"><xsl:value-of select="OutputMod10/Label/post" /></td>	
		</tr>
		<tr>
			<td style="font-size:12px; font-weight:bold;">Installed</td>
			<td colspan="3" style="font-size:12px; font-weight:normal; color:blue;"><xsl:value-of select="OutputMod10/Enable/pre" /></td>
			<td colspan="4" style="background-color:yellow; font-size:12px; font-weight:normal; color:red;"><xsl:value-of select="OutputMod10/Enable/post" /></td>
		</tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;" width="5%">Output</td>
            <td style="font-size:12px; font-weight:bold;" width="15%">Zones</td>
            <td style="font-size:12px; font-weight:bold;" width="10%">Drillable</td>
			<td style="font-size:12px; font-weight:bold;" width="10%">Ext. signaling</td>
            <td style="font-size:12px; font-weight:bold;" width="10%">Bypassed</td>
            <td style="font-size:12px; font-weight:bold;" width="10%">ENormal</td>
            <td style="font-size:12px; font-weight:bold;" width="10%">Sequential</td>
            <td style="font-size:12px; font-weight:bold;" width="20%">Label</td>
        </tr>
        <xsl:apply-templates select="OutputMod10" />
    </table>
	
    <table border="1" style="color:black; width:800px; left:50px;">
        <tr>
            <td colspan="7" align="left" style="background:#CCCCCC; font-size:12px; font-weight:bold;">FPP-RNAC-8A-4A Remote NAC Power Supply</td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;" rowspan="11">Address 11</td>
			<td style="font-size:12px; font-weight:bold;">Label</td>
			<td colspan="3" style="font-size:12px; font-weight:normal; color:blue;"><xsl:value-of select="RNAC11/Label/pre" /></td>
			<td colspan="3" style="background-color:yellow;font-size:12px; font-weight:normal; color:red;"><xsl:value-of select="RNAC11/Label/post" /></td>
		</tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Installed</td>
			<td colspan="3" style="font-size:12px; font-weight:normal; color:blue;"><xsl:value-of select="RNAC11/Enable/pre" /></td>
			<td colspan="3" style="background-color:yellow; font-size:12px; font-weight:normal; color:red;"><xsl:value-of select="RNAC11/Enable/post" /></td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;" width="10%">Output</td>
            <td style="font-size:12px; font-weight:bold;" width="15%">Zones</td>
            <td style="font-size:12px; font-weight:bold;" width="15%">Pattern</td>
            <td style="font-size:12px; font-weight:bold;" width="10%">Silence</td>
            <td style="font-size:12px; font-weight:bold;" width="10%">Bypassed</td>
            <td style="font-size:12px; font-weight:bold;" width="20%">Label</td>
        </tr>
        <xsl:apply-templates select="RNAC11" />
        <tr>
            <td style="font-size:12px; font-weight:bold;" rowspan="11">Address 12</td>
			<td style="font-size:12px; font-weight:bold;">Label</td>
			<td colspan="3" style="font-size:12px; font-weight:normal; color:blue;"><xsl:value-of select="RNAC12/Label/pre" /></td>
			<td colspan="3" style="background-color:yellow;font-size:12px; font-weight:normal; color:red;"><xsl:value-of select="RNAC12/Label/post" /></td>
		</tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Installed</td>
			<td colspan="3" style="font-size:12px; font-weight:normal; color:blue;"><xsl:value-of select="RNAC12/Enable/pre" /></td>
			<td colspan="3" style="background-color:yellow; font-size:12px; font-weight:normal; color:red;"><xsl:value-of select="RNAC12/Enable/post" /></td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;" width="10%">Output</td>
            <td style="font-size:12px; font-weight:bold;" width="15%">Zones</td>
            <td style="font-size:12px; font-weight:bold;" width="15%">Pattern</td>
            <td style="font-size:12px; font-weight:bold;" width="10%">Silence</td>
            <td style="font-size:12px; font-weight:bold;" width="10%">Bypassed</td>
            <td style="font-size:12px; font-weight:bold;" width="20%">Label</td>
        </tr>        
        <xsl:apply-templates select="RNAC12" />
       <tr>
            <td style="font-size:12px; font-weight:bold;" rowspan="11">Address 13</td>
			<td style="font-size:12px; font-weight:bold;">Label</td>
			<td colspan="3" style="font-size:12px; font-weight:normal; color:blue;"><xsl:value-of select="RNAC13/Label/pre" /></td>
			<td colspan="3" style="background-color:yellow;font-size:12px; font-weight:normal; color:red;"><xsl:value-of select="RNAC13/Label/post" /></td>
		</tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Installed</td>
			<td colspan="3" style="font-size:12px; font-weight:normal; color:blue;"><xsl:value-of select="RNAC13/Enable/pre" /></td>
			<td colspan="3" style="background-color:yellow; font-size:12px; font-weight:normal; color:red;"><xsl:value-of select="RNAC13/Enable/post" /></td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;" width="10%">Output</td>
            <td style="font-size:12px; font-weight:bold;" width="15%">Zones</td>
            <td style="font-size:12px; font-weight:bold;" width="15%">Pattern</td>
            <td style="font-size:12px; font-weight:bold;" width="10%">Silence</td>
            <td style="font-size:12px; font-weight:bold;" width="10%">Bypassed</td>
            <td style="font-size:12px; font-weight:bold;" width="20%">Label</td>
        </tr>
        <xsl:apply-templates select="RNAC13" />
      <tr>
            <td style="font-size:12px; font-weight:bold;" rowspan="11">Address 14</td>
			<td style="font-size:12px; font-weight:bold;">Label</td>
			<td colspan="3" style="font-size:12px; font-weight:normal; color:blue;"><xsl:value-of select="RNAC14/Label/pre" /></td>
			<td colspan="3" style="background-color:yellow;font-size:12px; font-weight:normal; color:red;"><xsl:value-of select="RNAC14/Label/post" /></td>
		</tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;">Installed</td>
			<td colspan="3" style="font-size:12px; font-weight:normal; color:blue;"><xsl:value-of select="RNAC14/Enable/pre" /></td>
			<td colspan="3" style="background-color:yellow; font-size:12px; font-weight:normal; color:red;"><xsl:value-of select="RNAC14/Enable/post" /></td>
        </tr>
        <tr>
            <td style="font-size:12px; font-weight:bold;" width="10%">Output</td>
            <td style="font-size:12px; font-weight:bold;" width="15%">Zones</td>
            <td style="font-size:12px; font-weight:bold;" width="15%">Pattern</td>
            <td style="font-size:12px; font-weight:bold;" width="10%">Silence</td>
            <td style="font-size:12px; font-weight:bold;" width="10%">Bypassed</td>
            <td style="font-size:12px; font-weight:bold;" width="20%">Label</td>
        </tr>
        <xsl:apply-templates select="RNAC14" />
    </table>
</xsl:template>

<xsl:template match="FPA1000/OPTIONBUS/RNAC11|RNAC12|RNAC13|RNAC14" >
    <tr style="color:blue; font-size:12px; font-weight:normal;">
        <td style="color:black;">1</td>
        <xsl:for-each select="NAC1">
            <xsl:call-template name="RNAC_NACSPre" />
        </xsl:for-each>
    </tr>
	<tr style=" background-color:yellow; color:red; font-size:12px; font-weight:normal;">
        <td style="color:black;">1</td>
        <xsl:for-each select="NAC1">
            <xsl:call-template name="RNAC_NACSPost" />
        </xsl:for-each>
    </tr>
    <tr style="color:blue; font-size:12px; font-weight:normal;">
        <td style="color:black;">2</td>
        <xsl:for-each select="NAC2">
            <xsl:call-template name="RNAC_NACSPre" />
        </xsl:for-each>
    </tr>
	<tr style=" background-color:yellow; color:red; font-size:12px; font-weight:normal;">
        <td style="color:black;">2</td>
        <xsl:for-each select="NAC2">
            <xsl:call-template name="RNAC_NACSPost" />
        </xsl:for-each>
    </tr>
    <tr style="color:blue; font-size:12px; font-weight:normal;">
        <td style="color:black;">3</td>
        <xsl:for-each select="NAC3">
            <xsl:call-template name="RNAC_NACSPre" />
        </xsl:for-each>
    </tr>
	<tr style=" background-color:yellow; color:red; font-size:12px; font-weight:normal;">
        <td style="color:black;">3</td>
        <xsl:for-each select="NAC3">
            <xsl:call-template name="RNAC_NACSPost" />
        </xsl:for-each>
    </tr>
    <tr style="color:blue; font-size:12px; font-weight:normal;">
        <td style="color:black;">4</td>
        <xsl:for-each select="NAC4">
            <xsl:call-template name="RNAC_NACSPre" />
        </xsl:for-each>
    </tr>
	<tr style=" background-color:yellow; color:red; font-size:12px; font-weight:normal;">
        <td style="color:black;">4</td>
        <xsl:for-each select="NAC4">
            <xsl:call-template name="RNAC_NACSPost" />
        </xsl:for-each>
    </tr>
</xsl:template>

<xsl:template name="RNAC_NACSPre">
    <td style="color:blue; font-size:12px; font-weight:normal;">
        <xsl:call-template name="Zone1_5Pre" /></td>
    <td style="font-size:12px; font-weight:normal; color:blue;">
        <xsl:for-each select="Pattern/pre">
        <xsl:call-template name="ID_MAINPATTERN" />
        </xsl:for-each></td>
    <td style="font-size:12px; font-weight:normal; color:blue;">
        <xsl:value-of select="Drillenceable/pre" /></td>
    <td style="font-size:12px; font-weight:normal; color:blue;">
        <xsl:value-of select="Bypassed/pre" /></td>
    <td style="font-size:12px; font-weight:normal; color:blue;">
        <xsl:value-of select="Label/pre" /></td>
</xsl:template>

<xsl:template name="RNAC_NACSPost">
    <td style="color:red; font-size:12px; font-weight:normal;">
        <xsl:call-template name="Zone1_5Post" /></td>
    <td style="font-size:12px; font-weight:normal; color:red;">
        <xsl:for-each select="Pattern/post">
        <xsl:call-template name="ID_MAINPATTERN" />
        </xsl:for-each></td>
    <td style="font-size:12px; font-weight:normal; color:red;">
        <xsl:value-of select="Drillenceable/post" /></td>
    <td style="font-size:12px; font-weight:normal; color:red;">
        <xsl:value-of select="Bypassed/post" /></td>
    <td style="font-size:12px; font-weight:normal; color:red;">
        <xsl:value-of select="Label/post" /></td>
</xsl:template>

<xsl:template match="OutputMod9|OutputMod10" >
    <tr>
        <td style="font-size:12px; font-weight:normal; color:black;">1</td>
        <xsl:for-each select="Relay1">
            <xsl:call-template name="OUTPUT_RELAYSPre" />
        </xsl:for-each>
    </tr>
	<tr style="background-color:yellow;">
        <td style="font-size:12px; font-weight:normal; color:black;">1</td>
        <xsl:for-each select="Relay1">
            <xsl:call-template name="OUTPUT_RELAYSPost" />
        </xsl:for-each>
    </tr>
	<tr>
        <td style="font-size:12px; font-weight:normal; color:black;">2</td>
        <xsl:for-each select="Relay2">
            <xsl:call-template name="OUTPUT_RELAYSPre" />
        </xsl:for-each>
    </tr>
	<tr style="background-color:yellow;">
        <td style="font-size:12px; font-weight:normal; color:black;">2</td>
        <xsl:for-each select="Relay2">
            <xsl:call-template name="OUTPUT_RELAYSPost" />
        </xsl:for-each>
    </tr>
	<tr>
        <td style="font-size:12px; font-weight:normal; color:black;">3</td>
        <xsl:for-each select="Relay3">
            <xsl:call-template name="OUTPUT_RELAYSPre" />
        </xsl:for-each>
    </tr>
	<tr style="background-color:yellow;">
        <td style="font-size:12px; font-weight:normal; color:black;">3</td>
        <xsl:for-each select="Relay3">
            <xsl:call-template name="OUTPUT_RELAYSPost" />
        </xsl:for-each>
    </tr>
    <tr>
        <td style="font-size:12px; font-weight:normal; color:black;">4</td>
        <xsl:for-each select="Relay4">
            <xsl:call-template name="OUTPUT_RELAYSPre" />
        </xsl:for-each>
    </tr>
	<tr style="background-color:yellow;">
        <td style="font-size:12px; font-weight:normal; color:black;">4</td>
        <xsl:for-each select="Relay4">
            <xsl:call-template name="OUTPUT_RELAYSPost" />
        </xsl:for-each>
    </tr>
    <tr>
        <td style="font-size:12px; font-weight:normal; color:black;">5</td>
        <xsl:for-each select="Relay5">
            <xsl:call-template name="OUTPUT_RELAYSPre" />
        </xsl:for-each>
    </tr>
	<tr style="background-color:yellow;">
        <td style="font-size:12px; font-weight:normal; color:black;">5</td>
        <xsl:for-each select="Relay5">
            <xsl:call-template name="OUTPUT_RELAYSPost" />
        </xsl:for-each>
    </tr>
    <tr>
        <td style="font-size:12px; font-weight:normal; color:black;">6</td>
        <xsl:for-each select="Relay6">
            <xsl:call-template name="OUTPUT_RELAYSPre" />
        </xsl:for-each>
    </tr>
	<tr style="background-color:yellow;">
        <td style="font-size:12px; font-weight:normal; color:black;">6</td>
        <xsl:for-each select="Relay6">
            <xsl:call-template name="OUTPUT_RELAYSPost" />
        </xsl:for-each>
    </tr>
    <tr>
        <td style="font-size:12px; font-weight:normal; color:black;">7</td>
        <xsl:for-each select="Relay7">
            <xsl:call-template name="OUTPUT_RELAYSPre" />
        </xsl:for-each>
    </tr>
	<tr style="background-color:yellow;">
        <td style="font-size:12px; font-weight:normal; color:black;">7</td>
        <xsl:for-each select="Relay7">
            <xsl:call-template name="OUTPUT_RELAYSPost" />
        </xsl:for-each>
    </tr>
    <tr>
        <td style="font-size:12px; font-weight:normal; color:black;">8</td>
        <xsl:for-each select="Relay8">
            <xsl:call-template name="OUTPUT_RELAYSPre" />
        </xsl:for-each>
    </tr>
	<tr style="background-color:yellow;">
        <td style="font-size:12px; font-weight:normal; color:black;">8</td>
        <xsl:for-each select="Relay8">
            <xsl:call-template name="OUTPUT_RELAYSPost" />
        </xsl:for-each>
    </tr>
</xsl:template>

<xsl:template name="OUTPUT_RELAYSPre" >
    <td style="font-size:12px; font-weight:normal; color:blue;">
        <xsl:call-template name="Zone1_5Pre" /></td>
    <td style="font-size:12px; font-weight:normal; color:blue;">
        <xsl:value-of select="Drillenceable/pre" /></td>
	<td style="font-size:12px; font-weight:normal; color:blue;">
		<xsl:value-of select="Silenceable/pre" /></td>	
    <td style="font-size:12px; font-weight:normal; color:blue;">
        <xsl:value-of select="Bypassed/pre" /></td>
    <td style="font-size:12px; font-weight:normal; color:blue;">
        <xsl:value-of select="ENormal/pre" /></td>
    <td style="font-size:12px; font-weight:normal; color:blue;">
        <xsl:value-of select="Sequential/pre" /></td>
    <td style="font-size:12px; font-weight:normal; color:blue;">
        <xsl:value-of select="Label/pre" /></td>
</xsl:template>

<xsl:template name="OUTPUT_RELAYSPost" >
    <td style="font-size:12px; font-weight:normal; color:red;">
        <xsl:call-template name="Zone1_5Post" /></td>
    <td style="font-size:12px; font-weight:normal; color:red;">
        <xsl:value-of select="Drillenceable/post" /></td>
	<td style="font-size:12px; font-weight:normal; color:blue;">
		<xsl:value-of select="Silenceable/post" /></td>	
    <td style="font-size:12px; font-weight:normal; color:red;">
        <xsl:value-of select="Bypassed/post" /></td>
    <td style="font-size:12px; font-weight:normal; color:red;">
        <xsl:value-of select="ENormal/post" /></td>
    <td style="font-size:12px; font-weight:normal; color:red;">
        <xsl:value-of select="Sequential/post" /></td>
    <td style="font-size:12px; font-weight:normal; color:red;">
        <xsl:value-of select="Label/post" /></td>
</xsl:template>

<xsl:template name="MAINBOARD_RELAYTYPE">
    <xsl:choose>
		<xsl:when test=". = 0"><xsl:text>Fire alarm</xsl:text></xsl:when>
		<xsl:when test=". = 1"><xsl:text>Trouble</xsl:text></xsl:when>
		<xsl:when test=". = 2"><xsl:text>Supervisory</xsl:text></xsl:when>
		<xsl:when test=". = 3"><xsl:text>Gas Alarm</xsl:text></xsl:when>
		<xsl:when test=". = 4"><xsl:text>By Zone</xsl:text></xsl:when>
    </xsl:choose>
</xsl:template>

<xsl:template name="ID_MAINPATTERN">
    <xsl:choose>
        <xsl:when test=". = 1" ><xsl:text>Steady</xsl:text></xsl:when>
        <xsl:when test=". = 2" ><xsl:text>Pulsing</xsl:text></xsl:when>
        <xsl:when test=". = 3" ><xsl:text>Temporal Code 3</xsl:text></xsl:when>
		<xsl:when test=". = 4" ><xsl:text>Temporal Code 4</xsl:text></xsl:when>
        <xsl:when test=". = 5" ><xsl:text>Wheelock</xsl:text></xsl:when>
        <xsl:when test=". = 6" ><xsl:text>Gentex</xsl:text></xsl:when>
        <xsl:when test=". = 7" ><xsl:text>System Sensor</xsl:text></xsl:when>
		<xsl:when test=". = 8" ><xsl:text>Power Supply Mode</xsl:text></xsl:when>
		<xsl:otherwise></xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template name="ID_PATTERN">
    <xsl:choose>
		<xsl:when test=". = 0"><xsl:text>Default</xsl:text></xsl:when>
		<xsl:when test=". = 1"><xsl:text>Steady</xsl:text></xsl:when>
		<xsl:when test=". = 2"><xsl:text>Pulsing</xsl:text></xsl:when>
		<xsl:when test=". = 3"><xsl:text>Temporal Code 3</xsl:text></xsl:when>
		<xsl:when test=". = 4"><xsl:text>Temporal Code 4</xsl:text></xsl:when>
		<xsl:when test=". = 5"><xsl:text>Wheelock</xsl:text></xsl:when>
		<xsl:when test=". = 6"><xsl:text>Gentex</xsl:text></xsl:when>
		<xsl:when test=". = 7"><xsl:text>System Sensor</xsl:text></xsl:when>
		<xsl:when test=". = 8"><xsl:text>Power Supply Mode</xsl:text></xsl:when>
		<xsl:otherwise></xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="DelayModeOption/pre | DelayModeOption/post">
    <xsl:choose>
        <xsl:when test=".=0"><xsl:text>AV/PAS/Pre-signal</xsl:text></xsl:when>
        <xsl:when test=".=1"><xsl:text>Sandwich/Dual-zone</xsl:text></xsl:when>
    </xsl:choose>
</xsl:template>

<xsl:template match="RTI">
    <xsl:choose>
		<xsl:when test=". = 1"><xsl:text>Standard</xsl:text></xsl:when>
		<xsl:when test=". = 2"><xsl:text>Quick</xsl:text></xsl:when>
		<xsl:otherwise></xsl:otherwise>
    </xsl:choose>
	
</xsl:template>

</xsl:stylesheet>

